//---------------------------------------------------------------------------

#ifndef CheckExecuteUH
#define CheckExecuteUH

#include "Data_Gen.h"

#define chCENTR_TENSION               1
#define chCENTR_COMPRESSION           2
#define chBENDING                     4
#define chBENDING_TRUBA               4
#define chTENSION_BENDING             8   // - (- )
#define chCOMPRESSION_BENDING         16  // - (- )
#define chCOMPRESSION_BENDING_CONST   16  // - (- )
#define chCOMPRESSION_BENDING_VARY    32  // - (- )
#define chCOMPRESSION_BENDING_TRUBA   16  // - (- )

#define CENTR_TENSION       0
#define CENTR_COMPRESSION   1
#define COMPRESSION_BENDING 2
#define BENDING             3
#define TENSION_BENDING     4

//   
#define List_Centr_TensionU\
", . 7.1.1 .(5)",\
"     (XZ), . 10.4.1, 10.4.2. . 33",\
"     (YZ), . 10.4.1, 10.4.2. . 33"

#define   N_CENTR_TENSION_U 3
#define NUM_PROV_CENTR_TENSION         { 1, 1, 1}

//   
#define List_Centr_TensionU_Tube\
", . 7.1.1 .(5)",\
"    XZ, . 10.4.1, 10.4.2. . 33",\
"    YZ, . 10.4.1, 10.4.2. . 33"

#define   N_CENTR_TENSION_TUBE_U 3
#define NUM_PROV_CENTR_TENSION_TUBE         { 1, 1, 1}
#define NUM_PROV_CENTR_TENSION_CIRC         { 1, 1, 1}


//   
#define List_Centr_CompressionU \
", . 7.1.1 .(5)",\
"    (XZ), . 7.1.3., 7.3.5, 7.3.6 .(7)",\
"    (YZ), . 7.1.3., 7.3.5, 7.3.6 .(7)",\
"  , . 7.3.2, 7.3.6, 7.3.11",\
"    , . 7.3.3",\
"   , . 7.3.3",\
"   , . 7.3.3",\
"   , . 7.3.3",\
"   1, . 7.3.8",\
"   2, . 7.3.8",\
"     (XZ), . 32",\
"     (YZ), . 32",\
",     Qfic, . 7.2.10",\
",     Qfic, . 7.2.10",\
"      Qfic . 7.1.6, .(42)"
#define   N_CENTR_COMPRESSION_U 15
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19
#define NUM_PROV_CENTR_COMPRESS        { 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0}

//   
#define List_Centr_CompressionU_Tube \
", . 7.1.1 .(5)",\
"   XZ, . 7.1.3., 7.3.5, 7.3.6 .(7)",\
"   YZ, . 7.1.3., 7.3.5, 7.3.6 .(7)",\
"     XZ, . 7.3.2, 7.3.6, 7.3.11",\
"    , . 7.3.3",\
"   , . 7.3.3",\
"   , . 7.3.3",\
"   , . 7.3.3",\
"     XZ, . 7.3.8",\
"     YZ, . 7.3.8",\
"    XZ, . 32",\
"    YZ, . 32",\
",     Qfic, . 7.2.10",\
",     Qfic, . 7.2.10",\
"      Qfic . 7.1.6, .(42)"

#define   N_CENTR_COMPRESSION_TUBE_U 15
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13 14
#define NUM_PROV_CENTR_COMPRESS_TUBE   { 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0}
#define NUM_PROV_CENTR_COMPRESS_CIRC   { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0}

//  
#define List_BendingU \
"   , . 9.1.1 . (105)   . 8.2.3,  . (106)",\
"     , . 8.2.1, . (42)",\
"        , . 8.2.1",\
"       , . 8.2.3, . 54",\
"          , . 8.2.3, . 55",\
" ,    ,    , . 8.2.2, . (46)",\
"    , . 8.2.1 . (44)",\
"    , . 8.2.1 . (44)",\
"  - , . 8.4.1",\
", . 8.4.4, 8.4.6",\
"   , . 8.5.3.",\
"  , . 8.5.3, 8.5.6, 8.5.7.",\
"      . 8.5.9.",\
"    ,  8.5.9.",\
"     . 1  3, . .20",\
"     . 2  4, . .21",\
"   , . .22",\
"   , . 8.5.18, 8.5.18.",\
"   , . 9.4.",\
"   , . 9.4.",\
" ,  . .1  20.13330"

#define  N_BENDING_U 21
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20
#define NUM_PROV_BENDING               { 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1}
#define NUM_PROV_BENDING_WELD          { 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1}
#define NUM_PROV_BENDING_PERF          { 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1}

//  
#define List_Bending_TubeU \
"   , . 9.1.1 . (105)   . 8.2.3",\
"     Qy, . 8.2.1, . (42)",\
"     Qx, . 8.2.1, . (42)",\
"         . YZ, . 8.2.3, . 54",\
"         . XZ, . 8.2.3, . 55",\
" ,    ,    , . 8.2.2, . (46)",\
"    , . 8.2.1 . (44)",\
"    . XZ, . 9.1.3, .(107)",\
"  - , . 8.4.1, 8.4.4, 8.4.6",\
",   , . 8.4.5.",\
"   . YZ, . 8.5.1, 8.5.3, 8.5.6, 8.5.7, 8.5.8.",\
"      . 8.5.9.",\
"    . XZ, . 8.5.18, 8.5.18.",\
" ,  . .1  20.13330"

#define  N_BENDING_TUBE_U 14
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13
#define NUM_PROV_BENDING_TUBE          { 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1}
#define NUM_PROV_BENDING_CIRC          { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}


// - 
#define List_Compression_Bending_ConstU\
"   , . 9.1.1 .(105)  (106)",\
"    , . 8.2.1, . (42)",\
"          , . 8.2.2, .(46)",\
"    , . 8.2.1 . (44)",\
"  , . 9.1.3, .(107)",\
"    (YZ), . 9.2.1 . (109)",\
"    (XZ), . 9.2.4 . (111)",\
"      . 9.2.9, . (116)",\
"    , . 9.4.4",\
"  , . 9.4.4",\
"  , . 7.3.3",\
"  , . 7.3.3",\
"       , . 8.5.10.",\
"   *fi_y > fi_e, . 9.4",\
"   *fi_y <= fi_e, . 9.4",\
" , . 9.4",\
"  , . 9.4",\
"     (XZ), . 10.4",\
"     (YZ), . 10.4",\
"  , . 8.4.5",\
"  , . 8.4.5"
#define  N_COMPRESSION_BENDING_U 21
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19  20
#define NUM_PROV_COMPRESS_BENDING      { 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0}

// - 
#define List_Compression_Bending_TubeU\
"   , . 9.1.1 .(105)  (106)",\
"     Qy, . 8.2.1, . (42)",\
"     Qx, . 8.2.1, . (42)",\
" ,       , . 8.2.2, . (46)",\
"      . XY, . 8.2.1 . (44)",\
"    . XZ, . 9.1.3, .(107)",\
"     . YZ . 9.2.10 .(120)",\
"     . XZ . 9.2.10 .(121)",\
"      . 7.3.3.",\
"   . XZ . 9.4.7",\
"   . YZ, . 9.4.7",\
"   . XZ, . 9.4.7",\
"   . XZ, . 32",\
"   . YZ, . 32",\
",   , . 8.4.5",\
",   , . 8.4.5"
#define  N_COMPRESSION_BENDING_TUBE_U 16
//                                       0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
#define NUM_PROV_COMPRESS_BENDING_TUBE { 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0}
#define NUM_PROV_COMPRESS_BENDING_CIRC { 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0}

// - 
#define List_Tension_Bending_U\
"   , . 9.1.1 .(105)  (106)",\
"     , . 8.2.1, . (42)",\
"    , . 8.2.1 . (44)",\
"  , . 9.1.3, .(107)",\
"    (YZ)       . 7.1.3, . (7)",\
"    , . 9.4.4",\
" , . 8.5.3, 8.5.6, 8.5.7.",\
" , . 9.4",\
"     (YZ), . 10.4",\
"     (XZ), . 10.4"
#define  N_TENSION_BENDING_U 10
//                                      0  1  2  3  4  5  6  7  8  9
#define NUM_PROV_TENSION_BENDING      { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}

// - 
#define List_Tension_Bending_TubeU\
"   , . 9.1.1 .(105)  (106)",\
"     Qy, . 8.2.1, . (42)",\
"     Qx, . 8.2.1, . (42)",\
" ,       , . 8.2.2, . (46)",\
"    , . 8.2.1 . (44)",\
"    . XZ, . 9.1.3, .(107)",\
"     . YZ . 9.2.10 .(120)",\
"     . XZ . 9.2.10 .(121)",\
"      . 7.3.3.",\
"   . XZ, . 9.4.7",\
"   . YZ, . 9.4.7",\
"   . XZ, . 9.4.7",\
"   . XZ, . 32",\
"   . YZ, . 32",\
",   , . 8.4.5",\
",   , . 8.4.5"

#define  N_TENSION_BENDING_TUBE_U 16
//                                      0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
#define NUM_PROV_TENSION_BENDING_TUBE { 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0}
#define NUM_PROV_TENSION_BENDING_CIRC { 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0}

#define MAXNNEL(x, y, i)\
						  if ((x) < (y)) {         \
							(x) = (y);             \
							nnel_krit[i] = n_elem_rep; \
						  }


typedef struct _data_check_u {  //  
   double gamma_c;                //   
   double gamma_n;                //    
   double Limit_lambda1;          //        ,  
   double Limit_lambda2;          //        ,  
   double Limit_lambda_plus;          //    
   int index_otvetstv;
   int index_class;     //   ( )
   int index_group;     //  
   double koeff_material_nadeghn;
   double edge_step;
   double edge_thick;
   double edge_width;
   int type_edge;   // -1 -   ; 0 - ; 2 -  
   bool flag_cont_ext;
   bool flag_cont_int;
   bool flag_netto;     //    
   int index_local;     //    
   double diametr[4];    //  :  ,  ,  ,  
   double space[4];      //       :  ,  ,  ,  
   double step[4];       //  :  ,  ,  ,  
   int    num_holes[4];   //  :  ,  , 
   double perfor_attit;  //    
   double perfor_alfa;   //  
   double perfor_a;   //
   double perfor_b;   //
   double perfor_h;      //  
   double q_ext;         //  ,    
   double M_third;       //       (1/3 )
   double IRels;
   double Qu_;
   double q_u_;
   double ugol_var;
   double span;         //  
   double del_max;      //    

   int    Local_F_;
   int    Local_b_;
   double length[100];
   double length_XZ[100];
   double length_YZ[100];
   double step_ext[100];
   double step_int[100];

   double len_ext;     //   
   double len_int;
   double strela;
   double delta_lim;
   double sigma_minus;
   double sigma_plus;
   double N_minus;
   double N_plus;
   double M_max_i;
   int index_place_local;     //     
   int index_limit;     //   
   int index_Qy;      // 0 -   , 1 -  , 2 -   
   char fi_b_type_constr;  //   0 - , 1 - 
   char fi_b_num_constr;   //     0 -  , 1 -    2 -   
   char fi_b_type_load;    //   0 -   , 2 -  ; 3 - ; 2 -   
   char fi_b_index_poyas;  // 0 -     , 1 -  
   bool flag_conclusion;
   bool flag_dummy0;
   bool flag_dynamic_load;
   bool flag_diff_Ry;
   bool flag_diff_edge_Ry;
   bool flag_weld;
   bool flag_vary_sten;
   bool flag_edge;       //   
   bool flag_razrez;     //  
   bool flag_bend_gib;
   bool flag_compress_gib;
   bool flag_init_check;       //  
   bool flag_perfor;     //   
   bool flag_bending;    //  ,      
   bool flag_dummy[2];
   int index_type;      //   .  (-, ..
   int num_krit;        //    
   bool Checked[100];  //  
}  DATA_CHECK_U;

typedef struct _check_elem_param_u {  //   
   DATA_SECT_SCAD Sect_Elem;        //    
   GEOM_PARAM_SECT param_sect;
   GEOM_PARAM_SECT param_netto;
   int    n_RSU;
   int    index_105;
   int    num_elem[6];  //  ,     
   int    nelem;
   char   Steel[12];
   double hsect;
   double bsect;
   double diametr;
   double hw;
   double hw1;
   double hw2;
   double hef;
   double hef1;
   double hef2;
   double bef;
   double Ad;   //     lambda_w < k*lambda_uw
   double RSU[10][7];
   double t0;
   double t1;
   double Ryn;
   double Ry;
   double Ryw;
   double Rs;
   double alfa_f;
   double lambda_w;
   double lambda_uw; //    
   double lambda_f;
   double lambda_uf; //        . XZ
   double lambda_wY;
   double lambda_uwY; //     (  )
   double lambda_f1;
   double lambda_f2;
   double lambdaX;
   double lambda_x;
   double lambdaY;
   double lambda_y;
   double lambdaBF1;
   double lambda_bf1;
   double lambda_b1;
   double lambdaBF2;
   double lambda_bf2;
   double lambda_b2;
   double m_exc;  //              
   double eta;
   double m_ef;   //         
   double mx;     //     Mc         
   double fi_x;
   double fi_e;
   double fi_y;
   double cfi_y;
   double fi_b;
   double fi_exy;
   double alfa;
   double Wc;   //      
   double Wt;    //      
   double Wx_min;
   double Wy_min;
   double sigma_max;
   double tau_max;
   double tau_y_max;
   double cx_;       //     . 105
   double cy_;
   double n_;
   //------------------------------------
   double Mx;
   double My;
   double N_;
   double Qy;
   double Qx;
   double Sy;   //   
   double Sx;   //   
   double Ix;
   double Iy;
   double tw;
   double tf;
   double Aw;
   double Af;
   double sig_xw;
   double sig_yw;
   double tau_w;
   double sig_xf;
   double sig_yf;
   double tau_f;
   double krit_lambdaw;
   double Wcx;
   double Wy;
   double sigma1w;
   double delta_b;
   double delta_ub;
   double beta;
   double cx;
   double cy;
   double N_105;
   double n_pow;
   double y_106;
   double x_106;
   double A_netto;
   double fi_1;
   double psi;
   double h_fi_b;
   double l_ef;
   double Ey;
   int index_stab_w;
   double k12;
   double M1;
   double M2;
   double Q_;
   double sigma_stab_max;
   double sigma_stab_cr;
   double tau_stab_max;
   double tau_stab_cr;
   double sigma_loc;
   double sigma_loc_cr;
   double r_stab;
   double alfa_stab;
   double del_lamb;
   bool flag_check_step;
   double step_max;
   double lambda_b;
   double lambda_ub;
   double step_edge_calc_CC;
   double edge_param[3][3]; // 0 - CC; 1 - B; 2 - CB // 0 - step; 1 - br; 2 - tr;

}  CHECK_ELEM_PARAM_U;


typedef struct _check_elem_param_cb_u {  //     Ncomp_max
   DATA_SECT_SCAD Sect_Elem;        //    
   GEOM_PARAM_SECT param_sect;
   GEOM_PARAM_SECT param_netto;
   int    n_RSU;
   int    num_elem[6];  //  
   int    index_105;
   int    nelem;
   char   Steel[12];
   double hw;
   double hw1;
   double hw2;
   double hef;
   double hef1;
   double hef2;
   double bef;
   double Ad;   //     lambda_w < k*lambda_uw
   double RSU[10][7];
   double Ryn;
   double Ry;
   double Ryw;
   double Rs;
   double alfa_f;
   double lambda_w;
   double lambda_uw; //    
   double lambda_f;
   double lambda_uf; //        . XZ
   double lambda_wY;
   double lambda_uwY; //     (  )
   double lambda_f1;
   double lambda_f2;
   double lambdaX;
   double lambda_x;
   double lambdaY;
   double lambda_y;
   double lambdaBF1;
   double lambda_bf1;
   double lambda_b1;
   double lambdaBF2;
   double lambda_bf2;
   double lambda_b2;
   double m_exc;  //              
   double eta;
   double m_ef;   //         
   double mx;     //     Mc         
   double fi_x;
   double fi_e;
   double fi_y;
   double cfi_y;
   double fi_b;
   double fi_exy;
   double alfa;
   double Wc;   //      
   double Wt;    //      
   double Wx_min;
   double Wy_min;
   double sigma_max;
   double tau_max;
   double cx_;       //     . 105
   double cy_;
   double n_;
}  CHECK_ELEM_PARAM_CB_U;

class TCheckExecute
{
  private:
	int index_M_max, index_N_plus, index_N_minus;
	int n_RSU_N_plus, n_RSU_N_minus, n_RSU_M_max, n_RSU_Q_max, n_RSU_My_max, n_RSU_Qy_max;


  public:
	 int CheckExecuteU(DATA_CHECK_U *data_check, int *n_krit, double *krit, int *nnel_krit);
	 int CheckExecuteU_Tube(DATA_CHECK_U *data_check, int *n_krit, double *krit, int *nnel_krit);
	 int CheckBending(DATA_CHECK_U *data_check, int *n_krit, double *krit, int *nnel_krit);
	 //           numUnit  
	 int SetConditionCheck(DATA_CHECK_U *data_check, bool *flag_krit);
	 void SetFlagCheck(int index_Type, DATA_CHECK_U *data_check, bool *flag_check);

	 int Material_Number;
     MATER MaterProp[MAX_MATERIAL];
     int NumNameGroup[2];       //   
     int NelemInGroup[2];       //    
     DATA_SECT_SCAD Sect_Elem_Group[2];       //     
     int NRSU;  //  
	 double Elem_RSU[200][6];           //   (N, Mk, x, Qy, My, Qx)
	 double q_bal_n[200][2];              //     qy  )
	 double q_bal_r[200][2];              //     qy  )
	 int ListElem_RSU[200];             //  ,  
	 bool CheckElem[200][6];            //     0 - _, 1 - e_, 2 - -, 3-, 4 - -, 5 - 
	 DATA_CHECK_U Data_check_U;     //     
	 CHECK_ELEM_PARAM_U Check_param;
	 CHECK_ELEM_PARAM_CB_U Check_param_cb;
	 char Msteel_prof[10];  //       
	 double thick_range_material[2];  //     (   -  )
	 double thick_prof;  //  ,     
	 double step_edge;
	 double edge_param[3][3]; // 0 - CC; 1 - B; 2 - CB // 0 - step; 1 - br; 2 - tr;

};

void Modif_perfor(DATA_CHECK_U *data_check, SECT_DVUTAVR *sect_perfor);


//---------------------------------------------------------------------------
#endif
