//---------------------------------------------------------------------------

#pragma hdrstop

#include "Mltmm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
/*-----------------------------------------------------*/
/*                                      */
/*-----------------------------------------------------*/
/*                        */
/*-----------------------------------------------------*/
#include <stdio.h>
#include "ProcExt.h"

void mltmv0(a1,n1,m1,a2,n2,a3,n3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
double *a3;
int     n3;
{
   int i,j;
   double p;
   double *a;

   a=a1;
   for (i=0; i<n1; i++) {
       p=0;
       for (j=0; j<m1; j++) {
          p += (*a)*a2[j];
          a++;
       }
       a3[i]=p;
   }
} /* mltmv0 */
void mltmtv0(a1,n1,m1,a2,n2,a3,n3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
double *a3;
int     n3;
{
   int i,j;
   double p;
   double *a;

   for (i=0; i<m1; i++) {
       a=a1+i;
       p=0;
       for (j=0; j<n1; j++) {
          p += (*a)*a2[j];
          a += m1;
       }
       a3[i]=p;
   }
} /* mltmtv0 */
/*-----------------------------------------------------*/
/*                        */
/*-----------------------------------------------------*/
void mltmm0(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *b, *c, *c0;

   l=m1;
   m=n1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (i=0; i<m; i++) {
     c0 = a3 + i*m3;
     b=a2;
     for (k=0; k<l; k++) {
         p = *a1;
         a1++;
         c = c0;
         for (j=0; j<n; j++) {
            c[j] += p * (*b);
            b++;
         }
     }
   }
} /* mltmm0 */
/*-----------------------------------------------------*/
/*              */
/*-----------------------------------------------------*/
void mltmm2(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *b, *c, *c0;

   l=m1;
   m=n1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (i=0; i<m; i++) {
     c0 = a3 + i*m3;
     for (k=0; k<l; k++) {
         p = *a1;
         a1++;
         if (p !=0e0 ){
            c = c0;
            b=a2 + k*m2;
            for (j=0; j<n; j++) {
              c[j] += p * (*b);
              b++;
            }
         }
     }

   }
} /* mltmm2 */
/*-----------------------------------------------------*/
/*              */
/*-----------------------------------------------------*/
void mltmtm2(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *b, *c, *a;

   l=m1;
   m=n1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (i=0; i<l; i++) {
     c = a3 + i*m3;
     a = a1+i;
     for (k=0; k<m; k++) {
         p = *a;
         a += m1;
         if (p !=0e0 ){
            b = a2 + k*m2;
            for (j=0; j<n; j++) {
              c[j] += p * (*b);
              b++;
            }
         }
     }
   }
} /* mltmtm2 */
/*-----------------------------------------------------*/
/*           */
/*-----------------------------------------------------*/
void mltmtm0(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *b, *c, *a;

   l=m1;
   m=n1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (i=0; i<l; i++) {
     c = a3 + i*m3;
     a = a1+i;
     b = a2;
     for (k=0; k<m; k++) {
         p = *a;
         a += m1;
         for (j=0; j<n; j++) {
            c[j] += p * (*b);
            b++;
         }
     }
   }
} /* mltmtm0 */
/*-----------------------------------------------------*/
/*                           */
/*-----------------------------------------------------*/
void mltmtm1(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *a, *c;

   l=m1;
   m=n1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (k=0; k<m; k++) {
     a = a1 + k*m1;
     for (j=0; j<n; j++) {
         p = *a2;
         a2++;
         if (p !=0e0 ){
            c = a3 + j;
            for (i=0; i<l; i++) {
              (*c) += p * a[i];
              c += m3;
            }
         }
     }
   }
} /* mltmtm1 */
/*-----------------------------------------------------*/
/*                           */
/*-----------------------------------------------------*/
void mltmm1(a1,n1,m1,a2,n2,m2,a3,n3,m3)
double *a1;
int     n1;
int     m1;
double *a2;
int     n2;
int     m2;
double *a3;
int     n3;
int     m3;
{
   int i,j,k,l,m,n;
   double p;
   double *a, *c ;

   m=n1;
   l=m1;
   n=m2;

   initd(a3,n3*m3,0e0);

   for (k=0; k<l; k++) {
     for (j=0; j<n; j++) {
         p = *a2;
         a2++;
         if (p !=0e0 ){
            c = a3 + j;
            a = a1 + k;
            for (i=0; i<m; i++) {
              (*c) += p * (*a);
              c += m3;
              a += m1;
            }
         }
     }
   }
} /* mltmm1 */
/*-------------------------------------------------------*/
 /* Initial significanse for double array                 */
 /*-------------------------------------------------------*/
 void initd(double *array, int n, double sign)
 //double array[],sign;
 //int n;             /* Element area number */
  {
     int  i;
     for (i=0; i<n; i++)
         array[i]=sign;
  }

