//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "BalkaLoad.h"
#include "SelectMod_Param.h"
#include "ListConst.h"
#include "ProcExt.h"
#include "Data_Gen.h"
#include "message.h"
#include "Alinit.h"
#include "SelectMod_Param.h"
#include "pCanvas_func.h"
#include "alinit.h"
#include "SortP.h"
#include "TablZagr.h"
#include "String_doubleUnit.h"
#include "ZagrPlus.h"
#include "CombLoad.h"

//#include "GrapFunc.h"

//#include "OutGraphic.h"

#define MAXLENGTH   10;       //     
#define N_BREAK     1000;      //   
#define RadMoment   30;
//#define SYMBCON     L"\u02DF"
#define SYMBCON     L"\u0007"

extern bool flag_image;


static int NAddFunc;
static double koeff_add[20][20];
static int num_fun[20][20];
static int n_fun[20];
//static int Nfun_Add;
static char nfu[8*1000];
static char nfu_add[8*20];
static bool flag_add;
static double MaxFun, MinFun;
static bool flag_constr = false;  //    


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBalkaLoadFrame *BalkaLoadFrame;


//---------------------------------------------------------------------------
__fastcall TBalkaLoadFrame::TBalkaLoadFrame(TComponent* Owner)
		: TFrame(Owner)
{
	 int rc;
	 Data = new TData3;
	 Data->Color = clWhite;
	 NAddFunc=0;
	 index_portion = 0;  //   
	 Alloc_region(PORTION_REGION);
	 n_beam = 0;
	 k_beam = -1;
	 matr_result = NULL;
	 x_result = NULL;
	 Margins = 10;
	 HText = 10;
	 StepGrid = 20;

	 StringGrid_Loads->ColCount = 5;
	 StringGrid_Loads->RowCount = 1;
	 StringGrid_Loads->Rows[0]->CommaText = ", \", \", \"Q, \", \"N, \", \"My, *\"";

	 StringGrid_q->ColCount = 5;
	 StringGrid_q->RowCount = 1;
	 StringGrid_q->Rows[0]->CommaText = ", \"X1, \", \"X2, \", \"q_1, /\", \"q_2, /\"";

	 StringGrid_N->ColCount = 5;
	 StringGrid_N->RowCount = 1;
	 StringGrid_N->Rows[0]->CommaText = ", \"X1, \", \"X2, \", \"n_1, /\", \"n_2, /\"";

	 StringGrid_Constr->ColCount = 5;
	 StringGrid_Constr->RowCount = 1;
	 StringGrid_Constr->Rows[0]->CommaText = ", \", \", \"TX\", \"TZ\", \"RY\"";
	 ListBox1->Items->Clear();
	 ListBox1->Items->Add(L"  N");
	 ListBox1->Items->Add(L"  Q");
	 ListBox1->Items->Add(L"  My");
	 ListBox1->Items->Add(L" \u03B4");
	 ListBox1->Items->Add(L"  . \u03c30");
	 ListBox1->Items->Add(L"    \u03c31");
	 ListBox1->Items->Add(L"    \u03c32");

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::InitBalka(TObject *Sender)
{
	 int rc;
	 Length_beam = 0;
	 beam_mod.q_length = 0;
	 beam_mod.EI_length = 0;
	 beam_mod.loads_length = 0;
	 beam_mod.constr_length = 0;
	 beam_mod.N_length = 0;
	 if (index_portion!=0) {
		 delete(EI);
		 delete(q_);
		 delete(N_);
		 delete(loads);
		 delete(constr);
	 }
	 if (SelectMod_ParamForm==NULL)
		 Application->CreateForm(__classid(TSelectMod_ParamForm), &SelectMod_ParamForm);
	 index_portion = PORTION_REGION;
	 EI = new BeamRegion[PORTION_REGION];  //   
	 q_ = new BeamRegion[PORTION_REGION];  //    
	 N_ = new BeamRegion[PORTION_REGION];  //    
	 loads = new Load[PORTION_REGION];       //    
	 constr = new Constraint[PORTION_REGION]; //    ()
	 flag_comb = false;
	 k_beam = 0;
	 n_beam = 0;
	 n_comb = 0;
	 Edit_num_zagr->Text = "0";

	 PageControl_Load->ActivePage = TabSheet_ConcentrLoad;
	 TabSheet_Combin->TabVisible = false;
	 PageControl_BoundCond->ActivePage = TabSheet_Load0;

	 type_region = -1;
	 SelectRow = 0;
	 Len_XY = Length_beam;
	 Step_up = Len_XY;
	 Step_down = Len_XY;
	 ALLOCMAT_(Combin, 1, 1);

	 NewBalka(Sender);
	 Edit_Length->Text = FloatToStr(Length_beam);
	 if (Length_beam==0) {
		PageControl_BoundCond->Visible = false;
		PageControl_TabLoads->Visible = false;
	 }
}
//-----------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::PutParamSect(GEOM_PARAM_SECT *param_sect)
{
   I_beam = param_sect->Izz;
   F_beam = param_sect->Ar;
   H_beam = param_sect->Hsect;
   Zct_beam = param_sect->Zct;
   IE_beam = I_beam*206000;
   FE_beam = F_beam*206000;
   FRo_beam = F_beam*7850*1e-6;  // /
   for (int i=0; i<n_beam; i++) {
	 EI_v[i].begValue = EI_v[i].endValue = IE_beam;
   }

}
//-----------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::Fill_field(TObject *Sender)
{
	Edit_Length->Text = FloatToStr(Length_beam);
	ImageList1->GetBitmap(0, SpeedButton_Apply->Glyph);
	PageControl_BoundCond->Visible = true;
	PageControl_TabLoads->Visible = true;
	Edit_num_zagr->Text = IntToStr(n_beam);
	//    
	if (n_beam>0) {
	  ComboBox_num_zagr->Items->Clear();
	  for (int i=0; i<n_beam; i++)
		ComboBox_num_zagr->Items->Add(IntToStr(i+1));

	  int rc = Get_beam_data(0);
	  if (rc>0)
		return;
	}
	ComboBox_num_zagr->ItemIndex = 0;
	ComboBox_num_zagrChange(Sender);
	if (n_comb > 0) {
		flag_comb = true;
		TabSheet_Combin->TabVisible = true;
		SpeedButton_CallCombin->Glyph->Width=0;
		ImageList1->GetBitmap(0, SpeedButton_CallCombin->Glyph);
	}
	else {
        flag_comb = false;
    }
	PageControl_BoundCondChange(Sender);
	Edit_muXY->Text = FloatToStr(Len_XY);
	Edit_step_up->Text = FloatToStr(Step_up);
	Edit_step_down->Text = FloatToStr(Step_down);
}
//---------------------------------------------------------------------------
//
void __fastcall TBalkaLoadFrame::DrawOut(int nfun, int n_result, int *index)
{
	int i,j,k,m;
	int rc,n0,nSa;
    int  numr[100];
	double rez[1000];
	double *Sa;
    double **matr;
	double t0;
	double koeff;
    char str[240];
	char str0[24];
	int  flagSa;
	char funSa[24];
	double sa_max;
    TColor LineColor[]={clTeeColor, clTeeColor, clTeeColor, clTeeColor,
	clTeeColor, clTeeColor, clTeeColor, clTeeColor};
	String Title_Ax[] = {L"N, ", L"Q, ", L"My, \u00B7", L"\u03B4, ", L"\u03c30, ", L"\u03c31, ", L"\u03c32, "};


	//koeff = strtod(((AnsiString)ComboBoxKoeff->Text).c_str(),NULL);
	koeff = 1;
		Series1->LinePen->Width=CSpinEditLineWidth->Value;
		Series2->LinePen->Width=CSpinEditLineWidth->Value;
		Series3->LinePen->Width=CSpinEditLineWidth->Value;
		Series4->LinePen->Width=CSpinEditLineWidth->Value;
		Series5->LinePen->Width=CSpinEditLineWidth->Value;
		Series6->LinePen->Width=CSpinEditLineWidth->Value;
		Series7->LinePen->Width=CSpinEditLineWidth->Value;
		Series8->LinePen->Width=CSpinEditLineWidth->Value;
        if (Data->Color!=clWhite) {
		   LineColor[0]=Data->Color;
		   LineColor[1]=Data->Color;
           LineColor[2]=Data->Color;
           LineColor[3]=Data->Color;
           LineColor[4]=Data->Color;
           LineColor[5]=Data->Color;
		   LineColor[6]=Data->Color;
           LineColor[7]=Data->Color;
		}
		Series1->Clear();
		Series2->Clear();
		Series3->Clear();
		Series4->Clear();
		Series5->Clear();

	   for(i=0; i<n_result; i++) {
		  Series1->AddXY(x_result[i], matr_result[i][index[0]]*koeff,"",  LineColor[0]);
		  if (n_fun == 1) continue;
		  Series2->AddXY(x_result[i], matr_result[i][index[1]]*koeff,"",  LineColor[1]);
		  if (n_fun == 2) continue;
          Series3->AddXY(x_result[i], matr_result[i][index[2]]*koeff,"",  LineColor[2]);
          if (n_fun == 3) continue;
		  Series4->AddXY(x_result[i], matr_result[i][index[3]]*koeff,"",  LineColor[3]);
		  if (n_fun == 4) continue;
		  Series5->AddXY(x_result[i], matr_result[i][index[4]]*koeff,"",  LineColor[4]);
       }
	   Chart1->Title->Text->Clear();
	   //sprintf(str,"%s: max=%g, x=%g;  min=%g, x=%g",
	   //		   ListBox1->Items->Strings[index[0]].c_str(),
	   //		   koeff*Max_Value[index[0]], Round(Max_X[index[0]], 0),
	   //		   koeff*Min_Value[index[0]], Round(Min_X[index[0]], 0));
	   sprintf(str,", max=%g, x=%g;  min=%g, x=%g",
			   koeff*Max_Value[index[0]], Round(Max_X[index[0]], 0),
			   koeff*Min_Value[index[0]], Round(Min_X[index[0]], 0));
	   Chart1->Title->Text->Add(ListBox1->Items->Strings[index[0]]+ AnsiString(str));
	   Chart1->LeftAxis->Title->Caption = Title_Ax[index[0]];
	   Chart1->LeftAxis->Title->Angle = 0;

       Repaint();
}
//---------------------------------------------------------------------------


void __fastcall TBalkaLoadFrame::ComboBoxKoeffChange(TObject *Sender)
{
    if  (n_fun>0) {
	  DrawOut(n_fun, n_result, index_fun);
    }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::CSpinEditLineWidthChange(TObject *Sender)
{
      int j;
	  DrawOut(n_fun, n_result, index_fun);

}
//
void __fastcall TBalkaLoadFrame::BitBtn_AddClick(TObject *Sender)
{
   int rc;
   //       StringGrid_param
   InsertToGridFromText(-1);
  //       
   rc = LoadDataFromGrid_param();
   if (rc>0) return;

   //Draw_beam();
}
//-----------------------------------------------------------------------------
//    k-  
void __fastcall TBalkaLoadFrame::InsertToGridFromText(int index_row) {
   int rc, k;
   double x0, x1, p1, p2;
   double pz, px, my;
   char stroka[120];
   BeamRegion br;
   Load ld;
   Constraint cn;
   double x20;

   n_fun = 0;
   n_result = 0;

   if (type_region<=typeDistrN) {
	  switch (type_region) {
	  case typeLinearLoad:
		if (index_row<0)
		  k = StringGrid_q->RowCount - 1;
		else
		  k = index_row - 1;
	  //     x20
		if (k>0) {
		  rc = String_double_zero_plus(StringGrid_q->Cells[1][0], StringGrid_q->Cells[1][k], &x0);
		  if (rc>0) return;
		  rc = String_double_zero_plus(StringGrid_q->Cells[1][0], StringGrid_q->Cells[2][k], &x1);
		  if (rc>0) return;
		  x20 = x1;
		}
		else
		  x20 = 0;
		rc = String_double_zero_plus(Label_x0->Caption, Edit_x0->Text, &x0);
		if (rc>0) return;
		rc = String_double_zero_plus(Label_x1->Caption, Edit_Len->Text, &x1);
		if (rc>0) return;
		rc = String_double(Label_p1->Caption, Edit_p1->Text, &p1);
		if (rc>0) return;
		rc = String_double(Label_p1->Caption, Edit_p2->Text, &p2);
		if (rc>0) return;
	  break;
	  case typeDistrN:
		if (index_row<0)
		  k = StringGrid_N->RowCount - 1;
		else
		  k = index_row - 1;
	  //     x20
		if (k>0) {
		  rc = String_double_zero_plus(StringGrid_N->Cells[1][0], StringGrid_N->Cells[1][k], &x0);
		  if (rc>0) return;
		  rc = String_double_zero_plus(StringGrid_N->Cells[1][0], StringGrid_N->Cells[2][k], &x1);
		  if (rc>0) return;
		  x20 = x1;
		}
		else
		  x20 = 0;
		rc = String_double_zero_plus(Label_x0n->Caption, Edit_x0n->Text, &x0);
		if (rc>0) return;
		rc = String_double_zero_plus(Label_x1n->Caption, Edit_Len_n->Text, &x1);
		if (rc>0) return;
		rc = String_double(Label_p1->Caption, Edit_n1->Text, &p1);
		if (rc>0) return;
		rc = String_double(Label_p1->Caption, Edit_n2->Text, &p2);
		if (rc>0) return;
	  break;
	  }
	  if (x0 < x20) {
			rc = Application->MessageBox(("           ("+
										  FloatToStr(x20)+")").c_str(),
						  L" ", MB_OK | MB_ICONERROR);
			return;
	  }
	  if (x1 <= x0) {
		 rc = Application->MessageBox(("         "+
										  FloatToStr(x0)).c_str(),
						  L" ", MB_OK | MB_ICONERROR);
		 return;
	  }
	  if (type_region>typeEI) {
		if (x1 > CalcLengthBeam()) {
		  rc = Application->MessageBox(("      ,    "+FloatToStr(Length_beam)).c_str(),
						  L" ", MB_OK | MB_ICONERROR);
		  return;
		}
	  }
	  br.X0 = x0;
	  br.Len = x1-x0;
	  br.begValue = p1;
	  br.endValue = p2;

	  BeamRegionToGrid_param(type_region, br, index_row);

	  //Edit_x0->Text = FloatToStr(x0 + Len);
   }
   else {
	  double xi;
	  if (type_region==typeConcentrLoad) {
		rc = String_double_zero_plus(Label_X0Load->Caption, Edit_X0Load->Text, &x0);
		if (rc>0) return;
		rc = String_double(Label_Fz->Caption, Edit_Fz->Text, &pz);
		if (rc>0) return;
		rc = String_double(Label_Fx->Caption, Edit_Fx->Text, &px);
		if (rc>0) return;
		rc = String_double(Label_My->Caption, Edit_My->Text, &my);
		if (rc>0) return;
		if (pz == 0 && px==0 && my==0) {
			rc = ApplicationMessageBox("        ",
						  " ", MB_OK | MB_ICONERROR);
			return;
		}
		if (x0 > CalcLengthBeam()) {
		  rc = Application->MessageBox(("     ,    "+FloatToStr(Length_beam)+
										" .").c_str(), L" ", MB_OK | MB_ICONERROR);
			return;
		}

		for (int i=1; i<StringGrid_Loads->RowCount; i++) {
		  if (i==index_row)
			  continue;
		  rc = String_double_zero_plus(StringGrid_Loads->Cells[1][0], StringGrid_Loads->Cells[1][i], &xi);
		  if (rc>0) return;
		  if ((ABS(x0 - xi))<1e-3) {
		  rc = Application->MessageBox(L"        ", L" ", MB_OK | MB_ICONERROR);
			return;
		  }
		}
		ld.X = x0;
		ld.u = px;
		ld.v = pz;
		ld.c = my;
		LoadToGrid_param(ld, index_row);
	  }
	  if (type_region==typeConstraint) {
		if (!CheckBox_Tx->Checked && !CheckBox_Tz->Checked && !CheckBox_Ry->Checked) {
			rc = ApplicationMessageBox("     ",
						  " ", MB_OK | MB_ICONERROR);
			return;
		}
		rc = String_double_zero_plus(Label_X0Constr->Caption, Edit_X0Constr->Text, &x0);
		if (rc>0) return;
		if (x0 > CalcLengthBeam()) {
		  rc = Application->MessageBox(("     ,    "+FloatToStr(Length_beam)).c_str(),
						  L" ", MB_OK | MB_ICONERROR);
		  return;
		}
		for (int i=1; i<StringGrid_Constr->RowCount; i++) {
		  if (i==index_row)
			  continue;
		  rc = String_double_zero_plus(StringGrid_Constr->Cells[1][0], StringGrid_Constr->Cells[1][i], &xi);
		  if (rc>0) return;
		  if ((ABS(x0 - xi))<1e-3) {
		  rc = Application->MessageBox(L"        ", L" ", MB_OK | MB_ICONERROR);
			return;
		  }
		}
		cn.X = x0;
		if (CheckBox_Tx->Checked)
		  cn.u = 1e30;
		else
		  cn.u = 0;
		if (CheckBox_Tz->Checked)
		  cn.v = 1e30;
		else
		  cn.v = 0;
		if (CheckBox_Ry->Checked)
		  cn.c = 1e30;
		else
		  cn.c = 0;
		ConstraintToGrid_param(cn, index_row);
	  }
	}
}
//---------------------------------------------------------------------------
//   
double __fastcall TBalkaLoadFrame::CalcLengthBeam()
{
   int rc;
   double ss;

   return Length_beam;
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::BeamRegionToGrid_param(int type_region, BeamRegion br, int index_row)
{
   int k, rc;
   double x0, x1, Len;
   switch (type_region) {
   case typeLinearLoad:
	  if (index_row<0)  {  //   
		 StringGrid_q->RowCount++;
		 k = StringGrid_q->RowCount - 1;
	  }
	  else {
		 k = index_row;
	  }
	  StringGrid_q->Cells[0][k] = k;
	  StringGrid_q->Cells[1][k] = br.X0;
	  StringGrid_q->Cells[2][k] = br.X0 + br.Len;
	  StringGrid_q->Cells[3][k] = br.begValue;
	  StringGrid_q->Cells[4][k] = br.endValue;
   break;
   case typeDistrN:
	  if (index_row<0)  {  //   
		 StringGrid_N->RowCount++;
		 k = StringGrid_N->RowCount - 1;
	  }
	  else {
		 k = index_row;
	  }
	  StringGrid_N->Cells[0][k] = k;
	  StringGrid_N->Cells[1][k] = br.X0;
	  StringGrid_N->Cells[2][k] = (br.X0 + br.Len);
	  StringGrid_N->Cells[3][k] = br.begValue;
	  StringGrid_N->Cells[4][k] = br.endValue;
   break;

   }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::LoadToGrid_param(Load ld, int index_row)
{
   int k;
	  if (index_row <0) {
		StringGrid_Loads->RowCount++;
		k = StringGrid_Loads->RowCount - 1;
	  }
      else
		k = index_row;
	  StringGrid_Loads->Cells[0][k] = k;
	  StringGrid_Loads->Cells[1][k] = ld.X;
	  StringGrid_Loads->Cells[2][k] = ld.v;
	  StringGrid_Loads->Cells[3][k] = ld.u;
	  StringGrid_Loads->Cells[4][k] = ld.c;
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::ConstraintToGrid_param(Constraint cn, int index_row)
{
   int k;
	  if (index_row <0) {
		StringGrid_Constr->RowCount++;
		k = StringGrid_Constr->RowCount - 1;
      }
	  else
        k = index_row;
	  StringGrid_Constr->Cells[0][k] = k;
	  StringGrid_Constr->Cells[1][k] = cn.X;
	  if (cn.u==1e30)
		  StringGrid_Constr->Cells[3][k] = SYMBCON;
	  else
		  StringGrid_Constr->Cells[3][k] =" ";
	  if (cn.v==1e30)
		  StringGrid_Constr->Cells[2][k] = SYMBCON;
	  else
		  StringGrid_Constr->Cells[2][k] =" ";
	  if (cn.c==1e30)
		  StringGrid_Constr->Cells[4][k] = SYMBCON;
	  else
		  StringGrid_Constr->Cells[4][k] =" ";
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::CheckBox_LinearClick(TObject *Sender)
{
	if (CheckBox_Linear->Checked) {
	  Label_p2->Visible = true;
	  Edit_p2->Visible = true;
	}
	else {
	  Label_p2->Visible = false;
	  Edit_p2->Visible = false;
	  Edit_p2->Text = Edit_p1->Text;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::Edit_p1Change(TObject *Sender)
{
   if (!CheckBox_Linear->Checked) {
	  Edit_p2->Text = Edit_p1->Text;
   }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::BitBtn_CalculateClick(TObject *Sender)
{
	 //     StringGrid_param  
	 //PageControl_BoundCondChange(Sender);
     k_result = 0;
	 //    -    ComboBox_num_zagr_rezChange
	 if (beam_mod.EI_length != 0 && Length_beam > 0) {
		 Put_beam_data();
	 }
	 //-----------------------------------------------------------------
	 if (beam_mod.constr_length == 0) {
		 int rc = ApplicationMessageBox("    ",
						  " ", MB_OK | MB_ICONERROR);
		 return;
	 }

	 ListBox1->Selected[3]=true;
	 PageControl1->ActivePage = TabSheetResult;
	 //   DrawOut
	 //ListBox1Click(Sender);
	 ComboBox_num_zagr_rez->Items->Clear();
	 for (int i=0; i<n_beam; i++) {
		  ComboBox_num_zagr_rez->Items->Add(L" "+IntToStr(i+1));
	 }
	 for (int i=0; i<n_comb; i++) {
		  ComboBox_num_zagr_rez->Items->Add(L" "+IntToStr(i+1));
	 }
	 ComboBox_num_zagr_rez->ItemIndex = 0;
	 ComboBox_num_zagr_rezChange(Sender);
}
//---------------------------------------------------------------------------
//   
void __fastcall TBalkaLoadFrame::CalculateExecute(int k_beam, bool flag_out, TObject *Sender)
{

	 int rc, i;
	 char stroka[240];
	 double MaxLength;
	 int N_break;
	 double *Xsort;
	 int *index;

	 //BeamRegion* EI_0;  //   
	 //BeamRegion* q_0;  //    
	 //BeamRegion* N_0;  //    
	 //Load*    loads_0;         //    
	 //Constraint* constr_0;     //    ()

	 //EI_0 = new BeamRegion[PORTION_REGION];  //   
	 //q_0 = new BeamRegion[PORTION_REGION];  //    
	 //N_0 = new BeamRegion[PORTION_REGION];  //    
	 //loads_0 = new Load[PORTION_REGION];       //    
	 //constr_0 = new Constraint[PORTION_REGION]; //    ()

	 if (beam_mod.q_length == 0 && beam_mod.N_length == 0 && beam_mod.loads_length == 0) {
		 rc = Application->MessageBox((L"  "+IntToStr(k_beam+1)+L"       ").c_str(),
						  L" ", MB_OK | MB_ICONERROR);
		 return;
	 }

	 MaxLength = MAXLENGTH;
	 MaxLength /= L1000;
	 N_break = N_BREAK;


	   int ku = 0;
	   int kv = 0;
	   int kc = 0;
	   for (int i = 0; i<beam_mod.constr_length; i++) {
		 if (constr[i].u!=0) ku ++;
		 if (constr[i].v!=0) kv ++;
		 if (constr[i].c!=0) kc ++;
	   }
	   if (((kv >= 1 && kc >= 1) || kv >= 2) && ku>=1)
		 flag_rigid = false;
	   if (flag_rigid) {
		 rc = ApplicationMessageBox("       ",
						  " ", MB_OK | MB_ICONERROR);
		 return;
	   }
	   if (beam_mod.q_length == 0) {
		 beam_mod.q_length = 1;
		 q_[0].X0 = 0;
		 q_[0].Len = 0;
		 q_[0].begValue = 0;
		 q_[0].endValue = 0;
	   }
	   if (beam_mod.N_length == 0) {
		 beam_mod.N_length = 1;
		 N_[0].X0 = 0;
		 N_[0].Len = 0;
		 N_[0].begValue = 0;
		 N_[0].endValue = 0;
	   }
	   if (beam_mod.loads_length == 0) {
		 beam_mod.loads_length = 1;
		 loads[0].X = 0;
		 loads[0].u = 0;
		 loads[0].v = 0;
		 loads[0].c = 0;
	   }
	   if (beam_mod.constr_length == 0) {
		 beam_mod.constr_length = 1;
		 constr[0].X = 0;
		 constr[0].u = 0;
		 constr[0].v = 0;
		 constr[0].c = 0;
	   }
	 //      
	   if (beam_mod.loads_length > 1) {
		 qsortk((char*)loads, beam_mod.loads_length, sizeof(Load), (fptr)cmp_Load);
	   }
	   if (beam_mod.constr_length > 1) {
		 qsortk((char*)constr, beam_mod.constr_length, sizeof(Constraint), (fptr)cmp_Constraint);
	   }

	   //      
	   beam_mod.MultiSupportBeam_(N_break, MaxLength, H_beam, Zct_beam, I_beam, F_beam);

	   //   
	   rc = beam_mod.calculate(EI, N_, q_, loads, constr, FE_beam);          //EI[0]
	   if (rc>0) {
		  if (rc == beam_mod.ErrSingular) {
			i = ApplicationMessageBox("               1.0", " ",
				   MB_OK | MB_ICONERROR);
		  }
		  else {
			i = Application->MessageBox(("        "+IntToStr(rc)).c_str(), L" ",
				   MB_OK | MB_ICONERROR);
		  }
		  return;
	   }
	   //   
	   rc = Get_beam_data(k_beam);
	   //    
	   //int n_break = ceil(CalcLengthBeam()/MaxLength);   //     
	   int n_break = N_break;   //     
	   //GetResult(10*CalcLengthBeam()/MaxLength);
	   //GetResult(100*n_break);
	   GetResult(n_break);

	   if (flag_out) {
		 //   DrawOut -  
		 ListBox1Click(Sender);

		 PageControl1->ActivePage=TabSheetResult;

		 double Lbeam = CalcLengthBeam();
		 printExtremum(beam_mod);

		 printResult(0);
		 printResult(Lbeam/2 - 1);
		 printResult(Lbeam/2);
		 printResult(Lbeam/2 + 1);
		 printResult(Lbeam);

		 for (int i=0; i < beam_mod.constr_force_length; i++) {
		   sprintf(stroka,"    %g: Rv=%g, Rc=%g ", beam_mod.ConstrForces[i].X,
			   beam_mod.ConstrForces[i].v, beam_mod.ConstrForces[i].c );
		   InfMessage((AnsiString)stroka);
		 }
	   }
}
//---------------------------------------------------------------------------
//   -   (        )
void __fastcall TBalkaLoadFrame::NewBalka(TObject *Sender)
{
	 int i, rc;

	 n_fun = 0;
	 n_result = 0;

	 if (beam_mod.EI_length != 0 && Length_beam > 0) {
		 //   .
		 Put_beam_data();
		 //   
		 Set_type_zagr(k_beam);
		 //  . 
		 rc = String_double_plus(Label_gamma_f->Caption, Edit_gamma_f->Text, &(Koeff_gamma_f[k_beam]));
		 if (rc>0) return;
		 //   .
		 rc = String_double_plus(Label_koef_low->Caption, Edit_koef_low->Text, &(Koeff_low[k_beam]));
		 if (rc>0) return;
	 }

	 if (n_beam == MAX_BEAM_DATA) {
	   i = Application->MessageBox((L"     " + IntToStr(n_beam)).c_str(), L" ",
		  MB_OK | MB_ICONERROR);
	   return;
	 }

	 k_beam = n_beam;
	 //CheckBox_Weight->Checked = false;
	 Label_Weight->Visible = false;
	 //   
	 Set_type_zagr(k_beam);
	 //  . 
	 rc = String_double_plus(Label_gamma_f->Caption, Edit_gamma_f->Text, &(Koeff_gamma_f[k_beam]));
	 if (rc>0) return;
	 //   .
	 rc = String_double_plus_low(Label_koef_low->Caption, Edit_koef_low->Text, 1.0, &(Koeff_low[k_beam]));
	 if (rc>0) return;

	 ComboBox_num_zagr->Items->Clear();
	 for (i=0; i<=n_beam; i++) {
		ComboBox_num_zagr->Items->Add(IntToStr(i+1));
	 }

	 ComboBox_num_zagr->ItemIndex = k_beam;
	 ComboBox_num_zagr->Text = k_beam+1;

	 beam_mod.EI_length = 1;
	 beam_mod.q_length = 0;
	 beam_mod.N_length = 0;
	 beam_mod.loads_length = 0;
	 //beam_mod.constr_length = 0;
	 type_region = -1;
     if (index_portion!=0) {
		 delete(EI);
		 delete(q_);
         delete(N_);
		 delete(loads);
		 //delete(constr);
     }
     flag_rigid = true;
	 index_portion = PORTION_REGION;

	 EI = new BeamRegion[PORTION_REGION];  //   
	 EI[0].begValue = IE_beam;
	 EI[0].endValue = IE_beam;

   //EI[0].begValue = 1e9;
   //EI[0].endValue = 1e9;

	 EI[0].X0 = 0;
	 EI[0].Len = Length_beam;
	 beam_mod.EI_length = 1;

     q_ = new BeamRegion[PORTION_REGION];  //    
     N_ = new BeamRegion[PORTION_REGION];  //    
	 loads = new Load[PORTION_REGION];       //    
	 //constr = new Constraint[PORTION_REGION]; //    ()

	 //Edit_X0Constr->Text = 0;
	 //CheckBox_Tx->Checked = false;
	 //CheckBox_Tz->Checked = false;
	 //CheckBox_Ry->Checked = false;

	 Edit_X0Load->Text = 0;
	 Edit_Fz->Text = 0;
	 Edit_Fx->Text = 0;
	 Edit_My->Text = 0;
	 StringGrid_Loads->RowCount = 1;

	 Edit_x0->Text = 0;
	 Edit_Len->Text = 0;
	 Edit_p1->Text = 0;
	 Edit_p2->Text = 0;
	 StringGrid_q->RowCount = 1;

	 Edit_x0n->Text = 0;
	 Edit_Len_n->Text = 0;
	 Edit_n1->Text = 0;
	 Edit_n2->Text = 0;
	 StringGrid_N->RowCount = 1;

	 PageControl1->ActivePage = TabSheetSourse;
	 PageControl_Load->ActivePage = TabSheet_ConcentrLoad;
	 //PageControl_ParamChange(Sender);
	 PageControl_BoundCondChange(Sender);
	 CheckBox_LinearClick(Sender);
	 CheckBox_Linear_nClick(Sender);
}
//---------------------------------------------------------------------------
//       
int __fastcall TBalkaLoadFrame::LoadDataFromGrid_param()
{
   int i, k, rc;
   double F0, M0, FX, FZ, MY;
   double x0, x1, len, q1, q2;
   char stroka[240];
   double x10;

   if (type_region >=0) {
	 *A_length = 0;
	 switch (type_region) {
	 case typeLinearLoad:
	   k = StringGrid_q->RowCount - 1;
	   x10 = 0;
	   for (i=0; i<k; i++) {
		 rc = String_double_zero_plus(StringGrid_q->Cells[1][0], StringGrid_q->Cells[1][i+1], &x0);
		 if (rc>0) return rc;
		 rc = String_double_plus(StringGrid_q->Cells[2][0], StringGrid_q->Cells[2][i+1], &x1);
		 if (rc>0) return rc;
		 len = x1 - x0;
		 rc = String_double(StringGrid_q->Cells[3][0], StringGrid_q->Cells[3][i+1], &q1);
		 if (rc>0) return rc;
		 rc = String_double(StringGrid_q->Cells[4][0], StringGrid_q->Cells[4][i+1], &q2);
		 if (rc>0) return rc;
		 //Arbit[i].X0 = y0;
		 //Arbit[i].Len = len;
		 //Arbit[i].begValue = q1;
		 //Arbit[i].endValue = q2;
		 q_[i].X0 = x0;
		 q_[i].Len = len;
		 q_[i].begValue = q1;
		 q_[i].endValue = q2;
		 x10 = x0 + len;
	   }
	   //*A_length = k;
	   beam_mod.q_length = k;
	 break;
	 case typeDistrN:
	   x10 = 0;
	   k = StringGrid_N->RowCount - 1;
	   for (i=0; i<k; i++) {
		 rc = String_double_zero_plus(StringGrid_N->Cells[1][0], StringGrid_N->Cells[1][i+1], &x0);
		 if (rc>0) return rc;
		 rc = String_double_plus(StringGrid_N->Cells[2][0], StringGrid_N->Cells[2][i+1], &x1);
		 if (rc>0) return rc;
		 len = x1 - x0;
		 rc = String_double(StringGrid_N->Cells[3][0], StringGrid_N->Cells[3][i+1], &q1);
		 if (rc>0) return rc;
		 rc = String_double(StringGrid_N->Cells[4][0], StringGrid_N->Cells[4][i+1], &q2);
		 if (rc>0) return rc;
		 //Arbit[i].X0 = y0;
		 //Arbit[i].Len = len;
		 //Arbit[i].begValue = q1;
		 //Arbit[i].endValue = q2;
		 N_[i].X0 = x0;
		 N_[i].Len = len;
		 N_[i].begValue = q1;
		 N_[i].endValue = q2;
		 x10 = x0 + len;
	   }
	   //*A_length = k;
	   beam_mod.N_length = k;
	 break;
	 case typeConcentrLoad:  //  
	   k = StringGrid_Loads->RowCount - 1;
	   for (i=0; i<k; i++) {
		  rc = String_double_zero_plus(StringGrid_Loads->Cells[1][0], StringGrid_Loads->Cells[1][i+1], &x0);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[2][0], StringGrid_Loads->Cells[2][i+1], &FZ);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[3][0], StringGrid_Loads->Cells[3][i+1], &FX);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[4][0], StringGrid_Loads->Cells[4][i+1], &MY);
		  if (rc>0) return rc;
		  loads[i].X = x0;
		  loads[i].u = FX;
		  loads[i].v = FZ;
		  loads[i].c = MY;
	   }
	   beam_mod.loads_length = k;
	 break;
	 case typeConstraint:  // 
	   k = StringGrid_Constr->RowCount - 1;
	   for (i=0; i<k; i++) {
		  rc = String_double_zero_plus(StringGrid_Constr->Cells[1][0], StringGrid_Constr->Cells[1][i+1], &x0);
		  if (rc>0) return rc;
		  if (StringGrid_Constr->Cells[3][i+1]==SYMBCON)
			constr[i].u = 1e30;
		  else
			constr[i].u = 0;
		  if (StringGrid_Constr->Cells[2][i+1]==SYMBCON)
			constr[i].v = 1e30;
		  else
			constr[i].v = 0;
		  if (StringGrid_Constr->Cells[4][i+1]==SYMBCON)
			constr[i].c = 1e30;
		  else
			constr[i].c = 0;
		  constr[i].X = x0;
	   }
	   beam_mod.constr_length = k;
	 break;
	 }
   }
   return 0;
}
//---------------------------------------------------------------------------
//        
int __fastcall TBalkaLoadFrame::LoadDataFromGrid_ToText()
{
   int i, k, rc;
   double FX, FZ, MY;
   double x0, x1, len, q1, q2, n1, n2;

	i = SelectRow-1;

	switch (type_region) {
	case typeLinearLoad:
	   rc = String_double_zero_plus(StringGrid_q->Cells[1][0], StringGrid_q->Cells[1][i+1], &x0);
	   if (rc>0) return rc;
	   rc = String_double_plus(StringGrid_q->Cells[2][0], StringGrid_q->Cells[2][i+1], &x1);
	   if (rc>0) return rc;
	   len = x1 - x0;
	   rc = String_double(StringGrid_q->Cells[3][0], StringGrid_q->Cells[3][i+1], &q1);
	   if (rc>0) return rc;
	   rc = String_double(StringGrid_q->Cells[4][0], StringGrid_q->Cells[4][i+1], &q2);
	   if (rc>0) return rc;
	   Edit_x0->Text = x0;
	   Edit_Len->Text = x1;
	   Edit_p1->Text = q1;
	   Edit_p2->Text = q2;
	   if (q1 != q2) {
		 CheckBox_Linear->Checked = true;
	   }
	   else {
		 CheckBox_Linear->Checked = false;
	   }
	break;
	case typeDistrN:
	   rc = String_double_zero_plus(StringGrid_N->Cells[1][0], StringGrid_N->Cells[1][i+1], &x0);
	   if (rc>0) return rc;
	   rc = String_double_plus(StringGrid_N->Cells[2][0], StringGrid_N->Cells[2][i+1], &x1);
	   if (rc>0) return rc;
	   len = x1 - x0;
	   rc = String_double(StringGrid_N->Cells[3][0], StringGrid_N->Cells[3][i+1], &n1);
	   if (rc>0) return rc;
	   rc = String_double(StringGrid_N->Cells[4][0], StringGrid_N->Cells[4][i+1], &n2);
	   if (rc>0) return rc;
	   Edit_x0n->Text = x0;
	   Edit_Len_n->Text = x1;
	   Edit_n1->Text = n1;
	   Edit_n2->Text = n2;
	   if (n1 != n2) {
		 CheckBox_Linear_n->Checked = true;
	   }
	   else {
		 CheckBox_Linear_n->Checked = false;
	   }
	break;
	case typeConcentrLoad:
		  rc = String_double_zero_plus(StringGrid_Loads->Cells[1][0], StringGrid_Loads->Cells[1][i+1], &x0);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[2][0], StringGrid_Loads->Cells[2][i+1], &FZ);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[3][0], StringGrid_Loads->Cells[3][i+1], &FX);
		  if (rc>0) return rc;
		  rc = String_double(StringGrid_Loads->Cells[4][0], StringGrid_Loads->Cells[4][i+1], &MY);
		  if (rc>0) return rc;
		  Edit_X0Load->Text = x0;
		  Edit_Fz->Text = FZ;
		  Edit_Fx->Text = FX;
		  Edit_My->Text = MY;
	break;
	case typeConstraint:  // 
		  rc = String_double_zero_plus(StringGrid_Constr->Cells[1][0], StringGrid_Constr->Cells[1][i+1], &x0);
		  if (rc>0) return rc;
		  if (StringGrid_Constr->Cells[3][i+1]==SYMBCON) {
			constr[i].u = 1e30;
			CheckBox_Tx->Checked = true;
		  }
		  else {
			constr[i].u = 0;
			CheckBox_Tx->Checked = false;
		  }
		  if (StringGrid_Constr->Cells[2][i+1]==SYMBCON) {
			constr[i].v = 1e30;
			CheckBox_Tz->Checked = true;
		  }
		  else  {
			constr[i].v = 0;
			CheckBox_Tz->Checked = false;
		  }
		  if (StringGrid_Constr->Cells[4][i+1]==SYMBCON)  {
			constr[i].c = 1e30;
			CheckBox_Ry->Checked = true;
		  }
		  else {
			constr[i].c = 0;
			CheckBox_Ry->Checked = false;
		  }
		  Edit_X0Constr->Text = FloatToStr(x0);
	  break;
	}
	return 0;
}
//-----------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::GetRegion(int *k_zagr, int *length_q, BeamRegion **Aq, int *length_N, BeamRegion **AN,
										 int *length_loads, Load** Aloads, int *length_constr, Constraint** Aconstr) {
	 if (beam_mod.EI_length != 0 && Length_beam > 0) {           //beam_mod.loads_length  beam_mod.q_length
	//    
		 Put_beam_data();
	 }
	   *k_zagr = k_beam;
	   *Aq = q_;
	   *length_q = beam_mod.q_length;
	   *AN = N_;
	   *length_N = beam_mod.N_length;
	   *Aloads = loads;
	   *length_loads = beam_mod.loads_length;
	   *Aconstr = constr;
	   *length_constr = beam_mod.constr_length;
}
//-----------------------------------------------------------------------------
//     
void __fastcall TBalkaLoadFrame::LoadDataToGrid_param(int type_param) {
   BeamRegion  *Arbit;
   int i;
   int length;
   if (type_param >=typeEI && type_param <= typeDistrN) {
	 switch (type_param) {
	 case typeEI:
	   Arbit = EI;
	   length = beam_mod.EI_length;
	 break;
	 case typeLinearLoad:
	   Arbit = q_;
	   length = beam_mod.q_length;
	 break;
	 case typeDistrN:
	   Arbit = N_;
	   length = beam_mod.N_length;
	 break;
	 }
	 for (i=0; i<length; i++) {
		BeamRegionToGrid_param(type_region, Arbit[i], -1);
	 }
   }
   else {
	  if (type_param == typeConcentrLoad) {
		for (i=0; i<beam_mod.loads_length; i++) {
		  LoadToGrid_param(loads[i], -1);
		}
	  }
	  if (type_param == typeConstraint) {  // 
		for (i=0; i<beam_mod.constr_length; i++) {
		  ConstraintToGrid_param(constr[i], -1);
		}
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::printExtremum (MultiSupportBeam oneFE){
	char stroka[240];

	sprintf(stroka,"V max:  = %g  X = %g", oneFE.vmax.value, oneFE.vmax.XCoord);
	InfMessage((AnsiString)stroka);
	sprintf(stroka,"V min:  = %g  X = %g", oneFE.vmin.value, oneFE.vmin.XCoord);
	InfMessage((AnsiString)stroka);
	sprintf(stroka,"C max:  = %g  X = %g", oneFE.cmax.value, oneFE.cmax.XCoord);
    InfMessage((AnsiString)stroka);
	sprintf(stroka,"C min:  = %g  X = %g", oneFE.cmin.value, oneFE.cmin.XCoord);
    InfMessage((AnsiString)stroka);
    sprintf(stroka,"Q max:  = %g  X = %g", oneFE.Qmax.value, oneFE.Qmax.XCoord);
    InfMessage((AnsiString)stroka);
	sprintf(stroka,"Q min:  = %g  X = %g", oneFE.Qmin.value, oneFE.Qmin.XCoord);
    InfMessage((AnsiString)stroka);
    sprintf(stroka,"M max:  = %g  X = %g", oneFE.Mmax.value, oneFE.Mmax.XCoord);
    InfMessage((AnsiString)stroka);
    sprintf(stroka,"M min:  = %g  X = %g", oneFE.Mmin.value, oneFE.Mmin.XCoord);
    InfMessage((AnsiString)stroka);

}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::GetResult(int n_break){
    int i, rc, k, m, lres;
    double Lbeam, X;
	float del;

	m = 0;
	Lbeam = CalcLengthBeam();
	Lbeam *= L1000;
	lres = beam_mod.EI_length*n_break +
		   beam_mod.loads_length*2 +  beam_mod.constr_length*2;
    if (x_result!=NULL) {
	  FREEVEC_(x_result);
    }
	ALLOCVEC_(x_result, lres+10, float);

	for (i=0; i<beam_mod.EI_length; i++) {
	  del = EI[i].Len/n_break;
	  del *= L1000;
	  for (k=0; k<n_break; k++) {
		x_result[m] = EI[i].X0*L1000 + del*k;
        m++;
      }
	}
	for (i=0; i<beam_mod.loads_length; i++) {
		x_result[m] = loads[i].X*L1000;
		m++;
		x_result[m] = loads[i].X*L1000 + Lbeam/10000;
		m++;
    }
    for (i=0; i<beam_mod.constr_length; i++) {
		x_result[m] = constr[i].X*L1000;
        m++;
        x_result[m] = constr[i].X*L1000 + Lbeam/10000;
        m++;
    }
	qsortk((char*)x_result, m, sizeof(float), (fptr)cmpf);
	k = 0;
	for (i=1; i<m; i++) {
      if (x_result[i] > Lbeam)
         break;
	  if (x_result[k] != x_result[i]) {
         x_result[k+1] = x_result[i];
		 k++;
	  }
	}
    k++;
	// k -  
	k_result = k;
    if (matr_result!=NULL) {
	  FREEMAT_(matr_result);
    }
	//ALLOCMAT_F_(matr_result, k, 5);
	matr_result = (float**)almat_f(k, 7, &rc);
	if (rc>0) {
	   rc = Application->MessageBox(L"Error almat_f", L" ", MB_OK | MB_ICONERROR);
	   return;
	}

	for (i=0; i<7; i++) {
	  Max_Value[i] = -1e20;
	  Min_Value[i] = 1e20;
    }
	i = beam_mod.constr_force_length;
	double xR = beam_mod.ConstrForces[0].X;
	double UR = beam_mod.ConstrForces[0].u;
	double VR = beam_mod.ConstrForces[0].v;
	double CR = beam_mod.ConstrForces[0].c;
	for (i=0; i<k; i++) {
	  X = x_result[i];
	  matr_result[i][0] = beam_mod.getResults(X).N;
	  matr_result[i][1] = beam_mod.getResults(X).Q;
	  matr_result[i][2] = beam_mod.getResults(X).Mz/1000;
	  matr_result[i][3] = beam_mod.getResults(X).v;
	  matr_result[i][4] = beam_mod.getResults(X).N/F_beam;
	  matr_result[i][5] = beam_mod.getResults(X).N/F_beam - beam_mod.getResults(X).Mz*Zct_beam/I_beam;
	  matr_result[i][6] = beam_mod.getResults(X).N/F_beam + beam_mod.getResults(X).Mz*(H_beam - Zct_beam)/I_beam;
	  //matr_result[i][3] = beam_mod.getResults(X).c*57.296;
	  if (Max_Value[0] < matr_result[i][0]) {
		 Max_Value[0] = matr_result[i][0];
		 Max_X[0] = X;
	  }
	  if (Min_Value[0] > matr_result[i][0]) {
		 Min_Value[0] = matr_result[i][0];
		 Min_X[0] = X;
	  }
	  if (Max_Value[4] < matr_result[i][4]) {
		 Max_Value[4] = matr_result[i][4];
		 Max_X[4] = X;
	  }
	  if (Min_Value[4] > matr_result[i][4]) {
		 Min_Value[4] = matr_result[i][4];
		 Min_X[4] = X;
	  }
	  if (Max_Value[5] < matr_result[i][5]) {
		 Max_Value[5] = matr_result[i][5];
		 Max_X[5] = X;
	  }
	  if (Min_Value[5] > matr_result[i][5]) {
		 Min_Value[5] = matr_result[i][5];
		 Min_X[5] = X;
	  }
	  if (Max_Value[6] < matr_result[i][6]) {
		 Max_Value[6] = matr_result[i][6];
		 Max_X[6] = X;
	  }
	  if (Min_Value[6] > matr_result[i][6]) {
		 Min_Value[6] = matr_result[i][6];
		 Min_X[6] = X;
	  }
	}
	n_result = k;

	Max_Value[1] = beam_mod.Qmax.value;
	Max_X[1] = beam_mod.Qmax.XCoord;
	Min_Value[1] = beam_mod.Qmin.value;
	Min_X[1] = beam_mod.Qmin.XCoord;

	Max_Value[2] = beam_mod.Mmax.value/1000;
	Max_X[2] = beam_mod.Mmax.XCoord;
	Min_Value[2] = beam_mod.Mmin.value/1000;
	Min_X[2] = beam_mod.Mmin.XCoord;

	Max_Value[3] = beam_mod.vmax.value;
	Max_X[3] = beam_mod.vmax.XCoord;
	Min_Value[3] = beam_mod.vmin.value;
	Min_X[3] = beam_mod.vmin.XCoord;

	Max_Value[0] = Round(Max_Value[0], 0);
	Min_Value[0] = Round(Min_Value[0], 0);

	Max_Value[1] = Round(Max_Value[1], 0);
	Min_Value[1] = Round(Min_Value[1], 0);

	Max_Value[2] = Round(Max_Value[2], 0);
	Min_Value[2] = Round(Min_Value[2], 0);

	Max_Value[3] = Round(Max_Value[3], 2);
	Min_Value[3] = Round(Min_Value[3], 2);

	Max_Value[4] = Round(Max_Value[4], 1);
	Min_Value[4] = Round(Min_Value[4], 1);

	Max_Value[5] = Round(Max_Value[5], 1);
	Min_Value[5] = Round(Min_Value[5], 1);

	Max_Value[6] = Round(Max_Value[6], 1);
	Min_Value[6] = Round(Min_Value[6], 1);

	/*
	Max_Value[4] = beam_mod.cmax.value;
	Max_X[4] = beam_mod.cmax.XCoord;
	Min_Value[4] = beam_mod.cmin.value;
	Min_X[4] = beam_mod.cmin.XCoord;
    */


}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::printResult(double X){
	char stroka[240];
     sprintf(stroka,"Q=%g, M=%g, R=%g, v=%g, c=%g", (beam_mod.getResults(X)).Q, (beam_mod.getResults(X)).Mz,
			(beam_mod.getResults(X)).R, (beam_mod.getResults(X)).v, (beam_mod.getResults(X)).c);
     InfMessage("   "+FloatToStr(X)+": "+(AnsiString)stroka);
}
//    
//    
//   
void __fastcall TBalkaLoadFrame::Alloc_region(int n_reg) {
	 EI_v = (BeamRegion*)calloc(n_reg, sizeof(BeamRegion));  //   
     q_v = (BeamRegion*)calloc(n_reg, sizeof(BeamRegion));  //    
     N_v = (BeamRegion*)calloc(n_reg, sizeof(BeamRegion));  //    
	 loads_v = (Load*)calloc(n_reg, sizeof(Load));       //    
	 //constr_v = (Constraint*)calloc(n_reg, sizeof(Constraint)); //    ()
	 Len_v = n_reg;

}
//---------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::ReAlloc_region(int n_reg) {
     Len_v += n_reg;
	 realloc(EI_v, n_reg*sizeof(BeamRegion));  //   
     realloc(q_v, n_reg*sizeof(BeamRegion));  //    
	 realloc(N_v, n_reg*sizeof(BeamRegion));  //    
	 realloc(loads_v, n_reg*sizeof(Load));       //    
	 //realloc(constr_v, n_reg*sizeof(Constraint)); //    ()
}
//---------------------------------------------------------------------------
//   
void __fastcall TBalkaLoadFrame::Free_region() {
     free(EI_v);
     free(q_v);
	 free(N_v);
	 free(loads_v);
	 //free(constr_v);
}
//---------------------------------------------------------------------------
//    
//    
void __fastcall TBalkaLoadFrame::CheckRegion_at_Put(BeamRegion *P_v, int iP, int P_length, int k, int nP) {
   int i, shift;
   int iP_v = index_beam[k][nP];

   if (iP + P_length != iP_v) {
	  shift = iP + P_length - iP_v;
	  // 
	  memcpy(P_v + iP_v + shift, P_v + iP_v, sizeof(BeamRegion)*(index_portion - (iP + iP_v + shift)));
	  for (i = k; i<n_beam; i++)
		index_beam[i][nP] += shift;
   }
}
//---------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::CheckLoad_at_Put(Load *loads_v, int ild, int loads_length, int k, int nP) {
   int i, shift;

   if (ild + loads_length > index_beam[k][nP]) {
	  shift = ild + loads_length - index_beam[k][nP];
	  // 
	  for (i = index_beam[n_beam-1][nP]-1; i >= index_beam[k][nP]; i--) {
		memcpy(loads_v + i + shift, loads_v + i, sizeof(Load));
	  }
	  for (i = k_beam + 1; i<n_beam; i++)
         index_beam[i][nP] += shift;
   }
}
//---------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::CheckConstraint_at_Put(Constraint *P_v, int iP, int P_length, int k, int nP) {
   int i, shift;

   if (iP + P_length > index_beam[k][nP]) {
	  shift = iP + P_length - index_beam[k][nP];
	  // 
	  for (i = index_beam[k_beam-1][nP]-1; i >= index_beam[k][nP]; i--) {
		memcpy(P_v+i+shift, P_v+i, sizeof(Constraint));
	  }
   }
}
//---------------------------------------------------------------------------
//    
int __fastcall TBalkaLoadFrame::Put_beam_data() {
   int i, k, rc;
   int iEI, iq_, iN_, ild;
   //int icn, irep;

   k = k_beam;  //  

   if (k==0) {
	 iEI = 0;
	 iq_ = 0;
	 iN_ = 0;
	 ild = 0;
	 //icn = 0;
   }
   else {
	 iEI = index_beam[k-1][0];
	 iq_ = index_beam[k-1][1];
	 iN_ = index_beam[k-1][4];
	 ild = index_beam[k-1][5];
	 //icn = index_beam[k-1][6];
   }
   AnsiString text = "";
rep:
   if (iq_ + beam_mod.q_length > Len_v)
	  text = " ";
   if (iN_ + beam_mod.N_length > Len_v)
	  text = " ";
   if (ild + beam_mod.loads_length > Len_v)
	  text = "";
   if (text!="") {
	   i = Application->MessageBox((L"  .   "+text+"   "+
								   IntToStr(Len_v)).c_str(), L" ",
								   MB_OK | MB_ICONERROR);
		  return 1;
   }

   // ,      -  
   //CheckRegion_at_Put(EI_v, iEI, beam_mod.EI_length, k, 0);
   //
   CheckRegion_at_Put(q_v, iq_, beam_mod.q_length, k, 1);
   CheckRegion_at_Put(N_v, iN_, beam_mod.N_length, k, 4);
   CheckLoad_at_Put(loads_v, ild, beam_mod.loads_length, k, 5);
   //
   //CheckConstraint_at_Put(constr_v, icn, beam_mod.constr_length, k, 6);

   EI[0].begValue = IE_beam;
   EI[0].endValue = IE_beam;

   memcpy(EI_v+iEI, EI, sizeof(BeamRegion)*beam_mod.EI_length);
   memcpy(q_v+iq_, q_, sizeof(BeamRegion)*beam_mod.q_length);
   memcpy(N_v+iN_, N_, sizeof(BeamRegion)*beam_mod.N_length);
   memcpy(loads_v+ild, loads, sizeof(Load)*beam_mod.loads_length);
   //memcpy(constr_v+icn, constr, sizeof(Constraint)*beam_mod.constr_length);

   index_beam[k][0] = iEI + beam_mod.EI_length;        // 
   index_beam[k][1] = iq_ + beam_mod.q_length;
   index_beam[k][4] = iN_ + beam_mod.N_length;
   index_beam[k][5] = ild + beam_mod.loads_length;
   //index_beam[k][6] = icn + beam_mod.constr_length;

   //   
   Set_type_zagr(k_beam);
   //  . 
   rc = String_double_plus(Label_gamma_f->Caption, Edit_gamma_f->Text, &(Koeff_gamma_f[k_beam]));
   if (rc>0) return rc;
   //   .
   rc = String_double_plus(Label_koef_low->Caption, Edit_koef_low->Text, &(Koeff_low[k_beam]));
   if (rc>0) return rc;

   n_beam = MAX(n_beam, k+1);
   return 0;
}
//---------------------------------------------------------------------------
//    
int __fastcall TBalkaLoadFrame::Get_beam_data(int k) {
   int iEI, iq_, iN_, ild;
   //int icn;
   if (k > n_beam-1)
	  return 1;
   if (k==0) {
	 iEI = 0;
	 iq_ = 0;
	 iN_ = 0;
	 ild = 0;
	 //icn = 0;
   }
   else {
	 iEI = index_beam[k-1][0];
	 iq_ = index_beam[k-1][1];
	 iN_ = index_beam[k-1][4];
	 ild = index_beam[k-1][5];
	 //icn = index_beam[k-1][6];
   }
   beam_mod.EI_length = index_beam[k][0] - iEI;
   beam_mod.q_length = index_beam[k][1] - iq_;
   beam_mod.N_length = index_beam[k][4] - iN_;
   beam_mod.loads_length = index_beam[k][5] - ild;
   //beam_mod.constr_length = index_beam[k][6] - icn;

   memcpy(EI, EI_v+iEI, sizeof(BeamRegion)*beam_mod.EI_length);
   memcpy(q_, q_v+iq_, sizeof(BeamRegion)*beam_mod.q_length);
   memcpy(N_, N_v+iN_, sizeof(BeamRegion)*beam_mod.N_length);
   memcpy(loads, loads_v+ild, sizeof(Load)*beam_mod.loads_length);
   //memcpy(constr, constr_v+icn, sizeof(Constraint)*beam_mod.constr_length);

   //   
   ComboBox_type_zagr->ItemIndex = type_zagr[k];
   //  . 
   Edit_gamma_f->Text = FloatToStr(Koeff_gamma_f[k]);
   //   .
   Edit_koef_low->Text = FloatToStr(Koeff_low[k]);
   //      
   if (flag_weight[k])
	  Label_Weight->Visible = true;
   else
	  Label_Weight->Visible = false;
   //CheckBox_Weight->Checked = flag_weight[k];
   return 0;
}
//---------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::BitBtnDeleteClick(TObject *Sender)
{
	int i, k1, k0, j0, j;
	double x00, x0, x1, p1, p2, Len;
    char stroka[240];
    int rc;

	n_fun = 0;
	n_result = 0;
	switch (type_region) {
	case typeLinearLoad:
	k1 = SelectRow;
	k0 = StringGrid_q->RowCount;
	j0 = 5;
	if (k1>0) {
		for (i = k1+1; i<k0; i++) {
		  for (j=1; j<j0; j++) {
			StringGrid_q->Cells[j][i-1] = StringGrid_q->Cells[j][i];
		  }
		}
		StringGrid_q->RowCount--;
	}
	*A_length = StringGrid_q->RowCount-1;
	break;
	case typeDistrN:
	k1 = SelectRow;
	k0 = StringGrid_N->RowCount;
	j0 = 5;
	if (k1>0) {
		for (i = k1+1; i<k0; i++) {
		  for (j=1; j<j0; j++) {
			StringGrid_N->Cells[j][i-1] = StringGrid_N->Cells[j][i];
		  }
		}
		StringGrid_N->RowCount--;
	}
	*A_length = StringGrid_q->RowCount-1;
	break;
	case typeConcentrLoad:
	k1 = SelectRow;
	k0 = StringGrid_Loads->RowCount;
	j0 = 5;
	if (k1>0) {
		for (i = k1+1; i<k0; i++) {
		  for (j=1; j<j0; j++) {
			StringGrid_Loads->Cells[j][i-1] = StringGrid_Loads->Cells[j][i];
		  }
		}
		StringGrid_Loads->RowCount--;
	}
	*A_length = StringGrid_Loads->RowCount-1;
	break;
	case typeConstraint:
	k1 = SelectRow;
	k0 = StringGrid_Constr->RowCount;
	j0 = 5;
	if (k1>0) {
		for (i = k1+1; i<k0; i++) {
		  for (j=1; j<j0; j++) {
			StringGrid_Constr->Cells[j][i-1] = StringGrid_Constr->Cells[j][i];
		  }
		}
		StringGrid_Constr->RowCount--;
	}
	*A_length = StringGrid_Constr->RowCount-1;
	break;
	}
	rc = LoadDataFromGrid_param();
	if (rc>0) return;
	//    
	   Put_beam_data();

	//Draw_beam();
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::StringGrid_LoadsSelectCell(
      TObject *Sender, int ACol, int ARow, bool &CanSelect)
{
	  int rc;
	  SelectRow = ARow;
	  if (ARow>0) {
	  //      
		 rc = LoadDataFromGrid_ToText();
	  }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::Draw_beam() {
  float scale, scale_force, scale_kp, scale_q, scale_m, scale_N, Value;
  int i;
  double Width, Height;
  double L_beam, H_beam, H_beam1, H_beam2, B_beam, I_beam;
  TPoint points[10];
  TPoint vert[13];
  double zero_px, zero_py;


//     
  Width = Image1->Width;
  Height = Image1->Height;

  L_beam = CalcLengthBeam();
  if (L_beam==0)
	return;

  H_beam = L_beam/30;
  I_beam = 0;
  for (i=0; i<beam_mod.EI_length; i++) {
	I_beam = MAX(I_beam, EI[i].begValue);
	I_beam = MAX(I_beam, EI[i].endValue);
  }
  if (I_beam==0)
    return;
  //B_beam = 12*I_beam/(pow(H_beam, 3.0));
  B_beam = 12*I_beam/(pow(H_beam, 2.0));
  scale = (Width - 60)/L_beam;

  //---------------------------------------------------
  Value = 0;
  for (i=0; i<beam_mod.loads_length; i++) {
     Value = MAX(Value, (ABS(loads[i].v)));
  }
  if (Value!=0)
     scale_force = (Height - 30)/(2*Value);
  else
	 scale_force = 0;
  //---------------------------------------------------
  Value = 0;
  for (i=0; i<beam_mod.q_length; i++) {
     Value = MAX(Value, (ABS(q_[i].begValue)));
     Value = MAX(Value, (ABS(q_[i].endValue)));
  }
  if (Value!=0)
	 scale_q = (Height - 30)/(4*Value);
  else
	 scale_q = 0;
  //---------------------------------------------------
  Value = 0;
  for (i=0; i<beam_mod.N_length; i++) {
	 Value = MAX(Value, (ABS(N_[i].begValue)));
	 Value = MAX(Value, (ABS(N_[i].endValue)));
  }
  if (Value!=0)
	 scale_N = (Height - 30)/(7*Value);
  else
     scale_N = 0;

  TRect NewRect = Rect(0, 0, Width, Height);

  pBrush_Color(Image1, clGray);
  //pBrush_Color(Image1, clBlack);
  pCanvas_FillRect(Image1, NewRect);
  zero_px = 30;
  zero_py = Height/2;
  //  
  pBrush_Color(Image1, clGreen);
  pPen_Color(Image1, clLime);
  for (i=0; i<beam_mod.EI_length; i++) {
	H_beam1 = sqrt(12*EI[i].begValue/B_beam);
	H_beam2 = sqrt(12*EI[i].endValue/B_beam);
    //H_beam1 = pow(12*EI[i].begValue/B_beam, 1/3.0);
    //H_beam2 = pow(12*EI[i].endValue/B_beam, 1/3.0);
	points[0] = Point(zero_px+EI[i].X0*scale, zero_py-H_beam1*scale/2);
    points[1] = Point(points[0].x, zero_py+H_beam1*scale/2);
    points[2] = Point(points[0].x+EI[i].Len*scale, zero_py+H_beam2*scale/2);
	points[3] = Point(points[2].x, zero_py-H_beam2*scale/2);
    points[4] = points[0];
    pCanvas_Polygon(Image1, points, 4);
  }
  pPen_Color(Image1, clWhite);
  points[0] = Point(zero_px, zero_py);
  points[1] = Point(points[0].x + L_beam*scale, zero_py);
  pCanvas_Polyline(Image1, points, 1);
  //    
  for (i=0; i<beam_mod.N_length; i++) {
    Draw_N(clNavy, clSkyBlue, N_, zero_px, zero_py, i, scale, scale_N, 40.0);
  }
  //  
  for (i=0; i<beam_mod.constr_length; i++) {
	Draw_opora(zero_px, zero_py, i, scale);
  }
  //   
  for (i=0; i<beam_mod.loads_length; i++) {
	Draw_load(zero_px, zero_py, i, scale, scale_force);
  }
  //    
  for (i=0; i<beam_mod.q_length; i++) {
	Draw_q_or_kp("q=",clRed, 1.0, q_, zero_px, zero_py, i, scale, scale_q, 40.0);
  }
}
//-------------------------------------------------------------
#define  CONST_OPORA  21
void __fastcall TBalkaLoadFrame::Draw_opora(double zero_px, double zero_py, int i, float scale ) {
  TPoint points[10];
  TPoint point_0;

  point_0 = Point(zero_px + constr[i].X*scale, zero_py);
  //  
  pBrush_Color(Image1, clLtGray);
  pPen_Color(Image1, clBlue);
  if (constr[i].v!=0 && constr[i].c!=0) {  // 
	points[0] = Point(point_0.x, point_0.y - CONST_OPORA);
    points[1] = Point(point_0.x, point_0.y + CONST_OPORA);
    pCanvas_Polyline(Image1, points, 1);
    Shtrih(points, 7.0, -1.0, 1.0);
  }
  if (constr[i].v!=0 && constr[i].c==0) {  //  
    points[0] = Point(point_0.x, point_0.y);
	points[1] = Point(points[0].x + CONST_OPORA*0.5, point_0.y + CONST_OPORA);
	points[2] = Point(points[0].x - CONST_OPORA*0.5, point_0.y + CONST_OPORA);
    points[3] = points[0];
    pCanvas_Polygon(Image1, points, 3);
    Shtrih(points+1, 7.0, -1.0, 1.0);
  }
  if (constr[i].v==0 && constr[i].c!=0) {  //
    points[0] = Point(point_0.x - 5 , point_0.y - CONST_OPORA);
    points[1] = Point(point_0.x - 5 , point_0.y + CONST_OPORA);
    pCanvas_Polyline(Image1, points, 1);
    Shtrih(points, 7.0, -1.0, 1.0);

    points[0] = Point(point_0.x + 5 , zero_py - CONST_OPORA);
    points[1] = Point(point_0.x + 5 , zero_py + CONST_OPORA);
	pCanvas_Polyline(Image1, points, 1);
    Shtrih(points, 7.0, 1.0, 1.0);
  }
  pCanvas_Ellipse(Image1, point_0.x+3, point_0.y+3, point_0.x-3, point_0.y-3);
}
//-------------------------------------------------------------
// 
void __fastcall TBalkaLoadFrame::Shtrih(TPoint *points, float s_s, float mx, float my) {
    // points -  
	// s_s -  
    // mx, my: +1  -1  - ,   
    float delx, dely;
	int k;
    TPoint vert[2];
    float l_s;

	delx = points[1].x - points[0].x;
    dely = points[1].y - points[0].y;
    l_s = sqrt(delx*delx + dely*dely);

    for (k=0; k < l_s; k += s_s) {
      vert[0] = Point(points[0].x + delx*k/l_s, points[0].y + dely*k/l_s);
      vert[1] = Point(vert[0].x + mx*s_s, vert[0].y +my*s_s);
      pCanvas_Polygon(Image1, vert, 1);
    }
}
//------------------------------------------------------------------------------------------------------
//   
void __fastcall TBalkaLoadFrame::Draw_load(double zero_px, double zero_py, int i, float scale, float scale_load) {
  TPoint points[10];
  TPoint vert[10];
  TPoint point_0;
  int X1, X2, X3, X4, Y1, Y2, Y3, Y4;

	pPen_Color(Image1, clMaroon);
    pBrush_Color(Image1, clMaroon);
    pBrush_Style(Image1, bsClear);

    point_0 = Point(zero_px + loads[i].X*scale, zero_py);

    if (loads[i].v!=0) {
	  points[0] = point_0;
      points[1] = Point(point_0.x, point_0.y - loads[i].v*scale_load);
      CoorAx.PutArrow(points, 0, MAX_PIC);
      CoorAx.SetArrow();

      pPen_Width(Image1, 1);;
      pCanvas_Polyline(Image1, CoorAx.LArrow, 2);
	  pCanvas_Polyline(Image1, CoorAx.Ar, 3);
      pFont_Color(Image1, clWhite);
      pCanvas_TextOut(Image1, points[1].x+2, points[1].y, "Py="+FloatToStr(loads[i].v));
      pBrush_Style(Image1, bsSolid);
    }
    if (loads[i].c!=0) {

	  X1 = point_0.x - RadMoment;
      Y1 = point_0.y - RadMoment;
      X2 = point_0.x + RadMoment;
	  Y2 = point_0.y + RadMoment;
      X3 = point_0.x;
      Y3 = point_0.y + RadMoment;
      X4 = point_0.x;
	  Y4 = point_0.y - RadMoment;
      vert[2] = Point(X1, Y1);
      vert[3] = Point(X2, Y2);
      vert[0] = Point(X3, Y3);
      vert[1] = Point(X4, Y4);
      if (loads[i].c < 0) {
        points[0] = Point(X2, Y2 - 5);
        points[1] = Point(X3, Y3);
	  }
	  else {
        points[0] = Point(X2, Y1 + 5);
        points[1] = Point(X4, Y4);
	  }
      CoorAx.PutArrow(points, 0, MAX_PIC);
      CoorAx.SetArrow();

	  pPen_Width(Image1, 1);;
      pCanvas_Arc(Image1, vert, vert + 2);
      pBrush_Style(Image1, bsSolid);
      pCanvas_Ellipse(Image1, point_0.x - 2, point_0.y - 2, point_0.x + 2, point_0.y + 2);
      pBrush_Color(Image1, clMaroon);
      pCanvas_Polygon(Image1, CoorAx.Ar, 3);
	  pCanvas_Ellipse(Image1, point_0.x - 2, point_0.y - 2, point_0.x + 2, point_0.y + 2);
      pFont_Color(Image1, clWhite);
      pBrush_Style(Image1, bsClear);
	  pCanvas_TextOut(Image1, points[1].x + 5, points[1].y + 2, "Mz="+FloatToStr(loads[i].c));
      pBrush_Style(Image1, bsSolid);
    }
}
//----------------------------------------------------------------------------------------------------
//      
void __fastcall TBalkaLoadFrame::Draw_q_or_kp(AnsiString Name, TColor color, float mult, BeamRegion* Ar, double zero_px, double zero_py, int i, float scale, float scale_load, float step) {
  TPoint points[10];
  TPoint vert[10];
  TPoint point_0;
  TPoint point_1;
  TPoint point_d;
  int k, n;
  float del;

    if (Ar[i].begValue==0 && Ar[i].endValue==0)
	   return;
    pPen_Color(Image1, color);
    pBrush_Style(Image1, bsClear);

    point_0 = Point(zero_px + Ar[i].X0*scale, zero_py);
    point_1 = Point(point_0.x + Ar[i].Len*scale, zero_py);
    n = ceil(Ar[i].Len*scale/step);

    points[0] = point_0;
    points[1] = Point(point_0.x, point_0.y - mult*Ar[i].begValue*scale_load);
	del = (Ar[i].endValue - Ar[i].begValue)*scale_load;
    for (k=0; k <=n ; k++) {

	  vert[0] = Point(point_0.x + k*Ar[i].Len*scale/n, point_0.y);
	  vert[1] = Point(vert[0].x, points[1].y - mult*del*k/n);
	  if (mult == -1) {  // 
        point_d = vert[0];
        vert[0] = vert[1];
        vert[1] = point_d;
      }
      CoorAx.PutArrow(vert, 0, MAX_PIC);
	  CoorAx.SetArrow();

      pPen_Width(Image1, 1);
      pCanvas_Polyline(Image1, CoorAx.LArrow, 2);
	  pCanvas_Polyline(Image1, CoorAx.Ar, 3);
    }
    if (mult == -1) {
       points[2] = vert[0];
    }
    else
       points[2] = vert[1];
    pCanvas_Polyline(Image1, points+1, 1);
    if (mult == -1) {
      Shtrih(points+1, 10.0, -1.0, 1.0);
    }

	pFont_Color(Image1, clWhite);
    pCanvas_TextOut(Image1, points[1].x+2, points[1].y, Name+FloatToStr(Ar[i].begValue));
	pBrush_Style(Image1, bsSolid);
}
//----------------------------------------------------------------------------------------------------
//    
void __fastcall TBalkaLoadFrame::Draw_N(TColor colorPen, TColor colorBrush, BeamRegion* Ar, double zero_px, double zero_py, int i, float scale, float scale_load, float step) {
  TPoint vert[10];
  TPoint point_0;
  TPoint point_1;
  int n, k;

    if (Ar[i].begValue==0 && Ar[i].endValue==0)
       return;
    pPen_Color(Image1, colorPen);
    pBrush_Color(Image1, colorBrush);

	point_0 = Point(zero_px + Ar[i].X0*scale, zero_py);
    point_1 = Point(point_0.x + Ar[i].Len*scale, zero_py);

    vert[0] = point_0;
    vert[1] = Point(point_0.x, point_0.y - Ar[i].begValue*scale_load);
    vert[2] = Point(point_0.x + Ar[i].Len*scale, vert[1].y);
	vert[3] = Point(vert[2].x, point_1.y);
    vert[4] = vert[0];
    //pCanvas_Polygon(Image1, vert, 4);
    pCanvas_Polyline(Image1, vert, 4);
    n = ceil(Ar[i].Len*scale/step);
    for (k=1; k<n; k++) {
      vert[2] = Point(point_0.x + k*Ar[i].Len*scale/n, vert[0].y);
	  vert[3] = Point(vert[2].x, vert[1].y);
	  pCanvas_Polyline(Image1, vert+2, 1);
    }

	pBrush_Style(Image1, bsClear);
    pFont_Color(Image1, clWhite);
    pCanvas_TextOut(Image1, vert[1].x+2, vert[1].y, "N="+FloatToStr(Ar[i].begValue));
    pBrush_Style(Image1, bsSolid);
}
//--------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::BitBtn_InsertClick(TObject *Sender)
{
	int rc;
	rc = LoadDataFromGrid_param();
	if (rc>0) return;

	//Draw_beam();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::ListBox1Click(TObject *Sender)
{
	 int i,j;

	 for (i=0, j=0; i<7; i++) {
		 if (ListBox1->Selected[i]==true) {
		   index_fun[j] = i;
		   //if (i>0)
		   //	 index_fun[j] = i - 1;
		   //else
		   //	 index_fun[j] = 4;
		   j++;
         }
	 }
	 n_fun = j;
     if (n_fun > 0) {
		DrawOut(n_fun, n_result, index_fun);
	 }

}
//---------------------------------------------------------------------------


void __fastcall TBalkaLoadFrame::BitBtnOutEMFClick(TObject *Sender)
{
      char *ch;
	  char str[240];
      int  i,rc;
      FILE *fp;

      strcpy(str,Data->Variant.c_str());
      for (i=strlen(str)-1; i>=0; i--)
         if (str[i]=='\\') break;
      ch=strchr(str+i+1,(int)'.');
      if (ch==NULL) ch=str+i+1;
      for (i=0; i<100; i++) {
        sprintf(ch,"%.2d.emf",i);
        fp=fopen(str,"rb");
        if (fp==NULL)
		  break;
		fclose(fp);
	  }
      Chart1->SaveToMetafileEnh(str);

}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::BitBtn_ReplaceClick(TObject *Sender)
{
   double x00;
   int i, rc;
   double Len;

   if (SelectRow<=0) {
	   rc = ApplicationMessageBox("   ",
                          " ", MB_OK | MB_ICONERROR);
        return;
   }
   //     
   InsertToGridFromText(SelectRow);

	rc = LoadDataFromGrid_param();
	if (rc>0) return;

	//Draw_beam();
}
//---------------------------------------------------------------------------
 /*-------------------------------------------------------------------*/
 /*             */
 /*   ,    =0;            */
 /*    :                                          */
 /*         -1   -  "" ;                    */
 /*          0   - "";                                   */
 /*          1   -  "" .                    */
 /*-------------------------------------------------------------------*/
int   cmp_Load(Load *elem1, Load *elem2)
{
	   if ( elem1->X > elem2->X)
		  return 1;
	   if ( elem1->X < elem2->X)
          return -1;
	   else
          return 0;
}
 /*-------------------------------------------------------------------*/
 /*             */
 /*   ,    =0;            */
 /*    :                                          */
 /*         -1   -  "" ;                    */
 /*          0   - "";                                   */
 /*          1   -  "" .                    */
 /*-------------------------------------------------------------------*/
int   cmp_Constraint(Constraint *elem1, Constraint *elem2)
{
       if ( elem1->X > elem2->X)
          return 1;
	   if ( elem1->X < elem2->X)
		  return -1;
	   else
		  return 0;
}

void __fastcall TBalkaLoadFrame::Edit_n1Change(TObject *Sender)
{
   if (!CheckBox_Linear_n->Checked) {
	  Edit_n2->Text = Edit_n1->Text;
   }

}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::CheckBox_Linear_nClick(TObject *Sender)
{
	if (CheckBox_Linear_n->Checked) {
	  Label_n2->Visible = true;
	  Edit_n2->Visible = true;
	}
	else {
	  Label_n2->Visible = false;
	  Edit_n2->Visible = false;
	  Edit_n2->Text = Edit_n1->Text;
	}

}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButtonConstrFixClick(TObject *Sender)
{
   if (SpeedButtonConstrFix->Down) {
	 flag_constr = true;
	 CheckBox_Tx->Checked = true;
	 CheckBox_Tz->Checked = true;
	 CheckBox_Ry->Checked = true;
   }
   flag_constr = false;
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButtonConstrPinClick(TObject *Sender)
{
   if (SpeedButtonConstrPin->Down) {
	 flag_constr = true;
	 CheckBox_Tx->Checked = true;
	 CheckBox_Tz->Checked = true;
	 CheckBox_Ry->Checked = false;
   }
   flag_constr = false;

}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButtonConstrZClick(TObject *Sender)
{
   if (SpeedButtonConstrZ->Down) {
	 flag_constr = true;
	 CheckBox_Tx->Checked = false;
	 CheckBox_Tz->Checked = true;
	 CheckBox_Ry->Checked = false;
   }
   flag_constr = false;

}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButtonFreeClick(TObject *Sender)
{
   if (SpeedButtonFree->Down) {
	 flag_constr = true;
	 CheckBox_Tx->Checked = false;
	 CheckBox_Tz->Checked = false;
	 CheckBox_Ry->Checked = false;
   }
   flag_constr = false;
}
//---------------------------------------------------------------------------


void __fastcall TBalkaLoadFrame::CheckBox_TxClick(TObject *Sender)
{
   if (!flag_constr) {
	 SpeedButtonConstrFix->Down=false;
	 SpeedButtonConstrPin->Down=false;
	 SpeedButtonConstrZ->Down=false;
	 SpeedButtonFree->Down=false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::PageControl_BoundCondChange(TObject *Sender)
{
	if (PageControl_BoundCond->ActivePage==TabSheet_Constr) {
	   type_region = typeConstraint;
	   //------------------------------------------------------------
	   //  
	   ChangeRegion(type_region, Sender);
	}
	if (PageControl_BoundCond->ActivePage==TabSheet_Load0) {
	   //-----------------------------------------------------------------
	   PageControl_LoadChange(Sender);     //       ChangeRegion
	}
	if (PageControl_BoundCond->ActivePage==TabSheet_Combin) {
	   int i, j;
	   AnsiString ind;
	   StringGrid_Combin->ColCount = n_beam + 1;
	   StringGrid_Combin->RowCount = 1;
	   StringGrid_Combin->Cells[0][0] = " .";
	   for (i=1; i<StringGrid_Combin->ColCount; i++) {
		  if (type_zagr[i-1]==zagrCONSTANT)
			ind = " C";
		  if (type_zagr[i-1]==zagrTEMPORAR)
			ind = " L";
		  if (type_zagr[i-1]==zagrTRANSIST)
			ind = " S";
		  StringGrid_Combin->Cells[i][0] = IntToStr(i) + ind;
	   }
	   if (flag_comb) {
		 StringGrid_Combin->RowCount = n_comb + 1;
		 for (i=1; i<StringGrid_Combin->RowCount; i++) {
			 StringGrid_Combin->Cells[0][i] = IntToStr(i);
			 for (j=1; j<StringGrid_Combin->ColCount; j++)
			   StringGrid_Combin->Cells[j][i] = FloatToStr(Combin[i-1][j-1]);
		 }
	   }

	}

}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::PageControl_LoadChange(TObject *Sender)
{
	if (PageControl_Load->ActivePage==TabSheet_ConcentrLoad) {
	  type_region = typeConcentrLoad;
	}
	if (PageControl_Load->ActivePage==TabSheet_LinearLoad) {
	  type_region = typeLinearLoad;
	}
	if (PageControl_Load->ActivePage==TabSheet_DistrN) {
	  type_region = typeDistrN;
	}
	//-----------------------------------------------------------------------
	//  
	ChangeRegion(type_region, Sender);
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::ChangeRegion(int type_region, TObject *Sender)
{
   int i;

	 TabSheet_N_Loads->TabVisible = false;
	 TabSheet_LinLoads->TabVisible = false;
	 TabSheet_ConcLoads->TabVisible = false;
	 TabSheet_Constraints->TabVisible = false;

	 switch (type_region) {
	 case typeLinearLoad:
	   Arbit = q_;
	   A_length = &beam_mod.q_length;
	   TabSheet_LinLoads->TabVisible = true;
	 break;
	 case typeDistrN:
	   Arbit = N_;
	   A_length = &beam_mod.N_length;
	   TabSheet_N_Loads->TabVisible = true;
	 break;
	 case typeConcentrLoad:
	   A_length = &beam_mod.loads_length;
	   TabSheet_ConcLoads->TabVisible = true;
	 break;
	 case typeConstraint:
	   A_length = &beam_mod.constr_length;
	   TabSheet_Constraints->TabVisible = true;
	   for (i=0; i<beam_mod.constr_length; i++) {
		   ConstraintToGrid_param(constr[i], -1);
	   }
	 break;
	 }
	 //Draw_beam();

}
//--------------------------------------------------------------------------
//
void __fastcall TBalkaLoadFrame::ComboBox_num_zagrChange(TObject *Sender)
{
	 int i;
	 //-------------------------------------------------------------------
	 PageControl_BoundCondChange(Sender);

	 int k = ComboBox_num_zagr->ItemIndex;

	 if (beam_mod.EI_length != 0 && Length_beam > 0) {           //beam_mod.loads_length  beam_mod.q_length
		//    
		 Put_beam_data();
	 }

	 if (n_beam == MAX_BEAM_DATA) {
	   int i = Application->MessageBox(L"    .", L" ",
		  MB_OK | MB_ICONERROR);
	   return;
	 }
	 Edit_X0Load->Text = 0;
	 Edit_Fz->Text = 0;
	 Edit_Fx->Text = 0;
	 Edit_My->Text = 0;
	 StringGrid_Loads->RowCount = 1;

	 Edit_x0->Text = 0;
	 Edit_Len->Text = 0;
	 Edit_p1->Text = 0;
	 Edit_p2->Text = 0;
	 StringGrid_q->RowCount = 1;

	 Edit_x0n->Text = 0;
	 Edit_Len_n->Text = 0;
	 Edit_n1->Text = 0;
	 Edit_n2->Text = 0;
	 StringGrid_N->RowCount = 1;


	 //    
	 int rc = Get_beam_data(k);
	 if (rc>0)
		return;

	 type_region = -1;
	 for (i=0; i<beam_mod.N_length; i++) {
			StringGrid_N->Cells[0][i+1]= IntToStr(i+1);
			StringGrid_N->Cells[1][i+1]= FloatToStr(N_[i].X0);
			StringGrid_N->Cells[2][i+1]= FloatToStr(N_[i].X0 + N_[i].Len);
			StringGrid_N->Cells[3][i+1]= FloatToStr(N_[i].begValue);
			StringGrid_N->Cells[4][i+1]= FloatToStr(N_[i].endValue);
	 }
	 StringGrid_N->RowCount = beam_mod.N_length+1;
	 for (i=0; i<beam_mod.loads_length; i++) {
			StringGrid_Loads->Cells[0][i+1]= IntToStr(i+1);
			StringGrid_Loads->Cells[1][i+1]= FloatToStr(loads[i].X);
			StringGrid_Loads->Cells[2][i+1]= FloatToStr(loads[i].v);
			StringGrid_Loads->Cells[3][i+1]= FloatToStr(loads[i].u);
			StringGrid_Loads->Cells[4][i+1]= FloatToStr(loads[i].c);
	 }
	 StringGrid_Loads->RowCount = beam_mod.loads_length+1;
	 for (i=0; i<beam_mod.q_length; i++) {
			StringGrid_q->Cells[0][i+1]= IntToStr(i+1);
			StringGrid_q->Cells[1][i+1]= FloatToStr(q_[i].X0);
			StringGrid_q->Cells[2][i+1]= FloatToStr(q_[i].X0 + q_[i].Len);
			StringGrid_q->Cells[3][i+1]= FloatToStr(q_[i].begValue);
			StringGrid_q->Cells[4][i+1]= FloatToStr(q_[i].endValue);
	 }
	 StringGrid_q->RowCount= beam_mod.q_length+1;
	 TabSheet_Constraints->TabVisible = false;
	 PageControl_BoundCond->ActivePage = TabSheet_Load0;
	 if (beam_mod.N_length!=0) {
		 PageControl_Load->ActivePage = TabSheet_DistrN;
		 PageControl_TabLoads->ActivePage = TabSheet_N_Loads;
		 TabSheet_N_Loads->TabVisible = true;
		 TabSheet_ConcLoads->TabVisible = false;
		 TabSheet_LinLoads->TabVisible = false;
		 type_region = typeDistrN;
	 }
	 if (beam_mod.loads_length!=0) {
		 PageControl_Load->ActivePage = TabSheet_ConcentrLoad;
		 PageControl_TabLoads->ActivePage = TabSheet_ConcLoads;
		 TabSheet_N_Loads->TabVisible = false;
		 TabSheet_ConcLoads->TabVisible = true;
		 TabSheet_LinLoads->TabVisible = false;
		 type_region = typeConcentrLoad;
	 }
	 if (beam_mod.q_length!=0) {
		 PageControl_Load->ActivePage = TabSheet_LinearLoad;
		 PageControl_TabLoads->ActivePage = TabSheet_LinLoads;
		 TabSheet_N_Loads->TabVisible = false;
		 TabSheet_ConcLoads->TabVisible = false;
		 TabSheet_LinLoads->TabVisible = true;
		 type_region = typeLinearLoad;
	 }
	 if (!flag_weight[k]) {
	   TabSheet_ConcentrLoad->TabVisible = true;
	   TabSheet_DistrN->TabVisible = true;
	   //CheckBox_Weight->Checked = false;
	   //CheckBox_Weight->Visible = false;
	   Label_Weight->Visible = false;
	   TabSheet_ConcentrLoad->TabVisible = true;
	   TabSheet_DistrN->TabVisible = true;
	   ComboBox_type_zagr->Enabled = true;
	   PageControl_Load->Enabled = true;
	   Edit_gamma_f->ReadOnly = false;
	   Edit_koef_low->ReadOnly = false;
	   ComboBox_type_zagr->Enabled = true;
	   SpeedButtonTabl->Enabled = true;
	   BitBtn_Add->Enabled = true;
	   BitBtn_Replace->Enabled = true;
	   BitBtnDelete->Enabled = true;
	 }
	 else {
	   TabSheet_ConcentrLoad->TabVisible = false;
	   TabSheet_DistrN->TabVisible = false;
	   PageControl_Load->ActivePage = TabSheet_LinearLoad;
	   CheckBox_Linear->Checked = false;
	   PageControl_Load->Enabled = false;
	   //CheckBox_Weight->Checked = true;
	   //CheckBox_Weight->Visible = true;
	   Label_Weight->Visible = true;
	   Edit_gamma_f->ReadOnly = true;
	   Edit_koef_low->ReadOnly = true;
	   ComboBox_type_zagr->Enabled = false;
	   SpeedButtonTabl->Enabled = false;
	   BitBtn_Add->Enabled = false;
	   BitBtn_Replace->Enabled = false;
	   BitBtnDelete->Enabled = false;
	 }
	 //PageControl_LoadndChange(Sender);

	 k_beam = ComboBox_num_zagr->ItemIndex;
}
//---------------------------------------------------------------------------
//  
void __fastcall TBalkaLoadFrame::SpeedButtonDeleteClick(TObject *Sender)
{
  int i, rc;
	 if (flag_comb) {
		 #ifdef EMBRAC
		  rc=Application->MessageBox(L"       .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
		 #else
		  rc=Application->MessageBox("       .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
		 #endif
		 if (rc==IDNO) return;
		 else
		   flag_comb = false;
	 }
  int k = ComboBox_num_zagr->ItemIndex;
	 #ifdef EMBRAC
	 i=Application->MessageBox((L"  "+IntToStr(k+1)+"?").c_str(), L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 i=Application->MessageBox(("  "+IntToStr(k+1)+"?").c_str(), "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
  if (i==IDNO) return;

  //     
  int lenEI;
  int lenq_;
  int lenN_;
  int lenld;

  //     
  int iEI;
  int iq_;
  int iN_;
  int ild;

  if (k==0) {
   iEI = 0;
   iq_ = 0;
   iN_ = 0;
   ild = 0;
   lenEI = index_beam[k][0];
   lenq_ = index_beam[k][1];
   lenN_ = index_beam[k][4];
   lenld = index_beam[k][5];
  }
  else {
   iEI = index_beam[k-1][0];
   iq_ = index_beam[k-1][1];
   iN_ = index_beam[k-1][4];
   ild = index_beam[k-1][5];
   lenEI = index_beam[k][0] - iEI;
   lenq_ = index_beam[k][1] - iq_;
   lenN_ = index_beam[k][4] - iN_;
   lenld = index_beam[k][5] - ild;
  }
  for (i=k; i<n_beam-1; i++) {
	type_zagr[i] = 	type_zagr[i+1];  //  
	flag_weight[i] = flag_weight[i+1];
	Koeff_gamma_f[i] = Koeff_gamma_f[i+1];  //  
	Koeff_low[i] = Koeff_low[i+1];  //  
	index_beam[i][0] = index_beam[i+1][0] - lenEI;
	index_beam[i][1] = index_beam[i+1][1] - lenq_;
	index_beam[i][4] = index_beam[i+1][4] - lenN_;
	index_beam[i][5] = index_beam[i+1][5] - lenld;
  }
  memcpy(EI_v+iEI, EI_v + iEI + lenEI, sizeof(BeamRegion)*(index_portion - (iEI + lenEI)));        //EI[0]
  memcpy(q_v+iq_, q_v + iq_ + lenq_, sizeof(BeamRegion)*(index_portion - (iq_ + lenq_)));
  memcpy(N_v+iN_, N_v + iN_ + lenN_, sizeof(BeamRegion)*(index_portion - (iN_ + lenN_)));
  memcpy(loads_v+ild, loads_v + ild + lenld, sizeof(Load)*(index_portion - (ild + lenld)));
   //------------------------------------------------------------
   int n_row = ComboBox_num_zagr->Items->Count;
   n_row--;
   //    
   if (n_row>0) {
	 int rc = Get_beam_data(0);
	 if (rc>0)
	   return;
   }
   else {
	 StringGrid_q->RowCount = 1;
	 StringGrid_N->RowCount = 1;
	 StringGrid_Loads->RowCount = 1;
	 beam_mod.q_length = 0;
	 beam_mod.N_length = 0;
	 beam_mod.loads_length = 0;
   }
   ComboBox_num_zagr->ItemIndex = 0;

   if (n_row > 1)
		TabSheet_Combin->TabVisible = true;
   else
		TabSheet_Combin->TabVisible = false;
   ComboBox_num_zagr->Items->Clear();
   for (i=0; i<(MAX(1, n_row)); i++) {
	   ComboBox_num_zagr->Items->Add(IntToStr(i+1));
   }
   ComboBox_num_zagr->ItemIndex = 0;
   k_beam = 0;
   n_beam--;
   if (n_beam==0) {
	 Label_Weight->Visible = false;
	 ComboBox_type_zagr->ItemIndex = 0;
	 ComboBox_type_zagrChange(Sender);
   }
   ComboBox_num_zagrChange(Sender);
   Edit_num_zagr->Text = IntToStr(n_beam);

}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::ComboBox_type_zagrChange(TObject *Sender)
{
   TabSheet_ConcentrLoad->TabVisible = true;
   TabSheet_DistrN->TabVisible = true;
   switch (ComboBox_type_zagr->ItemIndex) {
   case 0:
	 Edit_gamma_f->Text =  1.1;
   break;
   case 1:
	 Edit_gamma_f->Text =  1.1;
   break;
   case 2:
	 Edit_gamma_f->Text =  1.1;
   break;
   }
   //   
   Set_type_zagr(k_beam);
}
//-----------------------------------------------------------------------------
//    num
void __fastcall TBalkaLoadFrame::Set_type_zagr(int num)
{
   switch (ComboBox_type_zagr->ItemIndex) {
   case 0:
	 type_zagr[num] = zagrCONSTANT;
   break;
   case 1:
	 type_zagr[num] = zagrTEMPORAR;
   break;
   case 2:
	 type_zagr[num] = zagrTRANSIST;
   break;
   }
   if (Label_Weight->Visible)
	  flag_weight[num] = true;
   else
	  flag_weight[num] = false;
}
//---------------------------------------------------------------------------
//   
void __fastcall TBalkaLoadFrame::PutZagrToDepo()
{
	 int rc;

	 //----------------------------------------------------------------
	 //     
	 Put_beam_data();
	 //   
	 Set_type_zagr(k_beam);
	 //  . 
	 rc = String_double_plus(Label_gamma_f->Caption, Edit_gamma_f->Text, &(Koeff_gamma_f[k_beam]));
	 if (rc>0) return;
	 //   .
	 rc = String_double_plus(Label_koef_low->Caption, Edit_koef_low->Text, &(Koeff_low[k_beam]));
	 if (rc>0) return;
	 //-----------------------------------------------------------------

}
//---------------------------------------------------------------------
//   
void __fastcall TBalkaLoadFrame::SpeedButtonTablClick(TObject *Sender)
{
	 int length_q;
	 BeamRegion *Aq;
	 int length_N;
	 BeamRegion *AN;
	 int length_loads;
	 Load *Aloads;
	 int length_constr;
	 Constraint *Aconstr;
	 int k_zagr;

	 GetRegion(&k_zagr, &length_q, &Aq, &length_N, &AN,
			   &length_loads, &Aloads, &length_constr, &Aconstr);

	 TablZagrForm->Koeff_gamma_f = Koeff_gamma_f[k_beam];
	 TablZagrForm->Koeff_low = Koeff_low[k_beam];
	 TablZagrForm->PutLoadRegion(Length_beam, k_beam, type_zagr, length_q, Aq, length_N, AN, length_loads, Aloads, Sender);

	 TablZagrForm->ShowModal();

	 beam_mod.q_length = TablZagrForm->length_q0;
	 beam_mod.N_length = TablZagrForm->length_N0;
	 beam_mod.loads_length = TablZagrForm->length_loads0;
	 Koeff_gamma_f[k_beam] = TablZagrForm->Koeff_gamma_f;
	 Koeff_low[k_beam] = TablZagrForm->Koeff_low;
	 Edit_gamma_f->Text = FloatToStr(Koeff_gamma_f[k_beam]);
	 Edit_koef_low->Text = FloatToStr(Koeff_low[k_beam]);


	//    
	 Put_beam_data();
	 //--------------------------------------------------------------------------
	 //       
	 StringGrid_Loads->RowCount = 1;
	 StringGrid_q->RowCount = 1;
	 StringGrid_N->RowCount = 1;
	 LoadDataToGrid_param(typeLinearLoad);
	 LoadDataToGrid_param(typeDistrN);
	 LoadDataToGrid_param(typeConcentrLoad);
	 if (StringGrid_N->RowCount > 1) {
	   type_region = typeDistrN;
	   SelectRow = 1;
	 //      
	   int rc = LoadDataFromGrid_ToText();
	 }
	 if (StringGrid_Loads->RowCount > 1) {
	   type_region = typeConcentrLoad;
	   SelectRow = 1;
	 //      
	   int rc = LoadDataFromGrid_ToText();
	 }
	 if (StringGrid_q->RowCount > 1) {
	   type_region = typeLinearLoad;
	   SelectRow = 1;
	 //      
	   int rc = LoadDataFromGrid_ToText();
	 }
	 type_zagr[k_beam] = TablZagrForm->type_zagr0;  //  
	 ComboBox_type_zagr->ItemIndex = type_zagr[k_beam];

}
//---------------------------------------------------------------------------
//  
void __fastcall TBalkaLoadFrame::SpeedButton_ApplyClick(TObject *Sender)
{
   int rc;
   if (n_beam>0 || beam_mod.q_length>0 || beam_mod.N_length>0 || beam_mod.loads_length>0 || beam_mod.constr_length>0) {
	 #ifdef EMBRAC
	 rc=Application->MessageBox(L"         .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 rc=Application->MessageBox("         .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;

   }
   rc = String_double_range(Label_Length->Caption, Edit_Length->Text, 0.1, 100.0, &Length_beam);
   if (rc>0) {
	 Length_beam = 0;
	 return;
   }
   if (Length_beam != EI[0].Len) {
	  //   
	  DeleteZagr(Sender);
   }
   EI[0].begValue = IE_beam;
   EI[0].endValue = IE_beam;

   //EI[0].begValue = 1e9;
   //EI[0].endValue = 1e9;

   EI[0].X0 = 0;
   EI[0].Len = Length_beam;
   beam_mod.EI_length = 1;
   ImageList1->GetBitmap(0, SpeedButton_Apply->Glyph);
   //Draw_beam();

   PageControl_BoundCond->Visible = true;
   PageControl_TabLoads->Visible = true;

   //--------------------------------------------------------------
   //    
   //NewBalka(Sender);
   //
   PageControl_Load->ActivePage = TabSheet_LinearLoad;
   PageControl_LoadChange(Sender);
   Edit_x0->Text = "0";
   Edit_Len->Text = Edit_Length->Text;
   Edit_p1->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
   Edit_p2->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
   CheckBox_Linear->Checked = false;
   BitBtn_AddClick(Sender);
   PageControl_Load->Enabled = false;
   Label_Weight->Visible = true;
   Edit_gamma_f->ReadOnly = true;
   Edit_koef_low->ReadOnly = true;
   ComboBox_type_zagr->Enabled = false;
   SpeedButtonTabl->Enabled = false;
   BitBtn_Add->Enabled = false;
   BitBtn_Replace->Enabled = false;
   BitBtnDelete->Enabled = false;
   ComboBox_type_zagr->ItemIndex = 0;
   ComboBox_type_zagrChange(Sender);
   Edit_gamma_f->Text = "1.05";
   Edit_koef_low->Text = "1";
   type_zagr[0] = ComboBox_type_zagr->ItemIndex;  //  
   Koeff_gamma_f[0] = 1.05;  //  
   Koeff_low[0] = 1.0;  //  
   k_beam = 0;
   Edit_num_zagr->Text = "1";

}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::SpeedButton_AddClick(TObject *Sender)
{
	 int rc;
	 if (flag_comb) {
		 #ifdef EMBRAC
		  rc=Application->MessageBox(L"      .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
		 #else
		  rc=Application->MessageBox("      .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
		 #endif
		 if (rc==IDNO) return;
		 else {
		   flag_comb = false;
		   TabSheet_Combin->TabVisible = false;
		   ImageList1->GetBitmap(1, SpeedButton_CallCombin->Glyph);
		   SpeedButton_CallCombin->Glyph->Width = 0;
		   //SpeedButton_CallCombin->Tag = 1 - SpeedButton_CallCombin->Tag;

		 }
	 }
     //    
	 ZagrPlusForm->ShowModal();

	 if (ZagrPlusForm->type_zagr>=0) {
	   // ,       
	   if (ZagrPlusForm->flag_weight) {
		 for (int i=0; i<n_beam; i++) {
		   if (flag_weight[i]) {
			 rc=Application->MessageBox(("      \" \" ( "+IntToStr(i+1)+")").c_str(), L"",
									 MB_ICONERROR);
			 return;
		   }
		 }
	   }
	   //  
	   NewBalka(Sender);

	   if (ZagrPlusForm->flag_weight) {
		 //TabSheet_ConcentrLoad->TabVisible = false;
		 //TabSheet_DistrN->TabVisible = false;
	 //      StringGrid_param    
	 //    StringGrid_param    
		 PageControl_Load->ActivePage = TabSheet_LinearLoad;
		 PageControl_LoadChange(Sender);
		 Edit_x0->Text = "0";
		 Edit_Len->Text = Edit_Length->Text;
		 Edit_p1->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
		 Edit_p2->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
		 CheckBox_Linear->Checked = false;
		 BitBtn_AddClick(Sender);
		 PageControl_Load->Enabled = false;
		 //CheckBox_Weight->Checked = true;
		 Label_Weight->Visible = true;
		 Edit_gamma_f->ReadOnly = true;
		 Edit_koef_low->ReadOnly = true;
		 ComboBox_type_zagr->Enabled = false;
		 SpeedButtonTabl->Enabled = false;
		 BitBtn_Add->Enabled = false;
		 BitBtn_Replace->Enabled = false;
		 BitBtnDelete->Enabled = false;
	   }
	   else {
		 //CheckBox_Weight->Checked = false;
		 //CheckBox_Weight->Visible = false;
		 Label_Weight->Visible = false;
		 TabSheet_ConcentrLoad->TabVisible = true;
		 TabSheet_DistrN->TabVisible = true;
		 ComboBox_type_zagr->Enabled = true;
		 PageControl_Load->Enabled = true;
		 Edit_gamma_f->ReadOnly = false;
		 Edit_koef_low->ReadOnly = false;
		 ComboBox_type_zagr->Enabled = true;
		 SpeedButtonTabl->Enabled = true;
		 BitBtn_Add->Enabled = true;
		 BitBtn_Replace->Enabled = true;
		 BitBtnDelete->Enabled = true;
		 Label_Weight->Visible = false;
	   }
	   ComboBox_type_zagr->ItemIndex = ZagrPlusForm->type_zagr;
	   ComboBox_type_zagrChange(Sender);
	   Edit_gamma_f->Text = FloatToStr(ZagrPlusForm->koeff_gamma_f);
	   Edit_koef_low->Text = FloatToStr(ZagrPlusForm->koeff_low);
	   type_zagr[k_beam] = ComboBox_type_zagr->ItemIndex;  //  
	   Koeff_gamma_f[k_beam] = ZagrPlusForm->koeff_gamma_f;  //  
	   Koeff_low[k_beam] = ZagrPlusForm->koeff_low;  //  
	   Edit_num_zagr->Text = IntToStr(k_beam+1);
	 }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::ComboBox_num_zagr_rezChange(TObject *Sender)
{
   int i, j, k, m, rc;
   float X;
   float **matr_combin;
   if (ComboBox_num_zagr_rez->ItemIndex < n_beam) {
	 if (ComboBox_num_zagr->ItemIndex != ComboBox_num_zagr_rez->ItemIndex) {
	   ComboBox_num_zagr->ItemIndex = ComboBox_num_zagr_rez->ItemIndex;
	   ComboBox_num_zagrChange(Sender);
	 }
	 CalculateExecute(k_beam, true, Sender);
   }
   else {
	 m = ComboBox_num_zagr_rez->ItemIndex - n_beam;  //  
	 matr_combin = (float**)almat_f(k_result, 7, &rc);
	 if (rc>0) {
	   rc = Application->MessageBox(L"Error almat_f", L" ", MB_OK | MB_ICONERROR);
	   return;
	 }
	 for (i=0; i<k_result; i++) {
	   for (j=0; j<7; j++)
		  matr_combin[i][j] = 0;
	 }
	 for (k=0; k<n_beam; k++) {
		//    
		int rc = Get_beam_data(k);
		if (rc>0)
		   return;
		CalculateExecute(k_beam, false, Sender);

		for (i=0; i<k_result; i++) {
		  for (j=0; j<7; j++) {
			matr_combin[i][j] += matr_result[i][j]*Koeff_gamma_f[k]*Combin[m][k];
		  }
		}
	 }
	 for (i=0; i<k_result; i++) {
		for (j=0; j<7; j++) {
		  matr_result[i][j] = matr_combin[i][j];
		}
	 }
	 for (i=0; i<k_result; i++) {
	   X = x_result[i];
	   for (j=1; j<7; j++) {
		 if (Max_Value[j] < matr_result[i][j]) {
		   Max_Value[j] = matr_result[i][j];
		   Max_X[j] = X;
		 }
		 if (Min_Value[j] > matr_result[i][j]) {
		   Min_Value[j] = matr_result[i][j];
		   Min_X[j] = X;
		 }
	   }
	 }
	 Max_Value[0] = Round(Max_Value[0], 0);
	 Min_Value[0] = Round(Min_Value[0], 0);

	 Max_Value[1] = Round(Max_Value[1], 0);
	 Min_Value[1] = Round(Min_Value[1], 0);

	 Max_Value[2] = Round(Max_Value[2], 0);
	 Min_Value[2] = Round(Min_Value[2], 0);

	 Max_Value[3] = Round(Max_Value[3], 2);
	 Min_Value[3] = Round(Min_Value[3], 2);

	 Max_Value[4] = Round(Max_Value[4], 1);
	 Min_Value[4] = Round(Min_Value[4], 1);

	 Max_Value[5] = Round(Max_Value[5], 1);
	 Min_Value[5] = Round(Min_Value[5], 1);

	 Max_Value[6] = Round(Max_Value[6], 1);
	 Min_Value[6] = Round(Min_Value[6], 1);

	 //   DrawOut
	 ListBox1Click(Sender);
	 FREEMAT_(matr_combin);
   }
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::DeleteZagr(TObject *Sender)
{
	  n_beam = 0;

	  Edit_num_zagr->Text = "0";
	  DeleteSupp(Sender);
	  DeleteLoad(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::DeleteSupp(TObject *Sender)
{
	  Edit_X0Constr->Text = 0;
	  CheckBox_Tx->Checked = false;
	  CheckBox_Tz->Checked = false;
	  CheckBox_Ry->Checked = false;
	  beam_mod.constr_length = 0;

	  StringGrid_Constr->RowCount = 1;
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::DeleteLoad(TObject *Sender)
{
	  beam_mod.q_length=0;
	  beam_mod.N_length=0;
	  beam_mod.loads_length=0;
	  StringGrid_Loads->RowCount = 1;
	  StringGrid_N->RowCount = 1;
	  StringGrid_q->RowCount = 1;
	  Edit_X0Load->Text = 0;
	  Edit_Fz->Text = 0;
	  Edit_Fx->Text = 0;
	  Edit_My->Text = 0;

	  Edit_x0->Text = 0;
	  Edit_Len->Text = 0;
	  Edit_p1->Text = 0;
	  Edit_p2->Text = 0;

	  Edit_x0->Text = 0;
	  Edit_Len->Text = 0;
	  Edit_p1->Text = 0;
	  Edit_p2->Text = 0;

}
//-----------------------------------------------------------------



void __fastcall TBalkaLoadFrame::BitBtn_DeleteZagrClick(TObject *Sender)
{
	 #ifdef EMBRAC
	 int rc=Application->MessageBox(L"    ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 int rc=Application->MessageBox("    ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;
	 DeleteZagr(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TBalkaLoadFrame::CheckBox_WeightClick(TObject *Sender)
{
   int i, rc;
   if (!CheckBox_Weight->Checked) {
	  CheckBox_Weight->Checked = true;
   }
   return;
   if (CheckBox_Weight->Checked) {
	 for (i=0; i<n_beam; i++) {
	   if (flag_weight[i]) {
		 rc=Application->MessageBox(("      \" \" ( "+IntToStr(i+1)+")").c_str(), L"",
									 MB_ICONWARNING);
		 CheckBox_Weight->Checked = false;
		 return;
	   }
	 }
	 if (!flag_weight[ComboBox_num_zagr->ItemIndex] && (beam_mod.q_length>0 || beam_mod.N_length>0 || beam_mod.loads_length>0)) {
	 #ifdef EMBRAC
	   rc=Application->MessageBox(L"    \" \"    .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	   rc=Application->MessageBox("    \" \"    .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	   if (rc==IDNO)
		  CheckBox_Weight->Checked = false;
	   else {
   //   
		 DeleteLoad(Sender);
	   }
	 }
	 ComboBox_type_zagr->ItemIndex = 0;
	 ComboBox_type_zagr->Enabled = false;
	 Edit_gamma_f->Text =  1.05;
	 TabSheet_ConcentrLoad->TabVisible = false;
	 TabSheet_DistrN->TabVisible = false;
	 //      StringGrid_param    
	 //    StringGrid_param    
	 PageControl_Load->ActivePage = TabSheet_LinearLoad;
	 PageControl_LoadChange(Sender);
	 Edit_x0->Text = "0";
	 Edit_Len->Text = Edit_Length->Text;
	 Edit_p1->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
	 Edit_p2->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
	 CheckBox_Linear->Checked = false;
	 BitBtn_AddClick(Sender);
	 PageControl_Load->Enabled = false;

   }
   else {
	 TabSheet_ConcentrLoad->TabVisible = true;
	 TabSheet_DistrN->TabVisible = true;
	 ComboBox_type_zagr->Enabled = true;
	 PageControl_Load->Enabled = true;
   }

}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::StringGrid_CombinSelectCell(TObject *Sender, int ACol,
		  int ARow, bool &CanSelect)
{
	CombRow = ARow;

}
//---------------------------------------------------------------------------





void __fastcall TBalkaLoadFrame::RadioGroup_SupCountClick(TObject *Sender)
{
  int i, rc;

  if (RadioGroup_SupCount->ItemIndex > 0) {
	if (beam_mod.constr_length > 0) {
	#ifdef EMBRAC
	 rc=Application->MessageBox(L"        .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 rc=Application->MessageBox("        .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;
	}
	DeleteSupp(Sender);


	 Edit_X0Constr->Text = "0";
	 CheckBox_Tx->Checked = true;
	 CheckBox_Tz->Checked = true;
	 CheckBox_Ry->Checked = false;
	 BitBtn_AddClick(Sender);

	 double step = Length_beam/(RadioGroup_SupCount->ItemIndex);
	 for (i=1; i<RadioGroup_SupCount->ItemIndex; i++) {
	   Edit_X0Constr->Text = FloatToStr(Round(step * i, 3));
	   CheckBox_Tx->Checked = false;
	   CheckBox_Tz->Checked = true;
	   CheckBox_Ry->Checked = false;
	   BitBtn_AddClick(Sender);
	 }
	 Edit_X0Constr->Text = FloatToStr(Length_beam);
	 CheckBox_Tx->Checked = false;
	 CheckBox_Tz->Checked = true;
	 CheckBox_Ry->Checked = false;
	 BitBtn_AddClick(Sender);

	 CheckBox_Tx->Checked = false;
	 CheckBox_Tz->Checked = false;
	 CheckBox_Ry->Checked = false;
  }
  else {
	if (beam_mod.constr_length > 0) {
	#ifdef EMBRAC
	 rc=Application->MessageBox(L"   .  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 rc=Application->MessageBox("   .  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;

	 DeleteSupp(Sender);
	}
  }
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButtonAppStepClick(TObject *Sender)
{
	   int rc;
		  rc = String_double_zero_plus(Label_muXY->Caption, Edit_muXY->Text, &Len_XY);
		  if (rc>0) return;
		  rc = String_double_zero_plus(Label_step_up->Caption, Edit_step_up->Text, &Step_up);
		  if (rc>0) return;
		  rc = String_double_zero_plus(Label_step_down->Caption, Edit_step_down->Text, &Step_down);
		  if (rc>0) return;
		  if (Len_XY==0)
			Len_XY = Length_beam;
		  if (Step_up==0)
			Step_up = Len_XY;
		  if (Step_down==0)
			Step_down = Len_XY;

	   ImageList1->GetBitmap(0, SpeedButtonAppStep->Glyph);
}
//---------------------------------------------------------------------------
//  
void __fastcall TBalkaLoadFrame::BitBtn_CreateRSUClick(TObject *Sender)
{
	 int i, j, k, m, rc;
	 float **matr_combin;
	 float **matr_res_w;
	 double *matr_V;  // 
	 Load *reac_combin;
	 Load *reac_w;
	 double MyPlus;
	 double	SigmaPlus;
	 double	SigmaMinus;
	 int k_w;

	 if (!flag_comb || n_comb==0) {
		 #ifdef EMBRAC
		 rc=Application->MessageBox(L"   ,   ", L" ", MB_OK | MB_ICONWARNING);
		 #else
		 rc=Application->MessageBox("   ", " ", MB_OK | MB_ICONERROR);
		 #endif
         BitBtn_CalculateClick(Sender);
		 return;
	 }
	 //  ,   k_result
	 BitBtn_CalculateClick(Sender);
	 if (k_result==0)
	   return;

	 matr_combin = (float**)almat_f(k_result, 7, &rc);
	 ALLOCVEC_(reac_combin, beam_mod.constr_force_length, Load);
	 ALLOCVEC_(matr_V, k_result, double);
	 if (rc>0) {
	   rc = Application->MessageBox(L"Error almat_f", L" ", MB_OK | MB_ICONERROR);
	   return;
	 }

	 FRo_RSU = FRo_beam; //        
	 Izz_RSU = I_beam; //       

	 for (i=0; i<6; i++) {
		MaxQ[i] = MaxQ_W[i] = 0; // N, Q, M
		MaxR[i] = MaxR_W[i] = 0; // N, Q, M
		MaxM[i] = MaxM_W[i] = 0; // N, Q, M
		MinM[i] = MinM_W[i] = 0; // N, Q, M
		MaxSigma[i] = MaxSigma_W[i] = 0; // N, Q, M
		MinSigma[i] = MinSigma_W[i] = 0; // N, Q, M
		MaxN[i] = MaxN_W[i] = 0;
		MinN[i] = MinN_W[i] = 0;
	 }
	 MaxQ[1] = -1e6; // N, Q, M
	 MaxR[1] = -1e6; // N, Q, M
	 MaxM[2] = -1e6; // N, Q, M
	 MinM[2] = 1e6; // N, Q, M
	 SigmaPlus = -1e6;
	 SigmaMinus = 1e6;
	 MaxN[0] = -1e6;
	 MinN[0] = 1e6;
	 MaxV = 0;
	 MaxV_W = 0;

	 for (i=0, k_w = -1; i<n_beam; i++) {
	   if (flag_weight[i]) {
		 k_w = i;
		 int rc = Get_beam_data(k_w);
		 if (rc>0)
		   return;
		 CalculateExecute(k_beam, false, Sender);
		 matr_res_w = (float**)almat_f(k_result, 7, &rc);
		 ALLOCVEC_(reac_w, beam_mod.constr_force_length, Load);
		 for (i=0; i<k_result; i++) {
		   for (j=0; j<7; j++) {
			  matr_res_w[i][j] = matr_result[i][j]*Koeff_gamma_f[k_w];
		   }
		   MaxV_W = MAX(MaxV_W, (ABS(matr_result[i][3])));
		 }
		 for (i=0; i<beam_mod.constr_force_length; i++) {
		   reac_w[i].X = beam_mod.ConstrForces[i].X;
		   reac_w[i].u = beam_mod.ConstrForces[i].u*Koeff_gamma_f[k_w];
		   reac_w[i].v = beam_mod.ConstrForces[i].v*Koeff_gamma_f[k_w];
		   reac_w[i].c = beam_mod.ConstrForces[i].c*Koeff_gamma_f[k_w];
		 }
		 break;
	   }
	 }
	 //    
	 double *x_span;
	 ALLOCVEC_(x_span, beam_mod.constr_force_length + 2, double);
	 for (i=0; i<beam_mod.constr_force_length; i++) {
		   x_span[i] = beam_mod.ConstrForces[i].X;
	 }
	 x_span[i] = 0;
	 x_span[i+1] = Length_beam*1000;
	 rc = qsortk((char*)x_span, beam_mod.constr_force_length + 2, SDOUBLE);
	 Span = 0;

	 for (i=0; i<beam_mod.constr_force_length+1; i++) {
	   Span = MAX(Span, x_span[i+1] - x_span[i]);
	 }
	 FREEVEC_(x_span);

	 MaxMy_R = 0;

	 for (m=0; m < n_comb; m++) {
	   for (i=0; i<k_result; i++) {
		 matr_V[i] = 0;
		 for (j=0; j<7; j++)
			matr_combin[i][j] = 0;
	   }
	   for (i=0; i<beam_mod.constr_force_length; i++) {
		 reac_combin[i].u = 0;
		 reac_combin[i].v = 0;
		 reac_combin[i].c = 0;
	   }
	   for (k=0; k<n_beam; k++) {
		//    
		 int rc = Get_beam_data(k);
		 if (rc>0)
		   return;
		 CalculateExecute(k_beam, false, Sender);

		 for (i=0; i<k_result; i++) {
		   for (j=0; j<7; j++) {
			  matr_combin[i][j] += matr_result[i][j]*Koeff_gamma_f[k]*Combin[m][k];      //matr_combin[500][3]
		   }
		 }
		 for (i=0; i<k_result; i++) {
		   matr_V[i] += matr_result[i][3]*Combin[m][k];      //matr_combin[500][3]
		 }
		 for (i=0; i<beam_mod.constr_force_length; i++) {
		   reac_combin[i].X = beam_mod.ConstrForces[i].X;
		   reac_combin[i].u += beam_mod.ConstrForces[i].u*Koeff_gamma_f[k]*Combin[m][k];
		   reac_combin[i].v += beam_mod.ConstrForces[i].v*Koeff_gamma_f[k]*Combin[m][k];
		   reac_combin[i].c += beam_mod.ConstrForces[i].c*Koeff_gamma_f[k]*Combin[m][k];
		 }
	   }
	   //  
	   for (i=0; i<k_result; i++) {
		 MaxV = MAX(MaxV, (ABS(matr_V[i])));
	   }
	   for (i=0; i<k_result; i++) {
		 if (MaxN[0] < matr_combin[i][0]) {
			 MaxN[0] = Round(matr_combin[i][0], -1);
			 MaxN[1] = Round(matr_combin[i][1], -1);
			 MaxN[2] = Round(matr_combin[i][2], -1);
			 MaxN[5] = x_result[i];
			 if (k_w>=0) {
				MaxN_W[0] = Round(matr_res_w[i][0], 0);
				MaxN_W[1] = Round(matr_res_w[i][1], 0);
				MaxN_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (MinN[0] > matr_combin[i][0]) {
			 MinN[0] = Round(matr_combin[i][0], -1);
			 MinN[1] = Round(matr_combin[i][1], -1);
			 MinN[2] = Round(matr_combin[i][2], -1);
			 MinN[5] = x_result[i];
			 if (k_w>=0) {
				MinN_W[0] = Round(matr_res_w[i][0], 0);
				MinN_W[1] = Round(matr_res_w[i][1], 0);
				MinN_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if ((ABS(MaxQ[1])) < (ABS(matr_combin[i][1]))) {
			 MaxQ[0] = Round(matr_combin[i][0], -1);
			 MaxQ[1] = Round(matr_combin[i][1], -1);
			 MaxQ[2] = Round(matr_combin[i][2], -1);
			 MaxQ[5] = x_result[i];
			 if (k_w>=0) {
				MaxQ_W[0] = Round(matr_res_w[i][0], 0);
				MaxQ_W[1] = Round(matr_res_w[i][1], 0);
				MaxQ_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (MaxM[2] < matr_combin[i][2]) {
			 MaxM[0] = Round(matr_combin[i][0], -1);
			 MaxM[1] = Round(matr_combin[i][1], -1);
			 MaxM[2] = Round(matr_combin[i][2], -1);
			 MaxM[5] = x_result[i];
			 if (k_w>=0) {
				MaxM_W[0] = Round(matr_res_w[i][0], 0);
				MaxM_W[1] = Round(matr_res_w[i][1], 0);
				MaxM_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (MinM[2] > matr_combin[i][2]) {
			 MinM[0] = Round(matr_combin[i][0], -1);
			 MinM[1] = Round(matr_combin[i][1], -1);
			 MinM[2] = Round(matr_combin[i][2], -1);
			 MinM[5] = x_result[i];
			 if (k_w>=0) {
				MinM_W[0] = Round(matr_res_w[i][0], 0);
				MinM_W[1] = Round(matr_res_w[i][1], 0);
				MinM_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (SigmaMinus > matr_combin[i][5]) {
			 SigmaMinus = matr_combin[i][5];
			 MinSigma[0] = Round(matr_combin[i][0], -1);
			 MinSigma[1] = Round(matr_combin[i][1], -1);
			 MinSigma[2] = Round(matr_combin[i][2], -1);
			 MinSigma[5] = x_result[i];
			 if (k_w>=0) {
				MinSigma_W[0] = Round(matr_res_w[i][0], 0);
				MinSigma_W[1] = Round(matr_res_w[i][1], 0);
				MinSigma_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (SigmaMinus > matr_combin[i][6]) {
			 SigmaMinus = matr_combin[i][6];
			 MinSigma[0] = Round(matr_combin[i][0], -1);
			 MinSigma[1] = Round(matr_combin[i][1], -1);
			 MinSigma[2] = Round(matr_combin[i][2], -1);
			 MinSigma[5] = x_result[i];
			 if (k_w>=0) {
				MinSigma_W[0] = Round(matr_res_w[i][0], 0);
				MinSigma_W[1] = Round(matr_res_w[i][1], 0);
				MinSigma_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (SigmaPlus < matr_combin[i][5]) {
			 SigmaPlus = matr_combin[i][5];
			 MaxSigma[0] = Round(matr_combin[i][0], -1);
			 MaxSigma[1] = Round(matr_combin[i][1], -1);
			 MaxSigma[2] = Round(matr_combin[i][2], -1);
			 MaxSigma[5] = x_result[i];
			 if (k_w>=0) {
				MaxSigma_W[0] = Round(matr_res_w[i][0], 0);
				MaxSigma_W[1] = Round(matr_res_w[i][1], 0);
				MaxSigma_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
		 if (SigmaPlus < matr_combin[i][6]) {
			 SigmaPlus = matr_combin[i][6];
			 MaxSigma[0] = Round(matr_combin[i][0], -1);
			 MaxSigma[1] = Round(matr_combin[i][1], -1);
			 MaxSigma[2] = Round(matr_combin[i][2], -1);
			 MaxSigma[5] = x_result[i];
			 if (k_w>=0) {
				MaxSigma_W[0] = Round(matr_res_w[i][0], 0);
				MaxSigma_W[1] = Round(matr_res_w[i][1], 0);
				MaxSigma_W[2] = Round(matr_res_w[i][2], 0);
			 }
		 }
	   }
	   //     
	   for (i=0; i<beam_mod.constr_force_length; i++) {
		 if (MaxR[1]  < (ABS(reac_combin[i].v))) {
		   MaxR[1] = ABS(reac_combin[i].v);
		   if (k_w>=0)
			 MaxR_W[1] = ABS(reac_w[i].v);
		   for (j=0; j<k_result; j++) {
			 if (reac_combin[i].X == x_result[j]) {
			   MaxR[0] = matr_combin[j][0];
			   MaxR[2] = matr_combin[j][2];
			   if (k_w>=0) {
					MaxR_W[0] = matr_res_w[j][0];
					MaxR_W[2] = matr_res_w[j][2];
			   }
			   break;
			 }
		   }
		 }
	   }
	   //     
	   for (i=0; i<beam_mod.constr_force_length; i++) {
		   for (j=0; j<k_result; j++) {
			 if (reac_combin[i].X == x_result[j]) {
			   MaxMy_R = MAX((ABS(matr_combin[j][2])), MaxMy_R);
			 }
		 }
	   }
	 }
	 double maxM;
	 maxM = MAX((ABS(MaxM[2])), (ABS(MinM[2])));
	 if (maxM > 0)
	   MaxMy_R /= maxM;

	 FREEMAT_(matr_combin);
	 FREEVEC_(reac_combin);
	 FREEVEC_(matr_V);
	 if (k_w>=0) {
	   FREEMAT_(matr_res_w);
	   FREEVEC_(reac_w);
	 }
}
//---------------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::SpeedButton_CallCombinClick(TObject *Sender)
{
	  int i, j, rc;
	 //   
	   PutZagrToDepo();

	   CombLoadForm->PutZagr(n_beam, type_zagr, n_comb, Combin, flag_comb);

	   CombLoadForm->ShowModal();

	   CombLoadForm->GetComb(&flag_comb, &n_comb);

	   if (flag_comb) {
		 FREEMAT_(Combin);
		 ALLOCMAT_(Combin, n_comb, n_beam);
		 for(i=0; i<n_comb; i++) {
			 for (j=0; j<n_beam; j++)
			   Combin[i][j] = CombLoadForm->CombStr[i][j];
		 }
		 PageControl_BoundCond->ActivePage = TabSheet_Combin;
		 TabSheet_Combin->TabVisible = true;
		 SpeedButton_CallCombin->Glyph->Width=0;
		 ImageList1->GetBitmap(0, SpeedButton_CallCombin->Glyph);
		 //SpeedButton_CallCombin->Glyph->ReleaseHandle();
		 SpeedButton_CallCombin->Tag = 1 - SpeedButton_CallCombin->Tag;

	   }
	   PageControl_BoundCondChange(Sender);

}
//-------------------------------------------------------------------

void __fastcall TBalkaLoadFrame::Correct_Weight()
{
int k;
   for (int i=0; i<n_beam; i++) {
	   if (flag_weight[i]) {
		 if (i==0)
		   k = 0;
		 else
		   k = index_beam[i-1][1];
		 q_v[k].begValue = Round(FRo_beam*9.81*1e-3, 3);
		 q_v[k].endValue = Round(FRo_beam*9.81*1e-3, 3);
	   }
   }
   if (Label_Weight->Visible) {
	   Edit_p1->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
	   Edit_p2->Text = FloatToStrF(FRo_beam*9.81*1e-3,ffFixed, 8, 3);
	   StringGrid_q->Cells[3][1] = Edit_p1->Text;
	   StringGrid_q->Cells[4][1] = Edit_p2->Text;
	   q_[0].begValue = Round(FRo_beam*9.81*1e-3, 3);
	   q_[0].endValue = Round(FRo_beam*9.81*1e-3, 3);

	   //k = ComboBox_num_zagr->ItemIndex;
	   Put_beam_data();
   }
}
