//---------------------------------------------------------------------------

#ifndef MultiSupportBeamH
#define MultiSupportBeamH

#define L1000   1000  // ,   -> ,   -> 
#define F1000   1000   // ,   -> ,   -> 

//---------------------------------------------------------------------------
class BeamRegion {

        private:
        public:
        double X0;
        /**
         *  
         */
        double Len;
        /**
         *       ( 
         *   X ).
         */
        double begValue;
        /**
         *       ( 
         *   X ).
         */
        double endValue;
        //   
        BeamRegion();
        //void BeamRegion_a(double len);
        //void BeamRegion_b(BeamRegion *new_region, BeamRegion base, double x0, double len);
        double valueAt(double x);

};
//---------------------------------------------------------------------------------------------
class BeamResults {
        private:
        public:
        /**
         *  .
         */
        double N;
        /**
         *  .
         */
        double Q;
        /**
         *  .
         */
        double Mz;
        /**
         *    .
         */
        double R;
        /**
         *   .
         */
        double u;
        /**
         *   .
         */
        double v;
        /**
         *   .
         */
        double c;
        BeamResults();
        //@Override
        //String toString();
};
//---------------------------------------------------------------------------------------------
class Constraint {  //     
        /**
         *  .
         */
        public:
        double X;
        /**
         *     . 
         *     .
         */
        double u;
        /**
         *     . 
         *     .
         */
        double v;
         /**
         *       . 
         *     .
         */
        double c;
        Constraint();
};
//---------------------------------------------------------------------------------------------
class Load { //    .
       public:
        /**
         *      .
         */
       double X;
        /**
         *    
         */
       double u;
        /**
         *    .
         */
       double v;
        /**
         * .
         */
       double c;

       Load();
};
//---------------------------------------------------------------------------------------------
class ExtremalValue {  //    
        public:
        /**
         *   .
         */
        double value;
        /**
         *   .
         */
        double XCoord;

        ExtremalValue();
        //@Override
        //String toString();
};
//---------------------------------------------------------------------------------------------
class BeamFE {
       private:
        /**
         *    .   :
		 * <ul>
         * <li> 0 -    .
         * <li> 1 -    .
         * <li> 2 -    .
         * <li> 3 -    .
         * <li> 4 -    .
         * <li> 5 -    .
         * </ul>
         */
        public:
        BeamRegion EI;
        BeamRegion EF;
        BeamRegion q;
        BeamRegion N;
        BeamRegion m;
        BeamRegion kpe;
        BeamRegion r;    //   
        double dsp[6];
        /**
         * ,      .
         *    .
		 */
        double load[6];
        double ke[6][6];
        double kg[6][6];
        double F[6];     //   
        public:
        ExtremalValue FEumax;
        ExtremalValue FEumin;
        //     .
        ExtremalValue FEvmax;
        //     .
        ExtremalValue FEvmin;
        //     .
        ExtremalValue FEcmax;
        //     .
        ExtremalValue FEcmin;
        ExtremalValue FENmax;
        ExtremalValue FENmin;
        //      
        ExtremalValue FEQmax;
        //      
		ExtremalValue FEQmin;
        //      
        ExtremalValue FEMmax;
        //      
        ExtremalValue FEMmin;
        //   
        //BeamFE();
        // 
		BeamFE(double x0, double len, BeamRegion EIr, BeamRegion EFr,
				BeamRegion qr, BeamRegion pr); //, BeamRegion mr, BeamRegion kpr);
        void  beam_ke();
        void  beam_load();
        void  beam_results();
        BeamResults resultsAt(double X);
        void BeamRegion_b(BeamRegion *new_region, BeamRegion base, double x0, double len);

};
//---------------------------------------------------------------------------------------------
class MultiSupportBeam
{
  private:
	double ConstConstr;     //    
	double ConstSingular;  // ,  
    //    
    BeamRegion* EI_BM;
    BeamRegion* EF_BM;
    BeamRegion* q_BM;
    BeamRegion* p_BM;
    BeamRegion* m_BM;
    BeamRegion* kp_BM;
	Load* loads_0;
    Constraint* constr_0;

    double beamLength;
    BeamFE* fem;
    int fem_length;
    ExtremalValue umax;
    ExtremalValue umin;
    ExtremalValue Nmax;
    ExtremalValue Nmin;

  public:
	int EI_length;
	int EF_length;
    int q_length;
    int m_length;
    int N_length;
    int kp_length;
    int loads_length;
    int constr_length;
    int constr_force_length;
	int EI_BM_length;
	double maxElementLength;
	int N_break;

	double H_beam;   //  
	double Zct_beam;  //  ..    
	double I_beam;  //   
	double F_beam;  //  

  //   
	MultiSupportBeam();
	void MultiSupportBeam_(int N_break0, double maxElemLen, double H_beam0, double Zct_beam0, double I_beam0, double F_beam0);
	//  
	/**
     *  ,    
     */
    int ErrSingular;
	/**
     *     .         
	 *  X.
	 */
    int ErrData;
	/**
     *    .
     */
    Load* ConstrForces;  //    
     /**
     *     .
     */
    ExtremalValue vmax;
     /**
     *     .
     */
    ExtremalValue vmin;
     /**
     *     .
     */
    ExtremalValue cmax;
    /**
     *     .
	 */
	ExtremalValue cmin;
    /**
	 *      
     */
    ExtremalValue Qmax;
    /**
     *      
     */
    ExtremalValue Qmin;
    /**
     *      
     */
    ExtremalValue Mmax;
    /**
     *      
     */
    ExtremalValue Mmin;
	int normaliseRegions(BeamRegion* EI, BeamRegion* N_, BeamRegion* qy,
						 //BeamRegion* mz,
						 //BeamRegion* ky,
						 Load* loads, Constraint* constraints, double FE_beam);
	int addRegion(int length, double len, double x, BeamRegion* EIv, BeamRegion* EI, int ind, int *kv);
    int Solver();
	int Solver_Mesh(int N_break0, double length_break);
    int mcond_front(int n0, int m0, double **mat0, double *load0);
    void mback_front(int n_break, int m, double **g_factor, double *l_factor, double *d_beam);
    int msolv(int nfr, double **k1, double *rst, double *bu);
	int calculate(BeamRegion* EI,
                  BeamRegion* N_, BeamRegion* qy,
				  //BeamRegion* mz,
				  //BeamRegion* ky,
				  Load* loads, Constraint* constraints, double FE_beam);
    BeamResults getResults(double X);
    void MaxExtremValue(int i, ExtremalValue* max, ExtremalValue *FEmax);
    void MinExtremValue(int i, ExtremalValue* min, ExtremalValue *FEmin);

};

double **allocmat(int n, int m);
int cmp_Load(Load *elem1, Load *elem2);
int cmp_Constraint(Constraint *elem1, Constraint *elem2);

#endif
