#include <stdio.h>
#include "ListConst.h"
#include "ProcExt.h"
//---------------------------------------------------------------------------
static double Row_th_full[90]={4.0, 4.5, 5.0, 5.5,  6,  6.5,  7,  7.5,  8,  8.5,
                             9,   9.5, 10,  10.5, 11, 11.5, 12, 12.5, 13, 13.5,
                             14, 14.5, 15,  15.5, 16, 16.5, 17, 17.5, 18, 18.5,
                             19, 19.5, 20,  20.5, 21, 21.5, 22, 22.5, 23, 23.5,
                             24, 24.5, 25,  25.5, 26, 27,   28, 29,   30, 31,
                             32, 34,   36,  38,   40, 42,   45, 48,   50, 52,
                             55, 58,   60,  62,   65, 68,   70, 72,   75, 78,
                             80, 82,   85,  87,   90, 92,   95, 100, 105, 110,
                            115, 120, 125, 130,  135, 140, 145, 150, 155, 160};
static int Count_row_full = {90};
static double Row_th_reduce[26]={4,  5,   6,   8,  10,   12, 14, 16, 18, 20,
                                 22, 25, 28,  30,  32,   36, 40, 42, 45, 50,
                                 60, 80, 100, 120, 140, 160};

static int Count_row_reduce = {26};

static double Row_th_Astron[10]={5, 6, 7, 8,  10, 12,  16, 20,  24, 30};
static double Row_width_Astron[10][6] = {150, 150, 150, 150, 150, 150,    //  5
                                         150, 180, 180, 180, 180, 180,    //  6
                                         150, 180, 200, 200, 200, 200,    //  7
                                         150, 180, 200, 250, 250, 250,    //  8
                                         180, 200, 250, 300, 300, 300,    // 10
                                         150, 200, 250, 300, 300, 300,    // 12
                                         150, 180, 200, 250, 300, 350,    // 16
                                         180, 200, 250, 300, 350, 420,    // 20
                                         200, 250, 300, 350, 420, 420,    // 24
                                         250, 300, 350, 420, 420, 420};   // 30


static int Count_row_Astron = {10};

//--------------------------------------------------------------------------
//       
double Round_row(double value, int index) {
  int i;
  double *row;
  int count;

  switch (index) {
  case 0:
      row = Row_th_full;
      count = Count_row_full;
  break;
  case 1:
      row = Row_th_reduce;
      count = Count_row_reduce;
  break;
  case 2:
      row = Row_th_Astron;
      count = Count_row_Astron;
  break;
  }

  for (i=0; i<count; i++) {
     if ((ABS(row[i] - value))<0.01)
         return row[i];
     if (row[i] >= value)
         return row[i];
  }
  return row[count - 1];
}
//--------------------------------------------------------------------------
//        
double Round_row_bpol(double thick, double width, double round_width, int index) {
  int i, k;
  double *row;
  int count;

  switch (index) {
  case 0:
  case 1:
      return Round_step(width, round_width);
  break;
  case 2:   // Astron
      row = Row_th_Astron;
      count = Count_row_Astron;
  break;
  }

  for (i=0, k = -1; i<count; i++) {
     if ((ABS(row[i] - thick))<0.01) {
         k = i;
         break;
     }
     if (row[i] >= thick) {
         k = i;
         break;
     }
  }
  if (k < 0)
    k = count - 1;
  row = &(Row_width_Astron[k][0]);
  count = 6;
  for (i=0; i<count; i++) {
     if ((ABS(row[i] - width))<0.01) {
       return row[i];
     }
     if (row[i] >= width) {
       return row[i];
     }
  }
  return row[count - 1];
}
//----------------------------------------------------------------------------------
//       
double Get_max_bpol(double thick, int index) {
  int i, k;
  double *row;
  int count;

  switch (index) {
  case 0:
  case 1:
      return 1e6;
  break;
  case 2:   // Astron
      row = Row_th_Astron;
      count = Count_row_Astron;
  break;
  }

  for (i=0, k = -1; i<count; i++) {
     if ((ABS(row[i] - thick))<0.01) {
         k = i;
         break;
     }
     if (row[i] >= thick) {
         k = i;
         break;
     }
  }
  if (k < 0)
    k = count - 1;
  return Row_width_Astron[k][5];
}

