//---------------------------------------------------------------------------


#pragma hdrstop

#include "SaveSelectProf.h"
#include "SelectProfilSect.h"
//#include "WRData_Dll.h"
#include "WRData_Check.h"
#include "Dvutavr_Choice_Alg.h"

#include "message.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
extern MATER MaterProp[MAX_MATERIAL];
extern int Material_Number;

//---------------------------------------------------------------------------
//    
bool SaveSelectProf(FILE * BD_file) {
   int rc;

   if (!BD_WSelectProf(BD_file)) {
      InfMessage("      ");
      return false;
   }
   if (!BD_WDataBeam(BD_file)) {
	  InfMessage("        ");
      return false;
   }
   return true;
}
//-------------------------------------------------------------
//   
bool OpenSelectProf(FILE * BD_file) {
   int rc;

   if (!BD_RSelectProf(BD_file)) {
	  InfMessage("      ");
	  return false;
   }
   if (!BD_RDataBeam(BD_file)) {
	  InfMessage("        ");
	  return false;
   }
   return true;
}
//---------------------------------
//   
bool BD_WSelectProf(FILE* BD_file) {

   FData * data1;
   int param[16];
   int i, j, rc;
   int n_material = 1;

   for (i=0; i<16; i++) {
	 param[i] = 0;
   }

   param[0] = n_material;         //     = 1
   param[1] = Material_Number;    //   
   param[2] = SelectProfilSectForm->Data_select.form_profil;    //  
   param[3] = SelectProfilSectForm->Last_type_sect;

   data1 = BD_WOpenData(BD_file, "SELECTPROF", 0, param, &rc);
   if (rc>0) {
	 PrinCodOpenData(rc);
	 return false;
   }

   rc = BD_WriteData((char *)&(SelectProfilSectForm->Data_select), sizeof(DATA_SELECT ), 1, data1);
   if (rc!=1) return false;
   rc = BD_WriteData((char *)&(MaterProp[0]), sizeof(MATER), n_material+1, data1);
   if (rc!=n_material+1) return false;
   if (param[2]==DVUTAVR_WELD) {
	 rc = BD_WriteData((char *)&(SelectProfilSectForm->Param_chosen_sect), sizeof(PARAM_CHOSEN_SECT), 1, data1);
	 if (rc!=1) return false;
   }
   if (SelectProfilSectForm->Last_type_sect > 0) {
	 rc = BD_WriteData((char *)&(SelectProfilSectForm->Last_com_sect), sizeof(COMMON_SECT), 1, data1);
	 if (rc!=1) return false;
   }
   BD_CloseData(data1);

   return true;
}
//---------------------------------
//    
bool BD_WDataBeam(FILE* BD_file) {

   FData * data1;
   int param[16];
   int i, j, rc;
   int Len_v = SelectProfilSectForm->Data_beam.Len_v;
   int n_zagr = SelectProfilSectForm->Data_beam.n_zagr;
   int n_comb = SelectProfilSectForm->Data_beam.n_comb;
   int constr_length = SelectProfilSectForm->Data_beam.constr_length;

   for (i=0; i<16; i++) {
	 param[i] = 0;
   }

   param[0] = n_zagr;   //  
   param[1] = Len_v;    //  
   param[2] = n_comb;   //  

   data1 = BD_WOpenData(BD_file, "DATABEAM", 0, param, &rc);
   if (rc>0) {
	 PrinCodOpenData(rc);
	 return false;
   }

   rc = BD_WriteData((char *)&(SelectProfilSectForm->Data_beam), sizeof(DATA_BEAM ), 1, data1);
   if (rc!=1) return false;
   if (n_zagr==0)
	 return true;
   //  
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.EI_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.q_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.N_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.loads_v, sizeof(Load), Len_v, data1);
   if (rc!=Len_v) return false;
   if (constr_length>0) {
	 rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.constr, sizeof(Constraint), constr_length, data1);
	 if (rc!=constr_length) return false;
   }
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.type_zagr, sizeof(int), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.flag_weight, sizeof(bool), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.Koeff_gamma_f, sizeof(double), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.Koeff_low, sizeof(double), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_WriteData((char *)SelectProfilSectForm->Data_region.index_beam, sizeof(int), n_zagr*7, data1);
   if (rc!=n_zagr*7) return false;

   if (n_comb!=0) {
	 rc = BD_WriteData((char *)&(SelectProfilSectForm->Data_region.Combin[0][0]), sizeof(double), n_zagr*n_comb, data1);
	 if (rc!=n_zagr*n_comb) return false;
   }

   BD_CloseData(data1);

   return true;
}
//---------------------------------------------------------------------------
bool BD_RSelectProf(FILE* BD_file) {
   FData * data1;
   int param[16];
   int i, j, rc;
   int n_material;


   data1 = BD_ROpenData(BD_file, "SELECTPROF", 0, param, &rc);
   if (rc>0) return false;
   n_material = param[0];         //   
   Material_Number = param[1];    //   
   SelectProfilSectForm->Last_type_sect = param[3];

   rc = BD_ReadData((char *)&(SelectProfilSectForm->Data_select), sizeof(DATA_SELECT ), 1, data1);
   if (rc!=1) return false;
   rc = BD_ReadData((char *)&(MaterProp[0]), sizeof(MATER), n_material+1, data1);
   if (rc!=n_material+1) return false;
   if (param[2]==DVUTAVR_WELD) {
	 rc = BD_ReadData((char *)&(SelectProfilSectForm->Param_chosen_sect), sizeof(PARAM_CHOSEN_SECT), 1, data1);
	 if (rc!=1) return false;
   }
   if (SelectProfilSectForm->Last_type_sect > 0) {
	 rc = BD_ReadData((char *)&(SelectProfilSectForm->Last_com_sect), sizeof(COMMON_SECT), 1, data1);
	 if (rc!=1) return false;
   }
   BD_CloseData(data1);
   return true;
}
//---------------------------------
//    
bool BD_RDataBeam(FILE* BD_file) {

   FData * data1;
   int param[16];
   int i, j, rc;

   data1 = BD_ROpenData(BD_file, "DATABEAM", 0, param, &rc);
   if (data1==NULL) {
	  SelectProfilSectForm->Data_beam.constr_length = 0;
	  SelectProfilSectForm->Data_region.EI_v = 0;
	  SelectProfilSectForm->Data_region.q_v = 0;
	  SelectProfilSectForm->Data_region.N_v = 0;
	  SelectProfilSectForm->Data_region.loads_v = 0;
	  return true;
   }
   if (rc>0) return false;

   int n_zagr = param[0];   //  
   int Len_v = param[1];    //  
   int n_comb = param[2];   //  

   rc = BD_ReadData((char *)&(SelectProfilSectForm->Data_beam), sizeof(DATA_BEAM ), 1, data1);
   if (rc!=1) return false;

   int constr_length = SelectProfilSectForm->Data_beam.constr_length;
   if (n_zagr==0)
	 return true;
   //  
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.EI_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.q_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.N_v, sizeof(BeamRegion), Len_v, data1);
   if (rc!=Len_v) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.loads_v, sizeof(Load), Len_v, data1);
   if (rc!=Len_v) return false;
   if (constr_length>0) {
	 rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.constr, sizeof(Constraint), constr_length, data1);
	 if (rc!=constr_length) return false;
   }
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.type_zagr, sizeof(int), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.flag_weight, sizeof(bool), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.Koeff_gamma_f, sizeof(double), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.Koeff_low, sizeof(double), n_zagr, data1);
   if (rc!=n_zagr) return false;
   rc = BD_ReadData((char *)SelectProfilSectForm->Data_region.index_beam, sizeof(int), n_zagr*7, data1);
   if (rc!=n_zagr*7) return false;
   if (n_comb!=0) {
	 SelectProfilSectForm->Data_region.Combin = (double**)almat((int)(n_comb),(int)(n_zagr),&rc);\
	 if (rc>0)
		return false;
	 rc = BD_ReadData((char *)&(SelectProfilSectForm->Data_region.Combin[0][0]), sizeof(double), n_zagr*n_comb, data1);
	 if (rc!=n_zagr*n_comb) return false;
   }
   BD_CloseData(data1);

   return true;
}

//------------------------------------------------------------
//  
void PrinCodOpenData(int rc) {
  char Message[6][100]={PRINT_ERROR_MESSAGE};

  ErrorMessage("     : "+(AnsiString)Message[rc]);

  return;
}

