//---------------------------------------------------------------------------

#include <vcl.h>
#include <Registry.hpp>

#pragma hdrstop

//     8239-89
//()   26020-83
// ()   26020-83
//   26020-83
//()   26020-83

#include "SelectProfilSect.h"
#include "Define_Material_ARSS.h"
#include "Advanced_gamma_c.h"
#include "Advanced_gamma_n.h"
#include "Data_Gen.h"
#include "StandartProfil.h"
#include "String_doubleUnit.h"
#include "CheckExecuteU.h""
#include "Steel_param_ARSS.h"
#include "TypeData.h"
#include "WRData_Check.h"
#include "message.h"
#include "SaveSelectProf.h"
#include "SortP.h"
#include "ProcExt.h"
#include "ListConst.h"
#include "HelpKoeffLength.h"
#include "HelpClass.h"
#include "ReportSelectSteel.h"
#include "Help_FlexComp.h"
#include "Help_FlexTens.h"
#include "EMBRAC.h"
#include "pCanvas_func.h"
#include "DefineQBal.h"
#include "DrawRSU.h"
#include "AboutProg.h"
#include "Point_dvutavr.h"
#include "Draw3D_beam.h"
#include "Help.h"
#include "Dvutavr_Choice_Alg.h"
#include "Dvutavr_Choice_Alg_0.h"
#include "ChoiceKolonna_Alg.h"
#include "Help_delta_Alg_1.h"
#include "Help_Algor.h"
#include "Get_param_sect_func.h"
//#include "MultiSupport.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SectSelectCom_Param"
#pragma link "SHDocVw_OCX"
#pragma link "Sect_Param_Weld"
#pragma link "Draw_RSU_F"
#pragma link "Draw_RSU_F"
#pragma link "BalkaLoad"
#pragma resource "*.dfm"

#define EMBRAC


TSelectProfilSectForm *SelectProfilSectForm;
//   
TCheckExecute CheckExecute;
const int MruCount = 5;
const char* RegKey = "Software\\BCBJournal\SelectProfilSectProgram";
TStringList* MruList;

MATER MaterProp[MAX_MATERIAL];
//int   n_material;
//int   index_modify_material;
int   Material_Number;

bool flag_sect_change; //    
int  Type_sect;   //   -   
COMMON_SECT *common_sect;
SECT_DVUTAVR *sect;
SECT_DVUTAVR *sect_w;
bool flag_image = true;
TMetafile * GrapMeta = NULL;
TFont     * TheFont;
int Page_Width = 400;
int Page_Height = 270;
TMetafileCanvas *pCanvas;



static TStandartProfil StandartProfil;

static AnsiString String_Centr_Tension[N_CENTR_TENSION_U] ={List_Centr_TensionU};
static int NCentr_Tension = N_CENTR_TENSION_U;

static AnsiString String_Centr_Tension_Tube[N_CENTR_TENSION_TUBE_U] ={List_Centr_TensionU_Tube};
static int NCentr_Tension_Tube = N_CENTR_TENSION_TUBE_U;

static AnsiString String_Centr_Compression[N_CENTR_COMPRESSION_U] ={List_Centr_CompressionU};
static int NCentr_Compression = N_CENTR_COMPRESSION_U;

static AnsiString String_Centr_Compression_Tube[N_CENTR_COMPRESSION_TUBE_U] ={List_Centr_CompressionU_Tube};
static int NCentr_Compression_Tube = N_CENTR_COMPRESSION_TUBE_U;

static AnsiString String_Bending[N_BENDING_U] ={List_BendingU};
static int NBending = N_BENDING_U;

static AnsiString String_Bending_Tube[N_BENDING_TUBE_U] = {List_Bending_TubeU};
static int NBending_Tube = N_BENDING_TUBE_U;

static AnsiString String_Compression_Bending_Const[N_COMPRESSION_BENDING_U] ={List_Compression_Bending_ConstU};
static int NCompression_Bending_Const = N_COMPRESSION_BENDING_U;

static AnsiString String_Compression_Bending_Tube[N_COMPRESSION_BENDING_TUBE_U] ={List_Compression_Bending_TubeU};
static int NCompression_Bending_Tube = N_COMPRESSION_BENDING_TUBE_U;

static AnsiString String_Tension_Bending[N_TENSION_BENDING_U] ={List_Tension_Bending_U};
static int NTension_Bending = N_TENSION_BENDING_U;

static AnsiString String_Tension_Bending_Tube[N_TENSION_BENDING_TUBE_U] ={List_Tension_Bending_TubeU};
static int NTension_Bending_Tube = N_TENSION_BENDING_TUBE_U;


extern char stroka_param[1024];

//---------------------------------------------------------------------------
__fastcall TSelectProfilSectForm::TSelectProfilSectForm(TComponent* Owner)
		: TForm(Owner)
{
	 sect_w = &(sect_weld);

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::FormShow(TObject *Sender)
{
   N_profil = 0;
   BalkaLoadFrame1->Length_beam = 0;

   ComboBox_TypeElemChange(Sender);
   PageControl_Data->ActivePage=TabSheet_Common;
   TabSheet_KI->TabVisible = false;
   TabSheet_Hole->TabVisible = false;
   TabSheet_Weld->TabVisible = false;
   Panel_mater->Caption = "";                                                                        flag_change_elem = false;
   flag_change_rsu = false;
   Label_alfa->Caption = L"  \u03B1, ";
   Label_mass_weld->Caption = "";

   //SectSelectCom_ParamFrame1->TabSheet_Weld->TabVisible = false;
   //SectSelectCom_ParamFrame1->TabSheet_STO->TabVisible = false;
   //SectSelectCom_ParamFrame1->TabSheet_GOST->TabVisible = false;
   SectSelectCom_ParamFrame1->Button_Apply->Visible = false;

   //  
   Define_Material_ARSSForm->ComboBox_gost->ItemIndex = 1;
   Define_Material_ARSSForm->ComboBox_gostChange(Sender);
   Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;

   flag_message = true; //      

   //        
   Draw_prof_ax(0);
   //InfMessage((AnsiString)stroka_param);
   if (stroka_param[0]!='\0') {
	 //  
	 OpenProject(Sender, 1);
	 //InfMessage(":\""+(AnsiString)stroka_param+"\"");
   }
   else {
	   NNewClick(Sender);
   }
   Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
   Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;

   N_profil = 0;

   Show_prof(0, Sender);
   index_mu = RadioGroup_mu->ItemIndex;

   sect_weld.h1 = sect_weld.h2 = 20;
   sect_weld.b1 = sect_weld.b2 = 300;
   sect_weld.h = 500;
   sect_weld.b = 8;
   sect_weld.flag_concl = true;
   sect_weld.n_group = -1;   //   
   sect_weld.n_profil = 0;  //    
   sect_weld.index_orient = 0;   //  = 0 (  XZ)  1 (  YZ)
   sect_weld.type_profil = DVUTAVR;  //   (DVUTAVR) ,  
   sect_weld.index_perfor = 0;  // 0 -   , 1 - 

   Sect_Param_WeldFrame1->Write_sect(Sender);  //    


   Label_mass->Caption =" ";
   Label_conditions->Caption =" ";
   Label_add_conditions->Caption =" ";
   Label_edge->Caption =" ";
   Label_edge_step->Caption =" ";
   Label_edge_param->Caption =" ";
   RadioGroup_Loads->ItemIndex = 0;
   RadioGroup_LoadsClick(Sender);
}
//---------------------------------------------------------------------------
//     
void __fastcall TSelectProfilSectForm::Draw_prof_ax(int n_profil)
{
   int rc;                  //Data_select.type_profil  Data_select.index_profil   BalkaLoadFrame1->n_beam
   double attit;
   double alfa;
   bool flag_sysc = Draw_RSU_Frame1->CheckListBox_Show->Checked[2];
   GEOM_PARAM_SECT param_sect;
   PARAM_PERFOR param_perfor;
   double  length_0;

   if (Draw_RSU_Frame1->CheckBox_RealScale->Checked)
	 length_0 = BalkaLoadFrame1->Length_beam;
   else
	 length_0 = 0;
   switch (Data_select.form_profil) {
   case DVUTAVR_STAND:    //  
   //    
	 Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
	 StandartProfil.SetProfil(Data_select.type_profil);
   //       
	 //NameProfil = StandartProfil.GetVectorNameProfil(&n_profil);
	 rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), n_profil);
	 if (rc>0) return;
	 //Draw_dvutavr(Image_prof, &com_sect.dvutavr, vDIMETR, 1.2, 20, true);
	 //Draw_dvutavr_oblic(Image_prof, &com_sect.dvutavr);
	 Draw_dvutavr(Draw_RSU_Frame1->Image1, &com_sect.dvutavr, vISOMETR, 4.0, 60, flag_sysc, false, 0, 0, length_0);
	 H_beam = com_sect.dvutavr.h + 2*com_sect.dvutavr.h1;
	 B_beam = com_sect.dvutavr.b1;
	 Get_param_sect_comm(DVUTAVR, &com_sect, &param_sect);

   break;
   case PERFOR_BEAM:
   //    
	 Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
	 StandartProfil.SetProfil(Data_select.type_profil);
   //       
	 //NameProfil = StandartProfil.GetVectorNameProfil(&n_profil);
	 rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), n_profil);
	 if (rc>0) return;

	 rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attit);
	 if (rc>0) return;

	 rc = String_double_range(Label_alfa->Caption, Edit_alfa->Text, 40.0, 70.0, &alfa);
	 if (rc>0) return;

	 com_sect.dvutavr.h *= attit;
	 Draw_dvutavr(Draw_RSU_Frame1->Image1, &com_sect.dvutavr, vISOMETR, 4.0, 60, flag_sysc, true, attit, alfa, length_0);

	 H_beam = com_sect.dvutavr.h + 2*com_sect.dvutavr.h1;
	 B_beam = com_sect.dvutavr.b1;

	 com_sect.dvutavr.h /= attit;
	 Get_param_sect_perfor(&com_sect.dvutavr, &param_sect, com_sect.dvutavr.h*attit, &param_perfor);

   break;
   case TRUBA:    // 
	 StandartProfil.SetProfil_Tube(Data_select.type_profil);
	 rc = StandartProfil.SetParamProfil_Tube(&(com_sect), Data_select.type_profil, n_profil);
	 if (rc>0) return;
	 //Draw_tube(Image_prof, &com_sect, Data_select.type_profil, vDIMETR, 1.2, 20, true);
	 Draw_tube(Draw_RSU_Frame1->Image1, &com_sect, Data_select.type_profil, vISOMETR, 4.0, 70, flag_sysc, length_0);

	 Get_param_sect_comm(type_sect_tube, &com_sect, &param_sect);
	 H_beam = param_sect.Hsect;
	 B_beam = param_sect.Wsect;

   break;
   case DVUTAVR_WELD:    //  

	 Draw_dvutavr_weld(Draw_RSU_Frame1->Image1, &sect_weld, vISOMETR, 4.0, 70, flag_sysc, length_0);
	 Get_param_sect(&sect_weld, &param_sect);
	 H_beam = param_sect.Hsect;
	 B_beam = param_sect.Wsect;
   break;
   }
   I_beam = param_sect.Izz;
   F_beam = param_sect.Ar;
   BalkaLoadFrame1->H_beam = H_beam;
   BalkaLoadFrame1->Zct_beam = param_sect.Zct;
   BalkaLoadFrame1->IE_beam = I_beam*206000;
   BalkaLoadFrame1->FE_beam = F_beam*206000;
   BalkaLoadFrame1->FRo_beam = F_beam*7850*1e-6;  // /
   BalkaLoadFrame1->I_beam = I_beam;
   BalkaLoadFrame1->F_beam = F_beam;
   //   ,   
   BalkaLoadFrame1->PutParamSect(&param_sect);

   Draw_RSU_Frame1->L_beam = Data_select.Length[n_plane];
   Draw_RSU_Frame1->form_profil = Data_select.form_profil;
   Draw_RSU_Frame1->index_profil = Data_select.index_profil;
   Draw_RSU_Frame1->type_profil = Data_select.type_profil;
   Draw_RSU_Frame1->attit = Data_select.perfor_attit;
   Draw_RSU_Frame1->alfa = Data_select.perfor_alfa;
   Draw_RSU_Frame1->H_beam = H_beam;
   Draw_RSU_Frame1->B_beam = B_beam;
   Draw_RSU_Frame1->index_Qy = Data_select.index_Qy;
   Draw_RSU_Frame1->Length_beam = BalkaLoadFrame1->Length_beam;
   Draw_RSU_Frame1->Len_XY = BalkaLoadFrame1->Len_XY;
   Draw_RSU_Frame1->Step_up = BalkaLoadFrame1->Step_up;
   Draw_RSU_Frame1->Step_down = BalkaLoadFrame1->Step_down;

   //Draw_RSU_Frame1->beam_mod = &(BalkaLoadFrame1->beam_mod);

   if (RadioGroup_Loads->ItemIndex==0) {  //     
	 double load[6];

	 GetLoadFromRSU(load);

	 for (int i=0; i<5; i++) {
	   Draw_RSU_Frame1->loads[i] = load[i];
	 }
	 Draw_RSU_Frame1->q_bal = load[5];
	 if (load[5]==0) {
	   Draw_RSU_Frame1->GroupBox_q_bal->Visible = false;
	 }
	 else {
	  Draw_RSU_Frame1->GroupBox_q_bal->Visible = true;

	 }
	 Draw_RSU_Frame1->Draw_load() ;
   }
   else {  //    
     int k_zagr;
	 int length_q;
	 BeamRegion *Aq;
	 int length_N;
	 BeamRegion *AN;
	 int length_loads;
	 Load *Aloads;
	 int length_constr;
	 Constraint *Aconstr;     //Data_beam

	 BalkaLoadFrame1->Correct_Weight();

	 BalkaLoadFrame1->GetRegion(&k_zagr, &length_q, &Aq, &length_N, &AN,
								&length_loads, &Aloads, &length_constr, &Aconstr);


	 Draw_RSU_Frame1->Draw_load_balka(k_zagr, length_q, Aq, length_N, AN,
								length_loads, Aloads, length_constr, Aconstr) ;

	 //        
	 GetDataBeam(&Data_beam, &Data_region);           //Data_beam.loads_v[0]

   }
}
//---------------------------------------------------------------------------
//        
void __fastcall TSelectProfilSectForm::GetDataBeam(DATA_BEAM *Data_Beam, DATA_REGION *Data_Region)  {
	//----------------------------------------------
	Data_Beam->n_zagr = BalkaLoadFrame1->n_beam;
	Data_Beam->Length_beam = BalkaLoadFrame1->Length_beam;
	Data_Beam->Len_v = BalkaLoadFrame1->Len_v;
	Data_Beam->n_comb = BalkaLoadFrame1->n_comb;
	Data_Beam->Len_XY = BalkaLoadFrame1->Len_XY;
	Data_Beam->Step_up = BalkaLoadFrame1->Step_up;
	Data_Beam->Step_down = BalkaLoadFrame1->Step_down;
	Data_Beam->constr_length = BalkaLoadFrame1->beam_mod.constr_length;

	Data_Region->EI_v = BalkaLoadFrame1->EI_v;
	Data_Region->q_v  = BalkaLoadFrame1->q_v;      //BalkaLoadFrame1->loads_v[0]
	Data_Region->N_v  = BalkaLoadFrame1->N_v;
	Data_Region->loads_v = BalkaLoadFrame1->loads_v;
	Data_Region->constr = BalkaLoadFrame1->constr;
	Data_Region->type_zagr = BalkaLoadFrame1->type_zagr;
	Data_Region->flag_weight = BalkaLoadFrame1->flag_weight;
	Data_Region->Koeff_gamma_f = BalkaLoadFrame1->Koeff_gamma_f;
	Data_Region->Koeff_low = BalkaLoadFrame1->Koeff_low;
	Data_Region->index_beam = &(BalkaLoadFrame1->index_beam[0][0]);
	Data_Region->Combin = BalkaLoadFrame1->Combin;
}
//---------------------------------------------------------------------------
//        
void __fastcall TSelectProfilSectForm::Fill_field_balka(DATA_BEAM *Data_Beam, DATA_REGION *Data_Region, TObject *Sender)  {
	//----------------------------------------------
	BalkaLoadFrame1->n_beam = Data_Beam->n_zagr;
	BalkaLoadFrame1->Length_beam = Data_Beam->Length_beam;
	BalkaLoadFrame1->Len_v = Data_Beam->Len_v;
	BalkaLoadFrame1->n_comb = Data_Beam->n_comb;
	BalkaLoadFrame1->Len_XY = Data_Beam->Len_XY;
	BalkaLoadFrame1->Step_up = Data_Beam->Step_up;
	BalkaLoadFrame1->Step_down = Data_Beam->Step_down;
	BalkaLoadFrame1->beam_mod.constr_length = Data_Beam->constr_length;

	BalkaLoadFrame1->Combin = Data_Region->Combin;
	//    
	BalkaLoadFrame1->Fill_field(Sender);
	/*
	Data_Region->EI_v = BalkaLoadFrame1->EI_v;
	Data_Region->q_v  = BalkaLoadFrame1->q_v;      //BalkaLoadFrame1->loads_v[0]
	Data_Region->N_v  = BalkaLoadFrame1->N_v;
	Data_Region->loads_v = BalkaLoadFrame1->loads_v;
	Data_Region->constr = BalkaLoadFrame1->constr;
	Data_Region->type_zagr = BalkaLoadFrame1->type_zagr;
	Data_Region->flag_weight = BalkaLoadFrame1->flag_weight;
	Data_Region->Koeff_gamma_f = BalkaLoadFrame1->Koeff_gamma_f;
	Data_Region->Koeff_low = BalkaLoadFrame1->Koeff_low;
	Data_Region->index_beam = &(BalkaLoadFrame1->index_beam[0][0]);
	*/
}

//-----------------------------------------------------------------
void __fastcall TSelectProfilSectForm::BitBtnExitClick(TObject *Sender)
{
	Close();
}
//
//---------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::BitBtnExecClick(TObject *Sender)
{
   int i, rc;
   if ( Material_Number < 1 || strcmp(MaterProp[Material_Number].title,"")==0) {
		 #ifdef EMBRAC
			i = Application->MessageBox(L" ",
										L"  ",
		 #else
			i = Application->MessageBox(" ",
										"  ",
		 #endif
				MB_OK | MB_ICONWARNING);
			BitBtnMaterialClick(Sender);
   }

   if (flag_change_rsu) {
	 #ifdef EMBRAC
	 rc=Application->MessageBox(L"   ,     .   c  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 rc=Application->MessageBox("   ,     .   c  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;
   }
   //InfMessage("  ");
   Label_mass->Caption = "";
   Label_mass_weld->Caption = "";
   Label_conditions->Caption = "";
   Label_edge->Caption = "";
   Label_edge_step->Caption =" ";
   Label_edge_param->Caption =" ";
   //TabSheet_sect_prof->TabVisible = false;
   TabSheet_KI->TabVisible = false;
   //Sect_Param_WeldFrame1->Visible = false;

   PageControl_Data->ActivePage=TabSheet_Common;
   flag_checking = false;

   //--------------------------------------------------------------
   //   
   SectChecking(-1, -1, Sender);       //common_sect->dvutavr

   Draw_prof_ax(N_profil);

}
//--------------------------------------------------------------------------------
//   
void __fastcall TSelectProfilSectForm::SectChecking(int index, int n_thick, TObject *Sender)
{
	  int i, rc;
	  double ss;
	  double mass_prof;
	  int num_prof;
	  AnsiString StrFall;

	  //  
	  rc = Read_data(Sender);
	  if (rc>0) {
		return;
	  }

	  //  
	  if (Data_select.flag_add_limit) {
		 if (Data_select.max_width == 0 && Data_select.max_height == 0) {
		  #ifdef EMBRAC
			rc=Application->MessageBox(L"     ",
									   L" ", MB_OK | MB_ICONERROR);
		  #else
			rc=Application->MessageBox("     ",
									   " ", MB_OK | MB_ICONERROR);
		  #endif
		  return;
		 }
	  }
	  //       
	  //if (!CheckRSU())
	  //	return;
	  flag_conditions = false;

	  //       
	  rc = Executive(index, n_thick, &mass_prof, &num_prof, Sender);

	  Label_add_conditions->Caption = "";

	  if (index>=0 && rc > 1) {   //   
		switch (rc) {
		case steel_T_UPPER:
		  if (Data_select.form_profil==DVUTAVR_STAND || Data_select.form_profil==TRUBA ||
			  Data_select.form_profil==PERFOR_BEAM) {
			  Label_add_conditions->Caption="  "+FloatToStrF(CheckExecute.thick_prof, ffFixed, 15, 1)+"     "+
			  FloatToStrF(CheckExecute.thick_range_material[0], ffFixed, 15, 0)+"    "+ (AnsiString)CheckExecute.Msteel_prof;
			  PageControl_Data->ActivePage = TabSheet_sect_prof;
		  }
		  else {
			  Label_mass_weld->Caption="  "+FloatToStrF(CheckExecute.thick_prof, ffFixed, 15, 1)+"     "+
			  FloatToStrF(CheckExecute.thick_range_material[0], ffFixed, 15, 0)+"    "+ (AnsiString)CheckExecute.Msteel_prof;
			  PageControl_Data->ActivePage = TabSheet_Weld;
		  }
		  Show_prof(num_prof, Sender);
		break;
		case steel_T_LESS:
		  if (Data_select.form_profil==DVUTAVR_STAND || Data_select.form_profil==TRUBA ||
			  Data_select.form_profil==PERFOR_BEAM) {
			  Label_add_conditions->Caption="  "+FloatToStrF(CheckExecute.thick_prof, ffFixed, 15, 1)+"     "+
			  FloatToStrF(CheckExecute.thick_range_material[1], ffFixed, 15, 0)+"    "+ (AnsiString)CheckExecute.Msteel_prof;
			  PageControl_Data->ActivePage = TabSheet_sect_prof;    //common_sect->dvutavr
		  }
		  else {
			  Label_mass_weld->Caption="  "+FloatToStrF(CheckExecute.thick_prof, ffFixed, 15, 1)+"     "+
			  FloatToStrF(CheckExecute.thick_range_material[1], ffFixed, 15, 0)+"    "+ (AnsiString)CheckExecute.Msteel_prof;
			  PageControl_Data->ActivePage = TabSheet_Weld;
		  }
		  Show_prof(num_prof, Sender);
		break;
		case steel_NO_STEEL:
		  if (strcmp(MaterProp[Material_Number].title,"")==0) {
	 #ifdef EMBRAC
			i=Application->MessageBox(L"   ", L"",
								  MB_OK | MB_ICONERROR);
	 #else
			i=Application->MessageBox("   ", "",
								  MB_OK | MB_ICONERROR);
	 #endif
		  }
		  else {
	 #ifdef EMBRAC
			i=Application->MessageBox((L"   " + (AnsiString)(MaterProp[Material_Number].title)).c_str(), L"",
								  MB_OK | MB_ICONERROR);
	 #else
			i=Application->MessageBox(("   " + (AnsiString)(MaterProp[Material_Number].title)).c_str(), "",
								  MB_OK | MB_ICONERROR);
	 #endif
		  }
		break;
		}
	  }

	  else  {
		switch (rc) {
		case steel_T_UPPER:
		case steel_T_LESS:
		case 1:
		 #ifdef EMBRAC
		 rc=Application->MessageBox(L"         ",
									L" ", MB_OK | MB_ICONERROR);
		 #else
		 rc=Application->MessageBox("         ",
									" ", MB_OK | MB_ICONERROR);
		 #endif
		case 0:
		  switch (Data_select.form_profil) {
		   case DVUTAVR_STAND:     //  
		   case TRUBA:
		  //      
			Show_prof(num_prof, Sender);
			TabSheet_sect_prof->TabVisible = true;
			PageControl_Data->ActivePage = TabSheet_sect_prof;    //common_sect->dvutavr
		   break;
		   case PERFOR_BEAM:
		  //      
			Show_prof(num_prof, Sender);

			Show_prof_perfor(num_prof, Sender, Data_select.perfor_attit, Data_select.perfor_alfa, true);
			TabSheet_sect_prof->TabVisible = true;
			PageControl_Data->ActivePage = TabSheet_sect_prof;    //common_sect->dvutavr
		   break;
		   case DVUTAVR_WELD:   //  
			Show_prof(num_prof, Sender);
		   break;
		  }
	  	  BitBtnCheck->Enabled = true;
		  TabSheet_KI->TabVisible = true;
		  Sect_Param_WeldFrame1->Visible = true;
		  Label_mass->Caption = "  "+FloatToStr(Round(mass_prof, 1));
		  Label_mass_weld->Caption = "  "+FloatToStr(Round(mass_prof, 1));
		  if (Flag_fall_mater)
			StrFall = ", -       .";
		  else
			StrFall ="";

		  Label_edge->Caption =" ";
		  Label_edge_step->Caption =" ";
          Label_edge_param->Caption =" ";


		  if (flag_conditions && rc == 0) {
			  if (Data_select.flag_add_limit)
				Label_conditions->Caption = "          ";
			  else
				Label_conditions->Caption = "    ";
			  //if (Data_select.index_edge==1 && CheckExecute.step_edge < 1e6) {
			  //	if (CheckExecute.step_edge > 10)
			  //	  Label_edge->Caption = "    " + FloatToStr(CheckExecute.step_edge) + " .";
			  //	else
			  //	  Label_edge->Caption = "  ";
			  //}
			  //	  Label_edge->Caption = "  ";
			  if (Data_select.index_1_or_2>=0) {
				  AnsiString Type_edge;
				  double step_max = MIN(CheckExecute.edge_param[0][0], CheckExecute.edge_param[1][0]);
				  step_max = MIN(step_max, CheckExecute.edge_param[2][0]);
				  double br = MAX(CheckExecute.edge_param[0][1], CheckExecute.edge_param[1][1]);
				  br = MAX(br, CheckExecute.edge_param[2][1]);
				  br = Round_row(br, 0);
				  double tr = MAX(CheckExecute.edge_param[0][2], CheckExecute.edge_param[1][2]);
				  tr = MAX(tr, CheckExecute.edge_param[2][2]);
				  tr = Round_row(tr, RadioGroup_sort->ItemIndex);
				  if (RadioGroup_1_or_2->ItemIndex==0)
					Type_edge = "    ";
				  else
					Type_edge = "     ";

				  if (step_max < 1e6) {
					Label_edge_step->Caption = Type_edge + FloatToStr(step_max) + " ";
					Label_edge_param->Caption = "   "+FloatToStr(br)+" ; " +
												" "+FloatToStr(tr)+" ."  ;
				  }
				  else {
					Label_edge_step->Caption = "  ";
				  }
			  }
		  }

			else {
			  if (index==-1) {
				if (Data_select.flag_add_limit)
					Label_conditions->Caption = "           . " + StrFall;
				else  {
			//       ";
				  Label_conditions->Caption = "     . " + StrFall;
				}


				Label_add_conditions->Caption = "      . ";

			  }
			 else
			   Label_conditions->Caption = "     ";
			}
		 break;
		 case 101:
			#ifdef EMBRAC
			 rc=Application->MessageBox(L"   .     ", L" ", MB_OK | MB_ICONERROR);
		   #else
			 rc=Application->MessageBox("   .     ", " ", MB_OK | MB_ICONERROR);
		   #endif
			PageControl_Data->ActivePage = TabSheet_Part;
		break;
		defaults:
		 #ifdef EMBRAC
		 rc=Application->MessageBox(L"Executive: ", L" ", MB_OK | MB_ICONERROR);
		 #else
		 rc=Application->MessageBox("Executive: ", " ", MB_OK | MB_ICONERROR);
		 #endif
		}
	 }
	flag_checking = true;
	return;

}
//--------------------------------------------------------------------
//       
//   
void __fastcall TSelectProfilSectForm::Show_prof(int num_prof, TObject *Sender)
{
	  int k, rc;
	  int i, j;

	  N_profil = num_prof;

	  TabSheet_Weld->TabVisible = false;
	  TabSheet_sect_prof->TabVisible = false;
	  switch (Data_select.form_profil) {
	  case DVUTAVR_STAND:
	  case PERFOR_BEAM:
		TabSheet_sect_prof->TabVisible = true;
		Type_sect = DVUTAVR;
		//        
		rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), num_prof);
		if (rc>0) return;
		SectSelectCom_ParamFrame1->TabSheet_Standart->TabVisible = true;
		SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = false;

		common_sect = &(com_sect);
		SectSelectCom_ParamFrame1->Check_Original();  //    
		//-------------------------------------------------
		//   
		//-------------------------------------------------
		SectSelectCom_ParamFrame1->Write_sect(Sender);
	  break;
	  case TRUBA:
		TabSheet_sect_prof->TabVisible = true;
		SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = false;
		SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = false;
		SectSelectCom_ParamFrame1->TabSheet_Standart->TabVisible = false;
		switch (Data_select.type_profil) {
		case typeSQUARE:
		  SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = true;
		  Type_sect = SQUARE_TUBE;
		break;
		case typeRECT:
		  SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = true;
		  Type_sect = RECT_TUBE;
		break;
		case typeCIRC:
		  SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = true;
		  Type_sect = CIRCULAR_TUBE;
		break;
		default:
		;
		}
		rc = StandartProfil.SetParamProfil_Tube(&(com_sect), Data_select.type_profil, num_prof);

		common_sect = &(com_sect);
		SectSelectCom_ParamFrame1->Check_Original();  //    
		SectSelectCom_ParamFrame1->Write_sect(Sender);
	  break;
	  case DVUTAVR_WELD:
		Type_sect = DVUTAVR;
		TabSheet_Weld->TabVisible = true;
		PageControl_Data->ActivePage = TabSheet_Weld;
		//        
		Sect_Param_WeldFrame1->Write_sect(Sender);  //    
	  break;
	  }


	  TRichEdit *RichEdit_KI;
	  TabSheet_KI_CT->TabVisible = false;
	  TabSheet_KI_CC->TabVisible = false;
	  TabSheet_KI_CB->TabVisible = false;
	  TabSheet_KI_B->TabVisible = false;
	  TabSheet_KI_TB->TabVisible = false;

	  flag_conditions = true;
	  for (j=0; j<NUMBER_CHECK; j++) {
		if (!flag_check[j])  // ,      
		   continue;
		switch (j) {
		case CENTR_TENSION:
		  TabSheet_KI_CT->TabVisible = true;
		  RichEdit_KI = RichEdit_KI_CT;
		break;
		case CENTR_COMPRESSION:
		  TabSheet_KI_CC->TabVisible = true;
		  RichEdit_KI = RichEdit_KI_CC;
		break;
		case COMPRESSION_BENDING:
		  TabSheet_KI_CB->TabVisible = true;
		  RichEdit_KI = RichEdit_KI_CB;
		break;
		case BENDING:
		  TabSheet_KI_B->TabVisible = true;
		  RichEdit_KI = RichEdit_KI_B;
		break;
		case TENSION_BENDING:
		  TabSheet_KI_TB->TabVisible = true;
		  RichEdit_KI = RichEdit_KI_TB;
		break;
		}
		RichEdit_KI->Clear();
		for (i=0, k=0; i<Data_select.N_check[j]; i++) {
		  if (Round(Krit[j][i], 2) > 1.0) {
			RichEdit_KI->SelAttributes->Color=clRed;
			flag_conditions = false;
		  }
		  else
			RichEdit_KI->SelAttributes->Color=clBlack;
		  if (Num_prov[j][i]==1) {
			k++;
			if (Krit[j][i] >=0)
			  RichEdit_KI->Lines->Add(" "+FloatToStr(Round(Krit[j][i], 2)));
			else
			  RichEdit_KI->Lines->Add("  -");
		  }
		}
	  }


}
//--------------------------------------------------------------------
//    
void __fastcall TSelectProfilSectForm::Show_prof_perfor(int num_prof, TObject *Sender, double perfor_attit, double perfor_alfa, bool flag_draw_size)
{
	  int k, rc;
	  int i, j;
	if (Data_select.form_profil!=PERFOR_BEAM)
	  return;

	N_profil = num_prof;

	//        
	rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), num_prof);
	if (rc>0) return;
	double h0 = com_sect.dvutavr.h + com_sect.dvutavr.h1 + com_sect.dvutavr.h2;
	double k_att = perfor_attit/3;
	double perfor_h = Round(k_att*h0, 0) - 1;
	double perfor_b = Round(k_att*h0/tan(perfor_alfa/RADIAN), 0);
	double perfor_a = Round(k_att*h0/sin(perfor_alfa/RADIAN), 0) + 2;
	double perfor_h1 = perfor_h;
	double perfor_h2 = Round(perfor_attit*h0 - 2*perfor_h, 0);
	double perfor_s = 2*(perfor_a + perfor_b);
	double perfor_c = MAX(250, perfor_a + perfor_b);
		//  :  ,  ,  ,  
	float scale = draw_profil_perfor_scale(Image_perfor, Image_Balka, &(com_sect.dvutavr), perfor_h1, perfor_s, perfor_c);
	//     XY
	draw_dvutavr_perfor(Image_perfor, &(com_sect.dvutavr), perfor_h1, scale, flag_draw_size);
	//     YZ ( )
	draw_profil_perfor(Image_Balka, &(com_sect.dvutavr), perfor_h1, perfor_a, perfor_b,
					   perfor_s, perfor_c, perfor_alfa, scale, flag_draw_size);
}
//---------------------------------------------------------------------------
//----------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::RadioButton_DvutavrClick(TObject *Sender)
{
	if (RadioButton_Dvutavr->Checked) {
	  //CheckBoxAddLimit->Enabled = true;
	  Label_step_comp->Visible = true;
	  Edit_step_comp->Visible = true;
	  Label_step_prim->Visible = true;
	  TabSheet_Weld->TabVisible = false;
	  TabSheetPerfor->TabVisible = false;
	  TabSheet_sect_prof->TabVisible = true;
	  TabSheet_KI->TabVisible = false;
	  CheckBoxAddLimit->Visible = true;
	  CheckBoxAddLimit->Checked = false;
	  CheckBox_edge->Enabled = true;
	  CheckBox_edge_choose->Visible = true;
	  RadioGroup_1_or_2->Visible = false;
	  RadioGroup_Loads->Visible = true;

	  RadioButton_Tube->Checked = false;
	  RadioButton_Weld->Checked = false;
	  ComboBox_Dvutavr->Visible = true;
	  ComboBox_Tube->Visible = false;
	  Data_select.form_profil = DVUTAVR_STAND;
	  Label_add_conditions->Caption = " ";
	  //Define_Material_ARSSForm->ComboBox_gost->ItemIndex = 1;
	  //Define_Material_ARSSForm->ComboBox_gostChange(Sender);
	  //   ,   ,
	  Define_Material_ARSSForm->Set_Material_name(DVUTAVR_STAND, Data_select.index_GOST, Data_select.title_material);
	  Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;

	  ComboBox_TypeElemChange(Sender);
	  Config_RSU(DVUTAVR_STAND);
	  flag_change_rsu = false;

	  GroupBox_bend->Visible = true;

	  //       
	  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;

	  Show_prof(0, Sender);

	  Draw_prof_ax(N_profil);
	  modify_project = true;

	}
}
//--------------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::RadioButton_WeldClick(TObject *Sender)
{
	if (RadioButton_Weld->Checked) {
	  CheckBoxAddLimit->Enabled = true;
	  Label_step_comp->Visible = true;
	  Edit_step_comp->Visible = true;
	  Label_step_prim->Visible = true;
	  TabSheet_sect_prof->TabVisible = false;
	  TabSheet_KI->TabVisible = false;
	  TabSheet_Weld->TabVisible = true;
	  TabSheetPerfor->TabVisible = false;
	  //GroupBox_AddLimit->Enabled = false;
	  Label_width->Enabled = false;
	  Edit_width->Enabled = false;
	  Label_height->Enabled = false;
	  Edit_height->Enabled = false;
	  flag_checking = false;
	  CheckBox_edge_choose->Visible = false;
	  RadioGroup_1_or_2->Visible = false;
	  RadioGroup_Loads->Visible =false;
	  RadioGroup_Loads->ItemIndex = 0;

	  RadioButton_Tube->Checked = false;
	  RadioButton_Dvutavr->Checked = false;
	  ComboBox_Dvutavr->Visible = false;
	  ComboBox_Tube->Visible = false;
	  Data_select.form_profil = DVUTAVR_WELD;
	  //Define_Material_ARSSForm->ComboBox_gost->ItemIndex = 1;
	  //Define_Material_ARSSForm->ComboBox_gostChange(Sender);
	  //   ,   ,
	  Define_Material_ARSSForm->Set_Material_name(Data_select.form_profil, Data_select.index_GOST, Data_select.title_material);
	  Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;

	  ComboBox_TypeElemChange(Sender);
	  Config_RSU(DVUTAVR_WELD);
	  GroupBox_bend->Visible = true;
	  flag_change_rsu = false;

	  //       
	  Draw_prof_ax(0);
	  modify_project = true;

	}

}
//---------------------------------------------------------------------------
// 
void __fastcall TSelectProfilSectForm::RadioButton_TubeClick(TObject *Sender)
{
	if (RadioButton_Tube->Checked) {
	  CheckBoxAddLimit->Checked = false;
	  CheckBoxAddLimit->Enabled = false;
	  CheckBoxAddLimit->Visible = true;
	  //GroupBox_bend->Visible = false;
	  Label_step_comp->Visible = false;
	  Edit_step_comp->Visible = false;
	  Label_step_prim->Visible = false;
	  TabSheet_sect_prof->TabVisible = true;
	  TabSheet_Weld->TabVisible = false;
	  TabSheetPerfor->TabVisible = false;
	  CheckBox_edge->Enabled = true;
	  CheckBox_edge_choose->Visible = false;
	  RadioGroup_1_or_2->Visible = false;
	  RadioGroup_Loads->Visible = true;

	  modify_project = true;

	  if (flag_message) {
		if (Data_select.N_plane > 0) {
		  #ifdef EMBRAC
		  //int rc = Application->MessageBox(L"          . ? ",
		  //L" ", MB_YESNO | MB_ICONQUESTION);
		  #else
		  //int rc = Application->MessageBox("          . ? ",
		  //" ", MB_YESNO | MB_ICONQUESTION);
		  #endif
		  //if (rc==IDNO) {
		  //	RadioButton_Dvutavr->Checked = true;
		  //	return;
		  //}

		}
	  }
	  RadioButton_Dvutavr->Checked = false;
	  RadioButton_Weld->Checked = false;
	  ComboBox_Dvutavr->Visible = false;
	  ComboBox_Tube->Visible = true;
	  Data_select.form_profil = TRUBA;
	  //   -   
	  Config_RSU(TRUBA);
	  flag_change_rsu = false;

	  switch (ComboBox_Tube->ItemIndex) {
			case 0:
			  Data_select.type_profil = typeSQUARE;
			  type_sect_tube = SQUARE_TUBE;
			  RadioButton_Tube->Caption = "    30245";
			break;
			case 1:
			  Data_select.type_profil = typeRECT;
			  type_sect_tube = RECT_TUBE;
			  RadioButton_Tube->Caption = "    30245";
			break;
			case 2:
			  Data_select.type_profil = typeCIRC;
			  type_sect_tube = CIRCULAR_TUBE;
			  RadioButton_Tube->Caption = "    58064";
			break;
	  }
	  //Define_Material_ARSSForm->ComboBox_gost->ItemIndex = 0;
	  //Define_Material_ARSSForm->ComboBox_gostChange(Sender);

	  //   ,   ,
	  Define_Material_ARSSForm->Set_Material_name(Data_select.form_profil, Data_select.index_GOST, Data_select.title_material);
	  Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;
	  ComboBox_TypeElemChange(Sender);

	  Data_select.form_profil = TRUBA;   // 

	  Show_prof(0, Sender);
	  //      
	  Draw_prof_ax(0);
	}

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::ComboBox_TypeElemChange(TObject *Sender)
{
	int i, k;
	// -
	int Num_prov_centr_tension[N_CENTR_TENSION_U] = NUM_PROV_CENTR_TENSION;
	int Num_prov_centr_tension_tube[N_CENTR_TENSION_TUBE_U] = NUM_PROV_CENTR_TENSION_TUBE;
	int Num_prov_centr_tension_circ[N_CENTR_TENSION_TUBE_U] = NUM_PROV_CENTR_TENSION_CIRC;
	// -
	int Num_prov_tension_bending[N_TENSION_BENDING_U] = NUM_PROV_TENSION_BENDING;
	int Num_prov_tension_bending_Tube[N_TENSION_BENDING_TUBE_U] = NUM_PROV_TENSION_BENDING_TUBE;
	int Num_prov_tension_bending_Circ[N_TENSION_BENDING_TUBE_U] = NUM_PROV_TENSION_BENDING_CIRC;
	// -
	int Num_prov_centr_compress[N_CENTR_COMPRESSION_U] = NUM_PROV_CENTR_COMPRESS;
	int Num_prov_centr_compress_tube[N_CENTR_COMPRESSION_TUBE_U] = NUM_PROV_CENTR_COMPRESS_TUBE;
	int Num_prov_centr_compress_circ[N_CENTR_COMPRESSION_TUBE_U] = NUM_PROV_CENTR_COMPRESS_CIRC;
	// -
	int Num_prov_compress_bending[N_COMPRESSION_BENDING_U] = NUM_PROV_COMPRESS_BENDING;
	int Num_prov_compress_bending_tube[N_COMPRESSION_BENDING_TUBE_U] = NUM_PROV_COMPRESS_BENDING_TUBE;
	int Num_prov_compress_bending_circ[N_COMPRESSION_BENDING_TUBE_U] = NUM_PROV_COMPRESS_BENDING_CIRC;
	// 
	int Num_prov_bending[N_BENDING_U] = NUM_PROV_BENDING;
	int Num_prov_bending_weld[N_BENDING_U] = NUM_PROV_BENDING_WELD;
	int Num_prov_bending_perf[N_BENDING_U] = NUM_PROV_BENDING_PERF;
	int Num_prov_bending_Tube[N_BENDING_TUBE_U] = NUM_PROV_BENDING_TUBE;
	int Num_prov_bending_Circ[N_BENDING_TUBE_U] = NUM_PROV_BENDING_CIRC;

	//---------------------------------------------------------------------------
	//     

	  ListBox_KI_CT->Clear();
	  ListBox_KI_TB->Clear();
		ListBox_KI_CC->Clear();
		ListBox_KI_CB->Clear();
		ListBox_KI_B->Clear();

	  switch (Data_select.form_profil) {
	  case DVUTAVR_STAND:
	  case PERFOR_BEAM:
	  case DVUTAVR_WELD:
		Data_select.N_check[0] = NCentr_Tension;
		for (i=0, k=0; i<NCentr_Tension; i++) {
		  Num_prov[0][i] = Num_prov_centr_tension[i];
		  if (Num_prov[0][i]==1) {
			k++;
			ListBox_KI_CT->Items->Add(IntToStr(k) + ". "+String_Centr_Tension[i]);
		  }
		}
		Data_select.N_check[1] = NCentr_Compression;
		for (i=0, k=0; i<NCentr_Compression; i++) {
		  Num_prov[1][i] = Num_prov_centr_compress[i];
		  if (Num_prov[1][i]==1) {
			k++;
			ListBox_KI_CC->Items->Add(IntToStr(k) + ". "+String_Centr_Compression[i]);
		  }
		}
		Data_select.N_check[2] = NCompression_Bending_Const;
		for (i=0, k=0; i<NCompression_Bending_Const; i++) {
		  Num_prov[2][i] = Num_prov_compress_bending[i];
		  if (Num_prov[2][i]==1) {
			k++;
			ListBox_KI_CB->Items->Add(IntToStr(k) + ". " + String_Compression_Bending_Const[i]);
		  }
		}
		Data_select.N_check[3] = NBending;
		for (i=0, k=0; i<NBending; i++) {
		  switch (Data_select.form_profil) {
		  case DVUTAVR_STAND:
			Num_prov[3][i] = Num_prov_bending[i];
		  break;
		  case PERFOR_BEAM:
			Num_prov[3][i] = Num_prov_bending_perf[i];
		  break;
		  case DVUTAVR_WELD:
			Num_prov[3][i] = Num_prov_bending_weld[i];
		  break;
		  }
		  if (Num_prov[3][i]==1) {
			k++;
			ListBox_KI_B->Items->Add(IntToStr(k) + ". " + String_Bending[i]);
		  }
		}
		Data_select.N_check[4] = NTension_Bending;
		for (i=0, k=0; i<NTension_Bending; i++) {
		  Num_prov[4][i] = Num_prov_tension_bending[i];
		  if (Num_prov[4][i]==1) {
			k++;
			ListBox_KI_TB->Items->Add(IntToStr(k) + ". " + String_Tension_Bending[i]);
		  }
		}
		StringGrid_Length->ColCount = 5;
	  break;
	  case TRUBA:  // 
		Data_select.N_check[0] = NCentr_Tension_Tube;
		for (i=0, k=0; i<NCentr_Tension_Tube; i++) {
		  if (Data_select.type_profil==typeCIRC)
			Num_prov[1][i] = Num_prov_centr_tension_circ[i];
		  else
			Num_prov[0][i] = Num_prov_centr_tension_tube[i];

		  if (Num_prov[0][i]==1) {
			k++;
			ListBox_KI_CT->Items->Add(IntToStr(k) + ". "+String_Centr_Tension_Tube[i]);      //ListBox_KI_CC->Visible
		  }
		}
		Data_select.N_check[1] = NCentr_Compression_Tube;
		for (i=0, k=0; i<NCentr_Compression_Tube; i++) {
		  if (Data_select.type_profil==typeCIRC)
			Num_prov[1][i] = Num_prov_centr_compress_circ[i];
		  else
			Num_prov[1][i] = Num_prov_centr_compress_tube[i];

		  if (Num_prov[1][i]==1) {
			k++;
			ListBox_KI_CC->Items->Add(IntToStr(k) + ". "+String_Centr_Compression_Tube[i]);
		  }
		}
		Data_select.N_check[2] = NCompression_Bending_Tube;
		for (i=0, k=0; i<NCompression_Bending_Tube; i++) {
		  if (Data_select.type_profil==typeCIRC)
			Num_prov[2][i] = Num_prov_compress_bending_circ[i];
		  else
			Num_prov[2][i] = Num_prov_compress_bending_tube[i];
		  if (Num_prov[2][i]==1) {
			k++;
			ListBox_KI_CB->Items->Add(IntToStr(k) + ". " + String_Compression_Bending_Tube[i]);
		  }
		}
		Data_select.N_check[3] = NBending_Tube;
		for (i=0, k=0; i<NBending_Tube; i++) {
		  if (Data_select.type_profil==typeCIRC)
			Num_prov[3][i] = Num_prov_bending_Circ[i];
		  else
			Num_prov[3][i] = Num_prov_bending_Tube[i];
		  if (Num_prov[3][i]==1) {
			k++;
			ListBox_KI_B->Items->Add(IntToStr(k) + ". " + String_Bending_Tube[i]);
		  }
		}
		Data_select.N_check[4] = NTension_Bending_Tube;
		for (i=0, k=0; i<NTension_Bending_Tube; i++) {
		  if (Data_select.type_profil==typeCIRC)
			Num_prov[4][i] = Num_prov_tension_bending_Circ[i];
		  else
			Num_prov[4][i] = Num_prov_tension_bending_Tube[i];
		  if (Num_prov[4][i]==1) {
			k++;
			ListBox_KI_TB->Items->Add(IntToStr(k) + ". " + String_Tension_Bending_Tube[i]);
		  }
		}
		StringGrid_Length->ColCount = 4;
	  break;
	  case 100:

		Data_select.N_check[0] = NCentr_Tension;
		for (i=0, k=0; i<NCentr_Tension; i++) {
		  Num_prov[0][i] = Num_prov_centr_tension[i];
		  if (Num_prov[0][i]==1) {
			k++;
			ListBox_KI_CT->Items->Add(IntToStr(k) + ". "+String_Centr_Tension[i]);
		  }
		}
		Data_select.N_check[1] = NCentr_Compression;
		for (i=0, k=0; i<NCentr_Compression; i++) {
		  Num_prov[1][i] = Num_prov_centr_compress[i];
		  if (Num_prov[1][i]==1) {
			k++;
			ListBox_KI_CC->Items->Add(IntToStr(k) + ". "+String_Centr_Compression[i]);
		  }
		}
		Data_select.N_check[2] = NCompression_Bending_Const;
		for (i=0, k=0; i<NCompression_Bending_Const; i++) {
		  Num_prov[2][i] = Num_prov_compress_bending[i];
		  if (Num_prov[2][i]==1) {
			k++;
			ListBox_KI_CB->Items->Add(IntToStr(k) + ". " + String_Compression_Bending_Const[i]);
		  }
		}
		Data_select.N_check[3] = NBending;
		for (i=0, k=0; i<NBending; i++) {
		  Num_prov[3][i] = Num_prov_bending[i];
		  if (Num_prov[3][i]==1) {
			k++;
			ListBox_KI_B->Items->Add(IntToStr(k) + ". " + String_Bending[i]);
		  }
		}
		Data_select.N_check[4] = NTension_Bending;
		for (i=0, k=0; i<NTension_Bending; i++) {
		  Num_prov[4][i] = Num_prov_tension_bending[i];
		  if (Num_prov[4][i]==1) {
			k++;
			ListBox_KI_TB->Items->Add(IntToStr(k) + ". " + String_Tension_Bending[i]);
		  }
		}
		StringGrid_Length->ColCount = 5;
	  break;
	  }

	RadioGroup_muClick(Sender);                 //Data_select.index_profil
	//
	NumRow_Len = -1;

	StringGrid_Length->RowCount = Data_select.N_plane + 1;
	 //     
	StringGrid_Length->Cells[0][0] = "";
	StringGrid_Length->Cells[1][0] = " L";
	StringGrid_Length->Cells[2][0] = "lef_XZ";
	StringGrid_Length->Cells[3][0] = "lef_XY";
	if (Data_select.form_profil == DVUTAVR_STAND || Data_select.form_profil == DVUTAVR_WELD || Data_select.form_profil == PERFOR_BEAM)
	  StringGrid_Length->Cells[4][0] = "l_";
	if (Data_select.N_plane==0 || RadioGroup_Loads->ItemIndex==1) {
	  BitBtn_LenRep->Enabled = false;
	  BitBtn_LenDel->Enabled = false;
	}
	else {
	  BitBtn_LenRep->Enabled = true;
	  BitBtn_LenDel->Enabled = true;
	}
	//    
	StringGrid_RSU->ColCount = 7;
	NumRow_RSU = -1;

	StringGrid_RSU->RowCount = 1;
	 //     
	StringGrid_RSU->Cells[0][0] = "";
	StringGrid_RSU->Cells[1][0] = "N, ";
	StringGrid_RSU->Cells[2][0] = "My, *";
	StringGrid_RSU->Cells[3][0] = "Qz, ";
	StringGrid_RSU->Cells[4][0] = "Mz, *";
	StringGrid_RSU->Cells[5][0] = "Qy, ";
	StringGrid_RSU->Cells[6][0] = "qz, /";
	BitBtn_RSUAdd->Enabled = false;
	BitBtn_RSURep->Enabled = false;
	BitBtn_RSUDel->Enabled = false;
	  //   Lenth
	  StringGrid_LengthMySelect(1);
	  //   RSU
	  if (Data_select.N_RSU[0]>0)
		StringGrid_RSUMySelect(1);

	//
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BitBtn_Advance_gamma_cClick(
	  TObject *Sender)
{
   Advanced_gamma_cForm->ShowModal();
   if (Advanced_gamma_cForm->Koeff_gamma_c > 0) {
	  ComboBox_gamma_c->Text = FloatToStr(Advanced_gamma_cForm->Koeff_gamma_c);
   }
   modify_project = true;


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtnMaterialClick(TObject *Sender)
{
	 Define_Material_ARSSForm->ShowModal();
	 Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;
	 modify_project = true;
	 strcpy(Data_select.title_material, MaterProp[Material_Number].title);
	 Data_select.index_GOST = MaterProp[Material_Number].index_GOST;
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::ComboBox_n_partChange(
      TObject *Sender)
{
	 ComboBox_TypeElemChange(Sender);
}
//---------------------------------------------------------------------------
#include "SelectProfilSect%Executive.cpp"


//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::NOpenClick(TObject *Sender)
{
	  OpenProject(Sender, 0);
}
//---------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::OpenProject(TObject *Sender, int index_open)
{

   FILE * BD_file=NULL;
   bool rc_bool;
   int rc;

   flag_message = false;
   NewProject(Sender);

   switch (index_open) {
   case 0:
	 if(OpenDialog_Model->Execute())
	 {
	   FileDir_Name = OpenDialog_Model->FileName;
	 }
   break;
   case 1:
	 stroka_param[strlen(stroka_param)-1]='\0';
	 FileDir_Name = (AnsiString)(stroka_param+1);
   break;
   case 2:
	 ;
   break;
   }

   if (FileDir_Name!="") {
	 //InfMessage("  " + FileDir_Name);

	  ModelFile = UNTITLED;
	//  
	  BD_file = BD_Open(FileDir_Name.c_str(),"r");

	  if (BD_file==NULL) {
		  #ifdef EMBRAC
			rc = Application->MessageBox((L"   : " + (String)FileDir_Name).c_str(),L" ", MB_OK | MB_ICONERROR);
		  #else
			rc=Application->MessageBox(("   : " + FileDir_Name).c_str()," ", MB_OK | MB_ICONERROR);
		  #endif
		  InfMessage("   : "+FileDir_Name);
		  return;
	  }
	  if (MruList->Strings[0] != FileDir_Name) {
		MruList->Insert(0, FileDir_Name);
		if (MruList->Count > MruCount)
		  MruList->Delete(MruCount);
	  }
   }

   //--------------------------------------------
   //    
   if (!OpenSelectProf(BD_file)) {
		 InfMessage("     ");
		  return;
   }
	  ModelName(FileDir_Name.c_str());
	  InfMessage("  \"" + ModelFile+"\"");
	  Caption = "   - [" + ModelFile +".pwkS]";

	  //Sect_Param_WeldFrame1->Visible = false;
	  TabSheet_KI->TabVisible = false;
	  TabSheet_sect_prof->TabVisible = false;
	  TabSheetPerfor->TabVisible = false;
	  TabSheet_Weld->TabVisible = false;
	  //---------------------------------------------

	  if (Data_beam.Length_beam > 0 ) {
		RadioGroup_Loads->ItemIndex = 1;
		RadioGroup_LoadsClick(Sender);
		//    
		Fill_field_balka(&Data_beam, &Data_region, Sender);
	  }

      //  
	  Fill_field(Sender);


	  //   Lenth
	  StringGrid_LengthMySelect(1);
	  //   RSU
	  if (Data_select.N_RSU[0]>0)
		StringGrid_RSUMySelect(1);


	  PageControl_Data->ActivePage=TabSheet_Common;

	  modify_project = false;
	  flag_change_rsu = false;
	  flag_change_elem = false;
	  flag_checking = false;

	  flag_message = true;


   }
//---------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::Fill_field(TObject *Sender)
{
	 int i, k, m, n;

	 double Gamma_c[5] = {0.9, 0.95, 1.0, 1.05, 1.1};
	 double Gamma_n[4] = {1.2, 1.1, 1.0, 0.8};
	 double Perfor_attit[7] = {1.2, 1.25, 1.3, 1.35, 1.4, 1.45, 1.5};


	 double *jdd = (double*)bsearch((char*)&(Data_select.gamma_n),(char*)Gamma_n, ComboBox_gamma_n->Items->Count, sizeof(double),(fptr)cmpd);
	 if (jdd!=NULL)
	   ComboBox_gamma_n->ItemIndex = (int)(jdd - Gamma_n);
	 else
	   ComboBox_gamma_n->Text = FloatToStr(Data_select.gamma_n);

	  RadioGroup_Schema_constr->ItemIndex = Data_select.index_constr;
	  RadioGroup_Schema_constrClick(Sender);

	  ComboBox_G1_Count->ItemIndex = Data_select.index_G1_count;
	  ComboBox_G1_CountChange(Sender);

	  ComboBox_G1_Load->ItemIndex = Data_select.index_G1_load;

	 jdd = (double*)bsearch((char*)&(Data_select.gamma_c),(char*)Gamma_c, ComboBox_gamma_c->Items->Count, sizeof(double),(fptr)cmpd);
	 if (jdd!=NULL)
	   ComboBox_gamma_c->ItemIndex = (int)(jdd - Gamma_c);
	 else
	   ComboBox_gamma_c->Text = FloatToStr(Data_select.gamma_c);

	 Edit_Krn->Text = FloatToStr(Data_select.Krn);

	 RadioGroup_gruppa->ItemIndex = Data_select.index_group - 1;
	 RadioGroup_class->ItemIndex = Data_select.index_class - 1;
	 for (i=0; i<Data_select.N_plane; i++) {
	   StringGrid_Length->Cells[0][i+1] = i+1;
	   StringGrid_Length->Cells[1][i+1] = FloatToStrFCut(Data_select.Length[i]/1000, 7, 3);
	   StringGrid_Length->Cells[2][i+1] = FloatToStrFCut(Data_select.length_YY[i]/1000, 7, 3);
	   StringGrid_Length->Cells[3][i+1] = FloatToStrFCut(Data_select.length_XX[i]/1000, 7, 3);
	   StringGrid_Length->Cells[4][i+1] = FloatToStrFCut(Data_select.step_comp[i]/1000, 7, 3);
	 }

	 //   ,   (  )      
	 Define_Material_ARSSForm->Set_Material_name(Data_select.form_profil, Data_select.index_GOST, Data_select.title_material);
	 Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;

	 CheckBoxAddLimit->Checked = Data_select.flag_add_limit;
	 CheckBoxAddLimitClick(Sender);

	 Edit_width->Text = Data_select.max_width;
	 Edit_height->Text = Data_select.max_height;
	 LabeledEdit_a->Text = MAX(0, Data_select.Step_edge);

	 TabSheet_sect_prof->TabVisible = false;
	 TabSheet_Weld->TabVisible = false;
	 TabSheetPerfor->TabVisible = false;

	 switch (Data_select.form_profil) {
	 case DVUTAVR_STAND:
	   RadioButton_Dvutavr->Checked = true;
	   ComboBox_Dvutavr->ItemIndex = Data_select.index_profil;
	   TabSheet_sect_prof->TabVisible = true;
	   SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_Standart->TabVisible = true;

	 break;
	 case TRUBA:
	   flag_message = false;
	   flag_message = true;
	   TabSheet_sect_prof->TabVisible = true;
	   SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_Standart->TabVisible = false;
	   switch(Data_select.type_profil) {
	   case typeSQUARE:
		ComboBox_Tube->ItemIndex = 0;
		SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = true;
	   break;
	   case typeRECT:
		ComboBox_Tube->ItemIndex = 1;
		SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = true;
	   break;
	   case typeCIRC:
		ComboBox_Tube->ItemIndex = 2;
		SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = true;
	   break;
	   }
	   RadioButton_Tube->Checked = true;
	 break;
	 case DVUTAVR_WELD:
	   flag_message = false;
	   RadioButton_Weld->Checked = true;
	   flag_message = true;
	   TabSheet_Weld->TabVisible = true;
	 break;
	 case PERFOR_BEAM:
	   RadioButtonPerfor->Checked = true;
	   ComboBox_Dvutavr->ItemIndex = Data_select.index_profil;
	   Edit_alfa->Text = FloatToStr(Data_select.perfor_alfa);
	   jdd = (double*)bsearch((char*)&(Data_select.perfor_attit),(char*)Perfor_attit, ComboBox_attit->Items->Count, sizeof(double),(fptr)cmpd);
	   if (jdd!=NULL)
		 ComboBox_gamma_c->ItemIndex = (int)(jdd - Gamma_c);
	   else
		 ComboBox_gamma_c->Text = FloatToStr(Data_select.gamma_c);
	   TabSheet_sect_prof->TabVisible = true;
	   TabSheetPerfor->TabVisible = true;
	   SectSelectCom_ParamFrame1->TabSheet_StandTube->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_CYL->TabVisible = false;
	   SectSelectCom_ParamFrame1->TabSheet_Standart->TabVisible = true;

	 break;
	 }
	 if (Data_select.N_plane==0)
	   Label_plane->Caption = "   ";
	 else
	   Label_plane->Caption = "  "+IntToStr(Data_select.N_plane);
	 Edit1->Text = FloatToStr(Data_select.Limit_lambda1);
	 Edit2->Text = FloatToStr(Data_select.Limit_lambda2);
	 if (Data_select.Limit_lambda2 == 0) {
		Edit2->Visible = false;
		Label4->Visible = false;
		Label5->Visible = false;
	 }
	 else {
		Edit2->Visible = true;
		Label4->Visible = true;
		Label5->Visible = true;
	 }
	 Edit_Tens->Text = FloatToStr(Data_select.Limit_lambda_plus);
	 //-------------------------------------------------------------
	 //   
	 Edit_strela->Text = FloatToStr(Data_select.Strela);
	 if (Data_select.Delta_lim ==0) {
	   ComboBox_Delta_lim->ItemIndex=0;
	 }
	 else {
	   String Astr = "l/"+FloatToStr(Data_select.Delta_lim);
	   for (i=0; i<ComboBox_Delta_lim->Items->Count; i++) {
		   if (ComboBox_Delta_lim->Items->Strings[i]==Astr) {
			 ComboBox_Delta_lim->ItemIndex=i;
			 break;
		   }
       }
	 }

	 //Data_beam
	 if (Data_select.index_razrez == 1)
	   CheckBox_razrez->Checked = true;
	 else
	   CheckBox_razrez->Checked = false;

	 if (Data_select.index_edge == 1)
	   CheckBox_edge->Checked = true;
	 else
	   CheckBox_edge->Checked = false;

	 if (Data_select.index_1_or_2 == -1) {
	   CheckBox_edge_choose->Checked = false;
	 }
	 else  {
	   CheckBox_edge_choose->Checked = true;
	   RadioGroup_1_or_2->ItemIndex = Data_select.index_1_or_2;
	 }


	 ComboBox_TypeElemChange(Sender);

	 if (Data_select.form_profil!=TRUBA)
		ComboBox_DvutavrChange(Sender);
	 else
	   ComboBox_TubeChange(Sender);

	 Data_select.index_Qy = MAX(0, Data_select.index_Qy);
	 Data_select.index_Qy = MIN(2, Data_select.index_Qy);

	 ComboBox_index_Qy->ItemIndex = Data_select.index_Qy;

	 //   
	 if (Last_type_sect!=0) {
	   switch (Data_select.form_profil) {
	   case DVUTAVR_STAND:
	   case TRUBA:
		 common_sect = &(Last_com_sect);
		 Type_sect = Last_type_sect;
		 SectSelectCom_ParamFrame1->Check_Original();  //    
		 //-------------------------------------------------
		 //   
		 //-------------------------------------------------
		 SectSelectCom_ParamFrame1->Write_sect(Sender);
		 TabSheet_sect_prof->TabVisible = true;
	   break;
	   case DVUTAVR_WELD:
		 //sect_w = &(Last_com_sect.dvutavr);
		 memcpy((char*)&sect_weld, (char*)&(Last_com_sect.dvutavr), sizeof(SECT_DVUTAVR));
		 Type_sect = Last_type_sect;
		 Sect_Param_WeldFrame1->Check_Original();  //    
		 //-------------------------------------------------
		 //   
		 //-------------------------------------------------
		 Sect_Param_WeldFrame1->Write_sect(Sender);
         Sect_Param_WeldFrame1->Visible = true;

	   break;
	   case PERFOR_BEAM:
		 common_sect = &(Last_com_sect);
		 Type_sect = Last_type_sect;
		 SectSelectCom_ParamFrame1->Check_Original();  //    
		 //-------------------------------------------------
		 //   
		 //-------------------------------------------------
		 SectSelectCom_ParamFrame1->Write_sect(Sender);
		 TabSheet_sect_prof->TabVisible = true;
	   break;
	   }
	   BitBtnCheck->Enabled = true;
	 }
	 //-----------------------------------------------------------------------
	 //       
	  if (Data_select.form_profil==DVUTAVR_WELD) {
		LabeledEdit_lambda0->Text = FloatToStr(Param_chosen_sect.lambda0);
		LabeledEdit_a->Text = FloatToStr(Param_chosen_sect.size_a);
		Edit_d_lambda->Text = FloatToStr(Param_chosen_sect.delta_lambda);
		Edit_d_w->Text = FloatToStr(Param_chosen_sect.delta_w);
		Edit_d_f->Text = FloatToStr(Param_chosen_sect.delta_f);
		Edit_round_h->Text = FloatToStr(Param_chosen_sect.round_h);
		Edit_round_width->Text = FloatToStr(Param_chosen_sect.round_width);
		RadioGroup_sort->ItemIndex = Param_chosen_sect.round_thick;
		Edit_min_tpol->Text = FloatToStr(Param_chosen_sect.min_tpol);
		Edit_max_tpol->Text = FloatToStr(Param_chosen_sect.max_tpol);
		Edit_min_tsten->Text = FloatToStr(Param_chosen_sect.min_tsten);
		Edit_max_tsten->Text = FloatToStr(Param_chosen_sect.max_tsten);
		Edit_min_bpol->Text = FloatToStr(Param_chosen_sect.min_bpol);
		Edit_max_bpol->Text = FloatToStr(Param_chosen_sect.max_bpol);
		Edit_min_hsten->Text = FloatToStr(Param_chosen_sect.min_hsten);
		Edit_max_hsten->Text = FloatToStr(Param_chosen_sect.max_hsten);
		CheckBox_ind_minimax->Checked = Param_chosen_sect.flag_minimax;
	 }


}
//---------------------------------------------------------------------------
//       
void __fastcall TSelectProfilSectForm::ModelName(char * str0)
{
	  char *ptr1, *ptr2;
	  char i, str[240];

	  if (ModelFile == UNTITLED) {
	   i= 240<strlen(str0) ? 240 : strlen(str0);
	   strcpy(str,str0);
	   ptr1 = strrchr(str,'\\');
	   ptr2 = strrchr(ptr1,'.');
	   if (ptr2!=NULL)
		 *ptr2='\0';
	   if (ptr1==NULL)
		ModelFile = (AnsiString)str;
	   else
		ModelFile = (AnsiString)(ptr1+1);
	  }
}
//--------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NSaveClick(TObject *Sender)
{
   int i, rc;
   char _error[240];
   char * path;
   AnsiString File;
   FILE * BD_file=NULL;
   bool rc_bool;
   bool flag_demo, flag_demo2;

   //------------------------------------
   //  
   rc = Read_data(Sender);
   if (rc>0) {
	 #ifdef EMBRAC
			rc=Application->MessageBox(L"  ", L" ", MB_OK | MB_ICONINFORMATION);
	 #else
			rc=Application->MessageBox("  ", " ", MB_OK | MB_ICONINFORMATION);
	 #endif
	 return;
   }
   //   ,     
   //path = getcwd(Path_gen, PATHLEN);
   unsigned long dword = GetModuleFileName(NULL, Path_gen, PATHLEN );
   path = strrchr(Path_gen, '\\');
   path[0] = '\0';

   //-------------------------------------------------------------
   if  (ModelFile ==UNTITLED || ModelFile == NULL) {
	  if(SaveDialog_Model->Execute())
      {
		  File = SaveDialog_Model->FileName;
          FileDir_Name = File;
          ModelName(File.c_str());
      }
	  else return;
   }
   else
	   File = FileDir_Name;
   rc = BD_Close(BD_file);

   BD_file = BD_Open(File.c_str(),"w");
   if (BD_file==NULL) {
	  InfMessage("    "+ File +"  ");
	  return;
   }
   //InfMessage("    ");
   rc_bool = SaveSelectProf(BD_file);
   if (!rc_bool) {
      InfMessage("     ");
      return;
   }
   rc = BD_Close(BD_file);

   BD_file = BD_Open(File.c_str(),"r");
   if (BD_file==NULL) {
      InfMessage("    "+File+"  ");
      return;
   }

   InfMessage("    "+ File);
   modify_project = false;

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::NSaveAsClick(TObject *Sender)
{
       ModelFile = UNTITLED;
       NSaveClick(Sender);

}
//---------------------------------------------------------------------------
//    
void __fastcall TSelectProfilSectForm::ComboBox_DvutavrChange(
	  TObject *Sender)
{
		Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
		//       
		N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;
		Draw_prof_ax(N_profil);

		Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
		Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
		Show_prof(0, Sender);

		modify_project = true;
		Edit_alfaEnter(Sender);
}
//---------------------------------------------------------------------------
//   
void __fastcall TSelectProfilSectForm::ComboBox_TubeChange(TObject *Sender)
{
		switch (ComboBox_Tube->ItemIndex) {
			case 0:
			  Data_select.type_profil = typeSQUARE;
			  RadioButton_Tube->Caption = "    30245";
			break;
			case 1:
			  Data_select.type_profil = typeRECT;
			  RadioButton_Tube->Caption = "    30245";
			break;
			case 2:
			  Data_select.type_profil = typeCIRC;
			  RadioButton_Tube->Caption = "    58064";
			break;
		}
		Show_prof(0, Sender);
	  //      
		Draw_prof_ax(0);
		modify_project = true;

		ComboBox_TypeElemChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::RadioGroup_classClick(
      TObject *Sender)
{
          Data_select.index_class = RadioGroup_class->ItemIndex + 1;
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::ComboBox_gamma_cChange(
      TObject *Sender)
{
	  int rc = String_double_plus(Label_koeff_uslovij->Caption, ComboBox_gamma_c->Text, &(Data_select.gamma_c));
      if (rc>0) return;

}
//---------------------------------------------------------------------------
//     
void __fastcall TSelectProfilSectForm::BitBtnCheckClick(TObject *Sender)
{
   int j = 1;
   int rc;
   int index, n_thick, n_prof;

   //  
   rc = Read_data(Sender);
   if (rc>0) {
		return;
   }
   if ( Material_Number < 1 || strcmp(MaterProp[Material_Number].title,"")==0) {
		 #ifdef EMBRAC
			rc = Application->MessageBox(L" ",
										L"  ",
		 #else
			rc = Application->MessageBox(" ",
										"  ",
		 #endif
				MB_OK | MB_ICONWARNING);
		 BitBtnMaterialClick(Sender);
   }
   if (flag_change_rsu) {
	 #ifdef EMBRAC
	 rc=Application->MessageBox(L"   ,     .   c  ?", L"",
								  MB_YESNO | MB_ICONQUESTION);
	 #else
	 rc=Application->MessageBox("   ,     .   c  ?", "",
								  MB_YESNO | MB_ICONQUESTION);
	 #endif
	 if (rc==IDNO) return;
   }
   Label_edge->Caption = "";
   //     
   switch (Data_select.form_profil) {
   case DVUTAVR_STAND:    //  
   case PERFOR_BEAM:      //  , 
	 //     
	 SectChecking(SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex, j, Sender);
   break;
   case TRUBA:
	 switch (ComboBox_Tube->ItemIndex) {
     case 0:
	   index = SectSelectCom_ParamFrame1->ComboBox_h_b_square->ItemIndex;
       n_thick = SectSelectCom_ParamFrame1->ComboBox_t_square->ItemIndex;
     break;
     case 1:
       index = SectSelectCom_ParamFrame1->ComboBox_h_b_rect->ItemIndex;
       n_thick = SectSelectCom_ParamFrame1->ComboBox_t_rect->ItemIndex;
	 break;
	 case 2:
       index = SectSelectCom_ParamFrame1->ComboBox_Cyl_D->ItemIndex;
	   n_thick = SectSelectCom_ParamFrame1->ComboBox_Cyl_t->ItemIndex;
	 break;
	 }
	 //n_prof = StandartProfil.GetNumberProfil_Tube(index, n_thick);
	 //     
	 SectChecking(index, n_thick, Sender);
   break;
   case DVUTAVR_WELD:    //  

	 SectChecking(0, 0, Sender);
   break;
   }
   Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//     
int __fastcall TSelectProfilSectForm::Read_data(TObject *Sender)
{
	  int i, k, m, rc;
	  double ss;
	  /*
	  if (Material_Number<1) {
		 #ifdef EMBRAC
			i = Application->MessageBox(L" ",
										L"  ",
		 #else
			i = Application->MessageBox(" ",
										"  ",
		 #endif
				MB_OK | MB_ICONWARNING);
			BitBtnMaterialClick(Sender);
	  }
	  if (Data_select.N_plane==0) {
		 #ifdef EMBRAC
			rc = Application->MessageBox(L"     ",
										L"",
		 #else
			rc = Application->MessageBox("     ",
										"",
		 #endif
			  MB_OK | MB_ICONERROR);
			PageControl_Data->ActivePage = TabSheet_Part;
			return rc;
	  }
	  */
	  rc = 0;
	  //    
	  for (i=0; i<Data_select.N_plane; i++) {
		if (Data_select.N_RSU[i] == 0) {
		 #ifdef EMBRAC
			rc += Application->MessageBox((L"     "+IntToStr(i+1)).c_str(),
										L"",
		 #else
			rc += Application->MessageBox(("     "+IntToStr(i+1)).c_str(),
										"",
		 #endif
				MB_OK | MB_ICONERROR);
		}
	  }
	  if (rc>0) {
			  PageControl_Data->ActivePage = TabSheet_Part;
			  return rc;
	  }
	  //----------------------------------------------------------------------
	  //    
	  char str[20];
	  AnsiString Lim;

	  if (ComboBox_Delta_lim->ItemIndex==0)
		Data_select.Delta_lim = 0;
	  else {
		Lim = ComboBox_Delta_lim->Text;
		strcpy(str, Lim.c_str());
		Data_select.Delta_lim = StrToFloat((AnsiString)(str+2));
	  }

	  rc = String_double(Label_strela->Caption, Edit_strela->Text, &(ss));
	  if (rc>0)
		return rc;
	  Data_select.Strela = ss;
	  //-------------------------------------------------

	  rc = String_double_plus(Label_gamma_n->Caption, ComboBox_gamma_n->Text, &ss);
	  if (rc>0) return rc;
	  Data_select.gamma_n = ss;

	  Data_select.index_otvetstv = MAX(0, ComboBox_gamma_n->ItemIndex - 1);

	  rc = String_double_plus(Label_koeff_uslovij->Caption, ComboBox_gamma_c->Text, &ss);
	  if (rc>0) return rc;
	  Data_select.gamma_c = ss;
	  Data_select.index_group = RadioGroup_gruppa->ItemIndex + 1;
	  Data_select.index_class = RadioGroup_class->ItemIndex + 1;

	  ComboBox_G1_Count->ItemIndex = MAX(0, ComboBox_G1_Count->ItemIndex);
	  Data_select.index_G1_count = ComboBox_G1_Count->ItemIndex;
	  Data_select.index_G1_load = ComboBox_G1_Load->ItemIndex;
	  Data_select.index_constr = RadioGroup_Schema_constr->ItemIndex;
	  if (CheckBox_edge_choose->Checked) {
		 Data_select.index_1_or_2 = RadioGroup_1_or_2->ItemIndex;
	  }
	  else {
		 Data_select.index_1_or_2 = -1;
	  }

	  if (Edit1->Text == "" || Edit2->Text == "" || Edit_Tens->Text=="") {
		 #ifdef EMBRAC
			rc = Application->MessageBox(L"    ",
										L"",
		 #else
			rc = Application->MessageBox("    ",
										"",
		 #endif
			  MB_OK | MB_ICONERROR);
			return rc;
	  }
	  rc = String_double_range(Label_Krn->Caption, Edit_Krn->Text, 0.7, 1.0, &(Data_select.Krn));
	  if (rc>0)
		return rc;
	  rc = String_double_range(". 1    ", Edit1->Text, 120, 220, &ss);
	  if (rc>0) return rc;
	  Data_select.Limit_lambda1 = ss;
	  rc = String_double_range(". 2    ", Edit2->Text, 0, 60, &ss);
	  if (rc>0) return rc;
	  Data_select.Limit_lambda2 = ss;
	  rc = String_double_range(".    ", Edit_Tens->Text, 150, 400, &ss);
	  if (rc>0) return rc;
	  Data_select.Limit_lambda_plus = ss;
	  if (CheckBoxAddLimit->Checked) {
		rc=String_double_zero_plus(Label_width->Caption,Edit_width->Text, &ss);
		if (rc>0) return rc;
		Data_select.max_width = ss;

		rc=String_double_zero_plus(Label_height->Caption,Edit_height->Text, &ss);
		if (rc>0) return rc;
		Data_select.max_height = ss;
	  }
	  if (CheckBox_razrez->Checked)
		 Data_select.index_razrez = 1;
	  else
		 Data_select.index_razrez = 0;

	  if (CheckBox_edge->Checked)
		 Data_select.index_edge = 1;
	  else
		 Data_select.index_edge = 0;


	  switch (Data_select.form_profil) {
	  case TRUBA:  // 
			switch (ComboBox_Tube->ItemIndex) {
			case 0:
			  Data_select.type_profil = typeSQUARE;
			  type_sect_tube = SQUARE_TUBE;  //  : SQUARE_TUBE || RECT_TUBE || CIRCULAR_TUBE
			break;
			case 1:
			  Data_select.type_profil = typeRECT;
			  type_sect_tube = RECT_TUBE;
			break;
			case 2:
			  Data_select.type_profil = typeCIRC;
			  type_sect_tube = CIRCULAR_TUBE;
			break;
			}
	  break;
	  case DVUTAVR_STAND:
			Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
			Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
			ss = 0;
			if (CheckBox_edge->Checked) {
			  rc = String_double_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}
			else {
			  rc = String_double_zero_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}
			Data_select.Step_edge = ss;
	  break;
	  case PERFOR_BEAM:
			Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
			Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
			ss = 0;
			if (CheckBox_edge->Checked) {
			  rc = String_double_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}
			else {
			  rc = String_double_zero_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}

			Data_select.Step_edge = ss;
			rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &ss);
			if (rc>0) return 1;
			Data_select.perfor_attit = ss;
			rc = String_double_range(Label_alfa->Caption, Edit_alfa->Text, 40.0, 70.0, &ss);
			if (rc>0) return 1;
			Data_select.perfor_alfa = ss;
	  break;
	  case DVUTAVR_WELD:
			Data_select.index_profil = -1;
			Data_select.type_profil = -1;
			ss = 0;
			if (CheckBox_edge->Checked) {
			  rc = String_double_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}
			else {
			  rc = String_double_zero_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
			}

			Data_select.Step_edge = ss;
	  break;
	  }
	  //    
	  strcpy(Data_select.title_material, MaterProp[Material_Number].title);
	  Data_select.gamma_m = MaterProp[Material_Number].gamma_m;

	  //-----------------------------------------------------------------------
	  //       
	  if (Data_select.form_profil==DVUTAVR_WELD) {
		Param_chosen_sect.gamma_c = Data_select.gamma_c;
		rc = String_double_plus(LabeledEdit_lambda0->EditLabel->Caption, LabeledEdit_lambda0->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.lambda0 = ss;
		ss = 0;
		if (CheckBox_edge->Checked) {
		  rc = String_double_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
		  if (rc>0) return 1;
		}
		else {
			  rc = String_double_zero_plus(LabeledEdit_a->EditLabel->Caption, LabeledEdit_a->Text, &ss);
			  if (rc>0) return 1;
		}
		Param_chosen_sect.size_a = ss;
		rc = String_double_plus_low(Label_delta->Caption, Edit_d_lambda->Text, 2.5, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.delta_lambda = ss;
		if (Edit_d_w->Text=="*") {
		   Param_chosen_sect.delta_w = 0.0;
		}
		else {
		   rc = String_double_plus_low(Label_delta->Caption, Edit_d_w->Text, 2.0, &ss);
		   if (rc>0) return 1;
		   Param_chosen_sect.delta_w = ss;
		}
		rc = String_double_plus_low(Label_delta->Caption, Edit_d_f->Text, 1.15, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.delta_f = ss;
		rc = String_double_plus(Label_h->Caption, Edit_round_h->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.round_h = ss;
		rc = String_double_plus(Label_width->Caption, Edit_round_width->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.round_width = ss;
		Param_chosen_sect.round_thick = RadioGroup_sort->ItemIndex;

		rc = String_double_plus(Label_min_tpol->Caption, Edit_min_tpol->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.min_tpol = ss;
		rc = String_double_plus(Label_max_tpol->Caption, Edit_max_tpol->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.max_tpol = ss;
		rc = String_double_plus(Label_min_tsten->Caption, Edit_min_tsten->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.min_tsten = ss;
		rc = String_double_plus(Label_max_tsten->Caption, Edit_max_tsten->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.max_tsten = ss;
		rc = String_double_plus(Label_min_bpol->Caption, Edit_min_bpol->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.min_bpol = ss;
		rc = String_double_plus(Label_max_bpol->Caption, Edit_max_bpol->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.max_bpol = ss;
		rc = String_double_plus(Label_min_hsten->Caption, Edit_min_hsten->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.min_hsten = ss;
		rc = String_double_plus(Label_max_hsten->Caption, Edit_max_hsten->Text, &ss);
		if (rc>0) return 1;
		Param_chosen_sect.max_hsten = ss;
		Param_chosen_sect.flag_minimax = CheckBox_ind_minimax->Checked;

	 }

	 return 0;
}
//------------------------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_t_squareChange(
	  TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_t_squareChange(Sender);
  Label_mass->Caption = "";
  Label_mass_weld->Caption = "";
  Label_conditions->Caption = "";
  Label_add_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  flag_checking = false;

  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_h_b_square->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_t_square->ItemIndex);
  Draw_prof_ax(n_prof);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_t_rectChange(
      TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_t_rectChange(Sender);
  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_h_b_rect->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_t_rect->ItemIndex);
  Draw_prof_ax(n_prof);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_Cyl_tChange(
	  TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_Cyl_tChange(Sender);
  Label_mass->Caption = "";
  Label_conditions->Caption = "";
  Label_add_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  //Sect_Param_WeldFrame1->Visible = false;
  flag_checking = false;

  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_Cyl_D->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_Cyl_t->ItemIndex);
  Draw_prof_ax(n_prof);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_Cyl_DChange(
      TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_Cyl_DChange(Sender);
  Label_mass->Caption = "";
  Label_conditions->Caption = "";
  Label_add_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  flag_checking = false;

    //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_Cyl_D->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_Cyl_t->ItemIndex);
  Draw_prof_ax(n_prof);


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_h_b_rectChange(
      TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_h_b_rectChange(Sender);
  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_h_b_rect->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_t_rect->ItemIndex);
  Draw_prof_ax(n_prof);


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_h_b_squareChange(
	  TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_h_b_squareChange(Sender);
  Label_mass->Caption = "";
  Label_conditions->Caption = "";
  Label_add_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  flag_checking = false;

  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_h_b_square->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_t_square->ItemIndex);
  Draw_prof_ax(n_prof);


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1RadioGroupGOST57837Click(
      TObject *Sender)
{

  SectSelectCom_ParamFrame1->RadioGroupGOST57837Click(Sender);
  ComboBox_Dvutavr->ItemIndex = SectSelectCom_ParamFrame1->RadioGroupGOST57837->ItemIndex;
  Label_mass->Caption = "";
  Label_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  flag_checking = false;
  //    
  Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
  Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;

  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;
  Draw_prof_ax(N_profil);

  if (Data_select.form_profil==PERFOR_BEAM) {
	  AnsiString Astr = Edit_alfa->Text;
	  int rc;
	  double alfa = str_exp(Astr.c_str(), &rc);
	  if (rc>0 || alfa<40 || alfa>70)
		return;
	  double attid;
	  rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attid);
	  if (rc>0) return;
	  //    
	  Show_prof_perfor(N_profil, Sender, attid, alfa, false);
  }



}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::ComboBox_RSUChange(TObject *Sender)
{
     ComboBox_TypeElemChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1ComboBox_profilChange(
      TObject *Sender)
{
  SectSelectCom_ParamFrame1->ComboBox_profilChange(Sender);
  Label_mass->Caption = "";
  Label_conditions->Caption = "";
  Label_add_conditions->Caption = "";
  TabSheet_KI->TabVisible = false;
  flag_checking = false;
  //    
  Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
  Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;

  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;
  Draw_prof_ax(N_profil);
  if (Data_select.form_profil==PERFOR_BEAM) {
	  AnsiString Astr = Edit_alfa->Text;
	  int rc;
	  double alfa = str_exp(Astr.c_str(), &rc);
	  if (rc>0 || alfa<40 || alfa>70)
		return;
	  double attid;
	  rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attid);
	  if (rc>0) return;
	  //    
	  Show_prof_perfor(N_profil, Sender, attid, alfa, false);
  }



}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::BitBtn3Click(TObject *Sender)
{
	 HelpKoeffLengthForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::CheckBoxAddLimitClick(TObject *Sender)
{
   if (CheckBoxAddLimit->Checked) {
	  //GroupBox_AddLimit->Enabled = true;
	  Label_width->Enabled = true;
	  Edit_width->Enabled = true;
	  Label_height->Enabled = true;
	  Edit_height->Enabled = true;

   }
   else {
	  //GroupBox_AddLimit->Enabled = false;
	  Label_width->Enabled = false;
	  Edit_width->Enabled = false;
	  Label_height->Enabled = false;
	  Edit_height->Enabled = false;
   }
   Data_select.flag_add_limit = CheckBoxAddLimit->Checked;

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtnAddLimitClick(TObject *Sender)
{
   //AddLimitForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn4Click(TObject *Sender)
{
	   HelpClassForm->ShowModal();
       modify_project = true;

	   if (HelpClassForm->Class >=0) {
		   RadioGroup_class->ItemIndex = HelpClassForm->Class;
	   }
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NPreferencesClick(TObject *Sender)
{
	   //   XML
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NOutReportClick(TObject *Sender)
{
	int i;
	if (flag_checking)
		int rc = Report_Checking();
	else {
		 #ifdef EMBRAC
		 i = Application->MessageBox(L"  .   ,   ",
									  L"",
									  MB_OK | MB_ICONWARNING);
		 #else
		 i = Application->MessageBox("  .   ,   ",
									  "",
									  MB_OK | MB_ICONWARNING);
		 #endif
	}
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BitBtn_flex_tensClick(TObject *Sender)
{
	   Help_FlexCompForm->ShowModal();
	   if (Help_FlexCompForm->Koeff_FlexComp[0] != 0.0) {
		 Edit1->Text = FloatToStr(Help_FlexCompForm->Koeff_FlexComp[0]);
		 Edit2->Text = FloatToStr(Help_FlexCompForm->Koeff_FlexComp[1]);
		 if (Help_FlexCompForm->Koeff_FlexComp[1] == 0.0) {
		   Label4->Visible = false;
		   Label5->Visible = false;
		   Edit2->Visible = false;
		 }
		 else {
		   Label4->Visible = true;
		   Label5->Visible = true;
		   Edit2->Visible = true;
		 }
	   }
	   modify_project = true;

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn_flex_compClick(TObject *Sender)
{
	   Help_FlexTensForm->ShowModal();
	   if (Help_FlexTensForm->Koeff_FlexTens != 0.0) {
		 Edit_Tens->Text = FloatToStr(Help_FlexTensForm->Koeff_FlexTens);
	   }
	   modify_project = true;

}
//---------------------------------------------------------------------------
//       
void __fastcall TSelectProfilSectForm::FillRow_Len(TObject *Sender)
{
   int k, n_row;
   double Len;
   double muXZ, muYZ, step_comp;

   if (NumRow_Len >=0)
	 k = NumRow_Len - 1;
   else
	 k = Data_select.N_plane;

   int rc1 = String_double_plus(Label_Len->Caption, Edit_Len->Text, &(Len));
   int rc2 = String_double_plus(Label_muXZ->Caption, Edit_muXZ->Text, &(muXZ));
   int rc3 = String_double_plus(Label_muYZ->Caption, Edit_muYZ->Text, &(muYZ));
   int rc4 = String_double_zero_plus(Label_step_comp->Caption, Edit_step_comp->Text, &(step_comp));
   if (rc1>0 || rc2>0 || rc3>0 || rc4>0)
	 return;
   Data_select.Length[k] = Len*1000;
   Data_select.step_comp[k] = step_comp*1000;
   if (RadioGroup_mu->ItemIndex==0) {   //   
	 if (muYZ < 1.0) {
		 #ifdef EMBRAC
		 rc1 = Application->MessageBox(L"    . YZ  1.0 ",
									  L"",
									  MB_OK | MB_ICONWARNING);
		 #else
		rc1 = Application->MessageBox("    . YZ  1.0 ",
									  "",
									  MB_OK | MB_ICONWARNING);
		 #endif
	 }
	 if (muXZ < 1.0) {
		 #ifdef EMBRAC
		 rc1 = Application->MessageBox(L"    . XZ  1.0 ",
									  L"",
									  MB_OK | MB_ICONWARNING);
		 #else
		 rc1 = Application->MessageBox("    . XZ  1.0 ",
									  "",
									  MB_OK | MB_ICONWARNING);
		 #endif
	 }
	 Data_select.length_YY[k] = muYZ*1000;
	 Data_select.length_XX[k] = muXZ*1000;
	 Data_select.koeff_length_YY[k] = Data_select.length_YY[k]/Data_select.Length[k];
	 Data_select.koeff_length_XX[k] = Data_select.length_XX[k]/Data_select.Length[k];
   }
   else {    //    
	 Data_select.koeff_length_YY[k] = muYZ;
	 Data_select.koeff_length_XX[k] = muXZ;
	 if (muYZ > 3.0) {
		 #ifdef EMBRAC
		 rc1 = Application->MessageBox(L"     . YZ  3.0",
									  L"",
									  MB_OK | MB_ICONERROR);
		 #else
		 rc1 = Application->MessageBox("     . YZ  3.0",
									  "",
									  MB_OK | MB_ICONERROR);
		 #endif
		 return;
	 }
	 if (muXZ > 3.0) {
		 #ifdef EMBRAC
		 rc1 = Application->MessageBox(L"     . XZ  3.0",
									  L"",
									  MB_OK | MB_ICONERROR);
		 #else
		 rc1 = Application->MessageBox("     . XZ  3.0",
									  "",
									  MB_OK | MB_ICONERROR);
		 #endif
		 return;
	 }
	 Data_select.length_YY[k] = muYZ*Data_select.Length[k];
	 Data_select.length_XX[k] = muXZ*Data_select.Length[k];
   }

   if (NumRow_Len < 0) {
	 Data_select.N_plane++;
	 StringGrid_Length->RowCount = Data_select.N_plane +1;
	 n_row = Data_select.N_plane;
   }
   else {
	 n_row = NumRow_Len;
   }
   StringGrid_Length->Cells[0][n_row] = n_row;
   StringGrid_Length->Cells[1][n_row] = FloatToStrFCut(Data_select.Length[k]/1000, 7, 3);
   StringGrid_Length->Cells[2][n_row] = FloatToStrFCut(Data_select.length_YY[k]/1000, 7, 3);
   StringGrid_Length->Cells[3][n_row] = FloatToStrFCut(Data_select.length_XX[k]/1000, 7, 3);
   StringGrid_Length->Cells[4][n_row] = FloatToStrFCut(Data_select.step_comp[k]/1000, 7, 3);
   n_plane = k;

   if (RadioGroup_Loads->ItemIndex==0) {
	 BitBtn_LenRep->Enabled = true;
	 BitBtn_LenDel->Enabled = true;
   }
}
//--------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::BitBtn_LenAddClick(TObject *Sender)
{
	 int k = NumRow_Len;
	 NumRow_Len = -1;
	 //       
	 FillRow_Len(Sender);

	 //   Lenth
	 StringGrid_LengthMySelect(Data_select.N_plane);

	 Label_plane->Caption = "  "+IntToStr(Data_select.N_plane);
	 modify_project = true;

	 TabSheet_KI->TabVisible = false;
	 //TabSheet_sect_prof->TabVisible = false;
	 flag_checking = false;



}
//-----------------------------------------------
//   
void __fastcall TSelectProfilSectForm::StringGrid_LengthMySelect(int RowSelect)
{
	 // The following code selects the rectangle containing
	 // rows 1 through 4, and columns 2 and 3.
	 TGridRect myRect;
	 myRect.Left = 0;
	 myRect.Top = RowSelect;
	 myRect.Right = 4;
	 myRect.Bottom = RowSelect;
	 StringGrid_Length->Selection = myRect;
	 NumRow_Len = RowSelect;
	 OutRSU(RowSelect);
}

//----------------------------------------
//   
void __fastcall TSelectProfilSectForm::StringGrid_LengthSelectCell(TObject *Sender,
		  int ACol, int ARow, bool &CanSelect)
{
	 OutRSU(ARow);

}
//--------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::OutRSU(int ARow)
{
   int n;
   if (ARow > 0)  {
	 NumRow_Len = ARow;

	 if (RadioGroup_Loads->ItemIndex==0)
		BitBtn_RSUAdd->Enabled = true;
	 n_plane = NumRow_Len - 1;
	 RadioGroup_mu->ItemIndex = 0;

	 index_mu = 0;
	 RadioGroup_mu->ItemIndex = 0;

	 Edit_Len->Text = FloatToStrFCut(Data_select.Length[n_plane]/1000, 7, 3);
	 Edit_muYZ->Text = FloatToStrFCut(Data_select.length_YY[n_plane]/1000, 7, 3);
	 Edit_muXZ->Text = FloatToStrFCut(Data_select.length_XX[n_plane]/1000, 7, 3);
	 Edit_step_comp->Text = FloatToStrFCut(Data_select.step_comp[n_plane]/1000, 7, 3);


	 if (Data_select.N_RSU[NumRow_Len - 1] >0 && RadioGroup_Loads->ItemIndex==0) {
		BitBtn_RSURep->Enabled = true;
		BitBtn_RSUDel->Enabled = true;
	 }
	 else {
		BitBtn_RSURep->Enabled = false;
		BitBtn_RSUDel->Enabled = false;
	 }
	 //   
	 FillTab_RSU();             //Data_select.type_profil  Data_select.index_profil   BalkaLoadFrame1->n_beam
	 Draw_prof_ax(N_profil);     //Data_beam

   }
}
//---------------------------------------------------------------------------
//  ,   . 
//   
void __fastcall TSelectProfilSectForm::BitBtn_LenRepClick(TObject *Sender)
{
   if (NumRow_Len > 0) {
	  //       
	  FillRow_Len(Sender);
	  //  ,   . 
   	  modify_project = true;

   }
   else {
		  #ifdef EMBRAC
	  int rc = Application->MessageBox(L"  ", L" ", MB_OK | MB_ICONWARNING);
		  #else
	  int rc = Application->MessageBox("  ", " ", MB_OK | MB_ICONWARNING);
		  #endif

   }
   TabSheet_KI->TabVisible = false;
   TabSheet_sect_prof->TabVisible = false;
   flag_checking = false;

}
//---------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::BitBtn_LenDelClick(TObject *Sender)
{
   int i;
   if (NumRow_Len > 0) {
	  if (NumRow_Len > 1) {
		for (i = NumRow_Len; i < StringGrid_Length->RowCount - 1; i++) {
		  StringGrid_Length->Cells[1][i] = StringGrid_Length->Cells[1][i+1];
		  StringGrid_Length->Cells[2][i] = StringGrid_Length->Cells[2][i+1];
		  StringGrid_Length->Cells[3][i] = StringGrid_Length->Cells[3][i+1];
		  StringGrid_Length->Cells[4][i] = StringGrid_Length->Cells[4][i+1];
		  Data_select.Length[i-1] = Data_select.Length[i];
		  Data_select.length_YY[i-1] = Data_select.length_YY[i];
		  Data_select.length_XX[i-1] = Data_select.length_XX[i];
		  Data_select.step_comp[i-1] = Data_select.step_comp[i];
		}
	  }
	  StringGrid_Length->RowCount--;
	  if (Data_select.N_plane==0) {
		BitBtn_LenRep->Enabled = false;
		BitBtn_LenDel->Enabled = false;
	  }
	  Data_select.N_plane--;
	  modify_project = true;
	 //  
	 //StringGrid_LengthMySelect(NumRow_Len);

   }
   else {
		  #ifdef EMBRAC
	  int rc = Application->MessageBox(L"  ", L" ", MB_OK | MB_ICONWARNING);
		  #else
	  int rc = Application->MessageBox("  ", " ", MB_OK | MB_ICONWARNING);
		  #endif

   }
	 TabSheet_KI->TabVisible = false;
	 //TabSheet_sect_prof->TabVisible = false;
	 flag_checking = false;


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::RadioGroup_muClick(TObject *Sender)
{
   double Len, muXZ, muYZ;
   int rc1 = String_double_zero_plus(Label_muXZ->Caption, Edit_Len->Text, &(Len));
   int rc2 = String_double_zero_plus(Label_muXZ->Caption, Edit_muXZ->Text, &(muXZ));
   int rc3 = String_double_zero_plus(Label_muYZ->Caption, Edit_muYZ->Text, &(muYZ));
   if (rc2>0 || rc3>0)
	 return;

   if (index_mu==1) {
	  muXZ *= Len;
	  muYZ *= Len;
   }

   if (RadioGroup_mu->ItemIndex==0) {
	  Label_muXZ->Caption = "  lef  . XY, ";
	  Label_muYZ->Caption = "  lef  . XZ, ";
	  Edit_muXZ->Text = FloatToStr(muXZ);
	  Edit_muYZ->Text = FloatToStr(muYZ);
   }
   else {
	  Label_muXZ->Caption = L"   \u03BC  . XY";
	  Label_muYZ->Caption = L"   \u03BC  . XZ";
	  if (Len!=0)  {
		Edit_muXZ->Text = FloatToStr(muXZ/Len);
		Edit_muYZ->Text = FloatToStr(muYZ/Len);
	  }
   }
   index_mu = RadioGroup_mu->ItemIndex;
}
//---------------------------------------------------------------------------
//    
void __fastcall TSelectProfilSectForm::BitBtn_RSUAddClick(TObject *Sender)
{
	 int k = NumRow_RSU;
	 NumRow_RSU = -1;
	 FillRow_RSU(Sender);
	 NumRow_RSU = k;
	 //   RSU
	 StringGrid_RSUMySelect(Data_select.N_RSU[n_plane]);
	 flag_change_rsu = false;

	 if (DrawRSUForm->Visible) {
		BitBtn_DrawClick(Sender);
	 }

	 TabSheet_KI->TabVisible = false;
	 //TabSheet_sect_prof->TabVisible = false;
	 flag_checking = false;


}
//---------------------------------------------------------------------------
//-----------------------------------------------
//   
void __fastcall TSelectProfilSectForm::StringGrid_RSUMySelect(int RowSelect)
{
	 // The following code selects the rectangle containing
	 // rows 1 through 4, and columns 2 and 3.
	 TGridRect myRect;
	 myRect.Left = 0;
	 myRect.Top = RowSelect;
	 myRect.Right = 6;
	 myRect.Bottom = RowSelect;
	 StringGrid_RSU->Selection = myRect;
	 NumRow_RSU = RowSelect;
	 if (NumRow_RSU > 0)  {
		 int n = NumRow_RSU - 1;
		 Edit_N->Text = Data_select.RSU[n_plane][n][0];
		 Edit_Mx->Text = Data_select.RSU[n_plane][n][1];
		 Edit_Qy->Text = Data_select.RSU[n_plane][n][2];
		 Edit_My->Text = Data_select.RSU[n_plane][n][3];
		 Edit_Qx->Text = Data_select.RSU[n_plane][n][4];
		 Edit_qy_->Text = Data_select.q_bal[n_plane][n];

		 Draw_prof_ax(N_profil);
	 }

}
//---------------------------------------------------------------------------
//  RSU    
void __fastcall TSelectProfilSectForm::FillRow_RSU(TObject *Sender)
{
   int k, n_row;
   double N_;
   double Mx_, Qy_, My_, Qx_, q_bal;

   if (NumRow_RSU >=0)
	 k = NumRow_RSU - 1;
   else
	 k = Data_select.N_RSU[n_plane];

   int rc1 = String_double(Label_N->Caption, Edit_N->Text, &(N_));
   int rc2 = String_double(Label_Mx->Caption, Edit_Mx->Text, &(Mx_));
   int rc3 = String_double(Label_Qy->Caption, Edit_Qy->Text, &(Qy_));
   int rc4 = String_double(Label_My->Caption, Edit_My->Text, &(My_));
   int rc5 = String_double(Label_Qx->Caption, Edit_Qx->Text, &(Qx_));
   int rc6 = String_double(Label_qy_->Caption, Edit_qy_->Text, &(q_bal));
   if (rc1>0 || rc2>0 || rc3>0 || rc4>0 || rc5>0|| rc6>0)
	 return;
   if (N_==0 && Mx_==0 & My_==0 && Qx_==0 && Qy_==0 && q_bal==0) {
	   rc1 = Application->MessageBox(L"     ",
									   L" ", MB_OK | MB_ICONERROR);
	   return;
   }
   if (N_==0 && Mx_==0 && Qy_ == 0 && q_bal == 0) {
	   //rc1 = Application->MessageBox(L"    N  Mx      ",
	   rc1 = Application->MessageBox(L"   N, Mx  Qy      ",
									   L" ", MB_OK | MB_ICONERROR);
	   return;
   }
   Data_select.RSU[n_plane][k][0] = N_;
   Data_select.RSU[n_plane][k][1] = Mx_;
   Data_select.RSU[n_plane][k][2] = Qy_;
   Data_select.RSU[n_plane][k][3] = My_;
   Data_select.RSU[n_plane][k][4] = Qx_;
   Data_select.q_bal[n_plane][k] = q_bal;

   StringGrid_RSU->ColCount = 7;
   if (NumRow_RSU < 0) {
	 Data_select.N_RSU[n_plane]++;
	 StringGrid_RSU->RowCount = Data_select.N_RSU[n_plane] +1;
	 n_row = Data_select.N_RSU[n_plane];
   }
   else {
	 n_row = NumRow_RSU;
   }
   StringGrid_RSU->Cells[0][n_row] = n_row;
   StringGrid_RSU->Cells[1][n_row] = Data_select.RSU[n_plane][k][0];
   StringGrid_RSU->Cells[2][n_row] = Data_select.RSU[n_plane][k][1];
   StringGrid_RSU->Cells[3][n_row] = Data_select.RSU[n_plane][k][2];
   StringGrid_RSU->Cells[4][n_row] = Data_select.RSU[n_plane][k][3];
   StringGrid_RSU->Cells[5][n_row] = Data_select.RSU[n_plane][k][4];
   StringGrid_RSU->Cells[6][n_row] = Data_select.q_bal[n_plane][k];

   BitBtn_RSURep->Enabled = true;
   BitBtn_RSUDel->Enabled = true;
   modify_project = true;

}
//------------------------------------------------------------
//   
void __fastcall TSelectProfilSectForm::FillTab_RSU() {
  int k, n_row;

  GroupBox_RSU->Caption = "      " + IntToStr(n_plane+1) + " ";
  StringGrid_RSU->RowCount = Data_select.N_RSU[n_plane] +1;
  for (k=0; k<Data_select.N_RSU[n_plane]; k++) {
	n_row = k+1;
	StringGrid_RSU->Cells[0][n_row] = n_row;
	StringGrid_RSU->Cells[1][n_row] = Data_select.RSU[n_plane][k][0];
	StringGrid_RSU->Cells[2][n_row] = Data_select.RSU[n_plane][k][1];
	StringGrid_RSU->Cells[3][n_row] = Data_select.RSU[n_plane][k][2];
	StringGrid_RSU->Cells[4][n_row] = Data_select.RSU[n_plane][k][3];
	StringGrid_RSU->Cells[5][n_row] = Data_select.RSU[n_plane][k][4];
	StringGrid_RSU->Cells[6][n_row] = Data_select.q_bal[n_plane][k];
  }
  Edit_N->Text = StringGrid_RSU->Cells[1][n_row];
  Edit_Mx->Text = StringGrid_RSU->Cells[2][n_row];
  Edit_My->Text = StringGrid_RSU->Cells[4][n_row];
  Edit_Qy->Text = StringGrid_RSU->Cells[3][n_row];
  Edit_Qx->Text = StringGrid_RSU->Cells[5][n_row];
  Edit_qy_->Text = StringGrid_RSU->Cells[6][n_row];

}
//------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::BitBtn_RSURepClick(TObject *Sender)
{
   if (NumRow_RSU > 0) {
	  FillRow_RSU(Sender);
	  flag_change_rsu = false;
   }
   else {
		  #ifdef EMBRAC
	  int rc = Application->MessageBox(L"   ", L" ", MB_OK | MB_ICONWARNING);
		  #else
	  int rc = Application->MessageBox("   ", " ", MB_OK | MB_ICONWARNING);
		  #endif

   }
   Draw_prof_ax(N_profil);

   if (DrawRSUForm->Visible) {
	 if (DrawRSUForm->index_draw==0)
		BitBtn_DrawClick(Sender);
	 else
		BitBtn_EpurClick(Sender);
   }
	 TabSheet_KI->TabVisible = false;
	 //TabSheet_sect_prof->TabVisible = false;
     flag_checking = false;

}
//---------------------------------------------------------------------------
//   
void __fastcall TSelectProfilSectForm::StringGrid_RSUSelectCell(TObject *Sender, int ACol,
		  int ARow, bool &CanSelect)
{
   int n;
   if (ARow > 0)  {
	 NumRow_RSU = ARow;
	 n = NumRow_RSU - 1;
	 Edit_N->Text = Data_select.RSU[n_plane][n][0];
	 Edit_Mx->Text = Data_select.RSU[n_plane][n][1];
	 Edit_Qy->Text = Data_select.RSU[n_plane][n][2];
	 Edit_My->Text = Data_select.RSU[n_plane][n][3];
	 Edit_Qx->Text = Data_select.RSU[n_plane][n][4];
	 Edit_qy_->Text = Data_select.q_bal[n_plane][n];
	 Draw_prof_ax(N_profil);
	 if (DrawRSUForm->Visible) {
	   if (DrawRSUForm->index_draw==0)
			BitBtn_DrawClick(Sender);
	   else
			BitBtn_EpurClick(Sender);
	 }

   }
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn_RSUDelClick(TObject *Sender)
{
   int i;
   if (NumRow_RSU > 0) {
	  if (Data_select.N_RSU[n_plane] > 1) {
		for (i = NumRow_RSU; i < StringGrid_RSU->RowCount - 1; i++) {
		  StringGrid_RSU->Cells[1][i] = StringGrid_RSU->Cells[1][i+1];
		  StringGrid_RSU->Cells[2][i] = StringGrid_RSU->Cells[2][i+1];
		  StringGrid_RSU->Cells[3][i] = StringGrid_RSU->Cells[3][i+1];
		  StringGrid_RSU->Cells[4][i] = StringGrid_RSU->Cells[4][i+1];
		  StringGrid_RSU->Cells[5][i] = StringGrid_RSU->Cells[5][i+1];
		  StringGrid_RSU->Cells[6][i] = StringGrid_RSU->Cells[6][i+1];
		  StringGrid_RSU->Cells[7][i] = StringGrid_RSU->Cells[7][i+1];
		  Data_select.RSU[n_plane][i-1][0] = Data_select.RSU[n_plane][i][0];
		  Data_select.RSU[n_plane][i-1][1] = Data_select.RSU[n_plane][i][1];
		  Data_select.RSU[n_plane][i-1][2] = Data_select.RSU[n_plane][i][2];
		  Data_select.RSU[n_plane][i-1][3] = Data_select.RSU[n_plane][i][3];
		  Data_select.RSU[n_plane][i-1][4] = Data_select.RSU[n_plane][i][4];
		  Data_select.q_bal[n_plane][i-1] = Data_select.q_bal[n_plane][i];
		}
		Data_select.N_RSU[n_plane]--;
	  }
	  else
		Data_select.N_RSU[n_plane]=0;
	  StringGrid_RSU->RowCount--;
	  if (Data_select.N_RSU[n_plane]==0) {
		BitBtn_RSURep->Enabled = false;
		BitBtn_RSUDel->Enabled = false;
	  }
	  modify_project = true;
      flag_change_rsu = false;


   }
   else {
		  #ifdef EMBRAC
	  int rc = Application->MessageBox(L"   ", L" ", MB_OK | MB_ICONWARNING);
		  #else
	  int rc = Application->MessageBox("   ", " ", MB_OK | MB_ICONWARNING);
		  #endif
   }

	 TabSheet_KI->TabVisible = false;
	 //TabSheet_sect_prof->TabVisible = false;
	 flag_checking = false;


}
//---------------------------------------------------------------------------
//     
//    
void __fastcall TSelectProfilSectForm::Config_RSU(int index)
{
	//       
	int i, j, k, m;
	 if (index == PERFOR_BEAM) {
		Edit_N->Enabled = false;
		Edit_Mx->Enabled = false;
		Edit_Qy->Enabled = false;
		Edit_My->Enabled = false;
		Edit_Qx->Enabled = false;
		Edit_N->Text = "0";
		Edit_Mx->Text = "0";
		Edit_Qy->Text = "0";
		Edit_My->Text = "0";
		Edit_Qx->Text = "0";

		for (i=0; i<Data_select.N_plane; i++) {
		   for (j=0; j<Data_select.N_RSU[i]; j++) {
			  Data_select.RSU[i][j][0] = 0;
			  Data_select.RSU[i][j][1] = 0;
			  Data_select.RSU[i][j][2] = 0;
			  Data_select.RSU[i][j][3] = 0;
			  Data_select.RSU[i][j][4] = 0;
		   }

		   //   
		   for (j=0, m=0; j<Data_select.N_RSU[i]; j++) {
			 if (Data_select.q_bal[i][m] == 0) {
			   for (k=m; k < Data_select.N_RSU[i] - 1; k++) {
				 Data_select.RSU[i][k][0] = Data_select.RSU[i][k+1][0];
				 Data_select.RSU[i][k][1] = Data_select.RSU[i][k+1][1];
				 Data_select.RSU[i][k][2] = Data_select.RSU[i][k+1][2];
				 Data_select.RSU[i][k][3] = Data_select.RSU[i][k+1][3];
				 Data_select.RSU[i][k][4] = Data_select.RSU[i][k+1][4];
				 Data_select.q_bal[i][k] = Data_select.q_bal[i][k+1];
			   }
			 }
			 else
			   m++;
		   }
		   Data_select.N_RSU[i] = m;
		}
		for (i = 0; i < StringGrid_RSU->RowCount; i++) {
		  StringGrid_RSU->Cells[1][i] = 0;
		  StringGrid_RSU->Cells[2][i] = 0;
		  StringGrid_RSU->Cells[3][i] = 0;
		  StringGrid_RSU->Cells[4][i] = 0;
		  StringGrid_RSU->Cells[5][i] = 0;
		}
		Label_GridLen->Caption = "    , ";
	 }
	 else {
		Edit_N->Enabled = true;
		Edit_Mx->Enabled = true;
		Edit_Qy->Enabled = true;
		Edit_My->Enabled = true;
		Edit_Qx->Enabled = true;
		Edit_qy_->Enabled = true;
		Edit_N->Text = "0";
		Edit_Mx->Text = "0";
		Edit_Qy->Text = "0";
		Edit_My->Text = "0";
		Edit_Qx->Text = "0";
		Edit_qy_->Text = "0";
		Label_GridLen->Caption = "    , ";
	 }

}
//-----------------------------------------------------------------------
//
void __fastcall TSelectProfilSectForm::GetLoadFromRSU(double *load)
{
   flag_image = true;  //   

   //
   int n;
   n = NumRow_RSU - 1;
   Edit_N->Text = Data_select.RSU[n_plane][n][0];
   Edit_Mx->Text = Data_select.RSU[n_plane][n][1];
   Edit_Qy->Text = Data_select.RSU[n_plane][n][2];
   Edit_My->Text = Data_select.RSU[n_plane][n][3];
   Edit_Qx->Text = Data_select.RSU[n_plane][n][4];
   //

   int rc1 = String_double(Label_N->Caption, Edit_N->Text, &(load[0]));
   int rc2 = String_double(Label_Mx->Caption, Edit_Mx->Text, &(load[1]));
   int rc3 = String_double(Label_Qy->Caption, Edit_Qy->Text, &(load[2]));
   int rc4 = String_double(Label_My->Caption, Edit_My->Text, &(load[3]));
   int rc5 = String_double(Label_Qx->Caption, Edit_Qx->Text, &(load[4]));
   int rc6 = String_double(Label_qy_->Caption, Edit_qy_->Text, &(load[5]));
   if (rc1>0 || rc2>0 || rc3>0 || rc4>0 || rc5>0|| rc6>0)
	 return;
}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::BitBtn_DrawClick(TObject *Sender)
{
   double load[6];

   GetLoadFromRSU(load);

   for (int i=0; i<6; i++) {
	 DrawRSUForm->loads[i] = load[i];
   }
   DrawRSUForm->L_beam = Data_select.Length[n_plane];
   DrawRSUForm->form_profil = Data_select.form_profil;
   DrawRSUForm->index_profil = Data_select.index_profil;
   DrawRSUForm->type_profil = Data_select.type_profil;
   DrawRSUForm->attit = Data_select.perfor_attit;
   DrawRSUForm->alfa = Data_select.perfor_alfa;
   DrawRSUForm->index_draw = 0;
   if (!DrawRSUForm->Visible) {
	  DrawRSUForm->Show();
   }
   DrawRSUForm->Draw_All(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NNewClick(TObject *Sender)
{
	Caption = "   - [ ]";
	InfMessage(" ");
	NewProject(Sender);
}
//----------------------------------------------------------------
void __fastcall TSelectProfilSectForm::NewProject(TObject *Sender)
{
	int i;

	if (Data_select.N_plane!=0) {
	   i=Application->MessageBox(L"  ?", L" ",
				  MB_YESNO | MB_ICONQUESTION);
		if (i==IDNO)
		   return;
	   if (modify_project) {
		 i=Application->MessageBox(L"   , ?", L" ",
				  MB_YESNO | MB_ICONQUESTION);
		 if (i==IDYES) NSaveClick(Sender);
	   }
	}
	ModelFile = UNTITLED;
	modify_project = false;
	flag_checking = false;
 	flag_change_rsu = false;



	CheckBoxAddLimit->Checked = false;
	//GroupBox_AddLimit->Enabled = false;
	Label_width->Enabled = false;
	Edit_width->Enabled = false;
	Label_height->Enabled = false;
	Edit_height->Enabled = false;
	GroupBox_bend->Visible = true;
	//BitBtnCheck->Enabled = false;
    Data_select.form_profil = 0;

	RadioButton_DvutavrClick(Sender);
   //RadioButton_TubeClick(Sender);
	ComboBox_DvutavrChange(Sender);
   //ComboBox_TubeChange(Sender);


	Data_select.N_plane = 0;
	Data_select.Strela = 0;
	Data_select.Delta_lim = 0;
	Data_select.index_GOST = 0;  //    27772
	for (i=0; i<100; i++) {
	  Data_select.N_RSU[i] = 0;
	}
	//index_q_bal = -1;

	Label_plane->Caption = "   ";
    CheckBox_razrez->Checked = true;

	Edit_N->Text = "0";
	Edit_Mx->Text = "0";
	Edit_Qy->Text = "0";
	Edit_My->Text = "0";
	Edit_Qx->Text = "0";
	Edit_qy_->Text = "0";
	Edit1->Text = "120";
	Edit2->Text = "0";
	Label4->Visible = false;
	Label5->Visible = false;
	Edit2->Visible = false;

	Edit_Tens->Text = "400";
	Edit_Len->Text = "0";
	Edit_muYZ->Text = "0";
	Edit_muXZ->Text = "0";

	TabSheet_KI->TabVisible = false;
	//TabSheet_sect_prof->TabVisible = false;
	flag_checking = false;
	Last_type_sect = 0;
	ComboBox_index_Qy->ItemIndex = 0;
	//ComboBox_index_Qy->Visible = false;

	ComboBox_TypeElemChange(Sender);
	BalkaLoadFrame1->InitBalka(Sender);
	//   
	GetDataBeam(&Data_beam, &Data_region);           //Data_beam.loads_v[0]
	RadioGroup_Loads->ItemIndex = 0;

	Label_mass->Caption = "";
	Label_conditions->Caption = "";
	Label_add_conditions->Caption = "";
	Label_edge->Caption = "";
	Label_edge_step->Caption = "";
	Label_edge_param->Caption = "";
	Label_mass_weld->Caption = "";
	Label_edge_weld->Caption = "";
	Label_edge_param_weld->Caption = "";
    PageControl_Data->ActivePage = TabSheet_Common;
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn_Advance_gamma_nClick(TObject *Sender)

{
   Advanced_gamma_nForm->ShowModal();
   if (Advanced_gamma_nForm->Koeff_gamma_n > 0) {
	  ComboBox_gamma_n->Text = FloatToStr(Advanced_gamma_nForm->Koeff_gamma_n);
   }
   modify_project = true;

}
//---------------------------------------------------------------------------



void __fastcall TSelectProfilSectForm::BitBtn_OutWordClick(TObject *Sender)
{
	NOutReportClick(Sender);
}
//---------------------------------------------------------------------------
	//WinExec(("hh "+Name_help).c_str(), SW_RESTORE);


void __fastcall TSelectProfilSectForm::NHelpCaptClick(TObject *Sender)
{

	//unsigned long dword = GetModuleFileName(NULL, Path_gen, PATHLEN );
	//char *path = strrchr(Path_gen, '\\');
	//path[0] = '\0';
	//String  Name_help=(AnsiString)Path_gen+"\\ _ .pdf"; //  chm
	//HelpForm->CppWebBrowser1->Navigate(Name_help.c_str());

	WideString path = ExtractFilePath(Application->ExeName) + " _ _v3.1.pdf";
    InfMessage(path);
	HelpForm -> CppWebBrowser1 -> Navigate((BSTR)path);

	HelpForm->ShowModal();


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NRefProgClick(TObject *Sender)
{
   AboutProgForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Edit_NChange(TObject *Sender)
{
   flag_change_rsu = true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::CheckBox_gibClick(TObject *Sender)
{
	if (CheckBox_gib->Checked) {
       Edit_d_lambda->Text="1.25";
	   Edit_d_w->Text="0.75";
	   Edit_d_f->Text="1.15";
    }
	else {
	   Edit_d_lambda->Text="1.0";
       Edit_d_w->Text="1.0";
       Edit_d_f->Text="1.0";
    }
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1BitBtn_ApplyClick(TObject *Sender)
{
   Sect_Param_WeldFrame1->BitBtn_ApplyClick(Sender);
   Label_mass_weld->Caption = "";
   TabSheet_KI->TabVisible = false;

   Draw_prof_ax(-1);


}
//---------------------------------------------------------------------------
//  
void __fastcall TSelectProfilSectForm::RadioButtonPerforClick(TObject *Sender)
{
	if (RadioButtonPerfor->Checked) {
	  CheckBoxAddLimit->Enabled = true;
	  Label_step_comp->Visible = true;
	  Edit_step_comp->Visible = true;
	  Label_step_prim->Visible = true;
	  TabSheet_Weld->TabVisible = false;
	  TabSheetPerfor->TabVisible = true;
	  TabSheet_sect_prof->TabVisible = true;
	  TabSheet_KI->TabVisible = false;
	  CheckBoxAddLimit->Visible = true;
	  CheckBoxAddLimit->Checked = false;
	  CheckBox_edge->Enabled = true;
	  CheckBox_edge_choose->Visible = false;
	  RadioGroup_1_or_2->Visible = false;
	  RadioGroup_Loads->Visible = true;

	  RadioButton_Tube->Checked = false;
	  RadioButton_Weld->Checked = false;
	  ComboBox_Dvutavr->Visible = true;
	  ComboBox_Tube->Visible = false;
	  Data_select.form_profil = PERFOR_BEAM;
	  //Define_Material_ARSSForm->ComboBox_gost->ItemIndex = 1;
	  //Define_Material_ARSSForm->ComboBox_gostChange(Sender);
	  //   ,   ,
	  Define_Material_ARSSForm->Set_Material_name(Data_select.form_profil, Data_select.index_GOST, Data_select.title_material);
	  Panel_mater->Caption = Define_Material_ARSSForm->ComboBox_steel->Text;

	  ComboBox_TypeElemChange(Sender);

	  if (flag_message) {
		if (Data_select.N_plane != 0 ) {
		  #ifdef EMBRAC
		  int rc = Application->MessageBox(L"         . ? ",
		  L" ", MB_YESNO | MB_ICONQUESTION);
		  #else
		  int rc = Application->MessageBox("         . ? ",
		  " ", MB_YESNO | MB_ICONQUESTION);
		  #endif
		  if (rc==IDNO) {
			RadioButton_Dvutavr->Checked = true;
			return;
		  }

		}
	  }
	  //  
	  Config_RSU(PERFOR_BEAM);

	  flag_change_rsu = false;

	  GroupBox_bend->Visible = true;

	  //       
	  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;

	  Show_prof(0, Sender);

	  Draw_prof_ax(N_profil);

	  AnsiString Astr = Edit_alfa->Text;
	  int rc;
	  double alfa = str_exp(Astr.c_str(), &rc);
	  if (rc>0 || alfa<40 || alfa>70)
		return;
	  double attid;
	  rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attid);
	  if (rc>0) return;
	  //    
	  Show_prof_perfor(N_profil, Sender, attid, alfa, false);

	  modify_project = true;

	}

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::NMRU1Click(TObject *Sender)
{
  // Load a file in the Memo component based on
  // the MRU item that was clicked.
  TMenuItem* itemClicked = dynamic_cast<TMenuItem*>(Sender);
  int index = itemClicked->MenuIndex - NMRU1->MenuIndex;
  FileDir_Name = MruList->Strings[index];
  OpenProject(Sender, 2);

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::NFileClick(TObject *Sender)
{
// This is the OnClick handler for the top
// level File menu. Here we check each string
// in the MRU list and show the associated MRU
// menu item if the string is not empty.
  int index = NMRU1->MenuIndex;
  AnsiString Astr;
  for (int i=0; i<5; i++) {
	Astr = MruList->Strings[i];
	if (Astr != "") {
	  NMRUSeparator->Visible = true;
	  NFile->Items[index + i]->Visible = true;
	  char buff[MAX_PATH];
	  sprintf(buff, "&%d %s", i + 1, Astr.c_str());
	  NFile->Items[index + i]->Caption = buff;
	}
  }
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::FormCreate(TObject *Sender)
{
  // Create the TStringList class.
  MruList = new TStringList;
  // Load the strings from the registry. First
  // try to open the key. If that fails, then we
  // know that the program is being run for the
  // first time and that we need to create the
  // key and set up the MRU items in the key.
  TRegistry* reg = new TRegistry;
  if (!reg->OpenKey(RegKey, false)) {
	reg->OpenKey(RegKey, true);
	reg->WriteString("MRU1", "");
	reg->WriteString("MRU2", "");
	reg->WriteString("MRU3", "");
	reg->WriteString("MRU4", "");
	reg->WriteString("MRU5", "");
  }
// Read each string from the registry. Some of
// the strings could be empty, but thats OK.
  MruList->Add(reg->ReadString("MRU1"));
  MruList->Add(reg->ReadString("MRU2"));
  MruList->Add(reg->ReadString("MRU3"));
  MruList->Add(reg->ReadString("MRU4"));
  MruList->Add(reg->ReadString("MRU5"));
// Delete the TRegistry object.
  delete reg;

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::FormDestroy(TObject *Sender)
{
  // Save the string list to the registry. If
  // the check box is checked, then delete the
  // key and dont save the MRU list (duh).
  TRegistry* reg = new TRegistry;
  //if (CheckBox1->Checked)
  //  reg->DeleteKey(RegKey);
  //else {
	reg->OpenKey(RegKey, true);
   // Write the list to the registry.
	reg->WriteString("MRU1", MruList->Strings[0]);
	reg->WriteString("MRU2", MruList->Strings[1]);
	reg->WriteString("MRU3", MruList->Strings[2]);
	reg->WriteString("MRU4", MruList->Strings[3]);
	reg->WriteString("MRU5", MruList->Strings[4]);
  //}
  // Clean up.
  delete reg;
  delete MruList;

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::RadioGroup_SimmSectClick(TObject *Sender)
{
	if (RadioGroup_SimmSect->ItemIndex==0) {
	   CheckBox_equWidth->Checked = true;
	   CheckBox_equWidth->Enabled = false;
	}
	else {
	   CheckBox_equWidth->Enabled = true;
	}
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::ComboBox_AlgChange(TObject *Sender)
{
   if (ComboBox_Alg->ItemIndex==2) {
	   GroupBox_Set_1->Enabled = false;
       RadioGroup_SimmSect->ItemIndex = 0;
   }
   else {
	   GroupBox_Set_1->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn1Click(TObject *Sender)
{
	Help_delta_Alg_1Form->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BitBtn2Click(TObject *Sender)
{
	Help_Algor_Form->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::Edit_alfaEnter(TObject *Sender)
{
	  double alfa, attid;
	  int rc;
	  rc = String_double_range(Label_alfa->Caption, Edit_alfa->Text, 40.0, 70.0, &alfa);
	  if (rc>0) return;
	  //AnsiString Astr = Edit_alfa->Text;
	  //alfa = str_exp(Astr.c_str(), &rc);
	  //if (rc>0 || alfa<40 || alfa>70)
	  //	return;
	  rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attid);
	  if (rc>0) return;
	  //       
	  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;

	  Show_prof_perfor(N_profil, Sender, attid, alfa, false);

	  //    
	  Data_select.index_profil = ComboBox_Dvutavr->ItemIndex;
	  Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;

	  N_profil = SectSelectCom_ParamFrame1->ComboBox_profil->ItemIndex;
	  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Edit_alfaKeyDown(TObject *Sender, WORD &Key,
		  TShiftState Shift)
{
   if (Key == VK_RETURN) Edit_alfaEnter(Sender);

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::ComboBox_index_QyChange(TObject *Sender)
{
   Data_select.index_Qy = ComboBox_index_Qy->ItemIndex;

   Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Draw_RSU_Frame1CheckListBox_ShowClick(TObject *Sender)

{
	Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Draw_RSU_Frame1CheckBox_CentrClick(TObject *Sender)

{
  Draw_RSU_Frame1->CheckBox_CentrClick(Sender);
  Draw_prof_ax(N_profil);


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Draw_RSU_Frame1CheckBox_SideClick(TObject *Sender)

{
  Draw_RSU_Frame1->CheckBox_SideClick(Sender);
  Draw_prof_ax(N_profil);


}
//---------------------------------------------------------------------------




void __fastcall TSelectProfilSectForm::NUndoClick(TObject *Sender)
{
   //
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::NRedoClick(TObject *Sender)
{
	 //
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::SectSelectCom_ParamFrame1RadioGroup_orientClick(TObject *Sender)

{
  SectSelectCom_ParamFrame1->RadioGroup_orientClick(Sender);
  //   
  int n_prof = StandartProfil.GetNumberProfil_Tube(SectSelectCom_ParamFrame1->ComboBox_h_b_rect->ItemIndex,
											   SectSelectCom_ParamFrame1->ComboBox_t_rect->ItemIndex);
  Draw_prof_ax(n_prof);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::RadioGroup_LoadsClick(TObject *Sender)
{
   int i;
   if (RadioGroup_Loads->ItemIndex==0) {
	   TabSheet_Part->TabVisible = true;
	   TabSheet1_Load_Constr->TabVisible = false;
	   CheckBox_razrez->Enabled = true;
	   Edit_muYZ->Visible = true;
	   Label_muYZ->Visible = true;
	   Edit_muXZ->Visible = true;
	   Label_muXZ->Visible = true;
	   Edit_step_comp->Visible = true;
	   Label_step_comp->Visible = true;
	   Label_step_prim->Visible = true;
	   Label_message_length->Visible = false;
	   BitBtn_LenAdd->Enabled = true;
	   BitBtn_LenRep->Enabled = true;
	   BitBtn_LenDel->Enabled = true;
	   RadioGroup_mu->Enabled =  true;
	   Label_GridLen->Visible = true;
	   StringGrid_Length->Visible = true;

	   BitBtn_RSUAdd->Enabled = true;
	   BitBtn_RSURep->Enabled = true;
	   BitBtn_RSUDel->Enabled = true;

	   Draw_RSU_Frame1->CheckBox_RealScale->Visible = false;
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Clear();
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add("");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add(" ");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add(" ");
	   Draw_RSU_Frame1->CheckListBox_Show->Width = 250;
	   for (i=0; i<3; i++)
		  Draw_RSU_Frame1->CheckListBox_Show->Checked[i]=true;
   }
   else {
	   TabSheet_Part->TabVisible = false;
	   //BalkaLoadFrame1->PageControl_BoundCondChange(Sender);
	   TabSheet1_Load_Constr->TabVisible = true;
	   Draw_RSU_Frame1->CheckBox_RealScale->Visible = true;
	   CheckBox_razrez->Enabled = false;
	   Edit_muYZ->Visible = false;
	   Label_muYZ->Visible = false;
	   Edit_muXZ->Visible = false;
	   Label_muXZ->Visible = false;
	   Edit_step_comp->Visible = false;
	   Label_step_comp->Visible = false;
	   BitBtn_LenAdd->Enabled = false;
	   BitBtn_LenRep->Enabled = false;
	   BitBtn_LenDel->Enabled = false;
	   RadioGroup_mu->Enabled =  false;
	   Label_GridLen->Visible = false;
	   StringGrid_Length->Visible = false;

	   BitBtn_RSUAdd->Enabled = false;
	   BitBtn_RSURep->Enabled = false;
	   BitBtn_RSUDel->Enabled = false;

	   Draw_RSU_Frame1->CheckListBox_Show->Items->Clear();
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add("");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add(" ");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add(" ");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add("");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add("");
	   Draw_RSU_Frame1->CheckListBox_Show->Items->Add("   ");
	   Draw_RSU_Frame1->CheckListBox_Show->Width = 400;
	   for (i=0; i<4; i++)
		  Draw_RSU_Frame1->CheckListBox_Show->Checked[i]=true;
	   Draw_RSU_Frame1->CheckListBox_Show->Checked[4]=false;
	   PageControl_Data->ActivePage = TabSheet1_Load_Constr;
	   Label_step_prim->Visible = false;
	   Label_message_length->Visible = true;
	   Label_message_length->Top = Label_muXZ->Top;
	   Label_message_length->Left = Label_muXZ->Left;

   }
}
//---------------------------------------------------------------------------



void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_AddClick(TObject *Sender)

{
  BalkaLoadFrame1->BitBtn_AddClick(Sender);
  Draw_prof_ax(N_profil);
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtnDeleteClick(TObject *Sender)

{
	 BalkaLoadFrame1->BitBtnDeleteClick(Sender);
     Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_ReplaceClick(TObject *Sender)

{
	BalkaLoadFrame1->BitBtn_ReplaceClick(Sender);
    Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1Edit_p1Change(TObject *Sender)

{
     BalkaLoadFrame1->Edit_p1Change(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1Edit_n1Change(TObject *Sender)

{
     BalkaLoadFrame1->Edit_n1Change(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1CheckBox_LinearClick(TObject *Sender)

{
     BalkaLoadFrame1->CheckBox_LinearClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1CheckBox_Linear_nClick(TObject *Sender)

{
    BalkaLoadFrame1->CheckBox_Linear_nClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_InsertClick(TObject *Sender)

{
    BalkaLoadFrame1->BitBtn_InsertClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1ListBox1Click(TObject *Sender)

{
	BalkaLoadFrame1->ListBox1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1CSpinEditLineWidthChange(TObject *Sender)
{
	   BalkaLoadFrame1->CSpinEditLineWidthChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1PageControl_BoundCondChange(TObject *Sender)

{
  BalkaLoadFrame1->PageControl_BoundCondChange(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButton_AddClick(TObject *Sender)

{
  BalkaLoadFrame1->SpeedButton_AddClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButtonDeleteClick(TObject *Sender)

{
  BalkaLoadFrame1->SpeedButtonDeleteClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1ComboBox_num_zagrChange(TObject *Sender)

{
  BalkaLoadFrame1->ComboBox_num_zagrChange(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButton_ApplyClick(TObject *Sender)

{
	BalkaLoadFrame1->SpeedButton_ApplyClick(Sender);

	Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------
void __fastcall TSelectProfilSectForm::Draw_RSU_Frame1CheckBox_RealScaleClick(TObject *Sender)

{
	Draw_prof_ax(N_profil);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButtonTablClick(TObject *Sender)

{
  BalkaLoadFrame1->SpeedButtonTablClick(Sender);
  Draw_prof_ax(N_profil);


}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1PageControl_LoadChange(TObject *Sender)

{
	BalkaLoadFrame1->PageControl_LoadChange(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1ComboBox_type_zagrChange(TObject *Sender)

{
  BalkaLoadFrame1->ComboBox_type_zagrChange(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1CheckBox_WeightClick(TObject *Sender)

{
  BalkaLoadFrame1->CheckBox_WeightClick(Sender);
  Draw_prof_ax(N_profil);


}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_AddZClick(TObject *Sender)

{
  BalkaLoadFrame1->BitBtn_AddClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_ReplaceZClick(TObject *Sender)

{
  BalkaLoadFrame1->BitBtn_ReplaceClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_DeleteZClick(TObject *Sender)

{
  BalkaLoadFrame1->BitBtnDeleteClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1RadioGroup_SupCountClick(TObject *Sender)

{
  BalkaLoadFrame1->RadioGroup_SupCountClick(Sender);
  Draw_prof_ax(N_profil);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButtonAppStepClick(TObject *Sender)
{
  BalkaLoadFrame1->SpeedButtonAppStepClick(Sender);
  Draw_prof_ax(N_profil);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::BalkaLoadFrame1BitBtn_CreateRSUClick(TObject *Sender)

{
  int i, j;
  int k = 0;
  bool flag_repeat;
  //  
  BalkaLoadFrame1->BitBtn_CreateRSUClick(Sender);

  Data_select.MaxV0 = BalkaLoadFrame1->MaxV;
  Data_select.MaxV = BalkaLoadFrame1->MaxV;
  Data_select.MaxV_W = BalkaLoadFrame1->MaxV_W;
  Data_select.Span = BalkaLoadFrame1->Span;

  Data_select.N_plane =  1;
  if (BalkaLoadFrame1->MaxN[0]>0) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MaxN[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MaxN[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MaxN[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MaxN[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MaxN[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MaxN[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MaxN_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MaxN_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MaxN_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MaxN_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MaxN_W[3]/F1000;
	 k++;
  }
  if (BalkaLoadFrame1->MinN[0]<0) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MinN[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MinN[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MinN[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MinN[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MinN[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MinN[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MinN_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MinN_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MinN_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MinN_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MinN_W[3]/F1000;
	 k++;
  }
  flag_repeat = false;
  for (i=0; i<k; i++) {
	if ((ABS(BalkaLoadFrame1->MaxQ[1]/F1000 - Data_select.RSU[0][i][2]))<1e-3)
	  flag_repeat = true;
  }
  if (BalkaLoadFrame1->MaxQ[1]>0 && !flag_repeat) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MaxQ[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MaxQ[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MaxQ[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MaxQ[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MaxQ[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MaxQ[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MaxQ_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MaxQ_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MaxQ_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MaxQ_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MaxQ_W[3]/F1000;
	 k++;
   }
  flag_repeat = false;
  for (i=0; i<k; i++) {
	if ((ABS(BalkaLoadFrame1->MaxM[1]/F1000 - Data_select.RSU[0][i][1]))<1e-3)
	  flag_repeat = true;
  }
  if (BalkaLoadFrame1->MaxM[2]>0 && !flag_repeat) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MaxM[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MaxM[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MaxM[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MaxM[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MaxM[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MaxM[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MaxM_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MaxM_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MaxM_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MaxM_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MaxM_W[3]/F1000;
	 k++;
  }
  flag_repeat = false;
  for (i=0; i<k; i++) {
	if ((ABS(BalkaLoadFrame1->MinM[2]/F1000 - Data_select.RSU[0][i][1]))<1e-3)
	  flag_repeat = true;
  }
  if (BalkaLoadFrame1->MinM[2]<0 && !flag_repeat) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MinM[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MinM[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MinM[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MinM[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MinM[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MinM[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MinM_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MinM_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MinM_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MinM_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MinM_W[3]/F1000;
	 k++;
  }
  flag_repeat = false;
  for (i=0; i<k; i++) {
	if ((ABS(BalkaLoadFrame1->MaxSigma[2]/F1000 - Data_select.RSU[0][i][1]))<1e-3)
	  flag_repeat = true;
  }
  if (BalkaLoadFrame1->MaxSigma[2]>0 && !flag_repeat) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MaxSigma[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MaxSigma[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MaxSigma[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MaxSigma[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MaxSigma[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MaxSigma[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MaxSigma_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MaxSigma_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MaxSigma_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MaxSigma_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MaxSigma_W[3]/F1000;
	 k++;
  }
  flag_repeat = false;
  for (i=0; i<k; i++) {
	if ((ABS(BalkaLoadFrame1->MinSigma[2]/F1000 - Data_select.RSU[0][i][1]))<1e-3)
	  flag_repeat = true;
  }
  if (BalkaLoadFrame1->MinSigma[2]<0 && !flag_repeat) {
	 Data_select.RSU[0][k][0] = BalkaLoadFrame1->MinSigma[0]/F1000;
	 Data_select.RSU[0][k][1] = BalkaLoadFrame1->MinSigma[2]/F1000;
	 Data_select.RSU[0][k][2] = BalkaLoadFrame1->MinSigma[1]/F1000;
	 Data_select.RSU[0][k][3] = BalkaLoadFrame1->MinSigma[4]/F1000;
	 Data_select.RSU[0][k][4] = BalkaLoadFrame1->MinSigma[3]/F1000;
	 Data_select.X_sect[0][k] = BalkaLoadFrame1->MinSigma[5]/L1000;
	 Data_select.q_bal[0][k] = 0;
	 Data_select.RSU_W[k][0] = BalkaLoadFrame1->MinSigma_W[0]/F1000;
	 Data_select.RSU_W[k][1] = BalkaLoadFrame1->MinSigma_W[2]/F1000;
	 Data_select.RSU_W[k][2] = BalkaLoadFrame1->MinSigma_W[1]/F1000;
	 Data_select.RSU_W[k][3] = BalkaLoadFrame1->MinSigma_W[4]/F1000;
	 Data_select.RSU_W[k][4] = BalkaLoadFrame1->MinSigma_W[3]/F1000;
	 k++;
  }
  Data_select.FRo_RSU = BalkaLoadFrame1->FRo_RSU;
  Data_select.Izz_RSU = BalkaLoadFrame1->Izz_RSU;
  Data_select.N_RSU[0] = k;
  Data_select.Length[0] = BalkaLoadFrame1->Length_beam*L1000;
  Data_select.length_YY[0] = BalkaLoadFrame1->Length_beam*L1000;
  if (BalkaLoadFrame1->Len_XY > 0)
	Data_select.length_XX[0] = BalkaLoadFrame1->Len_XY*L1000;
  else
	Data_select.length_XX[0] = Data_select.Length[0];
  Data_select.koeff_length_YY[0] = 1;
  Data_select.koeff_length_XX[0] = BalkaLoadFrame1->Len_XY/BalkaLoadFrame1->Length_beam;
  Data_select.step_comp[0] = 0;
  if (BalkaLoadFrame1->Step_up > 0)
	Data_select.step_up = BalkaLoadFrame1->Step_up*L1000;
  else
	Data_select.step_up = Data_select.length_XX[0];
  if (BalkaLoadFrame1->Step_down > 0)
	Data_select.step_down = BalkaLoadFrame1->Step_down*L1000;
  else
	Data_select.step_down = Data_select.length_XX[0];
  //   
  StringGrid_Length->RowCount = 2;
  StringGrid_Length->Cells[0][1] = "1";
  StringGrid_Length->Cells[1][1] = FloatToStr(Data_select.Length[0]/L1000);
  StringGrid_Length->Cells[2][1] = FloatToStr(Data_select.length_YY[0]/L1000);
  StringGrid_Length->Cells[3][1] = FloatToStr(Data_select.length_XX[0]/L1000);
  StringGrid_Length->Cells[4][1] = FloatToStr(Data_select.step_comp[0]/L1000);
  //-------------------------------------------------------------------
  StringGrid_RSU->ColCount = 8;
  StringGrid_RSU->Cells[7][0] = "X ., ";
  StringGrid_RSU->RowCount = Data_select.N_RSU[0] + 1;
  for (i=0; i<Data_select.N_RSU[0]; i++) {
	StringGrid_RSU->Cells[0][i+1] = IntToStr(i+1);
	for (j=0; j<5; j++) {
	  StringGrid_RSU->Cells[j+1][i+1] =  FloatToStr(Data_select.RSU[0][i][j]);
	}
	StringGrid_RSU->Cells[j+1][i+1] = Data_select.q_bal[0][i];
	StringGrid_RSU->Cells[j+2][i+1] = Data_select.X_sect[0][i];
  }
  Edit_N->Text = Data_select.RSU[n_plane][0][0];
  Edit_Mx->Text = Data_select.RSU[n_plane][0][1];
  Edit_Qy->Text = Data_select.RSU[n_plane][0][2];
  Edit_My->Text = Data_select.RSU[n_plane][0][3];
  Edit_Qx->Text = Data_select.RSU[n_plane][0][4];
  Edit_qy_->Text = Data_select.q_bal[n_plane][0];
  TabSheet_Part->TabVisible = true;
  if (Data_select.Length[0]/Data_select.step_up < 2) {
	  ComboBox_G1_Count->ItemIndex = 0;
  }
  if (Data_select.Length[0]/Data_select.step_up>=2 && Data_select.Length[0]/Data_select.step_up< 3 ){
	  ComboBox_G1_Count->ItemIndex = 2;
  }
  if (Data_select.Length[0]/Data_select.step_up>=3) {
	  ComboBox_G1_Count->ItemIndex = 1;
  }
  // ,    
  if (BalkaLoadFrame1->MaxMy_R >0.01)   //  
	CheckBox_razrez->Checked = false;
  else
	CheckBox_razrez->Checked = true;
  OutRSU(1);
}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::BalkaLoadFrame1SpeedButton_CallCombinClick(TObject *Sender)

{
  BalkaLoadFrame1->SpeedButton_CallCombinClick(Sender);
  Draw_prof_ax(N_profil);

}
//---------------------------------------------------------------------------
//   
void __fastcall TSelectProfilSectForm::BitBtn_EpurClick(TObject *Sender)
{
   GEOM_PARAM_SECT param_sect;
   PARAM_PERFOR param_perfor;
   double attit;
   double alfa;
   double load[5];
   int rc;


   switch (Data_select.form_profil) {
   case DVUTAVR_STAND:    //  
   //    
	 Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
	 StandartProfil.SetProfil(Data_select.type_profil);
   //       
	 //NameProfil = StandartProfil.GetVectorNameProfil(&n_profil);
	 rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), N_profil);
	 if (rc>0) return;
	 //Draw_dvutavr(Image_prof, &com_sect.dvutavr, vDIMETR, 1.2, 20, true);
	 //Draw_dvutavr_oblic(Image_prof, &com_sect.dvutavr);
	 //Draw_dvutavr(Draw_RSU_Frame1->Image1, &com_sect.dvutavr, vISOMETR, 4.0, 60, flag_sysc, false, 0, 0, length_0);
	 H_beam = com_sect.dvutavr.h + 2*com_sect.dvutavr.h1;
	 B_beam = com_sect.dvutavr.b1;
	 Get_param_sect_comm(DVUTAVR, &com_sect, &param_sect);

   break;
   case PERFOR_BEAM:
   //    
	 Data_select.type_profil = Data_select.index_profil + typeGOST_G57837_B;
	 StandartProfil.SetProfil(Data_select.type_profil);
   //       
	 //NameProfil = StandartProfil.GetVectorNameProfil(&n_profil);
	 rc = StandartProfil.SetParamProfil(&(com_sect.dvutavr), N_profil);
	 if (rc>0) return;

	 rc = String_double_plus(Label_attit->Caption, ComboBox_attit->Text, &attit);
	 if (rc>0) return;

	 rc = String_double_range(Label_alfa->Caption, Edit_alfa->Text, 40.0, 70.0, &alfa);
	 if (rc>0) return;

	 com_sect.dvutavr.h *= attit;
	 //Draw_dvutavr(Draw_RSU_Frame1->Image1, &com_sect.dvutavr, vISOMETR, 4.0, 60, flag_sysc, true, attit, alfa, length_0);

	 H_beam = com_sect.dvutavr.h + 2*com_sect.dvutavr.h1;
	 B_beam = com_sect.dvutavr.b1;

	 com_sect.dvutavr.h /= attit;
	 Get_param_sect_perfor(&com_sect.dvutavr, &param_sect, com_sect.dvutavr.h*attit, &param_perfor);

   break;
   case TRUBA:    // 
	 StandartProfil.SetProfil_Tube(Data_select.type_profil);
	 rc = StandartProfil.SetParamProfil_Tube(&(com_sect), Data_select.type_profil, N_profil);
	 if (rc>0) return;
	 //Draw_tube(Image_prof, &com_sect, Data_select.type_profil, vDIMETR, 1.2, 20, true);
	 //Draw_tube(Draw_RSU_Frame1->Image1, &com_sect, Data_select.type_profil, vISOMETR, 4.0, 70, flag_sysc, length_0);

	 Get_param_sect_comm(type_sect_tube, &com_sect, &param_sect);
	 H_beam = param_sect.Hsect;
	 B_beam = param_sect.Wsect;

   break;
   case DVUTAVR_WELD:    //  

	 //Draw_dvutavr_weld(Draw_RSU_Frame1->Image1, &sect_weld, vISOMETR, 4.0, 70, flag_sysc, length_0);
	 Get_param_sect(&sect_weld, &param_sect);
	 H_beam = param_sect.Hsect;
	 B_beam = param_sect.Wsect;
   break;
   }

   GetLoadFromRSU(load);

   double sigma_ext = load[0]*1e3/param_sect.Ar - load[1]*1e6*param_sect.Zct/param_sect.Izz;
   double sigma_int = load[0]*1e3/param_sect.Ar + load[1]*1e6*(param_sect.Hsect - param_sect.Zct)/param_sect.Izz;

   DrawRSUForm->sigma_ext = sigma_ext;
   DrawRSUForm->sigma_int = sigma_int;
   DrawRSUForm->Hsect = param_sect.Hsect;
   DrawRSUForm->index_draw = 1;

   if (!DrawRSUForm->Visible) {
	  DrawRSUForm->Show();
   }
   DrawRSUForm->Draw_Epur(Sender);


}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::ComboBox_G1_CountChange(TObject *Sender)
{
	ComboBox_G1_Load->Items->Clear();
	switch (ComboBox_G1_Count->ItemIndex) {
	case G1_NULL:
	  ComboBox_G1_Load->Items->Add("");
	  ComboBox_G1_Load->Items->Add(" ");
	  ComboBox_G1_Load->ItemIndex = 1;
	break;
	case G1_TWO_MORE:
	  ComboBox_G1_Load->Items->Add("");
	  ComboBox_G1_Load->ItemIndex = 0;
	break;
	case G1_ONE:
	  ComboBox_G1_Load->Items->Add("  ");
	  ComboBox_G1_Load->Items->Add("  ");
	  ComboBox_G1_Load->Items->Add(" ");
	  ComboBox_G1_Load->ItemIndex = 2;
	break;
	}
}
//---------------------------------------------------------------------------
//
void __fastcall TSelectProfilSectForm::RadioGroup_Schema_constrClick(TObject *Sender)
{
  if (RadioGroup_Schema_constr->ItemIndex==0) {    //   
	 Label_G1_Count->Visible = true;
	 ComboBox_G1_Count->Visible = true;

	 Label_G1_Load->Caption = "   ";
	 ComboBox_G1_CountChange(Sender);
  }
  else {                                          //   
	 Label_G1_Count->Visible = false;
	 ComboBox_G1_Count->Visible = false;

	 Label_G1_Load->Caption = " ";
	 ComboBox_G1_Load->Items->Clear();
	 ComboBox_G1_Load->Items->Add("   ");
	 ComboBox_G1_Load->Items->Add(" ");
	 ComboBox_G1_Load->ItemIndex = 1;

  }
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_b1Exit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_h1Exit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_h_1Exit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_bExit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_b2Exit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);

}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::Sect_Param_WeldFrame1Edit_h2Exit(TObject *Sender)

{
  Sect_Param_WeldFrame1->Edit_h2Exit(Sender);
  Draw_prof_ax(-1);

}
//---------------------------------------------------------------------------


void __fastcall TSelectProfilSectForm::CheckBox_edge_chooseClick(TObject *Sender)

{
	if (CheckBox_edge_choose->Checked) {
		RadioGroup_1_or_2->Visible = true;
		CheckBox_edge->Checked = false;
	}
	else {
		RadioGroup_1_or_2->Visible = false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TSelectProfilSectForm::CheckBox_edgeClick(TObject *Sender)
{
	if (CheckBox_edge->Checked)
		CheckBox_edge_choose->Checked = false;
}
//---------------------------------------------------------------------------


