//---------------------------------------------------------------------------
//   n_sign   
double Round(double value, int n_sign) {
  double i, j;
  double x1, x2, xr, mult;

  mult = pow(10.0, double(n_sign));
  xr = value*mult;
  i=floor(xr);
  j=ceil(xr);
  x1=xr-i;
  x2=j-xr;
  if (x1<x2) return (double)i/mult;
  else return (double)j/mult;
}
//---------------------------------------------------------------------------
//       n_sign   
double Round_plus(double value, int n_sign) {
  int j;
  double mult, xr;

  mult = pow(10.0, n_sign);
  xr = value*mult;
  j=ceil(xr);
  return (double)j/mult;
}
//---------------------------------------------------------------------------
//      
double Round_step(double value, double step) {
  int v1, s1, i1;
  double v2;

  /*
  v1 = ceil(value);
  s1 = step;
  i1 = v1%s1;
  if (i1>0)
     v2 = v1 - i1 + s1;
  else
	 v2 = v1;
  */
  if (step < 1.0) {
    v2 = value;
  }
  v1 = ceil(value/step);
  v2 = v1*step;

  return v2;
}
//---------------------------------------------------------------------------
//      
double Round_step_floor(double value, double step) {
  int v1;
  double v2;

  v1 = floor(value/step);
  v2 = v1*step;
  return v2;
}
//---------------------------------------------------------------------------
//  a                          */
double l_app(double *f1, double* f2, double x1, int n) {
// double *f1;     */
// double *f2;    */
// double x1;
// int n;
   int i;
   if (x1 < f1[0]) {
      return f2[0];
   }
   for (i=1; i<n; i++)
     if (f1[i]>x1) break;
   if (i==n )
      return (f2[n-1]);
   else {
      return(f2[i]-(f1[i]-x1)*(f2[i]-f2[i-1])/(f1[i]-f1[i-1]));
   }
}
//-------------------------------------------------
//   
double lin_interpol(double x1, double x2, double y1, double y2, double x) {
   if (x1 == x2)
     return y1;
   return (y1 + (x - x1)*(y2 - y1)/(x2 - x1));
}
//-------------------------------------------------
//    
double l_linap(int npoint, double *y, double step, double xi)
//int npoint;   /*   */
//double *y;    /*   */
//double step;  /*  */
//double xi;    /*   */
{
    double d,yo,del_1, del_s;
    int i;

    if  (npoint<2)
        return 0.0;
    if (xi>step*(npoint-1)) {
        // return (y[npoint-1]);
        del_1 = y[npoint-1] - y[npoint-2];
        del_s = xi - step*(npoint-1);
        return (y[npoint-1] + del_s*del_1/step);
    }
    if (xi<0)
        return 0.0;

    i= floor(xi/step);
    if (i>npoint-2) yo=y[npoint-1];
    else {
       d= xi - i*step;
       if (step<1e-10 || (y[i+1]-y[i])>1e20 || d >1e20) {
              return y[i+1];
       }
       yo = y[i]+(y[i+1]-y[i])*d/step;

    }
	return(yo);
}  // l_linap
//---------------------------------------------------------------------------
//     
double Fun_app(int ncol, int nrow, double **Tabl, double *Column, double *Row, double x_, double y_) {
// ncol -   
// nrow -   
// Tabl -  ncol*nrow
// Column -   ( nrow)
// Column -   ( ncol)
// x_ -  
// y_ -  
   double value, di, dj, g1, g2;
   int i1, j1;
			for (i1=0; i1<nrow; i1++)
			  if (Column[i1] > y_) break;
			i1--;
			for (j1=0; j1<ncol; j1++)
			  if (Row[j1]>x_) break;
			j1--;
			i1 = ((nrow-1)<(i1)) ? (nrow-1):(i1);
			j1 = ((ncol-1)<(j1)) ? (ncol-1):(j1);
			if (i1 == -1) {
			  di = 0.0;
			  i1=0;
			}
			else
			  di = (y_- Column[i1])/(Column[i1+1] - Column[i1]);
			if (j1==-1) {
			  j1 = 0;
              dj = 0;
			}
            else
			  dj = (x_ - Row[j1])/(Row[j1+1] - Row[j1]);
			g1 = Tabl[i1][j1]*(1 - di) + Tabl[i1+1][j1]*di;
			g2 = Tabl[i1][j1+1]*(1 - di) + Tabl[i1+1][j1+1]*di;
			value = g1*(1 - dj) + g2*dj;
			return value;
}
/*---------------------------------------------------
      
----------------------------------------------------*/
void Blpmat(int n, int m, int sh, double *mat0, double **p_mat)
//int   n;    /*   */
//int   m;    /*   */
//int   sh;   /*  */
{
     int i;
     p_mat[0]=mat0 + sh;
     for (i=1; i<n; i++)
        p_mat[i]=p_mat[i-1] + m;
}


