//---------------------------------------------------------------------------
#include <vcl.h>

#ifndef StandartProfilH
#define StandartProfilH
#include "Data_Gen.h"

#define  typeGOST_0      0   //   
#define  typeGOST_B      1   // 
#define  typeGOST_DB     2   //  
#define  typeGOST_Width  3   // 
#define  typeGOST_K      4   // 

#define  typeSTO_B       5   // 
#define  typeSTO_Width   6   // 
#define  typeSTO_K       7   // 

#define  typeRECT        8   //  
#define  typeSQUARE      9   //  

#define  typeCHANNEL       10   //   8240-97

#define  typeGOST_G57837_B 11 //       57837-2017
#define  typeGOST_G57837Sh 12 //       57837-2017
#define  typeGOST_G57837_K 13 //      57837-2017
#define  typeGOST_G57837_S 14 //      57837-2017
#define  typeGOST_G57837DB 15 //       57837-2017
#define  typeGOST_G57837DK 16 //       57837-2017

#define  typeCIRC      20   //  



#define  sectWELD        0
#define  sectSTANDART    1

// :      0- h, 1-b, 2-s, 3-t, 4-A, 5-P, 6-Iy, 7-Wy, 8-Sy, 9-iy, 10-Iz, 11-Wz, 12-iz, 13-R
//  SQUARE:   0- h, 1-b, 2-t, 3-r, 4-hf=bf,    5-A, 6-m, 7-Iy, 8-Wy, 9-iy, 10-t_red
//  RECT:     0- h, 1-b, 2-t, 3-r, 4-hf, 5-bf, 6-A, 7-m, 8-Iy, 9-Wy, 10-iy, 11-Iz, 12-Wz, 13-iz, 14-t_red
//  CIRC:     0- D, 1-t, 2-A, 3-m, 4-Iy, 5-Wy, 6-iy, 7-t_red

#define  parHSECT    0
#define  parDCIRC    0
#define  parBSECT    1
#define  parTCIRC    1
#define  parBF       1
#define  parTW       2
#define  parTF       3
#define  parAREA_SQUARE_TUBE  5
#define  parAREA_RECT_TUBE  6
#define  parAREA_CIRC_TUBE  2
#define  parT_SQUARE_TUBE   2
#define  parT_RECT_TUBE   2
#define  parR_SQUARE_TUBE   3
#define  parR_RECT_TUBE   3
#define  parAREA     4
#define  parWEIGHT   5
#define  parIZZ_RECT_TUBE   8
#define  parIZZ      6
#define  parWZ_RECT_TUBE    9
#define  parWZ       7
#define  parSZ       8
#define  parIRADZ    9
#define  parIYY_SQUARE_TUBE   7
#define  parIYY_RECT_TUBE   11
#define  parIYY_CIRC_TUBE   4
#define  parIYY     10
#define  parWY_SQUARE_TUBE    8
#define  parWY_RECT_TUBE    12
#define  parWY_CIRC_TUBE    5
#define  parWY      11
#define  parIRADY   12
#define  parRAD     13
#define  parRAD2     14
#define  parX0     15
#define  parWEIGHT_DVUTAVR   5
#define  parWEIGHT_SQUARE_TUBE   6
#define  parWEIGHT_RECT_TUBE   7
#define  parWEIGHT_CIRC_TUBE   3


// : 0- h, 1-b, 2-s, 3-t, 4-A, 5-P, 6-Iy, 7-Wy, 8-Sy, 9-iy, 10-Iz, 11-Wz, 12-iz, 13-R
#define N_GOST_0     17
#define GOST_0  {100,   55,   4.5,   7.2,   12,   9.5,   198,   39.7,   40.6,   23,   17.9,   6.49,   12.2, 0,\
120,   64,   4.8,   7.3,   14.7,   11.5,   350,   58.4,   48.8,   33.7,   27.9,   8.72,   13.8, 0,\
140,   73,   4.9,   7.5,   17.4,   13.7,   572,   81.7,   57.3,   46.8,   41.9,   11.5,   15.5, 0,\
160,   81,   5,   7.8,   20.2,   15.9,   873,   109,   65.7,   62.3,   58.6,   14.5,   17, 0,\
180,   90,   5.1,   8.1,   23.4,   18.4,   1290,   143,   74.2,   81.4,   82.6,   18.4,   18.8, 0,\
200,   100,   5.2,   8.4,   26.8,   21,   1840,   184,   82.8,   104,   115,   23.1,   20.7, 0,\
220,   110,   5.4,   8.7,   30.6,   24,   2550,   232,   91.3,   131,   157,   28.6,   22.7, 0,\
240,   115,   5.6,   9.5,   34.8,   27.3,   3460,   289,   99.7,   163,   198,   34.5,   23.7, 0,\
270,   125,   6,   9.8,   40.2,   31.5,   5010,   371,   112,   210,   260,   41.5,   25.4, 0,\
300,   135,   6.5,   10.2,   46.5,   36.5,   7080,   472,   123,   268,   337,   49.9,   26.9, 0,\
330,   140,   7,   11.2,   53.8,   42.2,   9840,   597,   135,   339,   419,   59.9,   27.9, 0,\
360,   145,   7.5,   12.3,   61.9,   48.6,   13380,   743,   147,   423,   516,   71.1,   28.9, 0,\
400,   155,   8.3,   13,   72.6,   57,   19062,   953,   162,   545,   667,   86.1,   30.3, 0,\
450,   160,   9,   14.2,   84.7,   66.5,   27696,   1231,   181,   708,   808,   101,   30.9, 0,\
500,   170,   10,   15.2,   100,   78.5,   39727,   1589,   199,   919,   1043,   123,   32.3, 0,\
550,   180,   11,   16.5,   118,   92.6,   55962,   2035,   218,   1181,   1356,   151,   33.9, 0,\
600,   190,   12,   17.8,   138,   108,   76806,   2560,   236,   1491,   1725,   182,   35.4, 0}
#define NAME_GOST_0  {"10 ",   "12 ",   "14 ",   "16 ",   "18 ",   "20 ",   "22 ",   "24 ",   "27 ",   "30 ",   "33 ",\
"36 ",   "40 ",   "45 ",   "50 ",   "55 ",   "60 "  }

#define N_GOST_B     37
#define GOST_B  {100, 55, 4.1, 5.7, 10.3, 8.1, 171, 34.2, 19.7, 41, 15.9, 5.8, 12, 7, \
118, 64, 3.8, 5.1, 11, 8.7, 257, 43.8, 24.9, 48, 22.4, 7, 15, 7, \
120, 64, 4.4, 6.3, 13.2, 10.4, 318, 53, 30.4, 49, 27.7, 8.6, 15, 7, \
137, 73, 3.8, 5.6, 13.4, 10.5, 435, 63.3, 35.8, 57, 36.4, 10, 17, 7, \
140, 73, 4.7, 6.9, 16.4, 12.9, 541, 77.3, 44.2, 57, 44.9, 12.3, 17, 7, \
157, 82, 4, 5.9, 16.2, 12.7, 689, 87.8, 49.5, 65, 54.4, 13.3, 18, 9, \
160, 82, 5, 7.4, 20.1, 15.8, 869, 108.7, 61.9, 66, 68.3, 16.6, 18, 9, \
177, 91, 4.3, 6.5, 19.6, 15.4, 1063, 120.1, 67.7, 74, 81.9, 18, 20, 9, \
180, 91, 5.3, 8, 24, 18.8, 1317, 146.3, 83.2, 74, 100.8, 22.2, 21, 9, \
200, 100, 5.6, 8.5, 28.5, 22.4, 1943, 194.3, 110.3, 83, 142.3, 28.5, 22, 12, \
230, 110, 5.6, 9, 32.9, 25.8, 2996, 260.5, 147.2, 95, 200.3, 36.4, 25, 12, \
258, 120, 5.8, 8.5, 35.6, 28, 4024, 312, 176.6, 106, 245.6, 40.9, 26, 12, \
261, 120, 6, 10, 39.7, 31.2, 4654, 356.6, 201.5, 108, 288.8, 48.1, 27, 12, \
296, 140, 5.8, 8.5, 41.9, 32.9, 6328, 427, 240, 123, 390, 55.7, 31, 15, \
299, 140, 6, 10, 46.7, 36.6, 7293, 487.8, 273.8, 125, 458.6, 65.5, 31, 15, \
346, 155, 6.2, 8.5, 49.5, 38.9, 10060, 581.7, 328.6, 143, 529.6, 68.3, 33, 18, \
349, 155, 6.5, 10, 55.2, 43.3, 11550, 662.2, 373, 145, 622.9, 80.4, 34, 18, \
392, 165, 7, 9.5, 61.3, 48.1, 15750, 803.6, 456, 160, 714.9, 86.7, 34, 21, \
396, 165, 7.5, 11.5, 69.7, 54.7, 18530, 935.7, 529.7, 163, 865, 104.8, 35, 21, \
443, 180, 7.8, 11, 76.2, 59.8, 24940, 1125.8, 639.5, 181, 1073.7, 119.3, 38, 21, \
447, 180, 8.4, 13, 86, 67.5, 28870, 1291.9, 732.9, 183, 1269, 141, 38, 21, \
492, 200, 8.8, 12, 93, 73, 37160, 1511, 860.4, 200, 1606, 160.6, 42, 21, \
496, 200, 9.2, 14, 102.8, 80.7, 42390, 1709, 970.2, 203, 1873, 187.3, 43, 21, \
543, 220, 9.5, 13.5, 113.4, 89, 55680, 2051, 1165, 222, 2404, 218.6, 46, 24, \
547, 220, 10, 15.5, 124.8, 97.9, 62790, 2296, 1302, 224, 2760, 250.9, 47, 24, \
593, 230, 10.5, 15.5, 135.3, 106.2, 78760, 2656, 1512, 241, 3154, 274.3, 48, 24, \
597, 230, 11, 17.5, 147.3, 115.6, 87640, 2936, 1669, 244, 3561, 309.6, 49, 24, \
691, 260, 12, 15.5, 164.7, 129.3, 125930, 3645, 2095, 277, 4556, 350.5, 53, 24, \
697, 260, 12.5, 18.5, 183.6, 144.2, 145912, 4187, 2393, 282, 5437, 418.2, 54, 24, \
791, 280, 13.5, 17, 203.2, 159.5, 199500, 5044, 2917, 313, 6244, 446, 55, 26, \
798, 280, 14, 20.5, 226.6, 177.9, 232200, 5820, 3343, 320, 7527, 537.6, 58, 26, \
893, 300, 15, 18.5, 247.1, 194, 304400, 6817, 3964, 351, 8365, 557.6, 58, 30, \
900, 300, 15.5, 22, 272.4, 213.8, 349200, 7760, 4480, 358, 9943, 662.8, 60, 30, \
990, 320, 16, 21, 293.8, 230.6, 446000, 9011, 5234, 390, 11520, 719.9, 63, 30, \
998, 320, 17, 25, 328.9, 258.2, 516400, 10350, 5980, 396, 13710, 856.9, 65, 30, \
1006, 320, 18, 29, 364, 285.7, 587700, 11680, 6736, 402, 15900, 993.9, 66, 30, \
1013, 320, 19.5, 32.5, 400.6, 314.5, 655400, 12940, 7470, 405, 17830, 1114.3, 67, 30.0}

#define NAME_GOST_B  {"101",   "121",   "122",   "141",   "142",   "161",   "162",   "181",   "182",   "201",   "231",   "261",\
"262", "301",   "302",   "351",   "352",   "401",   "402",   "451",   "452",   "501",   "502",   "551",   "552",   "601",\
"602",   "701",   "702",   "801",   "802",   "901",   "902",   "1001",   "1002",   "1003",   "1004"}

#define N_GOST_DB     10
#define GOST_DB    {239,   115.0,   5.5,   9.3,   35.5,   27.8,   3535.0,   295.8,   166.6,   10.0,   236.8,   41.2,   2.6,   15.0,\
269,   125.0,   6.0,   9.5,   40.7,   31.9,   5068.0,   376.8,   212.7,   11.2,   310.5,   49.7,   2.8,   15.0,\
360,   145.0,   7.2,   12.3,   62.6,   49.1,   13800.0,   766.4,   434.1,   14.8,   627.6,   86.6,   3.2,   18.0,\
349,   127.0,   5.8,   8.5,   42.8,   33.6,   8540.0,   489.4,   279.4,   14.1,   291.5,   45.9,   2.6,   15.0,\
399,   139.0,   6.2,   9.0,   50.6,   39.7,   13050.0,   654.2,   374.5,   16.1,   404.4,   58.2,   2.8,   15.0,\
450,   152.0,   7.4,   11.0,   67.1,   52.6,   21810.0,   969.2,   556.8,   18.0,   646.2,   85.0,   3.1,   15.0,\
450,   180.0,   7.6,   13.3,   82.8,   65.0,   28840.0,   1280.0,   722.0,   18.7,   1300.0,   144.0,   4.0,   18.0,\
301,   201.9,   9.4,   16.0,   92.6,   72.7,   15090.0,   1000.0,   563.0,   12.8,   2200.0,   218.0,   4.9,   18.0,\
398,   302.0,   11.5,   18.7,   159.0,   124.0,   46330.0,   2330.0,   1290.0,   17.1,   8590.0,   569.0,   7.4,   22.0,\
496,   303.8,   14.2,   21.0,   198.0,   155.0,   86010.0,   3470.0,   1950.0,   20.8,   9830.0,   647.0,   7.1,   26.0}
#define NAME_GOST_DB  {"241",   "271",   "361",   "351",   "401",   "45",   "452","301","401","501"}

#define N_GOST_Width    26
// :         0- h,  1-b,     2-s,   3-t,   4-A,    5-P,    6-Iy,     7-Wy,    8-Sy,   9-iy,  10-Iz,   11-Wz, 12-iz, 13-R
#define GOST_Width {193,   150.0,   6.0,   9.0,   39.0,   30.6,   2660.0,   275.0,   153.0,   8.3,   507.0,   67.6,   3.6,   13.0,\
226,   155.0,   6.5,   10.0,   46.1,   36.2,   4260.0,   377.0,   210.0,   9.6,   622.0,   80.2,   3.7,   14.0,\
251,   180.0,   7.0,   10.0,   54.4,   42.7,   6225.0,   496.0,   276.0,   10.7,   974.0,   108.2,   4.2,   16.0,\
255,   180.0,   7.5,   12.0,   62.7,   49.2,   7429.0,   583.0,   325.0,   10.9,   1168.0,   129.8,   4.3,   16.0,\
291,   200.0,   8.0,   11.0,   68.3,   53.6,   10400.0,   715.0,   398.0,   12.3,   1470.0,   147.0,   4.6,   18.0,\
295,   200.0,   8.5,   13.0,   77.7,   61.0,   12200.0,   827.0,   462.0,   12.5,   1737.0,   173.7,   4.7,   18.0,\
299,   200.0,   9.0,   15.0,   87.0,   68.3,   14040.0,   939.0,   526.0,   12.7,   2004.0,   200.4,   4.8,   18.0,\
338,   250.0,   9.5,   12.5,   95.7,   75.1,   19790.0,   1171.0,   651.0,   14.4,   3260.0,   261.0,   5.8,   20.0,\
341,   250.0,   10.0,   14.0,   104.7,   82.2,   22070.0,   1295.0,   721.0,   14.5,   3650.0,   292.0,   5.9,   20.0,\
345,   250.0,   10.5,   16.0,   116.3,   91.3,   25140.0,   1458.0,   813.0,   14.7,   4170.0,   334.0,   6.0,   20.0,\
388,   300.0,   9.5,   14.0,   122.4,   96.1,   34360.0,   1771.0,   976.0,   16.8,   6306.0,   420.0,   7.2,   22.0,\
392,   300.0,   11.5,   16.0,   141.6,   111.1,   39700.0,   2025.0,   1125.0,   16.8,   7209.0,   481.0,   7.1,   22.0,\
396,   300.0,   12.5,   18.0,   157.2,   123.4,   44740.0,   2260.0,   1259.0,   16.9,   8111.0,   541.0,   7.2,   22.0,\
484,   300.0,   11.0,   15.0,   145.7,   114.4,   60930.0,   2518.0,   1403.0,   20.5,   6762.0,   451.0,   6.8,   26.0,\
489,   300.0,   14.5,   17.5,   176.6,   138.7,   72530.0,   2967.0,   1676.0,   20.3,   7900.0,   526.0,   6.7,   26.0,\
495,   300.0,   15.5,   20.5,   199.2,   156.4,   84200.0,   3402.0,   1923.0,   20.6,   9250.0,   617.0,   6.8,   26.0,\
501,   300.0,   16.5,   23.5,   221.7,   174.1,   96150.0,   3838.0,   2173.0,   20.8,   10600.0,   707.0,   6.9,   26.0,\
580,   320.0,   12.0,   17.0,   181.1,   142.1,   107300.0,   3701.0,   2068.0,   24.4,   9302.0,   581.0,   7.2,   28.0,\
587,   320.0,   16.0,   20.5,   225.3,   176.9,   131800.0,   4490.0,   2544.0,   24.2,   11230.0,   702.0,   7.1,   28.0,\
595,   320.0,   18.0,   24.5,   261.8,   205.5,   156900.0,   5273.0,   2997.0,   24.5,   13420.0,   839.0,   0.0,   28.0,\
603,   320.0,   20.0,   28.5,   298.3,   234.2,   182500.0,   6055.0,   3455.0,   24.7,   15620.0,   976.0,   7.2,   28.0,\
683,   320.0,   13.5,   19.0,   216.4,   169.9,   172000.0,   5036.0,   2843.0,   28.2,   10400.0,   650.0,   6.9,   30.0,\
691,   320.0,   15.0,   23.0,   251.7,   197.6,   205500.0,   5949.0,   3360.0,   28.6,   12590.0,   787.0,   7.1,   30.0,\
700,   320.0,   18.0,   27.5,   299.8,   235.4,   247100.0,   7059.0,   4017.0,   28.7,   15070.0,   942.0,   7.1,   30.0,\
708,   320.0,   20.5,   31.5,   341.6,   261.1,   284400.0,   8033.0,   4598.0,   28.9,   17270.0,   1079,   7.1,   30.0,\
718,   320.0,   23.0,   36.5,   389.7,   305.9,   330600.0,   9210.0,   5298.0,   29.1,   20020.0,   1251.0,   7.2,   30.0}

#define NAME_GOST_Width  {"201",   "231",   "261",   "262",   "301",   "302",   "303",   "351",   "352",   "353",\
"401",   "402",   "403",   "501",   "502",   "503",   "504",   "601",   "602",   "603",   "604",   "701",   "702",   "703",   "704",   "705"}

#define N_GOST_K    18
#define GOST_K   {195,   200.0,   6.5,   10.0,   52.8,   41.5,   3820.0,   392.0,   216.0,   8.5,   1334.0,   133.0,   5.0,   13.0,\
198,   200.0,   7.0,   11.5,   59.7,   46.9,   4422.0,   447.0,   247.0,   8.6,   1534.0,   153.0,   5.1,   13.0,\
227,   240.0,   7.0,   10.5,   66.5,   52.2,   6589.0,   580.0,   318.0,   10.0,   2421.0,   202.0,   6.0,   14.0,\
230,   240.0,   8.0,   12.0,   75.8,   59.5,   7601.0,   661.0,   365.0,   10.0,   2766.0,   231.0,   6.0,   14.0,\
255,   260.0,   8.0,   12.0,   83.1,   65.2,   10300.0,   809.0,   445.0,   11.1,   3517.0,   271.0,   6.5,   16.0,\
258,   260.0,   9.0,   13.5,   93.2,   73.2,   11700.0,   907.0,   501.0,   11.2,   3957.0,   304.0,   6.5,   16.0,\
262,   260.0,   10.0,   15.5,   105.9,   83.1,   13560.0,   1035.0,   576.0,   11.3,   4544.0,   349.0,   6.6,   16.0,\
296,   300.0,   9.0,   13.5,   108.0,   84.8,   18110.0,   1223.0,   672.0,   13.0,   6079.0,   405.0,   7.5,   18.0,\
300,   300.0,   10.0,   15.5,   122.7,   96.3,   20930.0,   1395.0,   771.0,   13.1,   6980.0,   465.0,   7.5,   18.0,\
304,   300.0,   11.5,   17.5,   138.7,   108.9,   23910.0,   1573.0,   874.0,   13.1,   7881.0,   525.0,   7.5,   18.0,\
343,   350.0,   10.0,   15.0,   139.7,   109.7,   31610.0,   1843.0,   1010.0,   15.0,   10720.0,   613.0,   8.8,   20.0,\
348,   350.0,   11.0,   17.5,   160.4,   125.9,   37090.0,   2132.0,   1173.0,   15.2,   12510.0,   715.0,   8.8,   20.0,\
353,   350.0,   13.0,   20.0,   184.1,   144.5,   42970.0,   2435.0,   1351.0,   15.3,   14330.0,   817.0,   8.8,   20.0,\
393,   400.0,   11.0,   16.5,   175.8,   138.0,   52400.0,   2664.0,   1457.0,   17.3,   17610.0,   880.0,   10.0,   22.0,\
400,   400.0,   13.0,   20.0,   211.0,   165.6,   64140.0,   3207.0,   1767.0,   17.4,   21350.0,   1067.0,   10.1,   22.0,\
409,   400.0,   16.0,   24.5,   257.8,   202.3,   80040.0,   3914.0,   2180.0,   17.6,   26150.0,   1307.0,   10.1,   22.0,\
419,   400.0,   19.0,   29.5,   308.6,   242.2,   98340.0,   4694.0,   2642.0,   17.9,   31500.0,   1575.0,   10.1,   22.0,\
431,   400.0,   23.0,   35.5,   371.0,   291.2,   121570.0,   5642.0,   3217.0,   18.1,   37910.0,   1896.0,   10.1,   22.0\
}

#define NAME_GOST_K  {"201",   "202",   "231",   "232",   "261",   "262",   "263",   "301",   "302",   "303",\
"351",   "352",   "353",   "401",   "402",   "403",   "404",   "405"}

#define N_STO_B    30
#define STO_B   {100,   55.0,   4.1,   5.7,   10.3,   8.1,   171.0,   34.2,   19.7,   4.1,   15.9,   5.8,   1.2,   7.0,\
118,   64.0,   3.8,   5.1,   11.0,   8.7,   257.0,   43.8,   24.9,   4.8,   22.4,   7.0,   1.4,   7.0,\
120,   64.0,   4.4,   6.3,   13.2,   10.4,   318.0,   53.0,   30.4,   4.9,   27.7,   8.7,   1.5,   7.0,\
137,   73.0,   3.8,   5.6,   13.4,   10.5,   435.0,   63.3,   35.8,   5.7,   36.4,   10.0,   1.7,   7.0,\
140,   73.0,   4.7,   6.9,   16.4,   12.9,   541.0,   77.3,   44.2,   5.7,   44.9,   12.3,   1.7,   7.0,\
157,   82.0,   4.0,   5.9,   16.2,   12.7,   689.0,   87.8,   49.6,   6.5,   54.4,   13.3,   1.8,   9.0,\
160,   82.0,   5.0,   7.4,   20.1,   15.8,   869.0,   108.7,   61.9,   6.6,   68.3,   16.7,   1.8,   9.0,\
177,   91.0,   4.3,   6.5,   19.6,   15.4,   1063.0,   120.1,   67.7,   7.4,   81.9,   18.0,   2.1,   9.0,\
180,   91.0,   5.3,   8.0,   24.0,   18.8,   1317.0,   146.3,   83.2,   7.4,   100.8,   22.2,   2.1,   9.0,\
200,   100.0,   5.5,   8.0,   27.2,   21.3,   1844.0,   184.4,   104.7,   8.2,   133.9,   26.8,   2.2,   11.0,\
248,   124.0,   5.0,   8.0,   32.7,   25.7,   3537.0,   285.3,   159.7,   10.4,   254.8,   41.1,   2.8,   12.0,\
250,   125.0,   6.0,   9.0,   37.7,   29.6,   4052.0,   324.2,   182.9,   10.4,   293.8,   47.0,   2.8,   12.0,\
298,   149.0,   5.5,   8.0,   40.8,   32.0,   6319.0,   424.1,   237.5,   12.4,   441.9,   59.3,   3.3,   13.0,\
300,   150.0,   6.5,   9.0,   46.8,   36.7,   7210.0,   480.6,   271.1,   12.4,   507.4,   67.7,   3.3,   13.0,\
346,   174.0,   6.0,   9.0,   52.7,   41.4,   11095.0,        641.3,   358.1,   14.5,   791.4,   91.0,   3.9,   14.0,\
350,   175.0,   7.0,   11.0,   63.1,   49.6,   13560.0,   774.8,   434.0,   14.7,   984.2,   112.5,   4.0,   14.0,\
396,   199.0,   7.0,   11.0,   72.2,   56.6,   20020.0,   1011.1,   564.0,   16.7,   1446.9,   145.4,   4.5,   16.0,\
400,   200.0,   8.0,   13.0,   84.1,   66.0,   23706.0,   1185.3,   663.2,   16.8,   1736.2,   173.6,   4.5,   16.0,\
446,   199.0,   8.0,   12.0,   84.3,   66.2,   28699.0,   1287.0,   725.1,   18.5,   1579.7,   158.8,   4.3,   18.0,\
450,   200.0,   9.0,   14.0,   96.8,   76.0,   33453.0,   1486.8,   839.6,   1859.0,   1871.3,   187.1,   4.4,   18.0,\
492,   199.0,   8.8,   12.0,   92.4,   72.5,   36845.0,   1497.8,   853.5,   20.0,   1581.5,   158.9,   4.1,   20.0,\
496,   199.0,   9.0,   14.0,   101.3,   79.5,   41872.0,   1688.4,   957.3,   20.3,   1844.4,   185.4,   4.3,   20.0,\
500,   200.0,   10.0,   16.0,   114.2,   89.7,   47849.0,   1914.0,   1087.7,   20.5,   2140.3,   214.0,   4.3,   20.0,\
543,   220.0,   9.5,   13.5,   113.4,   89.0,   55682.0,   2050.9,   1165.1,   22.2,   2404.5,   218.6,   4.6,   24.0,\
547,   220.0,   10.0,   15.5,   124.8,   97.9,   62790.0,   2295.8,   1301.6,   22.4,   2760.3,   250.9,   4.7,   24.0,\
596,   199.0,   10.0,   15.0,   120.5,   94.6,   68721.0,   2306.1,   1325.5,   23.9,   1979.0,   198.9,   4.1,   22.0,\
600,   200.0,   11.0,   17.0,   134.4,   105.5,   77638.0,   2587.9,   1489.5,   24.0,   2277.5,   227.8,   4.1,   22.0,\
693,   230.0,   11.8,   15.2,   153.1,   120.1,   114187.0,   3295.5,   1913.1,   27.3,   3097.7,   269.4,   4.5,   24.0,\
691,   260.0,   12.0,   15.5,   164.7,   129.3,   125931.0,   3644.9,   2094.9,   27.7,   4556.4,   350.5,   5.3,   24.0,\
697,   260.0,   12.5,   18.5,   183.6,   144.2,   145913.0,   4186.9,   2392.8,   28.2,   5436.7,   418.2,   5.4,   24.0}


#define NAME_STO_B  {"101", "121", "122", "141", "142", "161", "162", "181", "182", "201", "251", "252",\
                     "301", "302", "351", "352", "401", "402", "451", "452", "501", "502", "503", "551",\
                     "552", "601", "602", "700", "701", "702"}

#define N_STO_Width    30
#define STO_Width   {194,   150.0,   6.0,   9.0,   39.0,   30.6,   2690.0,   277.3,   154.3,   8.3,   507.1,   67.6,   3.6,   13.0,\
244,   175.0,   7.0,   11.0,   56.2,   44.1,   6122.0,   501.8,   279.2,   10.4,   984.3,   112.5,   4.2,   16.0,\
294,   200.0,   8.0,   12.0,   72.4,   56.8,   11339.0,   771.4,   429.5,   12.5,   1602.9,   160.3,   4.7,   18.0,\
300,   201.0,   9.0,   15.0,   87.4,   68.6,   14210.0,   947.4,   529.9,   12.8,   2033.8,   202.4,   4.8,   18.0,\
334,   249.0,   8.0,   11.0,   83.2,   65.3,   17108.0,   1024.4,   563.8,   14.3,   2834.1,   227.6,   5.8,   20.0,\
340,   250.0,   9.0,   14.0,   101.5,   79.7,   21678.0,   1275.2,   706.1,   14.6,   3650.5,   292.0,   6.0,   20.0,\
383,   299.0,   9.5,   12.5,   112.9,   88.6,   30556.0,   1595.6,   880.8,   16.5,   5575.4,   372.9,   7.0,   22.0,\
390,   300.0,   10.0,   16.0,   136.0,   106.7,   38676.0,   1983.4,   1094.0,   16.9,   7207.1,   480.5,   7.3,   22.0,\
440,   300.0,   11.0,   18.0,   157.4,   123.5,   56072.0,   2548.7,   1412.5,   18.9,   8110.3,   540.7,   7.2,   24.0,\
482,   300.0,   11.0,   15.0,   145.5,   114.2,   60371.0,   2505.0,   1395.7,   20.4,   6762.4,   450.8,   6.8,   26.0,\
487,   300.0,   14.5,   17.5,   176.3,   138.4,   71867.0,   2951.4,   1666.7,   20.2,   7896.4,   526.4,   6.7,   26.0,\
493,   300.0,   15.5,   20.5,   198.9,   156.1,   83441.0,   3385.0,   1912.8,   20.5,   9249.7,   616.6,   6.8,   26.0,\
499,   300.0,   16.5,   23.5,   221.4,   173.8,   95282.0,   3818.9,   2161.5,   20.8,   10603.4,   706.9,   6.9,   26.0,\
582,   300.0,   12.0,   17.0,   174.5,   137.0,   102717.0,   3529.8,   1981.5,   24.3,   7668.0,   511.2,   6.6,   28.0,\
589,   300.0,   16.0,   20.5,   217.4,   170.7,   126201.0,   4285.3,   2439.0,   24.1,   9257.4,   617.2,   6.5,   28.0,\
597,   300.0,   18.0,   24.5,   252.4,   198.1,   150043.0,   5026.6,   2869.9,   24.4,   11067.3,   737.8,   6.6,   28.0,\
605,   300.0,   20.0,   28.5,   287.3,   225.6,   174458.0,   5767.2,   3305.6,   24.6,   12879.3,   858.6,   6.7,   28.0,\
692,   300.0,   13.0,   20.0,   211.5,   166.0,   172433.0,   4983.7,   2814.6,   28.6,   9022.9,   601.5,   6.5,   28.0,\
698,   300.0,   15.0,   23.0,   242.5,   190.4,   198791.0,   5696.0,   3233.6,   28.6,   10381.1,   692.1,   6.5,   28.0,\
707,   300.0,   18.0,   27.5,   289.1,   226.9,   239032.0,   6761.9,   3867.2,   28.8,   12422.4,   828.2,   6.6,   28.0,\
715,   300.0,   20.5,   31.5,   329.4,   258.6,   275138.0,   7696.2,   4426.7,   28.9,   14240.2,   949.3,   6.6,   28.0,\
725,   300.0,   23.0,   36.5,   375.7,   294.9,   319793.0,   8821.9,   5099.5,   29.2,   16512.3,   1100.8,   6.6,   28.0,\
782,   300.0,   13.5,   17.0,   209.7,   164.6,   205458.0,   5254.7,   3018.9,   31.3,   7676.7,   511.8,   6.1,   28.0,\
792,   300.0,   14.0,   22.0,   243.5,   191.1,   253655.0,   6405.4,   3644.1,   32.3,   9928.9,   661.9,   6.4,   28.0,\
881,   299.0,   15.0,   18.5,   244.0,   191.5,   292583.0,   6642.1,   3861.2,   34.6,   8278.5,   553.7,   5.8,   28.0,\
890,   299.0,   15.0,   23.0,   270.9,   212.6,   345335.0,   7760.3,   4457.0,   35.7,   10283.3,   687.8,   6.2,   28.0,\
990,   320.0,   16.0,   21.0,   293.8,   230.6,   446039.0,   9010.9,   5234.1,   39.0,   11517.9,   719.9,   6.3,   30.0,\
998,   320.0,   17.0,   25.0,   328.9,   258.2,   516373.0,   10348.2,   5982.6,   39.6,   13710.0,   856.9,   6.5,   30.0,\
1006,   320.0,   18.0,   29.0,   364.0,   285.7,   587730.0,   11684.5,   6736.2,   40.2,   15903.0,   993.9,   6.6,   30.0,\
1013,   320.0,   19.5,   32.5,   400.6,   314.5,   655449.0,   12940.7,   7470.0,   40.5,   17828.8,   1114.3,   6.7,   30.0}


#define NAME_STO_Width  {"201",   "251",   "301",   "302",   "351",   "352",   "401",   "402",   "451",   "501",   "502",   "503",\
   "504",   "601",   "602",   "603",   "604",   "701",   "702",   "703",   "704",   "705",   "801",   "802",   "901",   "902",\
        "1001",   "1002",   "1003",   "1004"}

#define N_STO_K    16
#define STO_K   {196,   199.0,   6.5,   10.0,   52.7,   41.4,   3846.0,   392.5,   216.4,   85.4,   1314.4,   132.1,   49.9,   13.0,\
200,   200.0,   8.0,   12.0,   63.5,   49.9,   4716.0,   471.6,   262.8,   86.2,   1601.4,   160.1,   50.2,   13.0,\
246,   249.0,   8.0,   12.0,   79.7,   62.6,   9171.0,   745.6,   410.7,   107.3,   3089.9,   248.2,   62.3,   16.0,\
250,   250.0,   9.0,   14.0,   92.2,   72.4,   10833.0, 866.6,   480.3,   108.4,   3648.6,   291.9,   62.9,   16.0,\
253,   251.0,   10.0,   15.5,   102.2,   80.2,   12154.0, 960.8,   535.4,   109.0,   4088.6,   325.8,   63.2,   16.0,\
298,   299.0,   9.0,   14.0,   110.8,   87.0,   18849.0, 1265.1, 694.7,   130.4,   6240.9,   417.5,   75.1,   18.0,\
300,   300.0,   10.0,   15.0,   119.8,   94.0,   20411.0, 1360.7, 750.6,   130.5,   6754.5,   450.3,   75.1,   18.0,\
300,   305.0,   15.0,   15.0,   134.8,   105.8,   21536.0, 1433.7, 806.9,   126.4,   7104.4,   465.9,   72.6,   18.0,\
304,   301.0,   11.0,   17.0,   134.8,   105.8,   23381.0, 1538.2, 852.8,   131.7,   7732.3,   513.8,   75.7,   18.0,\
342,   348.0,   10.0,   15.0,   139.0,   109.1,   31249.0, 1827.4, 1001.2, 149.9,   10541.7, 605.8,   87.1,   20.0,\
350,   350.0,   12.0,   19.0,   173.9,   136.5,   40296.0, 2302.6, 1272.7, 152.2,   13585.3, 776.3,   88.4,   20.0,\
394,   398.0,   11.0,   18.0,   186.8,   146.6,   56147.0, 2850.1, 1559.3, 173.4,   18921.9, 950.8,   100.6,   22.0,\
400,   400.0,   13.0,   21.0,   218.7,   171.7,   66623.0, 3331.2, 1936.3, 174.5,   22412.0, 1120.6, 101.2,   22.0,\
406,   403.0,   16.0,   24.0,   254.9,   200.1,   78041.0, 3844.4, 2139.9, 175.0,   26199.5, 1300.2, 101.4,   22.0,\
414,   405.0,   18.0,   28.0,   295.4,   231.9,   92773.0, 4481.8, 2513.2, 177.2,   31026.2, 1532.2, 102.5,   22.0,\
429,   400.0,   23.0,   35.5,   370.5,   290.8,   120292.0, 5608.0, 3198.6, 180.2, 37914.2, 1895.7, 101.2, 22.0}

#define NAME_STO_K   {"201",   "202",   "251",   "252",   "253",   "301",   "302",   "303",   "304",   "351",   "352",   "401",\
     "402",   "403",   "404",   "405"}

#define N_SQUARE_PROF    155
#define SQUARE_PROF   {40, 40, 2, 2.94, 6.94, 3.47, 1.54, 2.31, \
40, 40, 2.5, 3.59, 8.21, 4.1, 1.51, 2.82, \
40, 40, 3, 4.21, 9.31, 4.65, 1.49, 3.3, \
40, 40, 3.5, 4.79, 10.26, 5.13, 1.46, 3.76, \
40, 40, 4, 5.35, 11.05, 5.52, 1.44, 4.2, \
50, 50, 2, 3.74, 14.14, 5.66, 1.95, 2.93, \
50, 50, 2.5, 4.59, 16.93, 6.77, 1.92, 3.6, \
50, 50, 3, 5.41, 19.45, 7.78, 1.9, 4.25, \
50, 50, 3.5, 6.19, 21.7, 8.68, 1.87, 4.86, \
50, 50, 4, 6.95, 23.7, 9.48, 1.85, 5.45, \
50, 50, 4.5, 7.67, 25.45, 10.19, 1.82, 6.02, \
50, 50, 5, 8.36, 26.98, 10.79, 1.8, 6.56, \
50, 50, 5.5, 9.01, 28.27, 11.31, 1.77, 7.07, \
50, 50, 6, 9.63, 29.36, 11.74, 1.75, 7.56, \
60, 60, 2, 4.54, 25.14, 8.38, 2.35, 3.56, \
60, 60, 2.5, 5.59, 30.33, 10.11, 2.33, 4.39, \
60, 60, 3, 6.61, 35.11, 11.7, 2.31, 5.19, \
60, 60, 3.5, 7.59, 39.5, 13.17, 2.28, 5.96, \
60, 60, 4, 8.55, 43.5, 14.5, 2.26, 6.71, \
60, 60, 4.5, 9.47, 47.14, 15.71, 2.23, 7.43, \
60, 60, 5, 10.36, 50.41, 16.8, 2.21, 8.13, \
60, 60, 5.5, 11.21, 53.34, 17.78, 2.18, 8.8, \
60, 60, 6, 12.03, 55.94, 18.65, 2.16, 9.45, \
70, 70, 2, 5.34, 40.72, 11.63, 2.76, 4.19, \
70, 70, 2.5, 6.59, 49.39, 14.11, 2.74, 5.17, \
70, 70, 3, 7.81, 57.5, 16.43, 2.71, 6.13, \
70, 70, 3.5, 8.99, 65.05, 18.59, 2.69, 7.06, \
70, 70, 4, 10.15, 72.06, 20.59, 2.66, 7.97, \
70, 70, 4.5, 11.27, 78.55, 22.44, 2.64, 8.85, \
70, 70, 5, 12.36, 84.52, 24.15, 2.62, 9.7, \
70, 70, 5.5, 13.41, 90.01, 25.72, 2.59, 10.53, \
70, 70, 6, 14.43, 95.01, 27.14, 2.57, 11.33, \
70, 70, 6.5, 15.06, 95.11, 27.17, 2.51, 11.82, \
70, 70, 7, 15.96, 98.5, 28.14, 2.48, 12.53, \
80, 80, 3, 9.01, 87.81, 21.95, 3.12, 7.07, \
80, 80, 3.5, 10.39, 99.75, 24.94, 3.1, 8.16, \
80, 80, 4, 11.75, 111, 27.74, 3.07, 9.22, \
80, 80, 4.5, 13.07, 121.5, 30.37, 3.05, 10.26, \
80, 80, 5, 14.36, 131.3, 32.83, 3.02, 11.27, \
80, 80, 5.5, 15.61, 140.5, 35.12, 3, 12.25, \
80, 80, 6, 16.83, 149, 37.24, 2.97, 13.21, \
80, 80, 6.5, 17.66, 151, 37.76, 2.92, 13.86, \
80, 80, 7, 18.76, 157.4, 39.34, 2.9, 14.72, \
80, 80, 7.5, 19.82, 163, 40.76, 2.87, 15.56, \
80, 80, 8, 20.84, 168, 42.01, 2.84, 16.36, \
90, 90, 3, 10.21, 127.2, 28.28, 3.53, 8.01, \
90, 90, 3.5, 11.79, 145, 32.22, 3.51, 9.26, \
90, 90, 4, 13.35, 161.8, 35.96, 3.48, 10.48, \
90, 90, 4.5, 14.87, 177.8, 39.5, 3.46, 11.67, \
90, 90, 5, 16.36, 192.8, 42.84, 3.43, 12.84, \
90, 90, 5.5, 17.81, 206.9, 45.99, 3.41, 13.98, \
90, 90, 6, 19.23, 220.2, 48.94, 3.38, 15.1, \
90, 90, 6.5, 20.26, 225.3, 50.07, 3.34, 15.9, \
90, 90, 7, 21.56, 235.8, 52.4, 3.31, 16.92, \
90, 90, 7.5, 22.82, 245.4, 54.54, 3.28, 17.91, \
90, 90, 8, 24.04, 254.2, 56.48, 3.25, 18.87, \
100, 100, 3, 11.41, 177, 35.4, 3.94, 8.96, \
100, 100, 3.5, 13.19, 202.2, 40.44, 3.91, 10.36, \
100, 100, 4, 14.95, 225.1, 45.02, 3.88, 11.73, \
100, 100, 4.5, 16.67, 247.5, 49.5, 3.85, 13.08, \
100, 100, 5, 18.36, 270.9, 54.19, 3.84, 14.41, \
100, 100, 5.5, 20.01, 291.6, 58.32, 3.82, 15.71, \
100, 100, 6, 21.63, 311.2, 62.24, 3.79, 16.98, \
100, 100, 6.5, 22.86, 320.6, 64.12, 3.75, 17.94, \
100, 100, 7, 24.36, 336.7, 67.33, 3.72, 19.12, \
100, 100, 7.5, 25.82, 351.6, 70.32, 3.69, 20.27, \
100, 100, 8, 27.24, 365.4, 73.09, 3.66, 21.39, \
120, 120, 3, 13.81, 312.3, 52.05, 4.76, 10.84, \
120, 120, 3.5, 15.99, 358.1, 59.68, 4.73, 12.56, \
120, 120, 4, 18.15, 402.2, 67.03, 4.71, 14.25, \
120, 120, 4.5, 20.27, 444.5, 74.09, 4.68, 15.91, \
120, 120, 5, 22.36, 485.3, 80.88, 4.66, 17.55, \
120, 120, 5.5, 24.41, 524.3, 87.39, 4.63, 19.16, \
120, 120, 6, 26.43, 561.8, 93.64, 4.61, 20.75, \
120, 120, 6.5, 28.06, 584.6, 97.43, 4.56, 22.03, \
120, 120, 7, 29.96, 616.8, 102.8, 4.54, 23.52, \
120, 120, 7.5, 31.82, 647.3, 107.9, 4.51, 24.98, \
120, 120, 8, 33.64, 676.2, 112.7, 4.48, 26.41, \
140, 140, 4, 21.35, 651.5, 93.07, 5.52, 16.76, \
140, 140, 4.5, 23.87, 722.1, 103.2, 5.5, 18.74, \
140, 140, 5, 26.36, 790.3, 112.9, 5.48, 20.69, \
140, 140, 5.5, 28.81, 856.3, 122.3, 5.45, 22.62, \
140, 140, 6, 31.23, 920, 131.4, 5.43, 24.52, \
140, 140, 6.5, 33.26, 963.6, 137.7, 5.38, 26.11, \
140, 140, 7, 35.56, 1020, 145.7, 5.36, 27.91, \
140, 140, 7.5, 37.82, 1074, 153.5, 5.33, 29.69, \
140, 140, 8, 40.04, 1126, 160.8, 5.3, 31.43, \
150, 150, 4, 22.95, 807.7, 107.7, 5.93, 18.01, \
150, 150, 4.5, 25.67, 896.1, 119.5, 5.91, 20.15, \
150, 150, 5, 28.36, 981.8, 130.9, 5.88, 22.26, \
150, 150, 5.5, 31.01, 1065, 142, 5.86, 24.34, \
150, 150, 6, 33.63, 1145, 152.7, 5.84, 26.4, \
150, 150, 6.5, 35.86, 1203, 160.4, 5.79, 28.15, \
150, 150, 7, 38.36, 1275, 170, 5.77, 30.11, \
150, 150, 7.5, 40.82, 1344, 179.2, 5.74, 32.04, \
150, 150, 8, 43.24, 1411, 188.1, 5.71, 33.95, \
160, 160, 4, 24.55, 987, 123.4, 6.34, 19.27, \
160, 160, 4.5, 27.47, 1096, 137, 6.32, 21.56, \
160, 160, 5, 30.36, 1202, 150.3, 6.29, 23.83, \
160, 160, 5.5, 33.21, 1305, 163.1, 6.27, 26.07, \
160, 160, 6, 36.03, 1405, 175.6, 6.24, 28.29, \
160, 160, 6.5, 38.46, 1479, 184.8, 6.2, 30.19, \
160, 160, 7, 41.16, 1569, 196.1, 6.17, 32.31, \
160, 160, 7.5, 43.82, 1656, 207, 6.15, 34.4, \
160, 160, 8, 46.44, 1740, 217.5, 6.12, 36.46, \
180, 180, 5, 34.36, 1737, 192.9, 7.11, 26.97, \
180, 180, 5.5, 37.61, 1888, 209.8, 7.09, 29.52, \
180, 180, 6, 40.83, 2036, 226.2, 7.06, 32.05, \
180, 180, 6.5, 43.66, 2150, 238.9, 7.02, 34.27, \
180, 180, 7, 46.76, 2286, 254, 6.99, 36.7, \
180, 180, 7.5, 49.82, 2417, 268.6, 6.97, 39.11, \
180, 180, 8, 52.84, 2545, 282.7, 6.94, 41.48, \
180, 180, 8.5, 55.83, 2668, 296.5, 6.91, 43.83, \
180, 180, 9, 58.78, 2787, 309.7, 6.89, 46.14, \
180, 180, 9.5, 61.69, 2903, 322.6, 6.86, 48.43, \
180, 180, 10, 64.57, 3015, 335, 6.83, 50.68, \
200, 200, 6, 45.63, 2832, 283.2, 7.88, 35.82, \
200, 200, 6.5, 48.86, 3000, 300, 7.84, 38.35, \
200, 200, 7, 52.36, 3193, 319.3, 7.81, 41.1, \
200, 200, 7.5, 55.82, 3382, 338.2, 7.78, 43.82, \
200, 200, 8, 59.24, 3565, 356.5, 7.76, 46.51, \
200, 200, 8.5, 62.63, 3743, 374.3, 7.73, 49.16, \
200, 200, 9, 65.98, 3917, 391.7, 7.7, 51.79, \
200, 200, 9.5, 69.29, 4085, 408.5, 7.68, 54.39, \
200, 200, 10, 72.57, 4249, 424.9, 7.65, 56.96, \
200, 200, 10.5, 74.86, 4309, 430.9, 7.59, 58.76, \
200, 200, 11, 77.97, 4454, 445.4, 7.56, 61.2, \
200, 200, 11.5, 81.03, 4593, 459.3, 7.53, 63.61, \
200, 200, 12, 84.06, 4727, 472.7, 7.5, 65.99, \
250, 250, 6, 57.63, 5671, 453.7, 9.92, 45.24, \
250, 250, 6.5, 61.86, 6036, 482.9, 9.88, 48.56, \
250, 250, 7, 66.36, 6441, 515.3, 9.85, 52.09, \
250, 250, 7.5, 70.82, 6838, 547.1, 9.83, 55.59, \
250, 250, 8, 75.24, 7227, 578.2, 9.8, 59.07, \
250, 250, 8.5, 79.63, 7608, 608.7, 9.77, 62.51, \
250, 250, 9, 83.98, 7981, 638.5, 9.75, 65.92, \
250, 250, 9.5, 88.29, 8346, 667.7, 9.72, 69.31, \
250, 250, 10, 92.57, 8703, 696.3, 9.7, 72.66, \
250, 250, 10.5, 95.86, 8900, 712, 9.64, 75.25, \
250, 250, 11, 99.97, 9227, 738.1, 9.61, 78.47, \
250, 250, 11.5, 104, 9545, 763.6, 9.58, 81.67, \
250, 250, 12, 108.1, 9854, 788.3, 9.55, 84.83, \
300, 300, 6, 69.63, 9963, 664.2, 11.96, 54.66, \
300, 300, 6.5, 74.86, 10637, 709.1, 11.92, 58.76, \
300, 300, 7, 80.36, 11370, 758, 11.89, 63.08, \
300, 300, 7.5, 85.82, 12090, 806, 11.87, 67.37, \
300, 300, 8, 91.24, 12798, 853.2, 11.84, 71.63, \
300, 300, 8.5, 96.63, 13495, 899.7, 11.82, 75.85, \
300, 300, 9, 102, 14180, 945.3, 11.79, 80.05, \
300, 300, 9.5, 107.3, 14853, 990.2, 11.77, 84.22, \
300, 300, 10, 112.6, 15515, 1034, 11.74, 88.36, \
300, 300, 10.5, 116.9, 15947, 1063, 11.68, 91.73, \
300, 300, 11, 122, 16564, 1104, 11.65, 95.74, \
300, 300, 11.5, 127, 17168, 1145, 11.63, 99.72, \
300, 300, 12, 132.1, 17761, 1184, 11.6, 103.7}

#define N_SQUARE_PROF_N    128
#define SQUARE_PROF_N   {40, 40, 2, 4, 32, 2.94, 2.31, 6.94, 3.47, 1.54, 1.9, \
40, 40, 2.5, 5, 30, 3.59, 2.82, 8.21, 4.1, 1.51, 2.4, \
40, 40, 3, 6, 28, 4.208, 3.303, 9.31, 4.655, 1.487, 2.811, \
40, 40, 3.5, 7, 26, 4.795, 3.764, 10.26, 5.130, 1.463, 3.240, \
40, 40, 4, 8, 24, 5.348, 4.198, 11.05, 5.525, 1.437, 3.656, \
50, 50, 2, 4, 42, 3.74, 2.93, 14.14, 5.66, 1.95, 1.9, \
50, 50, 2.5, 5, 40, 4.59, 3.6, 16.93, 6.77, 1.92, 2.4, \
50, 50, 3, 6, 38, 5.408, 4.245, 19.45, 7.780, 1.896, 2.851, \
50, 50, 3.5, 7, 36, 6.195, 4.863, 21.7, 8.680, 1.872, 3.295, \
50, 50, 4, 8, 34, 6.948, 5.454, 23.7, 9.480, 1.847, 3.730, \
50, 50, 4.5, 9, 32, 7.669, 6.020, 25.45, 10.180, 1.822, 4.155, \
50, 50, 5, 10, 30, 8.356, 6.560, 26.98, 10.792, 1.797, 4.570, \
50, 50, 5.5, 11, 28, 9.011, 7.074, 28.27, 11.308, 1.771, 4.975, \
50, 50, 6, 12, 26, 9.633, 7.562, 29.36, 11.744, 1.746, 5.370, \
60, 60, 2, 4, 52, 4.54, 3.56, 25.14, 8.38, 2.35, 1.9, \
60, 60, 2.5, 5, 50, 5.59, 4.39, 30.33, 10.11, 2.33, 2.4, \
60, 60, 3, 6, 48, 6.608, 5.187, 35.11, 11.703, 2.305, 2.877, \
60, 60, 3.5, 7, 46, 7.595, 5.962, 39.5, 13.167, 2.281, 3.331, \
60, 60, 4, 8, 44, 8.548, 6.710, 43.5, 14.500, 2.256, 3.778, \
60, 60, 4.5, 9, 42, 9.469, 7.433, 47.14, 15.713, 2.231, 4.217, \
60, 60, 5, 10, 40, 10.356, 8.130, 50.41, 16.803, 2.206, 4.648, \
60, 60, 5.5, 11, 38, 11.211, 8.801, 53.34, 17.780, 2.181, 5.070, \
60, 60, 6, 12, 36, 12.033, 9.446, 55.94, 18.647, 2.156, 5.485, \
70, 70, 2, 4, 62, 5.34, 4.19, 40.72, 11.63, 2.76, 1.9, \
70, 70, 2.5, 5, 60, 6.59, 5.17, 49.39, 14.11, 2.74, 2.4, \
70, 70, 3, 6, 58, 7.808, 6.129, 57.5, 16.429, 2.714, 2.895, \
70, 70, 3.5, 7, 56, 8.995, 7.061, 65.05, 18.586, 2.689, 3.356, \
70, 70, 4, 8, 54, 10.148, 7.966, 72.06, 20.589, 2.665, 3.811, \
70, 70, 4.5, 9, 52, 11.269, 8.846, 78.55, 22.443, 2.640, 4.260, \
70, 70, 5, 10, 50, 12.356, 9.700, 84.52, 24.149, 2.615, 4.701, \
70, 70, 5.5, 11, 48, 13.411, 10.528, 90.011, 25.717, 2.591, 5.136, \
70, 70, 6, 12, 46, 14.433, 11.330, 95.01, 27.146, 2.566, 5.564, \
70, 70, 6.5, 16.5, 37, 15.031, 11.800, 95.11, 27.174, 2.515, 5.973, \
70, 70, 7, 17.5, 35, 15.958, 12.527, 98.5, 28.143, 2.484, 6.384, \
80, 80, 3, 6, 68, 9.008, 7.071, 87.81, 21.953, 3.122, 2.909, \
80, 80, 3.5, 7, 66, 10.395, 8.160, 99.75, 24.938, 3.098, 3.375, \
80, 80, 4, 8, 64, 11.748, 9.222, 111, 27.750, 3.074, 3.836, \
80, 80, 4.5, 9, 62, 13.069, 10.259, 121.3, 30.325, 3.047, 4.291, \
80, 80, 5, 10, 60, 14.356, 11.270, 131.3, 32.825, 3.024, 4.741, \
80, 80, 5.5, 11, 58, 15.611, 12.255, 140.5, 35.125, 3.000, 5.184, \
80, 80, 6, 12, 56, 16.833, 13.214, 149, 37.250, 2.975, 5.622, \
80, 80, 6.5, 16.5, 47, 17.631, 13.841, 151, 37.750, 2.926, 6.045, \
80, 80, 7, 17.5, 45, 18.758, 14.725, 157.4, 39.350, 2.897, 6.469, \
80, 80, 7.5, 19, 42, 19.786, 15.532, 163, 40.750, 2.870, 6.885, \
80, 80, 8, 20, 40, 20.842, 16.361, 168, 42.000, 2.839, 7.296, \
90, 90, 3, 6, 78, 10.208, 8.013, 127.2, 28.267, 3.530, 2.919, \
90, 90, 3.5, 7, 76, 11.795, 9.259, 145, 32.222, 3.506, 3.389, \
90, 90, 4, 8, 74, 13.348, 10.478, 161.8, 35.956, 3.482, 3.855, \
90, 90, 4.5, 9, 72, 14.869, 11.672, 177.8, 39.511, 3.458, 4.315, \
90, 90, 5, 10, 70, 16.356, 12.840, 192.8, 42.844, 3.433, 4.771, \
90, 90, 5.5, 11, 68, 17.811, 13.982, 206.9, 45.978, 3.408, 5.221, \
90, 90, 6, 12, 66, 19.233, 15.098, 220.2, 48.933, 3.384, 5.667, \
90, 90, 6.5, 16.5, 57, 20.231, 15.882, 225.3, 50.067, 3.337, 6.100, \
90, 90, 7, 17.5, 55, 21.558, 16.923, 235.8, 52.400, 3.307, 6.533, \
90, 90, 7.5, 19, 52, 22.786, 17.887, 245.4, 54.533, 3.282, 6.960, \
90, 90, 8, 20, 50, 24.042, 18.873, 254.2, 56.489, 3.252, 7.383, \
100, 100, 3, 6, 88, 11.408, 8.955, 177, 35.400, 3.939, 2.927, \
100, 100, 3.5, 7, 86, 13.195, 10.358, 202.2, 40.440, 3.915, 3.401, \
100, 100, 4, 8, 84, 14.948, 11.734, 225.1, 45.020, 3.881, 3.870, \
100, 100, 4.5, 9, 82, 16.669, 13.085, 247.5, 49.500, 3.853, 4.335, \
100, 100, 5, 10, 80, 18.356, 14.410, 270.9, 54.180, 3.842, 4.795, \
100, 100, 5.5, 11, 78, 20.011, 15.709, 291.6, 58.320, 3.817, 5.251, \
100, 100, 6, 12, 76, 21.633, 16.982, 311.2, 62.240, 3.793, 5.702, \
100, 100, 6.5, 16.5, 67, 22.831, 17.923, 320.6, 64.120, 3.747, 6.143, \
100, 100, 7, 17.5, 65, 24.358, 19.121, 336.7, 67.340, 3.718, 6.584, \
100, 100, 7.5, 19, 62, 25.786, 20.242, 351.6, 70.320, 3.693, 7.019, \
100, 100, 8, 20, 60, 27.242, 21.385, 365.4, 73.080, 3.662, 7.450, \
120, 120, 3, 6, 108, 13.808, 10.839, 312.3, 52.050, 4.756, 2.940, \
120, 120, 3.5, 7, 106, 15.995, 12.556, 358.1, 59.683, 4.732, 3.418, \
120, 120, 4, 8, 104, 18.148, 14.246, 402.2, 67.033, 4.708, 3.892, \
120, 120, 4.5, 9, 102, 20.269, 15.911, 444.5, 74.083, 4.683, 4.363, \
120, 120, 5, 10, 100, 22.356, 17.550, 485.3, 80.883, 4.659, 4.830, \
120, 120, 5.5, 11, 98, 24.411, 19.163, 524.3, 87.383, 4.634, 5.294, \
120, 120, 6, 12, 96, 26.433, 20.750, 561.8, 93.633, 4.610, 5.754, \
120, 120, 6.5, 16.5, 87, 28.031, 22.005, 584.6, 97.433, 4.567, 6.206, \
120, 120, 7, 17.5, 85, 29.958, 23.517, 616.8, 102.800, 4.538, 6.658, \
120, 120, 7.5, 19, 82, 31.786, 24.952, 647.3, 107.883, 4.513, 7.105, \
120, 120, 8, 20, 80, 33.642, 26.409, 676.2, 112.700, 4.483, 7.549, \
140, 140, 4, 8, 124, 21.348, 16.758, 651.5, 93.071, 5.524, 3.908, \
140, 140, 4.5, 9, 122, 23.869, 18.737, 722.1, 103.157, 5.500, 4.383, \
140, 140, 5, 10, 120, 26.356, 20.690, 790.3, 112.900, 5.476, 4.855, \
140, 140, 5.5, 11, 118, 28.811, 22.617, 856.3, 122.329, 5.452, 5.324, \
140, 140, 6, 12, 116, 31.233, 24.518, 920, 131.429, 5.427, 5.790, \
140, 140, 6.5, 16.5, 107, 33.231, 26.087, 963.6, 137.657, 5.385, 6.250, \
140, 140, 7, 17.5, 105, 35.558, 27.913, 1020, 145.714, 5.356, 6.710, \
140, 140, 7.5, 19, 102, 37.786, 29.662, 1074, 153.429, 5.331, 7.165, \
140, 140, 8, 20, 100, 40.042, 31.433, 1126, 160.857, 5.303, 7.618, \
150, 150, 4, 8, 134, 22.948, 18.014, 807.7, 107.693, 5.933, 3.914, \
150, 150, 4.5, 9, 132, 25.669, 20.150, 896.1, 119.480, 5.909, 4.391, \
150, 150, 5, 10, 130, 28.356, 22.260, 981.8, 130.907, 5.884, 4.865, \
150, 150, 5.5, 11, 128, 31.011, 24.344, 1065, 142.000, 5.860, 5.336, \
150, 150, 6, 12, 126, 33.633, 26.402, 1145, 152.667, 5.835, 5.805, \
150, 150, 6.5, 16.5, 117, 35.831, 28.128, 1203, 160.400, 5.794, 6.268, \
150, 150, 7, 17.5, 115, 38.358, 30.111, 1275, 170.000, 5.765, 6.730, \
150, 150, 7.5, 19, 112, 40.786, 32.017, 1344, 179.200, 5.740, 7.189, \
150, 150, 8, 20, 110, 43.242, 33.945, 1411, 188.133, 5.712, 7.645, \
160, 160, 4, 8, 144, 24.548, 19.270, 987, 123.375, 6.341, 3.920, \
160, 160, 4.5, 9, 142, 27.469, 21.563, 1096, 137.000, 6.317, 4.398, \
160, 160, 5, 10, 140, 30.356, 23.830, 1202, 150.250, 6.293, 4.874, \
160, 160, 5.5, 11, 138, 33.211, 26.071, 1305, 163.125, 6.269, 5.347, \
160, 160, 6, 12, 136, 36.033, 28.286, 1405, 175.625, 6.244, 5.817, \
160, 160, 6.5, 16.5, 127, 38.431, 30.169, 1479, 184.875, 6.204, 6.283, \
160, 160, 7, 17.5, 125, 41.158, 32.309, 1569, 196.125, 6.174, 6.748, \
160, 160, 7.5, 19, 122, 43.786, 34.372, 1656, 207.000, 6.150, 7.209, \
160, 160, 8, 20, 120, 46.442, 36.457, 1740, 217.500, 6.121, 7.668, \
180, 180, 5, 10, 160, 34.356, 26.970, 1737, 193.000, 7.110, 4.888, \
180, 180, 5.5, 11, 158, 37.611, 29.525, 1888, 209.778, 7.085, 5.364, \
180, 180, 6, 12, 156, 40.833, 32.054, 2036, 226.222, 7.061, 5.838, \
180, 180, 6.5, 16.5, 147, 43.631, 34.251, 2150, 238.889, 7.020, 6.308, \
180, 180, 7, 17.5, 145, 46.758, 36.705, 2286, 254.000, 6.992, 6.777, \
180, 180, 7.5, 19, 142, 49.786, 39.082, 2417, 268.556, 6.968, 7.243, \
180, 180, 8, 20, 140, 52.842, 41.481, 2545, 282.778, 6.940, 7.707, \
180, 180, 8.5, 21.5, 137, 55.793, 43.797, 2668, 296.444, 6.915, 8.168, \
180, 180, 9, 22.5, 135, 58.779, 46.141, 2787, 309.667, 6.886, 8.627, \
180, 180, 9.5, 24, 132, 61.650, 48.396, 2903, 322.556, 6.862, 9.082, \
180, 180, 10, 25, 130, 64.566, 50.685, 3015, 335.000, 6.833, 9.536, \
180, 180, 10.5, 31.5, 117, 66.458, 52.170, 3045, 338.333, 6.769, 9.980, \
180, 180, 11, 33, 114, 69.167, 54.296, 3141, 349.000, 6.739, 10.427, \
180, 180, 11.5, 34.5, 111, 71.834, 56.390, 3234, 359.333, 6.710, 10.871, \
180, 180, 12, 36, 108, 74.459, 58.451, 3322, 369.111, 6.679, 11.313, \
180, 180, 12.5, 37.5, 105, 77.044, 60.479, 3405, 378.333, 6.648, 11.751, \
180, 180, 13, 39, 102, 79.586, 62.475, 3486, 387.333, 6.618, 12.187, \
180, 180, 13.5, 40.5, 99, 82.088, 64.439, 3563, 395.889, 6.588, 12.620, \
180, 180, 14, 42, 96, 84.548, 66.370, 3635, 403.889, 6.557, 13.050, \
180, 180, 14.5, 43.5, 93, 86.966, 68.268, 3704, 411.556, 6.526, 13.476, \
180, 180, 15, 45, 90, 89.343, 70.134, 3768, 418.667, 6.494, 13.900, \
180, 180, 15.5, 46.5, 87, 91.678, 71.968, 3829, 425.444, 6.463, 14.321, \
180, 180, 16, 48, 84, 93.972, 73.768, 3886, 431.778, 6.431, 14.739}

#define N_SQUARE_PROF1_N    109
#define SQUARE_PROF1_N   {200, 200, 5, 10, 180, 38.356, 30.110, 2410, 241.000, 7.927, 4.900, \
200, 200, 5.5, 11, 178, 42.011, 32.979, 2624, 262.400, 7.903, 5.378, \
200, 200, 6, 12, 176, 45.633, 35.822, 2832, 283.200, 7.878, 5.855, \
200, 200, 6.5, 16.5, 167, 48.831, 38.333, 3000, 300.000, 7.838, 6.328, \
200, 200, 7, 17.5, 165, 52.358, 41.101, 3193, 319.300, 7.809, 6.800, \
200, 200, 7.5, 19, 162, 55.786, 43.792, 3382, 338.200, 7.786, 7.270, \
200, 200, 8, 20, 160, 59.242, 46.505, 3565, 356.500, 7.757, 7.737, \
200, 200, 8.5, 21.5, 157, 62.593, 49.135, 3743, 374.300, 7.733, 8.203, \
200, 200, 9, 22.5, 155, 65.979, 51.793, 3917, 391.700, 7.705, 8.666, \
200, 200, 9.5, 24, 152, 69.250, 54.362, 4085, 408.500, 7.680, 9.126, \
200, 200, 10, 25, 150, 72.566, 56.965, 4249, 424.900, 7.652, 9.585, \
200, 200, 10.5, 31.5, 137, 74.858, 58.764, 4309, 430.900, 7.587, 10.036, \
200, 200, 11, 33, 134, 77.967, 61.204, 4454, 445.400, 7.558, 10.489, \
200, 200, 11.5, 34.5, 131, 81.034, 63.612, 4593, 459.300, 7.529, 10.939, \
200, 200, 12, 36, 128, 84.059, 65.987, 4727, 472.700, 7.499, 11.387, \
250, 250, 6, 12, 226, 57.633, 45.242, 5671, 453.680, 9.920, 5.885, \
250, 250, 6.5, 16.5, 217, 61.831, 48.538, 6036, 482.880, 9.880, 6.363, \
250, 250, 7, 17.5, 215, 66.358, 52.091, 6441, 515.280, 9.852, 6.841, \
250, 250, 7.5, 19, 212, 70.786, 55.567, 6838, 547.040, 9.829, 7.317, \
250, 250, 8, 20, 210, 75.242, 59.065, 7227, 578.160, 9.800, 7.792, \
250, 250, 8.5, 21.5, 207, 79.593, 62.480, 7608, 608.640, 9.777, 8.264, \
250, 250, 9, 22.5, 205, 83.979, 65.923, 7981, 638.480, 9.749, 8.735, \
250, 250, 9.5, 24, 202, 88.250, 69.277, 8346, 667.680, 9.725, 9.204, \
250, 250, 10, 25, 200, 92.566, 72.665, 8703, 696.240, 9.696, 9.672, \
250, 250, 10.5, 31.5, 187, 95.858, 75.249, 8900, 712.000, 9.636, 10.134, \
250, 250, 11, 33, 184, 99.967, 78.474, 9227, 738.160, 9.607, 10.597, \
250, 250, 11.5, 34.5, 181, 104.034, 81.667, 9545, 763.600, 9.579, 11.058, \
250, 250, 12, 36, 178, 108.059, 84.827, 9854, 788.320, 9.549, 11.518, \
300, 300, 6, 12, 276, 69.633, 54.662, 9963, 664.200, 11.962, 5.904, \
300, 300, 6.5, 16.5, 267, 74.831, 58.743, 10637, 709.133, 11.923, 6.387, \
300, 300, 7, 17.5, 265, 80.358, 63.081, 11370, 758.000, 11.895, 6.868, \
300, 300, 7.5, 19, 262, 85.786, 67.342, 12090, 806.000, 11.871, 7.349, \
300, 300, 8, 20, 260, 91.242, 71.625, 12798, 853.200, 11.843, 7.828, \
300, 300, 8.5, 21.5, 257, 96.593, 75.825, 13495, 899.667, 11.820, 8.305, \
300, 300, 9, 22.5, 255, 101.979, 80.053, 14180, 945.333, 11.792, 8.781, \
300, 300, 9.5, 24, 252, 107.250, 84.192, 14853, 990.200, 11.768, 9.255, \
300, 300, 10, 25, 250, 112.566, 88.365, 15515, 1034.333, 11.740, 9.728, \
300, 300, 10.5, 31.5, 237, 116.858, 91.734, 15947, 1063.133, 11.682, 10.198, \
300, 300, 11, 33, 234, 121.967, 95.744, 16564, 1104.267, 11.654, 10.668, \
300, 300, 11.5, 34.5, 231, 127.034, 99.722, 17168, 1144.533, 11.625, 11.136, \
300, 300, 12, 36, 228, 132.059, 103.667, 17761, 1184.067, 11.597, 11.603, \
300, 300, 12.5, 37.5, 225, 137.044, 107.579, 18347, 1223.133, 11.571, 12.068, \
300, 300, 13, 39, 222, 141.986, 111.459, 18915, 1261.000, 11.542, 12.531, \
300, 300, 13.5, 40.5, 219, 146.888, 115.307, 19472, 1298.133, 11.514, 12.994, \
300, 300, 14, 42, 216, 151.748, 119.122, 20016, 1334.400, 11.485, 13.454, \
300, 300, 14.5, 43.5, 213, 156.566, 122.904, 20548, 1369.867, 11.456, 13.913, \
300, 300, 15, 45, 210, 161.343, 126.654, 21069, 1404.600, 11.427, 14.370, \
300, 300, 15.5, 46.5, 207, 166.078, 130.372, 21577, 1438.467, 11.398, 14.826, \
300, 300, 16, 48, 204, 170.772, 134.056, 22074, 1471.600, 11.369, 15.280, \
300, 300, 16.5, 49.5, 201, 175.425, 137.709, 22559, 1503.933, 11.340, 15.733, \
300, 300, 17, 51, 198, 180.036, 141.328, 23032, 1535.467, 11.311, 16.184, \
300, 300, 17.5, 52.5, 195, 184.606, 144.915, 23494, 1566.267, 11.281, 16.633, \
300, 300, 18, 54, 192, 189.134, 148.470, 23945, 1596.333, 11.252, 17.081, \
300, 300, 18.5, 55.5, 189, 193.621, 151.992, 24383, 1625.533, 11.222, 17.527, \
300, 300, 19, 57, 186, 198.066, 155.482, 24811, 1654.067, 11.192, 17.971, \
300, 300, 20, 60, 180, 206.832, 162.363, 25632, 1708.800, 11.132, 18.854, \
350, 350, 6, 12, 326, 81.633, 64.082, 16007, 914.686, 14.003, 5.918, \
350, 350, 6.5, 16.5, 317, 87.831, 68.948, 17129, 978.800, 13.965, 6.403, \
350, 350, 7, 17.5, 315, 94.358, 74.071, 18329, 1047.371, 13.937, 6.888, \
350, 350, 7.5, 19, 312, 100.786, 79.117, 19512, 1114.971, 13.914, 7.371, \
350, 350, 8, 20, 310, 107.242, 84.185, 20680, 1181.714, 13.886, 7.853, \
350, 350, 8.5, 21.5, 307, 113.593, 89.170, 21831, 1247.486, 13.863, 8.333, \
350, 350, 9, 22.5, 305, 119.979, 94.183, 22966, 1312.343, 13.835, 8.813, \
350, 350, 9.5, 24, 302, 126.250, 99.107, 24085, 1376.286, 13.812, 9.291, \
350, 350, 10, 25, 300, 132.566, 104.065, 25188, 1439.314, 13.784, 9.769, \
350, 350, 10.5, 31.5, 287, 137.858, 108.219, 25977, 1484.400, 13.727, 10.243, \
350, 350, 11, 33, 284, 143.967, 113.014, 27019, 1543.943, 13.699, 10.717, \
350, 350, 11.5, 34.5, 281, 150.034, 117.777, 28044, 1602.514, 13.672, 11.190, \
350, 350, 12, 36, 278, 156.059, 122.507, 29052, 1660.114, 13.644, 11.662, \
350, 350, 12.5, 37.5, 275, 162.044, 127.204, 30043, 1716.743, 13.616, 12.132, \
350, 350, 13, 39, 272, 167.986, 131.869, 31016, 1772.343, 13.588, 12.602, \
350, 350, 13.5, 40.5, 269, 173.888, 136.502, 31973, 1827.029, 13.560, 13.070, \
350, 350, 14.5, 43.5, 263, 185.566, 145.669, 33837, 1933.543, 13.504, 14.002, \
350, 350, 15, 45, 260, 191.343, 150.204, 34744, 1985.371, 13.475, 14.466, \
350, 350, 15.5, 46.5, 257, 197.078, 154.707, 35634, 2036.229, 13.447, 14.928, \
350, 350, 16, 48, 254, 202.772, 159.176, 36508, 2086.171, 13.418, 15.390, \
350, 350, 16.5, 49.5, 251, 208.425, 163.614, 37366, 2135.200, 13.389, 15.850, \
350, 350, 17, 51, 248, 214.036, 168.018, 38207, 2183.257, 13.361, 16.308, \
350, 350, 17.5, 52.5, 245, 219.606, 172.390, 39032, 2230.400, 13.332, 16.765, \
350, 350, 18, 54, 242, 225.134, 176.730, 39841, 2276.629, 13.303, 17.221, \
350, 350, 18.5, 55.5, 239, 230.621, 181.037, 40634, 2321.943, 13.274, 17.676, \
350, 350, 19, 57, 236, 236.066, 185.312, 41411, 2366.343, 13.245, 18.129, \
350, 350, 20, 60, 230, 246.832, 193.763, 42917, 2452.400, 13.186, 19.031, \
400, 400, 7, 17.5, 365, 108.358, 85.061, 27667, 1383.350, 15.979, 6.902, \
400, 400, 7.5, 19, 362, 115.786, 90.892, 29478, 1473.900, 15.956, 7.387, \
400, 400, 8, 20, 360, 123.242, 96.745, 31268, 1563.400, 15.928, 7.872, \
400, 400, 8.5, 21.5, 357, 130.593, 102.515, 33036, 1651.800, 15.905, 8.355, \
400, 400, 9, 22.5, 355, 137.979, 108.313, 34783, 1739.150, 15.877, 8.837, \
400, 400, 9.5, 24, 352, 145.250, 114.022, 36509, 1825.450, 15.854, 9.318, \
400, 400, 10, 25, 350, 152.566, 119.765, 38214, 1910.700, 15.826, 9.798, \
400, 400, 10.5, 31.5, 337, 158.858, 124.704, 39510, 1975.500, 15.771, 10.276, \
400, 400, 11, 33, 334, 165.967, 130.284, 41135, 2056.750, 15.743, 10.754, \
400, 400, 11.5, 34.5, 331, 173.034, 135.832, 42737, 2136.850, 15.716, 11.230, \
400, 400, 12, 36, 328, 180.059, 141.347, 44316, 2215.800, 15.688, 11.706, \
400, 400, 12.5, 37.5, 325, 187.044, 146.829, 45873, 2293.650, 15.661, 12.180, \
400, 400, 13, 39, 322, 193.986, 152.279, 47408, 2370.400, 15.633, 12.654, \
400, 400, 13.5, 40.5, 319, 200.888, 157.697, 48920, 2446.000, 15.605, 13.126, \
400, 400, 14, 42, 316, 207.748, 163.082, 50410, 2520.500, 15.577, 13.597, \
400, 400, 14.5, 43.5, 313, 214.566, 168.434, 51878, 2593.900, 15.549, 14.067, \
400, 400, 15, 45, 310, 221.343, 173.754, 53323, 2666.150, 15.521, 14.536, \
400, 400, 15.5, 46.5, 307, 228.078, 179.042, 54747, 2737.350, 15.493, 15.003, \
400, 400, 16, 48, 304, 234.772, 184.296, 56149, 2807.450, 15.465, 15.470, \
400, 400, 16.5, 49.5, 301, 241.425, 189.519, 57529, 2876.450, 15.437, 15.935, \
400, 400, 17, 51, 298, 248.036, 194.708, 58888, 2944.400, 15.408, 16.400, \
400, 400, 17.5, 52.5, 295, 254.606, 199.865, 60224, 3011.200, 15.380, 16.863, \
400, 400, 18, 54, 292, 261.134, 204.990, 61540, 3077.000, 15.351, 17.325, \
400, 400, 18.5, 55.5, 289, 267.621, 210.082, 62833, 3141.650, 15.323, 17.785, \
400, 400, 19, 57, 286, 274.066, 215.142, 64106, 3205.300, 15.294, 18.245, \
400, 400, 20, 60, 280, 286.832, 225.163, 66587, 3329.350, 15.236, 19.161}


#define N_RECT_PROF    118
#define RECT_PROF   {50, 25, 2, 2.74, 8.38, 3.35, 1.75, 2.8, 2.24, 1.01, 2.15, \
50, 25, 2.5, 3.34, 9.88, 3.95, 1.72, 3.27, 2.61, 0.99, 2.62,\
50, 25, 3, 3.91, 11.17, 4.47, 1.69, 3.65, 2.92, 0.97, 3.07,\
50, 25, 3.5, 4.44, 12.24, 4.9, 1.66, 3.96, 3.16, 0.94, 3.49,\
50, 25, 4, 4.95, 13.12, 5.25, 1.63, 4.19, 3.35, 0.92, 3.88,\
50, 30, 2, 2.94, 9.53, 3.81, 1.8, 4.29, 2.86, 1.21, 2.31,\
50, 30, 2.5, 3.59, 11.29, 4.52, 1.77, 5.04, 3.36, 1.19, 2.82,\
50, 30, 3, 4.21, 12.82, 5.13, 1.75, 5.68, 3.79, 1.16, 3.3,\
50, 30, 3.5, 4.79, 14.13, 5.65, 1.72, 6.22, 4.15, 1.14, 3.76,\
50, 30, 4, 5.35, 15.24, 6.09, 1.69, 6.66, 4.44, 1.12, 4.2,\
50, 30, 5, 6.36, 16.85, 6.74, 1.63, 7.26, 4.84, 1.07, 4.99,\
50, 40, 2, 3.34, 11.84, 4.73, 1.88, 8.38, 4.19, 1.58, 2.62,\
50, 40, 2.5, 4.09, 14.11, 5.65, 1.86, 9.97, 4.98, 1.56, 3.21,\
50, 40, 3, 4.81, 16.14, 6.45, 1.83, 11.36, 5.68, 1.54, 3.77,\
50, 40, 3.5, 5.49, 17.92, 7.17, 1.81, 12.59, 6.29, 1.51, 4.31,\
50, 40, 4, 6.15, 19.47, 7.79, 1.78, 13.64, 6.82, 1.49, 4.83,\
50, 40, 4.5, 6.77, 20.8, 8.32, 1.75, 14.54, 7.27, 1.47, 5.31,\
50, 40, 5, 7.36, 21.91, 8.77, 1.73, 15.28, 7.64, 1.44, 5.77,\
60, 30, 2, 3.74, 18.41, 6.14, 2.22, 9.82, 4.91, 1.62, 2.93,\
60, 30, 2.5, 4.09, 17.93, 5.98, 2.09, 5.99, 3.99, 1.21, 3.21,\
60, 30, 3, 4.81, 20.49, 6.83, 2.06, 6.78, 4.52, 1.19, 3.77,\
60, 30, 3.5, 5.49, 22.74, 7.58, 2.03, 7.45, 4.97, 1.16, 4.31,\
60, 30, 4, 6.15, 24.69, 8.23, 2, 8.01, 5.34, 1.14, 4.83,\
60, 30, 4.5, 6.77, 26.34, 8.78, 1.97, 8.47, 5.64, 1.12, 5.31,\
60, 30, 5, 7.36, 27.72, 9.24, 1.94, 8.83, 5.88, 1.1, 5.77,\
60, 30, 5.5, 7.91, 28.84, 9.61, 1.91, 9.1, 6.06, 1.07, 6.21,\
60, 30, 6, 8.43, 29.69, 9.9, 1.88, 9.28, 6.19, 1.05, 6.62,\
60, 40, 2, 3.74, 18.41, 6.14, 2.22, 9.82, 4.91, 1.62, 2.93,\
60, 40, 2.5, 4.59, 22.06, 7.35, 2.19, 11.72, 5.86, 1.6, 3.6,\
60, 40, 3, 5.41, 25.37, 8.46, 2.17, 13.42, 6.71, 1.58, 4.25,\
60, 40, 3.5, 6.19, 28.33, 9.44, 2.14, 14.92, 7.46, 1.55, 4.86,\
60, 40, 4, 6.95, 30.96, 10.32, 2.11, 16.23, 8.12, 1.53, 5.45,\
60, 40, 4.5, 7.67, 33.28, 11.09, 2.08, 17.37, 8.69, 1.51, 6.02,\
60, 40, 5, 8.36, 35.29, 11.76, 2.05, 18.34, 9.17, 1.48, 6.56,\
60, 40, 5.5, 9.01, 37, 12.33, 2.03, 19.16, 9.58, 1.46, 7.07,\
60, 40, 6, 9.63, 38.44, 12.81, 2, 19.82, 9.91, 1.43, 7.56,\
70, 50, 2, 4.54, 31.47, 8.99, 2.63, 18.75, 7.5, 2.03, 3.56,\
70, 50, 2.5, 5.59, 38, 10.86, 2.61, 22.57, 9.03, 2.01, 4.39,\
70, 50, 3, 6.61, 44.03, 12.58, 2.58, 26.08, 10.43, 1.99, 5.19,\
70, 50, 3.5, 7.59, 49.57, 14.16, 2.55, 29.27, 11.71, 1.96, 5.96,\
70, 50, 4, 8.55, 54.64, 15.61, 2.53, 32.16, 12.87, 1.94, 6.71,\
70, 50, 4.5, 9.47, 59.24, 16.93, 2.5, 34.77, 13.91, 1.92, 7.43,\
70, 50, 5, 10.36, 63.4, 18.11, 2.47, 37.1, 14.84, 1.89, 8.13,\
70, 50, 5.5, 11.21, 67.12, 19.18, 2.45, 39.17, 15.67, 1.87, 8.8,\
70, 50, 6, 12.03, 70.43, 20.12, 2.42, 40.98, 16.39, 1.85, 9.45,\
80, 40, 2, 4.54, 37.35, 9.34, 2.87, 12.71, 6.36, 1.67, 3.56,\
80, 40, 2.5, 5.59, 45.1, 11.27, 2.84, 15.24, 7.62, 1.65, 4.39, \
80, 40, 3, 6.61, 52.24, 13.06, 2.81, 17.52, 8.76, 1.63, 5.19, \
80, 40, 3.5, 7.59, 58.79, 14.7, 2.78, 19.58, 9.79, 1.61, 5.96, \
80, 40, 4, 8.55, 64.77, 16.19, 2.75, 21.42, 10.71, 1.58, 6.71, \
80, 40, 4.5, 9.47, 70.19, 17.55, 2.72, 23.04, 11.52, 1.56, 7.43, \
80, 40, 5, 10.36, 75.07, 18.77, 2.69, 24.47, 12.23, 1.54, 8.13, \
80, 40, 5.5, 11.21, 79.42, 19.86, 2.66, 25.7, 12.85, 1.51, 8.8, \
80, 40, 6, 12.03, 83.26, 20.82, 2.63, 26.75, 13.38, 1.49, 9.45, \
80, 60, 2, 5.34, 49.52, 12.38, 3.05, 34.35, 11.45, 2.54, 4.19, \
80, 60, 2.5, 6.59, 60.11, 15.03, 3.02, 42.42, 14.14, 2.54, 5.17, \
80, 60, 3, 7.81, 70.02, 17.51, 2.99, 44.86, 14.95, 2.4, 6.13, \
80, 60, 3.5, 8.99, 79.27, 19.82, 2.97, 50.67, 16.89, 2.37, 7.06, \
80, 60, 4, 10.15, 87.87, 21.97, 2.94, 56.05, 18.68, 2.35, 7.97, \
80, 60, 4.5, 11.27, 95.84, 23.96, 2.92, 61, 20.33, 2.33, 8.85, \
80, 60, 5, 12.36, 103.2, 25.8, 2.89, 65.54, 21.85, 2.3, 9.7, \
80, 60, 5.5, 13.41, 109.9, 27.49, 2.86, 69.68, 23.23, 2.28, 10.53, \
80, 60, 6, 14.43, 116.1, 29.03, 2.84, 73.43, 24.48, 2.26, 11.33, \
80, 60, 6.5, 15.06, 115.9, 28.98, 2.77, 73.58, 24.53, 2.21, 11.82, \
80, 60, 7, 15.96, 120.1, 30.01, 2.74, 76.1, 25.37, 2.18, 12.53, \
80, 70, 3, 8.41, 78.92, 19.73, 3.06, 64.23, 18.35, 2.76, 6.6, \
80, 70, 3.5, 9.69, 89.51, 22.38, 3.04, 72.79, 20.8, 2.74, 7.61, \
80, 70, 4, 10.95, 99.42, 24.86, 3.01, 80.77, 23.08, 2.72, 8.59, \
80, 70, 4.5, 12.17, 108.7, 27.17, 2.99, 88.2, 25.2, 2.69, 9.55, \
80, 70, 5, 13.36, 117.3, 29.31, 2.96, 95.09, 27.17, 2.67, 10.48, \
80, 70, 5.5, 14.51, 125.2, 31.3, 2.94, 101.5, 28.98, 2.64, 11.39, \
80, 70, 6, 15.63, 132.5, 33.14, 2.91, 107.3, 30.66, 2.62, 12.27, \
80, 70, 6.5, 16.36, 133.5, 33.37, 2.86, 108.2, 30.92, 2.57, 12.84, \
80, 70, 7, 17.36, 138.7, 34.68, 2.83, 112.4, 32.11, 2.54, 13.63, \
90, 50, 3, 7.81, 81.83, 18.19, 3.24, 32.7, 13.08, 2.05, 6.13, \
90, 50, 3.5, 8.99, 92.63, 20.59, 3.21, 36.84, 14.74, 2.02, 7.06, \
90, 50, 4, 10.15, 102.7, 22.82, 3.18, 40.63, 16.25, 2, 7.97, \
90, 50, 4.5, 11.27, 112, 24.88, 3.15, 44.09, 17.63, 1.98, 8.85, \
90, 50, 5, 12.36, 120.5, 26.79, 3.12, 47.23, 18.89, 1.95, 9.7, \
90, 50, 5.5, 13.41, 128.4, 28.53, 3.09, 50.06, 20.02, 1.93, 10.53, \
90, 50, 6, 14.43, 135.6, 30.13, 3.06, 52.59, 21.04, 1.91, 11.33, \
90, 50, 6.5, 15.06, 134.7, 29.93, 2.99, 52.62, 21.05, 1.87, 11.82, \
90, 50, 7, 15.96, 139.4, 30.97, 2.96, 54.27, 21.71, 1.84, 12.53, \
90, 60, 3, 8.41, 93.19, 20.71, 3.33, 49.73, 16.58, 2.43, 6.6, \
90, 60, 3.5, 9.69, 105.7, 23.5, 3.3, 56.26, 18.75, 2.41, 7.61, \
90, 60, 4, 10.95, 117.5, 26.1, 3.28, 62.32, 20.77, 2.39, 8.59, \
90, 60, 4.5, 12.17, 128.4, 28.54, 3.25, 67.93, 22.64, 2.36, 9.55, \
90, 60, 5, 13.36, 138.6, 30.8, 3.22, 73.1, 24.37, 2.34, 10.48, \
90, 60, 5.5, 14.51, 148, 32.9, 3.19, 77.84, 25.95, 2.32, 11.39, \
90, 60, 6, 15.63, 156.7, 34.83, 3.17, 82.18, 27.39, 2.29, 12.27, \
90, 60, 7, 17.36, 163.5, 36.33, 3.07, 85.93, 28.64, 2.23, 13.63, \
100, 40, 3, 7.81, 92.33, 18.47, 3.44, 21.63, 10.82, 1.66, 6.13, \
100, 40, 3.5, 8.99, 104.4, 20.89, 3.41, 24.24, 12.12, 1.64, 7.06, \
100, 40, 4, 10.15, 115.7, 23.13, 3.38, 26.6, 13.3, 1.62, 7.97, \
100, 40, 4.5, 11.27, 126, 25.21, 3.34, 28.71, 14.36, 1.6, 8.85, \
100, 40, 5, 12.36, 135.6, 27.11, 3.31, 30.59, 15.3, 1.57, 9.7, \
100, 40, 5.5, 13.41, 144.3, 28.85, 3.28, 32.25, 16.12, 1.55, 10.53, \
100, 40, 6, 14.43, 152.2, 30.43, 3.25, 33.69, 16.85, 1.53, 11.33, \
100, 40, 6.5, 15.06, 150.1, 30.03, 3.16, 33.54, 16.77, 1.49, 11.82, \
100, 40, 7, 15.96, 155, 31.01, 3.12, 34.39, 17.19, 1.47, 12.53, \
100, 50, 3, 8.41, 106.4, 21.29, 3.56, 36.02, 14.41, 2.07, 6.6, \
100, 50, 3.5, 9.69, 120.7, 24.15, 3.53, 40.62, 16.25, 2.05, 7.61, \
100, 50, 4, 10.95, 134.1, 26.82, 3.5, 44.86, 17.94, 2.02, 8.59, \
100, 50, 4.5, 12.17, 146.6, 29.31, 3.47, 48.74, 19.5, 2, 9.55, \
100, 50, 5, 13.36, 158.1, 31.62, 3.44, 52.29, 20.92, 1.98, 10.48, \
100, 50, 5.5, 14.51, 168.8, 33.76, 3.41, 55.5, 22.2, 1.96, 11.39, \
100, 50, 6, 15.63, 178.7, 35.73, 3.38, 58.4, 23.36, 1.93, 12.27, \
100, 50, 6.5, 16.36, 178.6, 35.71, 3.3, 58.77, 23.51, 1.9, 12.84, \
100, 50, 7, 17.36, 185.3, 37.06, 3.27, 60.74, 24.29, 1.87, 13.63, \
100, 60, 3, 9.01, 120.6, 24.11, 3.66, 54.61, 18.2, 2.46, 7.07, \
100, 60, 3.5, 10.39, 137, 27.41, 3.63, 61.85, 20.62, 2.44, 8.16, \
100, 60, 4, 11.75, 152.5, 30.51, 3.6, 68.59, 22.86, 2.42, 9.22, \
100, 60, 4.5, 13.07, 167.1, 33.42, 3.58, 74.86, 24.95, 2.39, 10.26, \
100, 60, 5, 14.36, 180.7, 36.14, 3.55, 80.66, 26.89, 2.37, 11.27, \
100, 60, 5.5, 15.61, 193.4, 38.68, 3.52, 86.01, 28.67, 2.35, 12.25, \
100, 60, 6, 16.83, 205.2, 41.03, 3.49, 90.93, 30.31, 2.32, 13.21, \
100, 60, 6.5, 17.66, 207, 41.39, 3.42, 92.18, 30.73, 2.28, 13.86, \
100, 60, 7, 18.76, 215.6, 43.12, 3.39, 95.77, 31.92, 2.26, 14.72 \
}

#define N_RECT_PROF1    136
#define RECT_PROF1   {120, 40, 3, 9.01, 148, 24.67, 4.05, 25.74, 12.87, 1.69, 7.07, \
120, 40, 3.5, 10.39, 168.1, 28.01, 4.02, 28.91, 14.45, 1.67, 8.16, \
120, 40, 4, 11.75, 186.9, 31.14, 3.99, 31.79, 15.89, 1.64, 9.22, \
120, 40, 4.5, 13.07, 204.4, 34.07, 3.96, 34.38, 17.19, 1.62, 10.26, \
120, 40, 5, 14.36, 220.8, 36.79, 3.92, 36.72, 18.36, 1.6, 11.27, \
120, 40, 5.5, 15.61, 235.9, 39.32, 3.89, 38.79, 19.4, 1.58, 12.25, \
120, 40, 6, 16.83, 249.9, 41.65, 3.85, 40.63, 20.31, 1.55, 13.21, \
120, 40, 6.5, 17.66, 249.6, 41.6, 3.76, 40.84, 20.42, 1.52, 13.86, \
120, 40, 7, 18.76, 259.2, 43.21, 3.72, 42.01, 21, 1.5, 14.72, \
120, 60, 3, 10.21, 189.1, 31.52, 4.3, 64.35, 21.45, 2.51, 8.01, \
120, 60, 3.5, 11.79, 215.6, 35.93, 4.28, 73.02, 24.34, 2.49, 9.26, \
120, 60, 4, 13.35, 240.7, 40.12, 4.25, 81.14, 27.05, 2.47, 10.48, \
120, 60, 4.5, 14.87, 264.5, 44.08, 4.22, 88.72, 29.57, 2.44, 11.67, \
120, 60, 5, 16.36, 286.9, 47.82, 4.19, 95.79, 31.93, 2.42, 12.84, \
120, 60, 5.5, 17.81, 308, 51.34, 4.16, 102.3, 34.12, 2.4, 13.98, \
120, 60, 6, 19.23, 327.9, 54.65, 4.13, 108.4, 36.14, 2.37, 15.1, \
120, 60, 6.5, 20.26, 333.3, 55.56, 4.06, 110.8, 36.93, 2.34, 15.9, \
120, 60, 7, 21.56, 348.6, 58.1, 4.02, 115.4, 38.48, 2.31, 16.92, \
120, 80, 3, 11.41, 230.2, 38.36, 4.49, 123.4, 30.85, 3.29, 8.96, \
120, 80, 3.5, 13.19, 263.1, 43.85, 4.47, 140.7, 35.18, 3.27, 10.36, \
120, 80, 4, 14.95, 294.5, 49.09, 4.44, 157.2, 39.3, 3.24, 11.73, \
120, 80, 4.5, 16.67, 324.5, 54.08, 4.41, 172.8, 43.2, 3.22, 13.08, \
120, 80, 5, 18.36, 353, 58.84, 4.39, 187.6, 46.89, 3.2, 14.41, \
120, 80, 5.5, 20.01, 380.1, 63.36, 4.36, 201.5, 50.38, 3.17, 15.71, \
120, 80, 6, 21.63, 405.9, 67.64, 4.33, 214.7, 53.67, 3.15, 16.98, \
120, 80, 6.5, 22.86, 417.1, 69.51, 4.27, 221.3, 55.31, 3.11, 17.94, \
120, 80, 7, 24.36, 438, 73, 4.24, 232, 57.99, 3.09, 19.12, \
140, 60, 3, 11.41, 278.1, 39.72, 4.94, 74.1, 24.7, 2.55, 8.96, \
140, 60, 3.5, 13.19, 317.7, 45.39, 4.91, 84.19, 28.06, 2.53, 10.36, \
140, 60, 4, 14.95, 355.5, 50.79, 4.88, 93.68, 31.23, 2.5, 11.73, \
140, 60, 4.5, 16.67, 391.6, 55.94, 4.85, 102.6, 34.19, 2.48, 13.08, \
140, 60, 5, 18.36, 425.8, 60.83, 4.82, 110.9, 36.97, 2.46, 14.41, \
140, 60, 5.5, 20.01, 458.3, 65.47, 4.79, 118.7, 39.56, 2.44, 15.71, \
140, 60, 6, 21.63, 489.1, 69.87, 4.75, 125.9, 41.97, 2.41, 16.98, \
140, 60, 6.5, 22.86, 500.2, 71.46, 4.68, 129.4, 43.13, 2.38, 17.94, \
140, 60, 7, 24.36, 524.8, 74.97, 4.64, 135.1, 45.03, 2.36, 19.12, \
140, 100, 4, 18.15, 503.5, 71.93, 5.27, 300, 60, 4.07, 14.25, \
140, 100, 4.5, 20.27, 556.8, 79.54, 5.24, 331.2, 66.25, 4.04, 15.91, \
140, 100, 5, 22.36, 608.1, 86.87, 5.22, 361.2, 72.24, 4.02, 17.55, \
140, 100, 5.5, 24.41, 657.3, 93.9, 5.19, 389.8, 77.97, 4, 19.16, \
140, 100, 6, 26.43, 704.5, 100.6, 5.16, 417.2, 83.45, 3.97, 20.75, \
140, 100, 6.5, 28.06, 731.9, 104.6, 5.11, 434.3, 86.85, 3.93, 22.03, \
140, 100, 7, 29.96, 772.4, 110.3, 5.08, 457.8, 91.55, 3.91, 23.52, \
140, 120, 4, 19.75, 577.5, 82.5, 5.41, 456, 76, 4.81, 15.5, \
140, 120, 4.5, 22.07, 639.4, 91.35, 5.38, 504.6, 84.1, 4.78, 17.32, \
140, 120, 5, 24.36, 699.2, 99.88, 5.36, 551.4, 91.9, 4.76, 19.12, \
140, 120, 5.5, 26.61, 756.8, 108.1, 5.33, 596.5, 99.41, 4.73, 20.89, \
140, 120, 6, 28.83, 812.3, 116, 5.31, 639.8, 106.6, 4.71, 22.63, \
140, 120, 6.5, 30.66, 847.8, 121.11, 5.26, 668.3, 111.4, 4.67, 24.07, \
140, 120, 7, 32.76, 896.3, 128, 5.23, 706.2, 117.7, 4.64, 25.71, \
140, 120, 7.5, 34.82, 942.5, 134.6, 5.2, 742.2, 123.7, 4.62, 27.33, \
140, 120, 8, 36.84, 986.5, 140.9, 5.17, 776.5, 129.4, 4.59, 28.92, \
150, 100, 4, 18.95, 594.5, 79.27, 5.6, 318.4, 63.68, 4.1, 14.87, \
150, 100, 4.5, 21.17, 657.9, 87.72, 5.58, 351.8, 70.35, 4.08, 16.62, \
150, 100, 5, 23.36, 719, 95.87, 5.55, 383.7, 76.75, 4.05, 18.33, \
150, 100, 5.5, 25.51, 777.9, 103.7, 5.52, 414.4, 82.88, 4.03, 20.03, \
150, 100, 6, 27.63, 834.4, 111.3, 5.5, 443.7, 88.75, 4.01, 21.69, \
150, 100, 6.5, 29.36, 868.2, 115.8, 5.44, 462.7, 92.54, 3.97, 23.05, \
150, 100, 7, 31.36, 917.1, 122.3, 5.41, 488, 97.61, 3.95, 24.62, \
160, 40, 3, 11.41, 315.9, 39.49, 5.26, 33.95, 16.98, 1.73, 8.96, \
160, 40, 3.5, 13.19, 360.5, 45.07, 5.23, 38.23, 19.12, 1.7, 10.36, \
160, 40, 4, 14.95, 403, 50.37, 5.19, 42.15, 21.08, 1.68, 11.73, \
160, 40, 4.5, 16.67, 443.2, 55.4, 5.16, 45.73, 22.86, 1.66, 13.08, \
160, 40, 5, 18.36, 481.3, 60.16, 5.12, 48.97, 24.48, 1.63, 14.41, \
160, 40, 5.5, 20.01, 517.3, 64.66, 5.08, 51.89, 25.94, 1.61, 15.71, \
160, 40, 6, 21.63, 551.2, 68.9, 5.05, 54.5, 27.25, 1.59, 16.98, \
160, 40, 6.5, 22.86, 559.7, 69.96, 4.95, 55.43, 27.71, 1.56, 17.94, \
160, 40, 7, 24.36, 585.8, 73.22, 4.9, 57.26, 28.63, 1.53, 19.12, \
160, 60, 4, 18.15, 597.6, 74.71, 5.74, 203.4, 50.85, 3.35, 14.25, \
160, 60, 4.5, 20.27, 660.8, 82.6, 5.71, 224.1, 56.02, 3.33, 15.91, \
160, 60, 5, 22.36, 721.6, 90.2, 5.68, 243.8, 60.95, 3.3, 17.55, \
160, 60, 5.5, 24.41, 779.9, 97.48, 5.65, 262.6, 65.64, 3.28, 19.16, \
160, 60, 6, 26.43, 835.8, 104.5, 5.62, 280.4, 70.1, 3.26, 20.75, \
160, 60, 6.5, 28.06, 866, 108.3, 5.56, 291.5, 72.87, 3.22, 22.03, \
160, 60, 7, 29.96, 913.5, 114.2, 5.52, 306.6, 76.64, 3.2, 23.52, \
160, 100, 4, 19.75, 695, 86.87, 5.93, 336.9, 67.37, 4.13, 15.5, \
160, 100, 4.5, 22.07, 769.6, 96.21, 5.91, 372.3, 74.46, 4.11, 17.32, \
160, 100, 5, 24.36, 841.7, 105.2, 5.88, 406.3, 81.26, 4.08, 19.12, \
160, 100, 5.5, 26.61, 911.2, 113.9, 5.85, 439, 87.79, 4.06, 20.89, \
160, 100, 6, 28.83, 978.1, 122.3, 5.82, 470.2, 94.05, 4.04, 22.63, \
160, 100, 6.5, 30.66, 1019, 127.4, 5.77, 491.1, 98.22, 4, 24.07, \
160, 100, 7, 32.76, 1077, 134.7, 5.73, 518.3, 103.7, 3.98, 25.71, \
160, 100, 7.5, 34.82, 1133, 141.6, 5.7, 544.1, 108.8, 3.95, 27.33, \
160, 100, 8, 36.84, 1186, 148.2, 5.67, 568.6, 113.7, 3.93, 28.92, \
160, 120, 4, 21.35, 792.3, 99.04, 6.09, 509.8, 84.97, 4.89, 16.76, \
160, 120, 4.5, 23.87, 878.5, 109.8, 6.07, 564.6, 94.1, 4.86, 18.74, \
160, 120, 5, 26.36, 961.8, 120.2, 6.04, 617.5, 102.9, 4.84, 20.69, \
160, 120, 5.5, 28.81, 1042, 130.3, 6.02, 668.6, 111.4, 4.82, 22.62, \
160, 120, 6, 31.23, 1120, 140, 5.99, 717.8, 119.6, 4.79, 24.52, \
160, 120, 6.5, 33.26, 1172, 146.5, 5.94, 752, 125.3, 4.76, 26.11, \
160, 120, 7, 35.56, 1241, 155.2, 5.91, 795.5, 132.6, 4.73, 27.91, \
160, 120, 7.5, 37.82, 1307, 163.4, 5.88, 837.2, 139.5, 4.7, 29.69, \
160, 120, 8, 40.04, 1371, 171.3, 5.85, 876.9, 146.1, 4.68, 31.43, \
160, 140, 5, 28.36, 1082, 135.2, 6.18, 881.4, 125.9, 5.58, 22.26, \
160, 140, 5.5, 31.01, 1174, 146.7, 6.15, 955.8, 136.5, 5.55, 24.34, \
160, 140, 6, 33.63, 1263, 157.8, 6.13, 1028, 146.8, 5.53, 26.4, \
160, 140, 6.5, 35.86, 1325, 165.7, 6.08, 1079, 154.2, 5.49, 28.15, \
160, 140, 7, 38.36, 1405, 175.6, 6.05, 1144, 163.4, 5.46, 30.11, \
160, 140, 7.5, 40.82, 1482, 185.2, 6.02, 1206, 172.3, 5.44, 32.04, \
160, 140, 8, 43.24, 1555, 194.4, 6, 1265, 180.8, 5.41, 33.95, \
180, 60, 4, 18.15, 678.1, 75.3, 6.11, 118.8, 39.6, 2.56, 14.25, \
180, 60, 4.5, 20.27, 749.4, 83.3, 6.08, 130.3, 43.4, 2.54, 15.91, \
180, 60, 5, 22.36, 817.8, 90.9, 6.05, 141.2, 47.1, 2.51, 17.55, \
180, 60, 5.5, 24.41, 883.3, 98.1, 6.02, 151.4, 50.5, 2.49, 19.16, \
180, 60, 6, 26.43, 946, 105.1, 5.98, 160.9, 53.6, 2.47, 20.75, \
180, 60, 6.5, 28.06, 976.4, 108.5, 5.9, 166.6, 55.5, 2.44, 22.03, \
180, 60, 7, 29.96, 1029, 114.3, 5.86, 174.4, 58.1, 2.41, 23.52, \
180, 60, 7.5, 31.82, 1078, 119.8, 5.82, 181.6, 60.5, 2.39, 24.98, \
180, 60, 8, 33.64, 1125, 125, 5.78, 188.2, 62.7, 2.37, 26.41, \
180, 80, 4, 19.75, 802, 89.12, 6.37, 226.5, 56.62, 3.39, 15.5, \
180, 80, 4.5, 22.07, 888, 98.67, 6.34, 249.7, 62.44, 3.36, 17.32, \
180, 80, 5, 24.36, 970.9, 107.9, 6.31, 271.9, 67.99, 3.34, 19.12, \
180, 80, 5.5, 26.61, 1051, 116.8, 6.28, 293.1, 73.28, 3.32, 20.89, \
180, 80, 6, 28.83, 1128, 125.3, 6.25, 313.3, 78.31, 3.3, 22.63, \
180, 80, 6.5, 30.66, 1172, 130.2, 6.18, 326.6, 81.65, 3.26, 24.07, \
180, 80, 7, 32.76, 1238, 137.6, 6.15, 343.9, 85.97, 3.24, 25.71, \
180, 80, 7.5, 34.82, 1301, 144.6, 6.11, 360.1, 90.03, 3.22, 27.33, \
180, 80, 8, 36.84, 1361, 151.3, 6.08, 375.4, 93.85, 3.19, 28.92, \
180, 100, 4, 21.35, 926, 102.9, 6.59, 373.7, 74.74, 4.18, 16.76, \
180, 100, 4.5, 23.87, 1027, 114.1, 6.56, 413.3, 82.67, 4.16, 18.74, \
180, 100, 5, 26.36, 1124, 124.9, 6.53, 451.4, 90.29, 4.14, 20.69, \
180, 100, 5.5, 28.81, 1218, 135.4, 6.5, 488.1, 97.61, 4.12, 22.62, \
180, 100, 6, 31.23, 1309, 145.5, 6.47, 523.3, 104.7, 4.09, 24.52, \
180, 100, 6.5, 33.26, 1368, 152, 6.41, 547.9, 109.6, 4.06, 26.11, \
180, 100, 7, 35.56, 1448, 160.9, 6.38, 578.8, 115.8, 4.03, 27.91, \
180, 100, 7.5, 37.82, 1525, 169.4, 6.35, 608.3, 121.7, 4.01, 29.69, \
180, 100, 8, 40.04, 1598, 177.6, 6.32, 636.3, 127.3, 3.99, 31.43, \
180, 140, 4, 24.55, 1174, 130.42, 6.91, 799.5, 114.2, 5.71, 19.27, \
180, 140, 4.5, 27.47, 1304, 144.87, 6.89, 887.3, 126.8, 5.68, 21.56, \
180, 140, 5, 30.36, 1430, 158.92, 6.86, 972.6, 138.9, 5.66, 23.83, \
180, 140, 5.5, 33.21, 1553, 172.58, 6.84, 1055, 150.7, 5.64, 26.07, \
180, 140, 6, 36.03, 1673, 185.85, 6.81, 1135, 162.2, 5.61, 28.29, \
180, 140, 6.5, 38.46, 1759, 195.45, 6.76, 1195, 170.8, 5.57, 30.19, \
180, 140, 7, 41.16, 1867, 207.43, 6.73, 1268, 181.1, 5.55, 32.31, \
180, 140, 7.5, 43.82, 1971, 218.99, 6.71, 1338, 191.1, 5.52, 34.4, \
180, 140, 8, 46.44, 2071, 230.15, 6.68, 1405, 200.8, 5.5, 36.46}


#define N_RECT_PROF2    170
#define RECT_PROF2  {200, 40, 4, 18.15, 738.6, 73.86, 6.38, 52.52, 26.26, 1.7, 14.25, \
200, 40, 4.5, 20.27, 815.3, 81.53, 6.34, 57.07, 28.53, 1.68, 15.91, \
200, 40, 5, 22.36, 888.7, 88.87, 6.3, 61.22, 30.61, 1.65, 17.55, \
200, 40, 5.5, 24.41, 958.8, 95.88, 6.27, 64.98, 32.49, 1.63, 19.16, \
200, 40, 6, 26.43, 1026, 102.6, 6.23, 68.37, 34.19, 1.61, 20.75, \
200, 40, 6.5, 28.06, 1053, 105.3, 6.13, 70.02, 35.01, 1.58, 22.03, \
200, 40, 7, 29.96, 1107, 110.7, 6.08, 72.5, 36.25, 1.56, 23.52, \
200, 80, 4, 21.35, 1046, 104.6, 7, 249.6, 62.4, 3.42, 16.76, \
200, 80, 4.5, 23.87, 1159, 115.9, 6.97, 275.4, 68.85, 3.4, 18.74, \
200, 80, 5, 26.36, 1269, 126.9, 6.94, 300.1, 75.02, 3.37, 20.69, \
200, 80, 5.5, 28.81, 1375, 137.5, 6.91, 323.6, 80.91, 3.35, 22.62, \
200, 80, 6, 31.23, 1477, 147.7, 6.88, 346.1, 86.53, 3.33, 24.52, \
200, 80, 6.5, 33.26, 1539, 153.9, 6.8, 361.7, 90.43, 3.3, 26.11, \
200, 80, 7, 35.56, 1629, 162.9, 6.77, 381.2, 95.29, 3.27, 27.91, \
200, 80, 7.5, 37.82, 1714, 171.4, 6.73, 399.6, 99.89, 3.25, 29.69, \
200, 80, 8, 40.04, 1795, 179.5, 6.7, 416.9, 104.2, 3.23, 31.43, \
200, 100, 4, 22.95, 1200, 120, 7.23, 410.6, 82.12, 4.23, 18.01, \
200, 100, 4.5, 25.67, 1331, 133.1, 7.2, 454.4, 90.87, 4.21, 20.15, \
200, 100, 5, 28.36, 1459, 145.9, 7.17, 496.6, 99.31, 4.18, 22.26, \
200, 100, 5.5, 31.01, 1583, 158.3, 7.14, 537.2, 107.4, 4.16, 24.34, \
200, 100, 6, 33.63, 1703, 170.3, 7.12, 576.3, 115.3, 4.14, 26.4, \
200, 100, 6.5, 35.86, 1783, 178.3, 7.05, 604.7, 120.9, 4.11, 28.15, \
200, 100, 7, 38.36, 1889, 188.9, 7.02, 639.4, 127.9, 4.08, 30.11, \
200, 100, 7.5, 40.82, 1992, 199.2, 6.99, 672.5, 134.5, 4.06, 32.04, \
200, 100, 8, 43.24, 2090, 209, 6.95, 704, 140.8, 4.03, 33.95, \
200, 120, 4, 24.55, 1353, 135.3, 7.42, 617.5, 102.9, 5.02, 19.27, \
200, 120, 4.5, 27.47, 1503, 150.3, 7.4, 684.7, 114.1, 4.99, 21.56, \
200, 120, 5, 30.36, 1649, 164.9, 7.37, 749.8, 125, 4.97, 23.83, \
200, 120, 5.5, 33.21, 1791, 179.1, 7.34, 812.8, 135.5, 4.95, 26.07, \
200, 120, 6, 36.03, 1929, 192.9, 7.32, 873.7, 145.6, 4.92, 28.29, \
200, 120, 6.5, 38.46, 2026, 202.6, 7.26, 919.5, 153.2, 4.89, 30.19, \
200, 120, 7, 41.16, 2150, 215, 7.23, 974.3, 162.4, 4.87, 32.31, \
200, 120, 7.5, 43.82, 2270, 227, 7.2, 1027, 171.2, 4.84, 34.4, \
200, 120, 8, 46.44, 2385, 238.5, 7.17, 1078, 179.6, 4.82, 36.46, \
200, 160, 5, 34.36, 2029, 202.9, 7.69, 1442, 180.3, 6.48, 26.97, \
200, 160, 5.5, 37.61, 2207, 220.7, 7.66, 1568, 195.9, 6.46, 29.52, \
200, 160, 6, 40.83, 2380, 238, 7.64, 1690, 211.2, 6.43, 32.05, \
200, 160, 6.5, 43.66, 2513, 251.3, 7.59, 1785, 223.1, 6.39, 34.27, \
200, 160, 7, 46.76, 2672, 267.2, 7.56, 1897, 237.1, 6.37, 36.7, \
200, 160, 7.5, 49.82, 2826, 282.6, 7.53, 2005, 250.6, 6.34, 39.11, \
200, 160, 8, 52.84, 2975, 297.5, 7.5, 2110, 263.7, 6.32, 41.48, \
200, 160, 8.5, 55.83, 3120, 312, 7.48, 2211, 276.4, 6.29, 43.83, \
200, 160, 9, 58.78, 3260, 326, 7.45, 2309, 288.7, 6.27, 46.14, \
200, 160, 9.5, 61.69, 3395, 339.5, 7.42, 2404, 300.5, 6.24, 48.43, \
200, 160, 10, 64.57, 3527, 352.7, 7.39, 2496, 312, 6.22, 50.68, \
220, 100, 4, 24.55, 1519, 138.1, 7.87, 447.4, 89.49, 4.27, 19.27, \
220, 100, 4.5, 27.47, 1687, 153.4, 7.84, 495.4, 99.08, 4.25, 21.56, \
220, 100, 5, 30.36, 1851, 168.3, 7.81, 541.7, 108.34, 4.22, 23.83, \
220, 100, 5.5, 33.21, 2010, 182.7, 7.78, 586.3, 117.26, 4.2, 26.07, \
220, 100, 6, 36.03, 2164, 196.7, 7.75, 629.3, 125.86, 4.18, 28.29, \
220, 100, 6.5, 38.46, 2270, 206.3, 7.68, 661.6, 132.31, 4.15, 30.19, \
220, 100, 7, 41.16, 2408, 218.9, 7.65, 699.9, 139.99, 4.12, 32.31, \
220, 100, 7.5, 43.82, 2541, 231, 7.61, 736.6, 147.33, 4.1, 34.4, \
220, 100, 8, 46.44, 2669, 242.7, 7.58, 771.7, 154.34, 4.08, 36.46, \
220, 140, 5, 34.36, 2313, 210.3, 8.21, 1155, 165, 5.8, 26.97, \
220, 140, 5.5, 37.61, 2516, 228.7, 8.18, 1254, 179.2, 5.77, 29.52, \
220, 140, 6, 40.83, 2714, 246.7, 8.15, 1351, 193, 5.75, 32.05, \
220, 140, 6.5, 43.66, 2862, 260.2, 8.1, 1427, 203.7, 5.72, 34.27, \
220, 140, 7, 46.76, 3043, 276.6, 8.07, 1515, 216.5, 5.69, 36.7, \
220, 140, 7.5, 49.82, 3218, 292.6, 8.04, 1601, 228.7, 5.67, 39.11, \
220, 140, 8, 52.84, 3388, 308, 8.01, 1683, 240.5, 5.64, 41.48, \
240, 120, 5, 34.36, 2579, 215, 8.66, 882, 147, 5.07, 26.97, \
240, 120, 5.5, 37.61, 2805, 233.8, 8.64, 957, 159.5, 5.04, 29.52, \
240, 120, 6, 40.83, 3026, 252.1, 8.61, 1030, 171.6, 5.02, 32.05, \
240, 120, 6.5, 43.66, 3188, 265.6, 8.54, 1087, 181.2, 4.99, 34.27, \
240, 120, 7, 46.76, 3388, 282.4, 8.51, 1153, 192.2, 4.97, 36.7, \
240, 120, 7.5, 49.82, 3583, 298.6, 8.48, 1217, 202.8, 4.94, 39.11, \
240, 120, 8, 52.84, 3771, 314.3, 8.45, 1278, 213.1, 4.92, 41.48, \
240, 160, 6, 45.63, 3683, 306.9, 8.98, 1974, 246.8, 6.58, 35.82, \
240, 160, 6.5, 48.86, 3896, 324.7, 8.93, 2091, 261.4, 6.54, 38.35, \
240, 160, 7, 52.36, 4148, 345.7, 8.9, 2224, 278.1, 6.52, 41.1, \
240, 160, 7.5, 55.82, 4394, 366.2, 8.87, 2354, 294.2, 6.49, 43.82, \
240, 160, 8, 59.24, 4633, 386.1, 8.84, 2480, 309.9, 6.47, 46.51, \
240, 160, 8.5, 62.63, 4865, 405.4, 8.81, 2602, 325.2, 6.45, 49.16, \
240, 160, 9, 65.98, 5091, 424.2, 8.78, 2720, 340, 6.42, 51.79, \
240, 160, 9.5, 69.29, 5311, 442.5, 8.75, 2835, 354.3, 6.4, 54.39, \
240, 160, 10, 72.57, 5524, 460.3, 8.72, 2946, 368.2, 6.37, 56.96, \
240, 160, 10.5, 74.86, 5590, 465.8, 8.64, 2990, 373.8, 6.32, 58.76, \
240, 160, 11, 77.97, 5777, 481.4, 8.61, 3088, 386.1, 6.29, 61.2, \
240, 160, 11.5, 81.03, 5957, 496.4, 8.57, 3183, 397.8, 6.27, 63.61, \
240, 160, 12, 84.06, 6130, 510.9, 8.54, 3273, 409.2, 6.24, 65.99, \
250, 150, 6, 45.63, 3885, 310.8, 9.23, 1768, 235.7, 6.22, 35.82, \
250, 150, 6.5, 48.86, 4109, 328.7, 9.17, 1872, 249.6, 6.19, 38.35, \
250, 150, 7, 52.36, 4375, 350, 9.14, 1991, 265.4, 6.17, 41.1, \
250, 150, 7.5, 55.82, 4633, 370.7, 9.11, 2106, 280.8, 6.14, 43.82, \
250, 150, 8, 59.24, 4885, 390.8, 9.08, 2217, 295.7, 6.12, 46.51, \
260, 130, 6, 44.43, 3888, 299, 9.35, 1326, 204, 5.46, 34.88, \
260, 130, 6.5, 47.56, 4106, 315.8, 9.29, 1403, 215.8, 5.43, 37.33, \
260, 130, 7, 50.96, 4369, 336.1, 9.26, 1490, 229.2, 5.41, 40, \
260, 130, 7.5, 54.32, 4625, 355.8, 9.23, 1574, 242.2, 5.38, 42.64, \
260, 130, 8, 57.64, 4874, 374.9, 9.2, 1656, 254.8, 5.36, 45.25, \
260, 130, 8.5, 60.93, 5116, 393.5, 9.16, 1735, 266.9, 5.34, 47.83, \
260, 130, 9, 64.18, 5350, 411.6, 9.13, 1811, 278.6, 5.31, 50.38, \
260, 130, 9.5, 67.39, 5578, 429.1, 9.1, 1885, 290, 5.29, 52.9, \
260, 130, 10, 70.57, 5799, 446, 9.06, 1956, 300.9, 5.26, 55.39, \
260, 130, 10.5, 72.76, 5848, 449.8, 8.96, 1982, 305, 5.22, 57.12, \
260, 130, 11, 75.77, 6038, 464.5, 8.93, 2044, 314.5, 5.19, 59.48, \
260, 130, 11.5, 78.73, 6221, 478.6, 8.89, 2103, 323.6, 5.17, 61.81, \
260, 130, 12, 81.66, 6397, 492.1, 8.85, 2160, 332.3, 5.14, 64.1, \
300, 100, 6, 45.63, 4777, 318.4, 10.23, 841.4, 168.3, 4.29, 35.82, \
300, 100, 6.5, 48.86, 5038, 335.9, 10.15, 888.9, 177.8, 4.27, 38.35, \
300, 100, 7, 52.36, 5360, 357.3, 10.12, 942.1, 188.4, 4.24, 41.1, \
300, 100, 7.5, 55.82, 5673, 378.2, 10.08, 993.3, 198.7, 4.22, 43.82, \
300, 100, 8, 59.24, 5977, 398.5, 10.04, 1043, 208.5, 4.2, 46.51, \
300, 100, 8.5, 62.63, 6273, 418.2, 10.01, 1090, 218, 4.17, 49.16, \
300, 100, 9, 65.98, 6559, 437.3, 9.97, 1135, 227, 4.15, 51.79, \
300, 100, 9.5, 69.29, 6836, 455.8, 9.93, 1179, 235.7, 4.12, 54.39, \
300, 100, 10, 72.57, 7105, 473.7, 9.9, 1220, 244, 4.1, 56.96, \
300, 200, 6, 57.63, 7370, 491.3, 11.31, 3961, 396.1, 8.29, 45.24, \
300, 200, 6.5, 61.86, 7838, 522.5, 11.26, 4217, 421.7, 8.26, 48.56, \
300, 200, 7, 66.36, 8365, 557.7, 11.23, 4497, 449.7, 8.23, 52.09, \
300, 200, 7.5, 70.82, 8882, 592.1, 11.2, 4771, 477.1, 8.21, 55.59, \
300, 200, 8, 75.24, 9388, 625.9, 11.17, 5039, 503.9, 8.18, 59.07, \
300, 200, 8.5, 79.63, 9884, 658.9, 11.14, 5302, 530.2, 8.16, 62.51, \
300, 200, 9, 83.98, 10370, 691.3, 11.11, 5558, 555.8, 8.14, 65.92, \
300, 200, 9.5, 88.29, 10845, 723, 11.08, 5809, 580.9, 8.11, 69.31, \
300, 200, 10, 92.57, 11310, 754, 11.05, 6054, 605.4, 8.09, 72.66, \
300, 200, 10.5, 95.86, 11547, 769.8, 10.98, 6195, 619.5, 8.04, 75.25, \
300, 200, 11, 99.97, 11970, 798, 10.94, 6418, 641.8, 8.01, 78.47, \
300, 200, 11.5, 104, 12383, 825.5, 10.91, 6636, 663.6, 7.99, 81.67, \
300, 200, 12, 108.1, 12784, 852.3, 10.88, 6847, 684.7, 7.96, 84.83, \
320, 180, 6, 57.63, 8012, 500.8, 11.79, 3308, 367.5, 7.58, 45.24, \
320, 180, 6.5, 61.86, 8517, 532.3, 11.73, 3520, 391.1, 7.54, 48.56, \
320, 180, 7, 66.36, 9089, 568.1, 11.7, 3752, 416.9, 7.52, 52.09, \
320, 180, 7.5, 70.82, 9650, 603.1, 11.67, 3979, 442.2, 7.5, 55.59, \
320, 180, 8, 75.24, 10200, 637.5, 11.64, 4201, 466.8, 7.47, 59.07, \
320, 180, 8.5, 79.63, 10738, 671.1, 11.61, 4418, 490.9, 7.45, 62.51, \
320, 180, 9, 83.98, 11265, 704, 11.58, 4630, 514.4, 7.42, 65.92, \
320, 180, 9.5, 88.29, 11780, 736.3, 11.55, 4836, 537.4, 7.4, 69.31, \
320, 180, 10, 92.57, 12285, 767.8, 11.52, 5038, 559.7, 7.38, 72.66, \
320, 180, 10.5, 95.86, 12530, 783.1, 11.43, 5155, 572.7, 7.33, 75.25, \
320, 180, 11, 99.97, 12988, 811.7, 11.4, 5338, 593.1, 7.31, 78.47, \
320, 180, 11.5, 104, 13434, 839.6, 11.36, 5517, 613, 7.28, 81.67, \
320, 180, 12, 108.1, 13867, 866.7, 11.33, 5690, 632.2, 7.26, 84.83, \
350, 250, 6, 69.63, 12456, 711.8, 13.37, 7457, 596.6, 10.35, 54.66, \
350, 250, 6.5, 74.86, 13293, 759.6, 13.33, 7963, 637, 10.31, 58.76, \
350, 250, 7, 80.36, 14210, 812, 13.3, 8508, 680.6, 10.29, 63.08, \
350, 250, 7.5, 85.82, 15112, 863.5, 13.27, 9044, 723.5, 10.27, 67.37, \
350, 250, 8, 91.24, 15999, 914.3, 13.24, 9570, 765.6, 10.24, 71.63, \
350, 250, 8.5, 96.63, 16872, 964.1, 13.21, 10087, 807, 10.22, 75.85, \
350, 250, 9, 102, 17731, 1013, 13.19, 10595, 847.6, 10.19, 80.05, \
350, 250, 9.5, 107.3, 18575, 1061, 13.16, 11094, 887.5, 10.17, 84.22, \
350, 250, 10, 112.6, 19404, 1109, 13.13, 11583, 926.7, 10.14, 88.36, \
350, 250, 10.5, 116.9, 19923, 1138, 13.06, 11912, 952.9, 10.1, 91.73, \
350, 250, 11, 122, 20694, 1183, 13.03, 12368, 989.5, 10.07, 95.74, \
350, 250, 11.5, 127, 21451, 1226, 12.99, 12815, 1025, 10.04, 99.72,\
350, 250, 12, 132.1, 22191, 1268, 12.96, 13253, 1060, 10.02, 103.7, \
350, 300, 6, 75.63, 14232, 813.2, 13.72, 11259, 750.6, 12.2, 59.37, \
350, 300, 6.5, 81.36, 15210, 869.2, 13.67, 12037, 802.5, 12.16, 63.87, \
350, 300, 7, 87.36, 16269, 929.6, 13.65, 12872, 858.1, 12.14, 68.58, \
350, 300, 7.5, 93.32, 17312, 989.2, 13.62, 13694, 912.9, 12.11, 73.26, \
350, 300, 8, 99.24, 18339, 1048, 13.59, 14504, 966.9, 12.09, 77.91, \
350, 300, 8.5, 105.1, 19351, 1106, 13.57, 15301, 1020, 12.06, 82.53, \
350, 300, 9, 111, 20347, 1163, 13.54, 16086, 1072, 12.04, 87.12, \
350, 300, 9.5, 116.8, 21328, 1219, 13.51, 16858, 1124, 12.01, 91.68, \
350, 300, 10, 122.6, 22294, 1274, 13.49, 17618, 1175, 11.99, 96.21, \
350, 300, 10.5, 127.4, 22948, 1311, 13.42, 18147, 1210, 11.94, 99.98, \
350, 300, 11, 133, 23855, 1363, 13.39, 18861, 1257, 11.91, 104.4, \
350, 300, 11.5, 138.5, 24745, 1414, 13.36, 19561, 1304, 11.88, 108.7, \
350, 300, 12, 144.1, 25619, 1464, 13.34, 20249, 1350, 11.86, 113.1, \
380, 220, 6, 69.63, 13885, 730.8, 14.12, 6011, 546.4, 9.29, 54.66, \
380, 220, 6.5, 74.86, 14810, 779.5, 14.07, 6418, 583.4, 9.26, 58.76, \
380, 220, 7, 80.36, 15831, 833.2, 14.04, 6854, 623.1, 9.24, 63.08, \
380, 220, 7.5, 85.82, 16836, 886.1, 14.01, 7282, 662, 9.21, 67.37, \
380, 220, 8, 91.24, 17824, 938.1, 13.98, 7703, 700.3, 9.19, 71.63, \
380, 220, 10, 112.6, 23000, 1150, 14.29, 7859, 785.9, 8.36, 88.36, \
380, 220, 10.5, 116.9, 23577, 1179, 14.2, 8080, 808, 8.32, 91.73, \
400, 200, 11, 122, 24485, 1224, 14.17, 8383, 838.3, 8.29, 95.74, \
400, 200, 11.5, 127, 25374, 1269, 14.13, 8679, 867.9, 8.27, 99.72, \
400, 200, 12, 132.1, 26245, 1312, 14.1, 8968, 896.8, 8.24, 103.7}

#define N_CHANNEL     18
#define CHANNEL    {50, 32, 4.4, 7.0, 6.16, 4.84, 22.8, 9.1, 1.92, 5.59, 5.61, 2.75, 0.95, 6.0, 2.5, 1.16, \
65, 36, 4.4,  7.2, 7.51, 5.90, 48.6, 15.0, 2.54, 9.00, 8.70, 3.68, 1.08, 6.0, 2.5, 1.24, \
80, 40, 4.5,  7.4, 8.98, 7.05, 89.4, 22.4, 3.16, 23.30, 12.80, 4.75, 1.19, 6.5, 2.5, 1.31, \
100, 46, 4.5,  7.6, 10.90, 8.59, 174.0, 34.8, 3.99, 20.40, 20.40, 6.46, 1.37, 7.0, 3.0, 1.44, \
120, 52, 4.8,  7.8, 13.30, 10.40, 304.0, 50.6, 4.78, 29.60, 31.20, 8.52, 1.53, 7.5, 3.0, 1.54, \
140, 58, 4.9,  8.1, 15.60, 12.30, 491.0, 70.2, 5.60, 40.80, 45.40, 11.00, 1.70, 8.0, 3.0, 1.67, \
160, 64, 5.0,  8.4, 18.10, 14.20, 747.0, 93.4, 6.42, 54.10, 63.30, 13.80, 1.87, 8.5, 3.5, 1.80, \
160, 68, 5.0,  9.0, 19.50, 15.30, 823.0, 103.0, 6.49, 59.40, 78.80, 16.40, 2.01, 8.5, 3.5, 2.00, \
180, 70, 5.1,  8.7, 20.70, 16.30, 1090.0, 121.0, 7.24, 69.80, 86.00, 17.00, 2.04, 9.0, 3.5, 1.94, \
180, 74, 5.1,  9.3, 22.20, 17.40, 1190.0, 132.0, 7.32, 76.10, 105.00, 20.00, 2.18, 9.0, 3.5, 2.13, \
200, 76, 5.2,  9.0, 23.40, 18.40, 1520.0, 152.0, 8.07, 87.80, 113.00, 20.50, 2.20, 9.5, 4.0, 2.07, \
220, 82, 5.4,  9.5, 26.70, 21.00, 2110.0, 192.0, 8.89, 110.00, 151.00, 25.10, 2.37, 10.0, 4.0, 2.21, \
240, 90, 5.6,  10.0, 30.60, 24.00, 2900.0, 242.0, 9.73, 139.00, 208.00, 31.60, 2.60, 10.5, 4.0, 2.42, \
270, 95, 6.0,  10.5, 35.20, 27.70, 4160.0, 308.0, 10.90, 178.00, 262.00, 37.30, 2.73, 11.0, 4.5, 2.47, \
300, 100, 6.5,  11.0, 40.50, 31.80, 5810.0, 387.0, 12.00, 224.00, 327.00, 43.60, 2.84, 12.0, 5.0, 2.52, \
330, 105, 7.0,  11.7, 46.50, 36.50, 7980.0, 484.0, 13.10, 281.00, 410.00, 51.80, 2.97, 13.0, 5.0, 2.59, \
360, 110, 7.5,  12.6, 53.40, 41.90, 10820.0, 601.0, 14.20, 350.00, 513.00, 61.70, 3.10, 14.0, 6.0, 2.68, \
400, 115, 8.0,  13.5, 61.50, 48.30, 15220.0, 761.0, 15.70, 444.00, 642.00, 73.40, 3.23, 15.0, 6.0, 2.75}
//    
//                      xa    Iw     w1      w2       Ww1   Ww2     Itor     R =sqrt(GItor/EIw)
#define CHANNEL_SECTOR {1.16, 16,     2.36,  3.58,   6.91,   4.55,    0.93,  0.14854, \
                       1.24, 47,     3.50,  5.63,   13.48,   8.38,    1.16,  0.09741, \
                       1.31, 112,    4.81,  8.08,   23.30,   13.85,   1.43,  0.07014, \
                       1.33, 290,    7,     12.4,   41.3,    23.3,    1.8,   0.04845, \
                       1.47, 653,    9.4,   17.4,   69.5,    37.5,    2.3,   0.03631, \
					   1.64, 1319,   12.2,  23.2,   108,     57,      2.8,   0.02857, \
					   1.82, 2449,   15.4,  29.7,   159.6,   82.4,    3.5,   0.02327, \
                       1.90, 3387,   16.99, 30.57,  199.33,  110.80,  4.36,  0.02226, \
					   1.98, 4261,   18.8,  37.1,   226.8,   114.7,   4.2,   0.01943, \
					   2.13, 5896,   20.81, 38.00,  283.33,  155.18,  5.24,  0.01849, \
					   2.16, 7022,   22.7,  45.2,   309.5,   155.3,   5.1,   0.01657, \
					   2.33, 11330,  26.9,  54,     421.5,   209.9,   6.4,   0.01466, \
					   2.58, 18680,  32.3,  64.9,   578.9,   287.8,   8.2,   0.01286, \
					   2.66, 30070,  37.8,  78.2,   796.1,   384.6,   10.2,  0.01134, \
					   2.72, 46640,  43.3,  92.8,   1077.9,  502.6,   12.8,  0.01019, \
					   2.81, 82700,  50.60, 105.37, 1634.56, 784.84,  16.48, 0.00876, \
					   2.91, 123010, 56.89, 121.16, 2162.36, 1015.31, 21.70, 0.00824, \
					   3.00, 164800, 64.8,  144.8,  2542.7,  1138.5,  28.3,  0.00806}

#define NAME_CHANNEL  {"5", "6,5", "8", "10", "12", "14", "16", "16", "18", "18", "20", "22", "24", "27", "30", "33", "36", "40"}

//  
#define N_GOST_G57837DB    77
// :           0- h,  1-b,     2-s,   3-t,   4-A,    5-P,    6-Iy,     7-Wy,    8-Sy,   9-iy,  10-Iz,   11-Wz, 12-iz, 13-R
#define GOST_G57837DB {207, 133, 5.8, 8.4, 33.87, 26.6, 2580.37, 249.3, 139.48, 87.28, 329.79, 49.59, 31.2, 7.6, \
210, 134, 6.4, 10.2, 39.97, 31.4, 3137, 298.8, 167.61, 88.6, 409.58, 61.13, 32.01, 7.6, \
251, 146, 6, 8.6, 39.64, 31.1, 4395.18, 350.2, 196.03, 105.3, 446.61, 61.18, 33.57, 7.6, \
256, 146, 6.3, 10.9, 47.08, 37, 5523.69, 431.5, 241.08, 108.32, 565.99, 77.53, 34.67, 7.6, \
260, 147, 7.2, 12.7, 54.73, 43, 6554.72, 504.2, 283.24, 109.44, 673.24, 91.6, 35.07, 7.6, \
258, 146, 6.1, 9.1, 41.7, 32.7, 4887.5, 378.9, 212.12, 108.27, 472.58, 64.74, 33.67, 7.6, \
262, 147, 6.6, 11.2, 49.24, 38.7, 6007.11, 458.6, 256.75, 110.45, 593.66, 80.77, 34.72, 7.6, \
266, 148, 7.6, 13, 57.22, 44.9, 7108.01, 534.4, 301.04, 111.46, 703.43, 95.06, 35.06, 7.6, \
309, 102, 6, 8.9, 36.12, 28.4, 5426.36, 351.2, 203.38, 122.56, 158.06, 30.99, 20.92, 7.6, \
313, 102, 6.6, 10.8, 41.76, 32.8, 6496.06, 415.1, 240.08, 124.72, 191.85, 37.62, 21.43, 7.6, \
310, 165, 5.8, 9.7, 49.54, 38.9, 8544.97, 551.3, 306.41, 131.33, 726.88, 88.11, 38.3, 8.9, \
313, 166, 6.6, 11.2, 57.04, 44.8, 9960.39, 636.5, 355.1, 132.14, 854.77, 102.98, 38.71, 8.9, \
317, 167, 7.6, 13.2, 66.85, 52.5, 11873.01, 749.1, 419.95, 133.27, 1025.95, 122.87, 39.17, 8.9, \
303, 165, 6, 10.2, 51.3, 40.3, 8477.69, 559.6, 311.02, 128.56, 764.36, 92.65, 38.6, 8.9, \
307, 166, 6.7, 11.8, 58.84, 46.2, 9942.92, 647.8, 361.13, 129.99, 900.53, 108.5, 39.12, 8.9, \
310, 167, 7.9, 13.7, 68.76, 54, 11668.1, 752.8, 422.55, 130.26, 1064.87, 127.53, 39.35, 8.9, \
349, 127, 5.8, 8.5, 41.74, 32.8, 8267.33, 473.8, 271.01, 140.74, 291, 45.83, 26.4, 10.2, \
353, 128, 6.5, 10.7, 49.84, 39.1, 10240.24, 580.2, 331.05, 143.34, 375.06, 58.6, 27.43, 10.2, \
352, 171, 6.9, 9.8, 57.34, 45, 12166.36, 691.3, 389.35, 145.66, 817.94, 95.67, 37.77, 10.2, \
355, 171, 7.2, 11.6, 64.45, 50.6, 14130.93, 796.1, 446.97, 148.07, 968.08, 113.23, 38.76, 10.2, \
358, 172, 7.9, 13.1, 72.17, 56.7, 16051.94, 896.8, 504.59, 149.14, 1112.72, 129.39, 39.27, 10.2, \
363, 173.2, 9.1, 15.7, 85.45, 67.1, 19414.43, 1069.7, 604.58, 150.73, 1362.07, 157.28, 39.92, 10.2, \
353, 254, 9.5, 16.4, 115.93, 91, 26754.31, 1515.8, 840.02, 151.92, 4483.14, 353, 62.19, 16, \
357, 255, 10.5, 18.3, 129.17, 101.4, 30209.8, 1692.4, 942.22, 152.93, 5062.32, 397.04, 62.6, 16, \
360, 256, 11.4, 19.9, 140.59, 110.4, 33153.98, 1841.9, 1029.6, 153.57, 5570.48, 435.19, 62.95, 16, \
363, 257, 13, 21.7, 155.28, 121.9, 36598.33, 2016.4, 1134.85, 153.52, 6147.42, 478.4, 62.92, 16, \
399, 140, 6.4, 8.8, 49.94, 39.2, 12656.64, 634.4, 365.15, 159.19, 403.59, 57.66, 28.43, 10.2, \
403, 140, 7, 11.2, 58.9, 46.2, 15570.06, 772.7, 442.32, 162.59, 513.63, 73.38, 29.53, 10.2, \
403, 177, 7.5, 10.9, 68.07, 53.4, 18613.44, 923.7, 522.88, 165.36, 1009.08, 114.02, 38.5, 10.2, \
407, 178, 7.7, 12.8, 75.83, 59.5, 21585.78, 1060.7, 597.5, 168.72, 1204.97, 135.39, 39.86, 10.2, \
410, 179, 8.8, 14.4, 85.99, 67.5, 24557.5, 1197.9, 678.1, 168.99, 1379.08, 154.09, 40.05, 10.2, \
413, 180, 9.7, 16, 95.45, 74.9, 27495.01, 1331.5, 756.09, 169.72, 1558.58, 173.18, 40.41, 10.2, \
417, 181, 10.9, 18.2, 108.26, 85, 31537.51, 1512.6, 862.63, 170.68, 1803.36, 199.27, 40.81, 10.2, \
450, 152, 7.6, 10.8, 66.28, 52, 21216.72, 943, 544.31, 178.91, 634.06, 83.43, 30.93, 10.2, \
455, 153, 8, 13.3, 75.86, 59.6, 25498.98, 1120.8, 642.4, 183.34, 796.13, 104.07, 32.39, 10.2, \
459, 154, 9.1, 15.4, 87.29, 68.5, 29698.29, 1294, 744.05, 184.45, 940.55, 122.15, 32.83, 10.2, \
462, 154.4, 9.6, 17, 94.48, 74.2, 32674.03, 1414.5, 813.29, 185.97, 1046.53, 135.56, 33.28, 10.2, \
466, 155.3, 10.5, 18.9, 104.56, 82.1, 36624.87, 1571.9, 906.27, 187.16, 1184.51, 152.55, 33.66, 10.2, \
453, 189.9, 8.5, 12.7, 85.47, 67.1, 29321.46, 1294.6, 734.66, 185.22, 1452.13, 152.94, 41.22, 10.2, \
457, 190, 9, 14.5, 94.51, 74.2, 33262.54, 1455.7, 825.08, 187.6, 1660.63, 174.8, 41.92, 10.2, \
460, 191, 9.9, 16, 104.39, 81.9, 37004.02, 1608.9, 914.58, 188.28, 1862.06, 194.98, 42.24, 10.2, \
463, 192, 10.5, 17.7, 113.76, 89.3, 40952.17, 1769, 1006.08, 189.73, 2092.64, 217.98, 42.89, 10.2, \
466, 193, 11.4, 19, 123.03, 96.6, 44505.67, 1910.1, 1090.07, 190.2, 2282.42, 236.52, 43.07, 10.2, \
469, 194, 12.6, 20.6, 134.72, 105.8, 48825.33, 2082.1, 1193.69, 190.37, 2514.63, 259.24, 43.2, 10.2, \
524, 207, 9, 10.9, 91.7, 72, 40061.27, 1529.06, 880.05, 209.02, 1615.22, 156.06, 41.97, 12.7, \
528, 209, 9.5, 13.3, 104.4, 82, 47614.76, 1802.34, 1031.03, 213.56, 2028.08, 194.04, 44.07, 12.7, \
533, 209, 10.2, 15.6, 117.78, 92.5, 55246.34, 2073, 1181.69, 216.58, 2379.01, 227.66, 44.94, 12.7, \
537, 210, 10.9, 17.4, 129.2, 101.4, 61702.67, 2298.1, 1310.12, 218.53, 2692.14, 256.39, 45.65, 12.7, \
539, 211, 11.6, 18.8, 138.88, 109, 66731.56, 2476.1, 1413.46, 219.2, 2951.06, 279.72, 46.1, 12.7, \
544, 212, 13.1, 21.2, 156.98, 123.2, 76082.72, 2797.2, 1604, 220.15, 3377.3, 318.61, 46.38, 12.7, \
549, 214, 14.7, 23.6, 176.16, 138.3, 86084.33, 3136, 1806.6, 221.06, 3869.6, 361.64, 46.87, 12.7, \
599, 178, 10, 12.8, 104.29, 81.9, 55978.87, 1869.1, 1098.43, 231.68, 1208.85, 135.83, 34.05, 12.7, \
603, 179, 10.9, 15, 117.54, 92.3, 64629.04, 2143.6, 1256.38, 234.49, 1441.05, 161.01, 35.01, 12.7, \
603, 228, 10.5, 14.9, 129.51, 101.7, 76354.38, 2532.5, 1449.82, 242.81, 2949.85, 258.76, 47.72, 12.7, \
608, 228, 11.2, 17.3, 144.49, 113.4, 87546.5, 2879.8, 1644.93, 246.15, 3425.21, 300.46, 48.69, 12.7, \
612, 229, 11.9, 19.6, 159.32, 125.1, 98536.48, 3220.2, 1837.14, 248.7, 3932.13, 343.42, 49.68, 12.7, \
617, 230, 13.1, 22.2, 178.52, 140.1, 111971.15, 3629.5, 2075.04, 250.45, 4513.82, 392.51, 50.28, 12.7, \
623, 229, 14, 24.9, 195.67, 153, 125134.4, 4017.16, 2299.86, 252.89, 4998.26, 436.53, 50.54, 12.7, \
678, 253, 11.7, 16.3, 160, 125, 118774.6, 3500.58, 2007.66, 272.46, 4409.92, 348.61, 52.5, 15.7, \
684, 254, 12.4, 18.9, 177.99, 140, 135901.8, 3974.9, 2272.61, 276.32, 5155.91, 406.46, 53.82, 15.7, \
688, 254, 13.1, 21.1, 193.94, 152, 150835.9, 4384.76, 2504.54, 278.88, 5804.27, 456.31, 54.71, 15.7, \
693, 256, 14.5, 23.6, 216.45, 170, 169986.5, 4905.82, 2809.71, 280.24, 6617.85, 517.01, 55.29, 15.7, \
702, 254, 15.5, 27.9, 243.88, 192, 197984.5, 5640.58, 3229.29, 284.92, 7642.66, 601.78, 55.98, 15.7, \
835, 292, 14, 18.8, 224.15, 176, 246276.8, 5898.85, 3406.71, 331.47, 7822.9, 535.82, 59.08, 17, \
840, 292, 14.7, 21.7, 246.55, 193, 278350.2, 6627.38, 3812.25, 336, 9029.33, 618.45, 60.52, 17, \
846, 293, 15.4, 24.4, 268.47, 210, 310620.9, 7343.28, 4213.95, 340.15, 10257.47, 700.17, 61.81, 17, \
851, 294, 16.1, 26.8, 288.69, 226, 339977.2, 7990.06, 4580.28, 343.17, 11382.74, 774.34, 62.79, 17, \
859, 292, 17, 31, 319.25, 251, 386394.3, 8996.38, 5150.94, 347.9, 12900.66, 883.61, 63.57, 17, \
903, 304, 15.2, 20.1, 256.57, 201, 325421.4, 7207.48, 4180.97, 356.14, 9441.91, 621.18, 60.66, 18.2, \
911, 304, 15.9, 23.9, 284.93, 223, 376536.8, 8266.36, 4762.44, 363.53, 11224.62, 738.46, 62.76, 18.2, \
915, 305, 16.5, 25.9, 303.2, 238, 406354.5, 8878.27, 5117.5, 366.09, 12285.06, 805.49, 63.65, 18.2, \
919, 306, 17.3, 27.9, 324.05, 253, 438001.8, 9532.11, 5487.32, 367.65, 13366.98, 873.66, 64.23, 18.2, \
923, 307, 18.4, 30, 346.12, 271, 471631.3, 10219.53, 5892.69, 369.14, 14518.1, 945.8, 64.77, 18.2, \
927, 308, 19.4, 32, 367.67, 289, 504537.3, 10885.38, 6283.65, 370.44, 15642.01, 1015.71, 65.23, 18.2, \
970, 300, 16, 21.1, 282.77, 222, 407664.4, 8405.45, 4901.99, 379.69, 9545.79, 636.39, 58.1, 29, \
980, 300, 16.5, 26, 316.84, 249, 481076.7, 9817.89, 5673.02, 389.66, 11754.44, 783.51, 60.91, 29, \
990, 300, 16.5, 31, 346.84, 272, 553844.2, 11188.77, 6411.34, 399.6, 14004.44, 933.5, 63.54, 29 }


#define NAME_GOST_G57837DB  {"201", "202", "251", "252", "253", "254", "255", "256", "301",\
							 "302", "303", "304", "305", "306", "307", "308", "351", "352",\
							 "353", "354", "355", "356", "357", "358", "359", "3510", "401",\
							 "402", "403", "404", "405", "406", "407", "451", "452", "453",\
							 "454", "455", "456", "457", "458", "459", "4510", "4511", "531",\
							 "532", "533",\
							 "534", "535", "536", "537", "601", "602", "603", "604", "605", "606",\
							 "607", "701", "702", "703", "704", "705", "851", "852", "853", "854",\
							 "855", "901", "902", "903", "904", "905", "906", "1001", "1002", "1003"}

#define N_GOST_G57837Sh    74      // 
// :           0- h,  1-b,     2-s,   3-t,   4-A,    5-P,    6-Iy,     7-Wy,    8-Sy,   9-iy,  10-Iz,   11-Wz, 12-iz, 13-R
#define GOST_G57837Sh {190, 149, 5, 7, 31.11, 24.4, 2079.6, 218.9, 120.97, 81.76, 386.62, 51.9, 35.25, 13, \
194, 150, 6, 9, 39.01, 30.6, 2689.74, 277.3, 154.28, 83.04, 507.16, 67.62, 36.06, 13, \
199, 151, 7.5, 11.5, 49.38, 38.8, 3502.14, 352, 198.01, 84.21, 661.25, 87.58, 36.59, 13, \
204, 152, 9, 14, 59.85, 47, 4362.01, 427.7, 243.18, 85.37, 821.37, 108.08, 37.05, 13, \
211, 155, 11, 17.5, 75.06, 58.9, 5696.83, 540, 311.2, 87.12, 1089.19, 140.54, 38.09, 13, \
218, 157, 13, 21, 90.27, 70.9, 7117.64, 653, 381.26, 88.8, 1359.05, 173.13, 38.8, 13, \
228, 159, 16, 26, 112.29, 88.2, 9312.8, 816.9, 485.66, 91.07, 1749.68, 220.09, 39.47, 13, \
240, 174, 6, 9, 46.84, 36.8, 4981.13, 415.1, 229.64, 103.13, 791.75, 91.01, 41.11, 16, \
244, 175, 7, 11, 56.24, 44.2, 6121.23, 501.7, 279.19, 104.33, 984.48, 112.51, 41.84, 16, \
249, 176, 8.5, 13.5, 68.59, 53.8, 7624.69, 612.4, 343.94, 105.44, 1229.33, 139.7, 42.34, 16, \
256, 177, 10.5, 17, 85.69, 67.3, 9819.49, 767.2, 436.06, 107.05, 1575.2, 177.99, 42.88, 16, \
264, 182, 13, 21, 107.5, 84.4, 12751.44, 966, 556.26, 108.91, 2116.49, 232.58, 44.37, 16, \
274, 184, 16, 26, 133.4, 104.7, 16478.26, 1202.8, 703.59, 111.14, 2710.17, 294.58, 45.07, 16, \
286, 186, 19, 32, 163.42, 128.3, 21287.68, 1488.7, 884.76, 114.13, 3448.57, 370.81, 45.94, 16, \
290, 199, 7, 10, 61.48, 48.3, 9429.75, 650.3, 360.6, 123.85, 1316.09, 132.27, 46.27, 18, \
294, 200, 8, 12, 72.38, 56.8, 11338.3, 771.3, 429.51, 125.16, 1603.26, 160.33, 47.06, 18, \
300, 201, 9, 15, 87.38, 68.6, 14209.66, 947.3, 529.86, 127.52, 2034.13, 202.4, 48.25, 18, \
306, 203, 11, 18, 105.56, 82.9, 17455.33, 1140.9, 644.63, 128.59, 2515.46, 247.83, 48.82, 18, \
314, 206, 13, 22, 128.52, 100.9, 21967.16, 1399.2, 798.35, 130.74, 3213.67, 312.01, 50, 18, \
326, 208, 16, 28, 162.46, 127.5, 29037.68, 1781.5, 1031.79, 133.69, 4213.04, 405.1, 50.92, 18, \
342, 210, 20, 36, 207.98, 163.3, 39315.66, 2299.2, 1357.14, 137.49, 5580.38, 531.47, 51.8, 18, \
334, 249, 8, 11, 83.17, 65.3, 17107.05, 1024.4, 565.71, 143.42, 2834.62, 227.68, 58.38, 20, \
340, 250, 9, 14, 101.51, 79.7, 21676.5, 1275.1, 706.03, 146.13, 3650.97, 292.08, 59.97, 20, \
347, 252, 11, 17.5, 125.95, 98.9, 27535.21, 1587, 886.41, 147.86, 4674.9, 371.02, 60.92, 20, \
354, 254, 13, 21, 150.67, 118.3, 33692.45, 1903.5, 1072.31, 149.54, 5745.8, 452.43, 61.75, 20, \
364, 258, 16, 26, 187.51, 147.2, 43231.44, 2375.4, 1354.36, 151.84, 7458.32, 578.16, 63.07, 20, \
376, 260, 19, 32, 229.11, 179.9, 54967.48, 2923.8, 1688.25, 154.89, 9398.88, 722.99, 64.05, 20, \
392, 262, 23, 40, 284.79, 223.6, 71815.25, 3664, 2150.36, 158.8, 12030.69, 918.37, 65, 20, \
383, 299, 9.5, 12.5, 112.91, 88.6, 30554.32, 1595.5, 880.73, 164.5, 5576.08, 372.98, 70.27, 22, \
390, 300, 10, 16, 135.95, 106.7, 38674.1, 1983.3, 1093.97, 168.66, 7207.77, 480.52, 72.81, 22, \
397, 302, 12, 19.5, 164.89, 129.4, 47846.38, 2410.4, 1339.96, 170.34, 8962.48, 593.54, 73.72, 22, \
406, 304, 14.5, 24, 201.98, 158.6, 60107.1, 2960.9, 1662, 172.51, 11253.74, 740.38, 74.64, 22, \
418, 309, 17.5, 30, 252.2, 198, 77867.25, 3725.7, 2114.9, 175.71, 14776.27, 956.39, 76.54, 22, \
430, 311, 21, 36, 303.25, 238.1, 96432.24, 4485.2, 2578.21, 178.32, 18086.35, 1163.11, 77.23, 22, \
446, 313, 25, 44, 369.09, 289.7, 122543.61, 5495.2, 3204.85, 182.21, 22547.07, 1440.71, 78.16, 22, \
434, 299, 10, 15, 135.04, 106, 46794.17, 2156.4, 1192.24, 186.15, 6692.4, 447.65, 70.4, 24, \
440, 300, 11, 18, 157.38, 123.6, 56069.13, 2548.6, 1412.44, 188.75, 8111.31, 540.75, 71.79, 24, \
446, 302, 13, 21, 184.3, 144.7, 66379.08, 2976.6, 1661.51, 189.78, 9655.62, 639.44, 72.38, 24, \
452, 304, 15, 24, 211.46, 166, 77050.83, 3409.3, 1915.99, 190.88, 11258.33, 740.68, 72.97, 24, \
464, 308, 18, 30, 262.46, 206, 98962.82, 4265.6, 2420.93, 194.18, 14639.89, 950.64, 74.69, 24, \
476, 310, 21, 36, 312.98, 245.7, 121722.09, 5114.4, 2932.26, 197.21, 17919.22, 1156.08, 75.67, 24, \
492, 312, 25, 44, 380.5, 298.7, 153856.39, 6254.3, 3633.74, 201.08, 22341.69, 1432.16, 76.63, 24, \
482, 300, 11, 15, 145.52, 114.2, 60366.76, 2504.8, 1395.56, 203.67, 6763.81, 450.92, 68.18, 26, \
487, 300, 14.5, 17.5, 176.34, 138.4, 71863.01, 2951.3, 1666.63, 201.87, 7897.76, 526.52, 66.92, 26, \
493, 300, 15.5, 20.5, 198.86, 156.1, 83437.19, 3384.9, 1912.66, 204.83, 9251.07, 616.74, 68.21, 26, \
499, 300, 16.5, 23.5, 221.38, 173.8, 95277.59, 3818.7, 2161.4, 207.45, 10604.77, 706.98, 69.21, 26, \
508, 302, 19, 28, 260.8, 204.7, 114959.83, 4526, 2578.55, 209.95, 12894.5, 853.94, 70.31, 26, \
518, 310, 22, 33, 309.84, 243.2, 140248.12, 5415, 3106.5, 212.75, 16442.93, 1060.83, 72.85, 26, \
532, 312, 26, 40, 372.92, 292.7, 174203.77, 6549, 3797.96, 216.13, 20335.66, 1303.57, 73.84, 26, \
548, 314, 30, 48, 442.84, 347.6, 214879.98, 7842.3, 4598.03, 220.28, 24895.52, 1585.7, 74.98, 26, \
582, 300, 12, 17, 174.49, 137, 102709.98, 3529.6, 1981.3, 242.62, 7669.85, 511.32, 66.3, 28, \
589, 300, 16, 20.5, 217.41, 170.7, 126193.28, 4285, 2438.84, 240.92, 9259.23, 617.28, 65.26, 28, \
597, 300, 18, 24.5, 252.37, 198.1, 150035.32, 5026.3, 2869.72, 243.82, 11069.15, 737.94, 66.23, 28, \
605, 300, 20, 28.5, 287.33, 225.6, 174450.48, 5767, 3305.39, 246.4, 12881.17, 858.74, 66.96, 28, \
616, 302, 23, 34, 338.13, 265.4, 210467.04, 6833.4, 3941.46, 249.49, 15686.68, 1038.85, 68.11, 28, \
630, 315, 27, 41, 412.99, 324.2, 266239.93, 8452.1, 4907.09, 253.9, 21476.18, 1363.57, 72.11, 28, \
644, 317, 31, 48, 480.93, 377.5, 318172.04, 9881.1, 5788.14, 257.21, 25653.76, 1618.53, 73.04, 28, \
664, 319, 36, 58, 574.05, 450.6, 394963.73, 11896.5, 7047.57, 262.3, 31634.21, 1983.34, 74.23, 28, \
692, 300, 13, 20, 211.49, 166, 172424.05, 4983.4, 2814.39, 285.53, 9024.74, 601.65, 65.32, 28, \
698, 300, 15, 23, 242.53, 190.4, 198779.77, 5695.7, 3233.41, 286.29, 10382.92, 692.19, 65.43, 28, \
707, 300, 18, 27.5, 289.09, 226.9, 239021.1, 6761.6, 3867.01, 287.54, 12424.2, 828.28, 65.56, 28, \
715, 300, 20.5, 31.5, 329.39, 258.6, 275127.01, 7695.9, 4426.46, 289.01, 14242, 949.47, 65.76, 28, \
725, 300, 23, 36.5, 375.69, 294.9, 319781.96, 8821.6, 5099.3, 291.75, 16514.18, 1100.95, 66.3, 28, \
740, 313, 27, 44, 458.21, 359.7, 403258.33, 10898.9, 6334.98, 296.66, 22622.21, 1445.51, 70.26, 28, \
758, 315, 32, 53, 549.27, 431.2, 496466.98, 13099.4, 7693, 300.64, 27822.58, 1766.51, 71.17, 28, \
780, 317, 38, 64, 660.25, 518.3, 616075.38, 15796.8, 9389.94, 305.47, 34321.6, 2165.4, 72.1, 28, \
782, 300, 13.5, 17, 209.71, 164.6, 205458, 5254.7, 3018.9, 313.01, 7676.7, 511.8, 60.5, 28, \
792, 300, 14, 22, 243.45, 191.1, 253655, 6405.4, 3644.1, 322.79, 9928.9, 661.9, 63.86, 28, \
881, 299, 15, 18.5, 243.96, 191.5, 292583, 6642.1, 3861.2, 346.31, 8278.5, 553.7, 58.25, 28, \
890, 299, 15, 23, 270.87, 212.6, 345335, 7760.3, 4457, 357.06, 10283.3, 687.8, 61.61, 28, \
990, 320, 16, 21, 293.82, 230.6, 446000, 9011, 5234, 389.61, 11520, 719.9, 62.62, 30, \
998, 320, 17, 25, 328.9, 258.2, 516400, 10350, 5980, 396.24, 13710, 856.9, 64.56, 30, \
1006, 320, 18, 29, 364, 285.7, 587700, 11680, 6736, 401.82, 15900, 993.9, 66.09, 30, \
1013, 320, 19.5, 32.5, 400.6, 314.5, 655400, 12940, 7470, 404.48, 17830, 1114.3, 66.71, 30}


#define NAME_GOST_G57837Sh  {"200", "201", "202", "203", "204", "205", "206", "250", "251", "252", "253",\
							 "254", "255", "256", "300", "301", "302", "303", "304", "305", "306", "351",\
							 "352", "353", "354", "355", "356", "357", "401", "402", "403", "404", "405",\
							 "406", "407", "450", "451", "452", "453", "454", "455", "456", "501", "502",\
							 "503", "504", "505", "506", "507", "508", "601", "602", "603", "604", "605",\
							 "606", "607", "608", "701", "702", "703", "704", "705", "706", "707", "708",\
							 "801", "802", "901", "902", "1001", "1002","1003","1004"}

#define N_GOST_G57837_K    89      // 

// h	b	s	t	F	m	Iz	Wz	Sz	iz	Iy	Wy	iy	r
#define GOST_G57837_K {147, 149, 6, 8.5, 34.17, 26.8, 1366.76, 186, 103.63, 63.25, 469.21, 62.98, 37.06, 11,\
150, 150, 7, 10, 40.14, 31.5, 1641.33, 218.8, 123.04, 63.95, 563.28, 75.1, 37.46, 11,\
155, 151, 8.5, 12.5, 49.84, 39.1, 2117.61, 273.2, 155.69, 65.18, 718.46, 95.16, 37.97, 11,\
160, 152, 10, 15, 59.64, 46.8, 2629.16, 328.6, 189.67, 66.4, 879.66, 115.74, 38.41, 11,\
166, 153, 12, 18, 71.72, 56.3, 3291.43, 396.6, 232.39, 67.74, 1077.13, 140.8, 38.75, 11,\
196, 199, 6.5, 10, 52.69, 41.4, 3846.06, 392.5, 216.41, 85.44, 1314.47, 132.11, 49.95, 13,\
200, 200, 8, 12, 63.53, 49.9, 4715.63, 471.6, 262.75, 86.15, 1601.53, 160.15, 50.21, 13,\
204, 201, 9, 14, 73.57, 57.8, 5602.48, 549.3, 308.35, 87.26, 1896.76, 188.73, 50.78, 13,\
210, 201, 10.5, 17, 88.27, 69.3, 6962.62, 663.1, 376.57, 88.81, 2303.59, 229.21, 51.09, 13,\
214, 202, 12, 19, 99.33, 78, 7970.4, 744.9, 426.84, 89.58, 2613.87, 258.8, 51.3, 13,\
220, 202, 14, 22, 114.97, 90.3, 9488.15, 862.6, 500.34, 90.84, 3027.75, 299.78, 51.32, 13,\
226, 203, 16, 25, 131.11, 102.9, 11136.66, 985.6, 578.16, 92.16, 3493.41, 344.18, 51.62, 13,\
234, 203, 18, 29, 150.87, 118.4, 13375.48, 1143.2, 679.29, 94.16, 4053.99, 399.41, 51.84, 13,\
246, 249, 8, 12, 79.72, 62.6, 9170.92, 745.6, 410.68, 107.26, 3090.06, 248.2, 62.26, 16,\
250, 250, 9, 14, 92.18, 72.4, 10832.61, 866.6, 480.25, 108.41, 3648.81, 291.9, 62.92, 16,\
253, 251, 10, 15.5, 102.21, 80.2, 12153.56, 960.8, 535.41, 109.05, 4088.75, 325.8, 63.25, 16,\
257, 252, 11, 17.5, 114.82, 90.1, 13927.17, 1083.8, 607.67, 110.14, 4672.01, 370.79, 63.79, 16,\
262, 253, 12.5, 20, 131.15, 103, 16243.92, 1240, 701.07, 111.29, 5404.02, 427.2, 64.19, 16,\
267, 253, 14, 22.5, 147.13, 115.5, 18593.24, 1392.8, 793.96, 112.42, 6080.59, 480.68, 64.29, 16,\
274, 258, 16, 26, 171.88, 134.9, 22416.62, 1636.3, 942.16, 114.2, 7452.57, 577.72, 65.85, 16,\
281, 259, 18, 29.5, 194.97, 153.1, 26169.72, 1862.6, 1083.49, 115.86, 8556.67, 660.75, 66.25, 16,\
288, 260, 20, 33, 218.2, 171.3, 30128.76, 2092.3, 1228.96, 117.51, 9685.85, 745.07, 66.63, 16,\
298, 261, 23, 38, 251.62, 197.5, 36112.37, 2423.7, 1442.84, 119.8, 11288.1, 864.99, 66.98, 16,\
298, 299, 9, 14, 110.8, 87, 18848.66, 1265, 694.64, 130.43, 6241.19, 417.47, 75.05, 18,\
300, 300, 10, 15, 119.78, 94, 20410.21, 1360.7, 750.59, 130.54, 6754.83, 450.32, 75.1, 18,\
300, 305, 15, 15, 134.78, 105.8, 21535.21, 1435.7, 806.84, 126.4, 7104.76, 465.89, 72.6, 18,\
304, 301, 11, 17, 134.82, 105.8, 23380.49, 1538.2, 852.74, 131.69, 7732.59, 513.79, 75.73, 18,\
308, 301, 12, 19, 149.56, 117.4, 26362.99, 1711.9, 953.96, 132.77, 8642.78, 574.27, 76.02, 18,\
312, 302, 13, 21, 164.72, 129.3, 29508.74, 1891.6, 1059.44, 133.84, 9648.6, 638.98, 76.53, 18,\
316, 302, 14.5, 23, 180.85, 142, 32732.42, 2071.7, 1167.93, 134.53, 10569.09, 699.94, 76.45, 18,\
316, 357, 14.5, 23, 206.15, 161.8, 38173.52, 2416.1, 1353.26, 136.08, 17452.1, 977.71, 92.01, 18,\
322, 358, 16, 26, 232.14, 182.2, 43983.21, 2731.9, 1541.6, 137.65, 19896.06, 1111.51, 92.58, 18,\
328, 359, 18, 29, 259.6, 203.8, 50113.52, 3055.7, 1738.68, 138.94, 22381.16, 1246.86, 92.85, 18,\
334, 360, 20, 32, 287.18, 225.4, 56488.07, 3382.5, 1939.98, 140.25, 24906.98, 1383.72, 93.13, 18,\
341, 361, 22, 35.5, 318.49, 250, 64158.87, 3763, 2176.26, 141.93, 27866.03, 1543.82, 93.54, 18,\
350, 362, 24, 40, 357.18, 280.4, 74376.59, 4250.1, 2481.31, 144.3, 31663.84, 1749.38, 94.15, 18,\
356, 371, 27, 43, 394.74, 309.9, 83542.72, 4693.4, 2760.9, 145.48, 36649.59, 1975.72, 96.36, 18,\
364, 372, 30, 47, 433.46, 340.3, 93889.39, 5158.8, 3062.8, 147.17, 40396.23, 2171.84, 96.54, 18,\
374, 373, 33, 52, 479.8, 376.6, 107317.14, 5738.9, 3441.68, 149.56, 45068.65, 2416.55, 96.92, 18,\
384, 374, 36, 57, 526.34, 413.2, 121512.35, 6328.8, 3831.76, 151.94, 49816.72, 2664, 97.29, 18,\
396, 375, 39, 63, 580.58, 455.8, 139424.86, 7041.7, 4307.16, 154.97, 55520.26, 2961.08, 97.79, 18,\
408, 385, 43, 69, 650.18, 510.4, 162282.28, 7955, 4912.82, 157.99, 65823.94, 3419.43, 100.62, 18,\
422, 387, 47, 76, 717.92, 563.6, 187072.37, 8866, 5534.78, 161.42, 73671.75, 3807.33, 101.3, 18,\
440, 389, 52, 85, 804.48, 631.5, 221339.16, 10060.9, 6361.1, 165.87, 83732.23, 4305, 102.02, 18,\
342, 348, 10, 15, 139.03, 109.1, 31247.91, 1827.4, 1001.17, 149.92, 10542.21, 605.87, 87.08, 20,\
346, 349, 11, 17, 156.41, 122.8, 35711.23, 2064.2, 1135.84, 151.1, 12051.44, 690.63, 87.78, 20,\
350, 350, 12, 19, 173.87, 136.5, 40295.09, 2302.6, 1272.61, 152.23, 13585.82, 776.33, 88.39, 20,\
355, 351, 13.5, 21.5, 196.48, 154.2, 46230.77, 2604.6, 1448.66, 153.39, 15506.81, 883.58, 88.84, 20,\
360, 352, 15, 24, 219.19, 172.1, 52353.7, 2908.5, 1627.8, 154.55, 17459.86, 992.04, 89.25, 20,\
365, 353, 16.5, 26.5, 242, 190, 58667.44, 3214.7, 1810.04, 155.7, 19445.3, 1101.72, 89.64, 20,\
369, 360, 18, 28.5, 264.79, 207.9, 64960.86, 3520.9, 1991.8, 156.63, 22183.47, 1232.42, 91.53, 20,\
376, 361, 20, 32, 296.87, 233.1, 74398.83, 3957.4, 2256.32, 158.31, 25119.61, 1391.67, 91.99, 20,\
382, 362, 22, 35, 325.47, 255.5, 82894.78, 4340, 2491.96, 159.59, 27708.51, 1530.86, 92.27, 20,\
389, 363, 24, 38.5, 357.82, 280.9, 93053.12, 4784.2, 2767.25, 161.26, 30738.03, 1693.56, 92.68, 20,\
396, 364, 26.5, 42, 391.87, 307.6, 103736.94, 5239.2, 3054.44, 162.7, 33819.63, 1858.22, 92.9, 20,\
404, 374, 29, 46, 437.99, 343.8, 118982.06, 5890.2, 3458.4, 164.82, 40183.36, 2148.84, 95.78, 20,\
414, 375, 32, 51, 485.77, 381.3, 135721.11, 6556.6, 3886.58, 167.15, 44924.28, 2395.96, 96.17, 20,\
424, 376, 35, 56, 533.75, 419, 153322.14, 7232.2, 4326.2, 169.49, 49742.08, 2645.86, 96.54, 20,\
434, 377, 38, 61, 581.93, 456.8, 171810.18, 7917.5, 4777.34, 171.83, 54637.74, 2898.55, 96.9, 20,\
446, 378, 42, 67, 640.99, 503.2, 195206.29, 8753.7, 5336.35, 174.51, 60526.72, 3202.47, 97.17, 20,\
458, 392, 46, 73, 719.27, 564.6, 227053.17, 9915, 6094.32, 177.67, 73566.95, 3753.42, 101.13, 20,\
472, 393, 50, 80, 788.23, 618.8, 258357.05, 10947.3, 6796.66, 181.04, 81286.57, 4136.72, 101.55, 20,\
488, 394, 55, 88, 868.47, 681.8, 296560.11, 12154.1, 7629.66, 184.79, 90173.86, 4577.35, 101.9, 20,\
506, 395, 60, 97, 956.93, 751.2, 342451.59, 13535.6, 8591.51, 189.17, 100237.84, 5075.33, 102.35, 20,\
520, 409, 65, 104, 1056.95, 829.7, 392963.38, 15114, 9664.42, 192.82, 119352.51, 5836.31, 106.26, 20,\
540, 411, 71, 114, 1162.03, 912.2, 454051.02, 16816.7, 10869.85, 197.67, 132896.31, 6466.97, 106.94, 20,\
562, 413, 77, 125, 1276.17, 1001.8, 526659.93, 18742.4, 12243.01, 203.15, 148011.27, 7167.62, 107.69, 20,\
580, 426, 84, 134, 1407.19, 1104.7, 606878.23, 20926.8, 13777.86, 207.67, 174271.92, 8181.78, 111.29, 20,\
604, 430, 92, 146, 1546.07, 1213.7, 704826.44, 23338.6, 15522.09, 213.51, 195579.56, 9096.72, 112.47, 20,\
394, 398, 11, 18, 186.81, 146.7, 56145.31, 2850, 1559.22, 173.36, 18922.62, 950.89, 100.64, 22,\
400, 400, 13, 21, 218.69, 171.7, 66621.41, 3331.1, 1836.23, 174.54, 22412.67, 1120.63, 101.23, 22,\
406, 403, 16, 24, 254.87, 200.1, 78039.22, 3844.3, 2139.84, 174.98, 26200.19, 1300.26, 101.39, 22,\
414, 405, 18, 28, 295.39, 231.9, 92771.14, 4481.7, 2513.15, 177.22, 31026.87, 1532.19, 102.49, 22,\
420, 403, 20, 31, 325.61, 255.6, 103629.7, 4934.8, 2786.46, 178.4, 33850.08, 1679.9, 101.96, 22,\
429, 400, 23, 35.5, 370.49, 290.8, 120290.27, 5607.9, 3198.49, 180.19, 37914.87, 1895.74, 101.16, 22,\
438, 370, 25, 40, 389.65, 305.9, 128432.35, 5864.5, 3381.88, 181.55, 33828.59, 1828.57, 93.18, 22,\
448, 371, 28, 45, 438.29, 344.1, 148100.16, 6611.6, 3848.78, 183.82, 38379.67, 2068.98, 93.58, 22,\
458, 372, 31, 50, 487.13, 382.4, 168699.38, 7366.8, 4327.2, 186.09, 43005.94, 2312.15, 93.96, 22,\
470, 373, 35, 56, 547.21, 429.6, 194740.01, 8286.8, 4920.7, 188.65, 48584.93, 2605.09, 94.23, 22,\
484, 374, 39, 63, 615.01, 482.8, 226537.95, 9361.1, 5620.76, 191.92, 55131.74, 2948.22, 94.68, 22,\
494, 392, 43, 68, 691.21, 542.6, 261626.63, 10592.2, 6402.77, 194.55, 68534.68, 3496.67, 99.57, 22,\
510, 393, 48, 76, 773.35, 607.1, 303779.05, 11912.9, 7286.5, 198.19, 77250.09, 3931.3, 99.94, 22,\
528, 394, 53, 85, 863.69, 678, 354176.39, 13415.8, 8303.29, 202.5, 87133.42, 4423.02, 100.44, 22,\
548, 395, 59, 95, 965.87, 758.2, 414486.6, 15127.3, 9480.79, 207.15, 98243.26, 4974.34, 100.85, 22,\
564, 410, 65, 103, 1081.45, 848.9, 482318.02, 17103.5, 10811.51, 211.18, 119192.55, 5814.27, 104.98, 22,\
588, 412, 72, 115, 1209.51, 949.5, 569246.79, 19362.1, 12395.01, 216.94, 135224.96, 6564.32, 105.74, 22,\
616, 414, 80, 129, 1358.67, 1066.6, 679972.83, 22077, 14322.16, 223.71, 154171.56, 7447.9, 106.52, 22,\
638, 430, 87, 140, 1519.61, 1192.9, 800682.16, 25099.8, 16419.75, 229.54, 187578.96, 8724.6, 111.1, 22,\
668, 435, 96, 155, 1696.33, 1331.6, 952172.58, 28508.2, 18868.64, 236.92, 215398.09, 9903.36, 112.68, 22}

#define NAME_GOST_G57837_K  {"15K1", "15K2", "15K3", "15K4", "15K5", "20K1", "20K2", "20K3", "20K4", "20K5",\
                             "20K6", "20K7", "20K8", "25K1", "25K2", "25K3", "25K4", "25K5", "25K6", "25K7",\
							 "25K8", "25K9", "25K10", "30K1", "30K2", "30K3", "30K4", "30K5", "30K6", "30K7",\
                             "30K8", "30K9", "30K10", "30K11", "30K12", "30K13", "30K14", "30K15", "30K16",\
							 "30K17", "30K18", "30K19", "30K20", "30K21", "35K1", "35K1.5", "35K2", "35K3",\
                             "35K4", "35K5", "35K6", "35K7", "35K8", "35K9", "35K10", "35K11", "35K12", "35K13",\
                             "35K14", "35K15", "35K16", "35K17", "35K18", "35K19", "35K20", "35K21", "35K22", "35K23",\
                             "35K24", "40K1", "40K2", "40K3", "40K4", "40K4.5", "40K5", "40K6", "40K7", "40K8", "40K9",\
                             "40K10", "40K11", "40K12", "40K13", "40K14", "40K15", "40K16", "40K17", "40K18", "40K19"}

#define N_GOST_G57837_B    49      //  

// h	b	s	t	F	m	Iz	Wz	Sz	iz	Iy	Wy	iy	r
#define GOST_G57837_B {100, 55, 4.1, 5.7, 10.32, 8.1, 171.01, 34.2, 19.7, 40.7, 15.92, 5.79, 12.42, 7,\
117.6, 64, 3.8, 5.1, 11.03, 8.7, 257.36, 43.8, 24.94, 48.3, 22.39, 7, 14.25, 7,\
120, 64, 4.4, 6.3, 13.21, 10.4, 317.75, 53, 30.36, 49.04, 27.67, 8.65, 14.47, 7,\
137.4, 73, 3.8, 5.6, 13.39, 10.5, 434.86, 63.3, 35.8, 56.98, 36.42, 9.98, 16.49, 7,\
140, 73, 4.7, 6.9, 16.43, 12.9, 541.22, 77.3, 44.17, 57.4, 44.92, 12.31, 16.54, 7,\
157, 82, 4, 5.9, 16.18, 12.7, 689.28, 87.8, 49.55, 65.27, 54.43, 13.27, 18.34, 9,\
160, 82, 5, 7.4, 20.09, 15.8, 869.29, 108.7, 61.93, 65.78, 68.31, 16.66, 18.44, 9,\
177, 91, 4.3, 6.5, 19.58, 15.4, 1062.74, 120.1, 67.66, 73.68, 81.89, 18, 20.45, 9,\
180, 91, 5.3, 8, 23.95, 18.8, 1316.96, 146.3, 83.21, 74.16, 100.85, 22.16, 20.52, 9,\
200, 100, 5.5, 8, 27.16, 21.3, 1844.26, 184.4, 104.73, 82.41, 133.91, 26.78, 22.21, 11,\
203, 101, 6.5, 9.5, 32.19, 25.3, 2218.49, 218.6, 124.99, 83.02, 163.93, 32.46, 22.57, 11,\
208, 102, 8, 12, 40.24, 31.6, 2852.62, 274.3, 158.46, 84.2, 213.5, 41.86, 23.03, 11,\
248, 124, 5, 8, 32.68, 25.7, 3537.11, 285.3, 159.68, 104.04, 254.85, 41.11, 27.93, 12,\
250, 125, 6, 9, 37.66, 29.6, 4051.73, 324.1, 182.93, 103.73, 293.85, 47.02, 27.93, 12,\
255, 126, 7.5, 11.5, 47.62, 37.4, 5238.16, 410.8, 233.88, 104.88, 384.79, 61.08, 28.43, 12,\
260, 127, 9, 14, 57.68, 45.3, 6481.01, 498.5, 286.25, 106, 480.07, 75.6, 28.85, 12,\
298, 149, 5.5, 8, 40.8, 32, 6318.22, 424, 237.53, 124.44, 442, 59.33, 32.91, 13,\
300, 150, 6.5, 9, 46.78, 36.7, 7209.26, 480.6, 271.06, 124.14, 507.53, 67.67, 32.94, 13,\
305, 151, 8, 11.5, 58.74, 46.1, 9254.92, 606.9, 344.37, 125.52, 661.88, 87.67, 33.57, 13,\
310, 152, 9.5, 14, 70.8, 55.6, 11381.41, 734.3, 419.4, 126.79, 822.37, 108.21, 34.08, 13,\
346, 174, 6, 9, 52.68, 41.4, 11094.49, 641.3, 358.09, 145.12, 791.54, 90.98, 38.76, 14,\
350, 175, 7, 11, 63.14, 49.6, 13559.01, 774.8, 433.96, 146.54, 984.34, 112.5, 39.48, 14,\
355, 176, 8.5, 13.5, 77.08, 60.5, 16797.02, 946.3, 533.54, 147.62, 1229.36, 139.7, 39.94, 14,\
361, 177, 10, 16.5, 92.89, 72.9, 20719.71, 1147.9, 651.07, 149.35, 1528.9, 172.76, 40.57, 14,\
396, 199, 7, 11, 72.16, 56.6, 20018.83, 1011.1, 563.93, 166.56, 1447.14, 145.44, 44.78, 16,\
400, 200, 8, 13, 84.12, 66, 23704.43, 1185.2, 663.13, 167.87, 1736.39, 173.64, 45.43, 16,\
406, 201, 9.5, 16, 102.05, 80.1, 29352.45, 1445.9, 813.38, 169.6, 2169.89, 215.91, 46.11, 16,\
412, 202, 11, 19, 120.1, 94.3, 35196.83, 1708.6, 966.65, 171.19, 2616.25, 259.03, 46.67, 16,\
446, 199, 8, 12, 84.3, 66.2, 28697.35, 1286.9, 725.06, 184.5, 1580.03, 158.8, 43.29, 18,\
450, 200, 9, 14, 96.76, 76, 33450.76, 1486.7, 839.53, 185.93, 1871.57, 187.16, 43.98, 18,\
456, 201, 10.5, 17, 115.43, 90.6, 40710.41, 1785.5, 1012.55, 187.8, 2307.62, 229.61, 44.71, 18,\
462, 202, 12, 20, 134.22, 105.4, 48197.42, 2086.5, 1188.75, 189.5, 2756.66, 272.94, 45.32, 18,\
492, 199, 8.8, 12, 92.38, 72.5, 36841.89, 1497.6, 853.45, 199.7, 1581.96, 158.99, 41.38, 20,\
496, 199, 9, 14, 101.27, 79.5, 41869.08, 1688.3, 957.23, 203.33, 1844.89, 185.42, 42.68, 20,\
500, 200, 10, 16, 114.23, 89.7, 47846.05, 1913.8, 1087.59, 204.66, 2140.79, 214.08, 43.29, 20,\
508, 201, 12, 20, 139.99, 109.9, 59953.57, 2360.4, 1348.82, 206.94, 2717.85, 270.43, 44.06, 20,\
516, 202, 15, 24, 170.59, 133.9, 73345.26, 2842.8, 1642.68, 207.35, 3315.53, 328.27, 44.09, 20,\
543, 220, 9.5, 13.5, 113.36, 89, 55677.42, 2050.7, 1164.94, 221.62, 2405.54, 218.69, 46.06, 24,\
547, 220, 10, 15.5, 124.74, 97.9, 62784.45, 2295.6, 1301.49, 224.34, 2761.34, 251.03, 47.05, 24,\
553, 221, 12, 18.5, 148.63, 116.7, 75321.22, 2724.1, 1554.49, 225.11, 3342.92, 302.53, 47.42, 24,\
560, 222, 14, 22, 174.86, 137.3, 89907.09, 3211, 1842.2, 226.75, 4032.07, 363.25, 48.02, 24,\
596, 199, 10, 15, 120.45, 94.6, 68715.9, 2305.9, 1325.36, 238.85, 1979.66, 198.96, 40.54, 22,\
600, 200, 11, 17, 134.41, 105.5, 77632.25, 2587.7, 1489.36, 240.32, 2278.16, 227.82, 41.17, 22,\
604, 201, 12.5, 19, 151.28, 118.8, 87472.1, 2896.4, 1675.38, 240.46, 2586.62, 257.38, 41.35, 22,\
612, 202, 15, 23, 181.97, 142.9, 106509.5, 3480.7, 2026.68, 241.93, 3182.62, 315.11, 41.82, 22,\
691, 260, 12, 15.5, 164.74, 129.3, 125922.2, 3644.6, 2094.79, 276.47, 4557.35, 350.57, 52.6, 24,\
697, 260, 12.5, 18.5, 183.64, 144.16, 145904, 4186.63, 2392.68, 281.87, 5437.68, 418.28, 54.41, 24,\
702, 261, 14.5, 21, 210.26, 165.1, 167085.1, 4760.3, 2736.06, 281.89, 6248.49, 478.81, 54.51, 24,\
710, 262, 17, 25, 248.14, 194.8, 199680, 5624.8, 3249.28, 283.67, 7531.16, 574.9, 55.09, 24}

#define NAME_GOST_G57837_B  {"101", "121", "122", "141", "142", "161", "162", "181", "182", \
							 "201", "202", "203", "251", "252", "253", "254", "301", "302", "303",\
							 "304", "351", "352", "353", "354", "401", "402", "403", "404", "451", \
							 "452", "453", "454", "501", "502", "503", "504", "505", "551", "552", \
							 "553", "554", "601", "602", "603", "604", "701", "702", "703", "704"}

#define N_GOST_G57837_S    14      // 

#define GOST_G57837_S  {128, 118, 9, 9, 32.38, 25.42, 887.11, 138.61, 80.04, 52.35, 247.82, 42, 27.67, 12, \
200, 204, 12, 12, 71.53, 56.2, 4982.3, 498.2, 282.75, 83.46, 1701.7, 166.83, 48.77, 13, \
244, 252, 11, 11, 82.06, 64.4, 8786.78, 720.3, 402.51, 103.48, 2938.35, 233.2, 59.84, 16, \
250, 255, 14, 14, 104.68, 82.2, 11483.66, 918.7, 519.31, 104.74, 3876.71, 304.06, 60.86, 16, \
294, 302, 12, 12, 107.66, 84.5, 16864.21, 1147.3, 638.55, 125.16, 5515.71, 365.28, 71.58, 18, \
300, 305, 15, 15, 134.78, 105.8, 21535.21, 1435.7, 806.84, 126.4, 7104.75, 465.89, 72.6, 18, \
326.7, 319.7, 24.8, 24.8, 229.28, 179.98, 40972.83, 2508.28, 1448.25, 133.68, 13546.38, 847.44, 76.87, 15.2, \
337.9, 325.7, 30.3, 30.4, 283.97, 222.92, 52698.77, 3119.19, 1826.55, 136.23, 17576.76, 1079.32, 78.67, 15.2, \
338, 351, 13, 13, 135.25, 106.2, 28190.35, 1668.1, 925.69, 144.37, 9379.75, 534.46, 83.28, 20, \
344, 354, 16, 16, 166.63, 130.8, 35330.39, 2054.2, 1149.6, 145.61, 11846.29, 669.28, 84.32, 20, \
350, 357, 19, 19, 198.37, 155.7, 42796.14, 2445.6, 1379.79, 146.88, 14433.12, 808.58, 85.3, 20, \
388, 402, 15, 15, 178.45, 140.1, 48965.18, 2524.1, 1401.07, 165.65, 16258.37, 808.87, 95.45, 22, \
394, 405, 18, 18, 214.39, 168.3, 59713.16, 3031.2, 1695.05, 166.89, 19955.17, 985.44, 96.48, 22, \
400, 408, 21, 21, 250.69, 196.8, 70888.09, 3544.5, 1996.23, 168.16, 23809.25, 1167.12, 97.45, 22}

#define NAME_GOST_G57837_S  {"13C1", "20C1", "25C1", "25C2", "30C1", "30C2", "32C1", "32C2", "35C1", "35C2",\
							 "35C3", "40C1", "40C2", "40C3"}

#define N_GOST_G57837DK    37      //  

#define GOST_G57837DK  {91, 100, 4.2, 5.5, 15.6, 12.2, 236.51, 51.98, 29.18, 38.94, 92.06, 18.41, 24.29, 12, \
96, 100, 5, 8, 21.24, 16.7, 349.23, 72.8, 41.51, 40.55, 133.81, 26.76, 25.1, 12, \
100, 100, 6, 10, 26.04, 20.4, 449.55, 89.9, 52.11, 41.55, 167.27, 33.45, 25.35, 12, \
120, 106, 12, 20, 53.24, 41.8, 1142.61, 190.4, 117.91, 46.33, 399.15, 75.31, 27.38, 12, \
109, 120, 4.2, 5.5, 18.55, 14.6, 413.36, 75.85, 42.2, 47.21, 158.81, 26.47, 29.26, 12, \
114, 120, 5, 8, 25.34, 19.9, 606.15, 106.3, 59.75, 48.91, 230.9, 38.48, 30.19, 12, \
120, 120, 6.5, 11, 34.01, 26.7, 864.37, 144.1, 82.61, 50.42, 317.52, 52.92, 30.56, 12, \
140, 126, 12.5, 21, 66.41, 52.1, 2017.57, 288.2, 175.31, 55.12, 702.78, 111.55, 32.53, 12, \
128, 140, 4.3, 6, 23.02, 18.1, 719.45, 112.41, 61.89, 55.9, 274.83, 39.26, 34.55, 12, \
133, 140, 5.5, 8.5, 31.42, 24.7, 1033.13, 155.4, 86.75, 57.35, 389.32, 55.62, 35.2, 12, \
140, 140, 7, 12, 42.96, 33.7, 1509.23, 215.6, 122.71, 59.27, 549.67, 78.52, 35.77, 12, \
160, 145, 13, 22, 80.12, 62.9, 3270.24, 408.8, 245.4, 63.89, 1121.06, 154.63, 37.41, 12, \
152, 152, 5.8, 6.6, 28.61, 22.5, 1213.15, 159.6, 88.58, 65.12, 386.64, 50.87, 36.76, 7.6, \
157, 153, 6.6, 9.3, 38.09, 29.9, 1722.51, 219.4, 122.56, 67.25, 555.61, 72.63, 38.19, 7.6, \
162, 154, 8.1, 11.6, 47.47, 37.3, 2227.67, 275, 155.52, 68.51, 706.89, 91.8, 38.59, 7.6, \
148, 160, 4.5, 7, 30.36, 23.8, 1282.88, 173.36, 95.21, 65, 478.73, 59.84, 39.71, 15, \
152, 160, 6, 9, 38.77, 30.4, 1672.98, 220.1, 122.57, 65.69, 615.57, 76.95, 39.85, 15, \
160, 160, 8, 13, 54.25, 42.6, 2492, 311.5, 176.98, 67.77, 889.23, 111.15, 40.49, 15, \
180, 166, 14, 23, 97.05, 76.2, 5098.27, 566.5, 337.28, 72.48, 1758.77, 211.9, 42.57, 15, \
167, 180, 5, 7.5, 36.53, 28.7, 1966.9, 235.56, 129.12, 73.38, 729.97, 81.11, 44.7, 15, \
171, 180, 6, 9.5, 45.25, 35.5, 2510.29, 293.6, 162.43, 74.48, 924.61, 102.73, 45.2, 15, \
180, 180, 8.3, 14, 64.95, 51, 3825.28, 425, 240.15, 76.75, 1362.76, 151.42, 45.81, 15, \
200, 186, 14.5, 24, 113.25, 88.9, 7483.13, 748.3, 441.72, 81.29, 2580.13, 277.43, 47.73, 15, \
203, 203, 7.2, 11, 58.59, 46, 4545.7, 447.9, 247.79, 88.09, 1534.57, 151.19, 51.18, 10.2, \
206, 204, 7.9, 12.6, 66.58, 52.3, 5272.37, 511.9, 284.77, 88.99, 1783.95, 174.9, 51.76, 10.2, \
210, 205, 9.1, 14.2, 75.64, 59.4, 6114, 582.3, 326.45, 89.91, 2040.5, 199.07, 51.94, 10.2, \
216, 206, 10.2, 17.4, 91.06, 71.5, 7662.28, 709.5, 401.74, 91.73, 2537.25, 246.33, 52.78, 10.2, \
222, 209, 13, 20.6, 110.51, 86.8, 9471.87, 853.3, 490.61, 92.58, 3138.43, 300.33, 53.29, 10.2, \
229, 210, 14.5, 23.7, 126.77, 99.5, 11328.82, 989.4, 574.62, 94.53, 3663.55, 348.91, 53.76, 10.2, \
253, 254, 8.6, 14.2, 92.84, 72.9, 11274.05, 891.2, 492.46, 110.2, 3880.25, 305.53, 64.65, 12.7, \
256, 255, 9.4, 15.6, 102.08, 80.1, 12567.16, 981.8, 545.12, 110.96, 4313.58, 338.32, 65.01, 12.7, \
260, 256, 10.7, 17.3, 114.08, 89.6, 14253.92, 1096.5, 612.99, 111.78, 4840.74, 378.18, 65.14, 12.7, \
264, 257, 11.9, 19.6, 128.88, 101.2, 16369.03, 1240.1, 698.3, 112.7, 5549.34, 431.86, 65.62, 12.7, \
269, 259, 13.5, 22.1, 146, 115, 18890.39, 1404.49, 797.58, 113.8, 6404.89, 494.55, 66.3, 10.7, \
275, 261, 15.4, 25.1, 167, 131, 22101.48, 1607.38, 921.26, 115.17, 7445.67, 570.55, 66.85, 10.7, \
282, 263, 17.3, 28.4, 190, 149, 25884.67, 1835.79, 1062.09, 116.93, 8621.57, 655.63, 67.48, 10.7, \
289, 265, 19.2, 31.8, 212, 167, 29966.97, 2073.84, 1211.04, 118.67, 9877.85, 745.5, 68.13, 10.7, \
}

#define NAME_GOST_G57837DK  {"100", "101", "102", "103", "120", "121", "122", "123", "140", "141",\
							 "142", "143", "151", "152", "153", "160", "161", "162", "163", "180",\
							 "181", "182", "183", "201", "202", "203", "204", "205", "206", "251",\
							 "252", "253", "254", "255", "256", "257", "258"}


				 //  D,  s,  A,    m,     Ix,    W,    ix,   s_pr
#define N_CIRC_PROF    152
#define CIRC_PROF  { 42, 3, 3.676, 2.885, 7.03, 3.347, 1.383, 2.786, \
42, 3.5, 4.233, 3.323, 7.908, 3.766, 1.367, 3.208, \
42, 4, 4.775, 3.749, 8.715, 4.15, 1.351, 3.619, \
48, 3, 4.241, 3.329, 10.783, 4.493, 1.595, 2.813, \
48, 3.5, 4.893, 3.841, 12.187, 5.078, 1.578, 3.245, \
48, 4, 5.529, 4.34, 13.491, 5.621, 1.562, 3.667, \
54, 3, 4.807, 3.773, 15.682, 5.808, 1.806, 2.833, \
54, 3.5, 5.553, 4.359, 17.786, 6.587, 1.79, 3.273, \
54, 4, 6.283, 4.932, 19.761, 7.319, 1.773, 3.704, \
57, 3, 5.089, 3.995, 18.608, 6.529, 1.912, 2.842, \
57, 3.5, 5.883, 4.618, 21.137, 7.417, 1.896, 3.285, \
57, 4, 6.66, 5.228, 23.519, 8.252, 1.879, 3.719, \
60, 3, 5.372, 4.217, 21.878, 7.293, 2.018, 2.85, \
60, 3.5, 6.212, 4.877, 24.885, 8.295, 2.001, 3.296, \
60, 4, 7.037, 5.524, 27.726, 9.242, 1.985, 3.733, \
70, 3, 6.315, 4.957, 35.504, 10.144, 2.371, 2.871, \
70, 3.5, 7.312, 5.74, 40.532, 11.58, 2.354, 3.325, \
70, 4, 8.294, 6.511, 45.326, 12.95, 2.338, 3.771, \
73, 3, 6.597, 5.179, 40.483, 11.091, 2.477, 2.877, \
73, 3.5, 7.642, 5.999, 46.258, 12.673, 2.46, 3.332, \
73, 4, 8.671, 6.807, 51.775, 14.185, 2.444, 3.781, \
73, 5, 10.681, 8.385, 62.072, 17.006, 2.411, 4.658, \
73, 5.5, 11.663, 9.156, 66.866, 18.32, 2.394, 5.086, \
76, 3, 6.88, 5.401, 45.907, 12.081, 2.583, 2.882, \
76, 3.5, 7.972, 6.258, 52.499, 13.816, 2.566, 3.339, \
76, 4, 9.048, 7.103, 58.811, 15.476, 2.55, 3.789, \
76, 5, 11.153, 8.755, 70.624, 18.585, 2.516, 4.671, \
76, 5.5, 12.182, 9.562, 76.142, 20.037, 2.5, 5.102, \
76, 6, 13.195, 10.358, 81.411, 21.424, 2.484, 5.526, \
83, 3, 7.54, 5.919, 60.403, 14.555, 2.83, 2.892, \
83, 3.5, 8.741, 6.862, 69.194, 16.673, 2.813, 3.352, \
83, 4, 9.927, 7.793, 77.645, 18.71, 2.797, 3.807, \
83, 5, 12.252, 9.618, 93.561, 22.545, 2.763, 4.699, \
83, 5.5, 13.391, 10.512, 101.044, 24.348, 2.747, 5.136, \
83, 6, 14.514, 11.394, 108.221, 26.077, 2.731, 5.566, \
89, 3, 8.105, 6.363, 75.025, 16.859, 3.042, 2.899, \
89, 3.5, 9.401, 7.38, 86.051, 19.337, 3.025, 3.362, \
89, 4, 10.681, 8.385, 96.68, 21.726, 3.009, 3.82, \
89, 5, 13.195, 10.358, 116.789, 26.245, 2.975, 4.719, \
89, 5.5, 14.428, 11.326, 126.288, 28.379, 2.959, 5.16, \
89, 6, 15.645, 12.281, 135.428, 30.433, 2.942, 5.596, \
95, 3, 8.671, 6.807, 91.835, 19.334, 3.254, 2.905, \
95, 3.5, 10.061, 7.898, 105.445, 22.199, 3.237, 3.371, \
95, 4, 11.435, 8.977, 118.599, 24.968, 3.22, 3.832, \
95, 5, 14.137, 11.098, 143.581, 30.227, 3.187, 4.737, \
95, 5.5, 15.464, 12.14, 155.428, 32.722, 3.17, 5.182, \
95, 6, 16.776, 13.169, 166.859, 35.128, 3.154, 5.621, \
102, 3, 9.331, 7.324, 114.416, 22.434, 3.502, 2.912, \
102, 3.5, 10.831, 8.502, 131.518, 25.788, 3.485, 3.38, \
102, 4, 12.315, 9.667, 148.088, 29.037, 3.468, 3.843, \
102, 5, 15.237, 11.961, 179.679, 35.231, 3.434, 4.755, \
102, 5.5, 16.674, 13.089, 194.721, 38.181, 3.417, 5.203, \
102, 6, 18.096, 14.205, 209.275, 41.034, 3.401, 5.647, \
108, 3, 9.896, 7.768, 136.491, 25.276, 3.714, 2.917, \
108, 3.5, 11.49, 9.02, 157.023, 29.078, 3.697, 3.387, \
108, 4, 13.069, 10.259, 176.955, 32.769, 3.68, 3.852, \
108, 5, 16.179, 12.701, 215.062, 39.826, 3.646, 4.769, \
108, 5.5, 17.711, 13.903, 233.261, 43.197, 3.629, 5.22, \
108, 6, 19.227, 15.093, 250.906, 46.464, 3.612, 5.667, \
108, 7, 22.211, 17.436, 284.579, 52.7, 3.579, 6.546, \
108, 8, 25.133, 19.729, 316.17, 58.55, 3.547, 7.407, \
114, 3, 10.462, 8.212, 161.238, 28.287, 3.926, 2.921, \
114, 3.5, 12.15, 9.538, 185.631, 32.567, 3.909, 3.393, \
114, 4, 13.823, 10.851, 209.349, 36.728, 3.892, 3.86, \
114, 5, 17.122, 13.441, 254.813, 44.704, 3.858, 4.781, \
114, 5.5, 18.747, 14.717, 276.584, 48.523, 3.841, 5.235, \
114, 6, 20.358, 15.981, 297.729, 52.233, 3.824, 5.684, \
114, 7, 23.531, 18.471, 338.193, 59.332, 3.791, 6.57, \
114, 8, 26.641, 20.913, 376.3, 66.018, 3.758, 7.439, \
114, 9, 29.688, 23.305, 412.144, 72.306, 3.726, 8.289, \
114, 10, 32.673, 25.648, 445.817, 78.214, 3.694, 9.123, \
121, 3, 11.121, 8.73, 193.69, 32.015, 4.173, 2.926, \
121, 3.5, 12.92, 10.142, 223.165, 36.887, 4.156, 3.399, \
121, 4, 14.703, 11.542, 251.875, 41.632, 4.139, 3.868, \
121, 5, 18.221, 14.304, 307.051, 50.752, 4.105, 4.793, \
121, 5.5, 19.957, 15.666, 333.543, 55.131, 4.088, 5.25, \
121, 6, 21.677, 17.016, 359.323, 59.392, 4.071, 5.702, \
121, 7, 25.07, 19.68, 408.796, 67.57, 4.038, 6.595, \
121, 8, 28.4, 22.294, 455.571, 75.301, 4.005, 7.471, \
121, 9, 31.667, 24.859, 499.749, 82.603, 3.973, 8.331, \
121, 10, 34.872, 27.374, 541.426, 89.492, 3.94, 9.174, \
127, 4, 15.457, 12.133, 292.613, 46.081, 4.351, 3.874, \
127, 5, 19.164, 15.044, 357.14, 56.242, 4.317, 4.803, \
127, 5.5, 20.994, 16.48, 388.187, 61.132, 4.3, 5.262, \
127, 6, 22.808, 17.904, 418.441, 65.896, 4.283, 5.717, \
127, 7, 26.389, 20.716, 476.625, 75.059, 4.25, 6.614, \
127, 8, 29.908, 23.478, 531.801, 83.748, 4.217, 7.496, \
127, 9, 33.364, 26.191, 584.074, 91.98, 4.184, 8.362, \
127, 10, 36.757, 28.854, 633.547, 99.771, 4.152, 9.213, \
133, 4, 16.211, 12.725, 337.525, 50.756, 4.563, 3.88, \
133, 5, 20.106, 15.783, 412.403, 62.016, 4.529, 4.812, \
133, 5.5, 22.03, 17.294, 448.498, 67.443, 4.512, 5.273, \
133, 6, 23.939, 18.792, 483.716, 72.739, 4.495, 5.729, \
133, 7, 27.709, 21.751, 551.579, 82.944, 4.462, 6.632, \
133, 8, 31.416, 24.662, 616.106, 92.647, 4.428, 7.519, \
133, 9, 35.06, 27.522, 677.406, 101.866, 4.396, 8.391, \
133, 10, 38.642, 30.334, 735.591, 110.615, 4.363, 9.248, \
140, 4, 17.09, 13.416, 395.469, 56.496, 4.81, 3.886, \
140, 5, 21.206, 16.647, 483.756, 69.108, 4.776, 4.821, \
140, 5.5, 23.24, 18.243, 526.399, 75.2, 4.759, 5.284, \
140, 6, 25.258, 19.828, 568.062, 81.152, 4.742, 5.743, \
140, 7, 29.248, 22.96, 648.506, 92.644, 4.709, 6.65, \
140, 8, 33.175, 26.043, 725.21, 103.601, 4.675, 7.543, \
140, 9, 37.039, 29.076, 798.291, 114.042, 4.642, 8.421, \
140, 10, 40.841, 32.06, 867.865, 123.981, 4.61, 9.286, \
140, 11, 44.579, 34.995, 934.046, 133.435, 4.577, 10.136, \
140, 12, 48.255, 37.88, 996.945, 142.421, 4.545, 10.971, \
140, 13, 51.868, 40.716, 1056.675, 150.954, 4.514, 11.793, \
146, 4, 17.844, 14.008, 450.121, 61.66, 5.022, 3.89, \
146, 5, 22.148, 17.386, 551.103, 75.494, 4.988, 4.829, \
146, 5.5, 24.277, 19.057, 599.952, 82.185, 4.971, 5.293, \
146, 6, 26.389, 20.716, 647.727, 88.73, 4.954, 5.753, \
146, 7, 30.568, 23.996, 740.12, 101.386, 4.921, 6.664, \
146, 8, 34.683, 27.226, 828.408, 113.481, 4.887, 7.562, \
146, 9, 38.736, 30.408, 912.713, 125.029, 4.854, 8.445, \
146, 10, 42.726, 33.54, 993.158, 136.049, 4.821, 9.315, \
146, 11, 46.653, 36.622, 1069.862, 146.556, 4.789, 10.171, \
146, 12, 50.517, 39.656, 1142.943, 156.568, 4.757, 11.014, \
146, 13, 54.318, 42.64, 1212.517, 166.098, 4.725, 11.842, \
152, 4, 18.598, 14.6, 509.591, 67.052, 5.235, 3.895, \
152, 5, 23.091, 18.126, 624.43, 82.162, 5.2, 4.836, \
152, 5.5, 25.313, 19.871, 680.06, 89.482, 5.183, 5.301, \
152, 6, 27.52, 21.603, 734.518, 96.647, 5.166, 5.763, \
152, 7, 31.887, 25.031, 839.988, 110.525, 5.132, 6.678, \
152, 8, 36.191, 28.41, 940.97, 123.812, 5.099, 7.579, \
152, 9, 40.432, 31.739, 1037.594, 136.526, 5.066, 8.467, \
152, 10, 44.611, 35.019, 1129.987, 148.682, 5.033, 9.342, \
152, 11, 48.726, 38.25, 1218.274, 160.299, 5, 10.204, \
152, 12, 52.779, 41.431, 1302.58, 171.392, 4.968, 11.053, \
152, 13, 56.769, 44.563, 1383.025, 181.977, 4.936, 11.888, \
159, 4, 19.478, 15.29, 585.334, 73.627, 5.482, 3.899, \
159, 5, 24.19, 18.989, 717.876, 90.299, 5.448, 4.843, \
159, 5.5, 26.523, 20.82, 782.177, 98.387, 5.431, 5.31, \
159, 6, 28.84, 22.639, 845.187, 106.313, 5.414, 5.774, \
159, 7, 33.427, 26.24, 967.406, 121.686, 5.38, 6.692, \
159, 8, 37.95, 29.791, 1084.671, 136.437, 5.346, 7.597, \
159, 9, 42.412, 33.293, 1197.118, 150.581, 5.313, 8.491, \
159, 10, 46.81, 36.746, 1304.88, 164.136, 5.28, 9.371, \
159, 11, 51.145, 40.149, 1408.089, 177.118, 5.247, 10.239, \
159, 12, 55.418, 43.503, 1506.876, 189.544, 5.215, 11.094, \
159, 13, 59.627, 46.808, 1601.369, 201.43, 5.182, 11.937, \
168, 4, 20.609, 16.178, 693.282, 82.534, 5.8, 3.905, \
168, 5, 25.604, 20.099, 851.14, 101.326, 5.766, 4.851, \
168, 5.5, 28.078, 22.041, 927.855, 110.459, 5.749, 5.32, \
168, 6, 30.536, 23.971, 1003.117, 119.419, 5.731, 5.786, \
168, 7, 35.406, 27.794, 1149.359, 136.828, 5.698, 6.708, \
168, 8, 40.212, 31.567, 1290.013, 153.573, 5.664, 7.619, \
168, 9, 44.956, 35.291, 1425.224, 169.669, 5.63, 8.518, \
168, 10, 49.637, 38.965, 1555.132, 185.135, 5.597, 9.405, \
168, 11, 54.255, 42.59, 1679.88, 199.986, 5.564, 10.28, \
168, 12, 58.811, 46.166, 1799.605, 214.239, 5.532, 11.143, \
168, 13, 63.303, 49.693, 1914.444, 227.91, 5.499, 11.994}

#define N_CIRC_PROF1    166
#define CIRC_PROF1  {178, 4, 21.865, 17.164, 827.937, 93.027, 6.153, 3.91, \
178, 5, 27.175, 21.332, 1017.492, 114.325, 6.119, 4.86, \
178, 5.5, 29.806, 23.398, 1109.765, 124.693, 6.102, 5.33, \
178, 6, 32.421, 25.451, 1200.396, 134.876, 6.085, 5.798, \
178, 7, 37.605, 29.52, 1376.808, 154.698, 6.051, 6.725, \
178, 8, 42.726, 33.54, 1546.883, 173.807, 6.017, 7.64, \
178, 9, 47.784, 37.51, 1710.773, 192.222, 5.984, 8.545, \
178, 10, 52.779, 41.431, 1868.632, 209.959, 5.95, 9.438, \
178, 11, 57.711, 45.303, 2020.608, 227.035, 5.917, 10.32, \
178, 12, 62.581, 49.126, 2166.851, 243.466, 5.884, 11.191, \
178, 13, 67.387, 52.899, 2307.505, 259.27, 5.852, 12.051, \
193.7, 4, 23.838, 18.713, 1072.791, 110.768, 6.708, 3.917, \
193.7, 5, 29.641, 23.268, 1320.232, 136.317, 6.674, 4.871, \
193.7, 5.5, 32.519, 25.527, 1440.961, 148.783, 6.657, 5.344, \
193.7, 6, 35.381, 27.774, 1559.723, 161.045, 6.64, 5.814, \
193.7, 7, 41.057, 32.23, 1791.435, 184.97, 6.605, 6.747, \
193.7, 8, 46.672, 36.637, 2015.537, 208.109, 6.572, 7.67, \
193.7, 9, 52.223, 40.995, 2232.2, 230.48, 6.538, 8.582, \
193.7, 10, 57.711, 45.303, 2441.588, 252.1, 6.504, 9.484, \
193.7, 11, 63.137, 49.562, 2643.867, 272.986, 6.471, 10.375, \
193.7, 12, 68.499, 53.772, 2839.2, 293.154, 6.438, 11.257, \
193.7, 13, 73.799, 57.932, 3027.748, 312.622, 6.405, 12.128, \
219, 4, 27.018, 21.209, 1561.657, 142.617, 7.603, 3.927, \
219, 5, 33.615, 26.388, 1925.344, 175.83, 7.568, 4.886, \
219, 5.5, 36.89, 28.959, 2103.315, 192.084, 7.551, 5.362, \
219, 6, 40.15, 31.517, 2278.738, 208.104, 7.534, 5.836, \
219, 7, 46.621, 36.598, 2622.037, 239.455, 7.499, 6.776, \
219, 8, 53.03, 41.629, 2955.433, 269.903, 7.465, 7.708, \
219, 9, 59.376, 46.61, 3279.119, 299.463, 7.431, 8.63, \
219, 10, 65.659, 51.543, 3593.287, 328.154, 7.398, 9.543, \
219, 11, 71.88, 56.426, 3898.123, 355.993, 7.364, 10.447, \
219, 12, 78.037, 61.259, 4193.815, 382.997, 7.331, 11.342, \
219, 13, 84.132, 66.044, 4480.547, 409.182, 7.298, 12.228, \
219, 14, 90.164, 70.779, 4758.502, 434.566, 7.265, 13.105, \
219, 15, 96.133, 75.464, 5027.862, 459.165, 7.232, 13.973, \
219, 16, 102.039, 80.101, 5288.805, 482.996, 7.199, 14.831, \
245, 4, 30.285, 23.774, 2199.331, 179.537, 8.522, 3.935, \
245, 5, 37.699, 29.594, 2715.514, 221.675, 8.487, 4.898, \
245, 5.5, 41.383, 32.485, 2968.712, 242.344, 8.47, 5.377, \
245, 6, 45.05, 35.365, 3218.685, 262.75, 8.453, 5.853, \
245, 7, 52.339, 41.086, 3709.064, 302.781, 8.418, 6.8, \
245, 8, 59.565, 46.758, 4186.87, 341.785, 8.384, 7.739, \
245, 9, 66.727, 52.381, 4652.32, 379.781, 8.35, 8.669, \
245, 10, 73.827, 57.955, 5105.628, 416.786, 8.316, 9.592, \
245, 11, 80.865, 63.479, 5547.008, 452.817, 8.282, 10.506, \
245, 12, 87.839, 68.954, 5976.671, 487.891, 8.249, 11.412, \
245, 13, 94.75, 74.379, 6394.825, 522.027, 8.215, 12.31, \
245, 14, 101.599, 79.755, 6801.679, 555.239, 8.182, 13.2, \
245, 15, 108.385, 85.082, 7197.438, 587.546, 8.149, 14.082, \
245, 16, 115.108, 90.36, 7582.305, 618.964, 8.116, 14.955, \
273, 4, 33.804, 26.536, 3058.248, 224.047, 9.512, 3.941, \
273, 5, 42.097, 33.046, 3780.815, 276.983, 9.477, 4.908, \
273, 5.5, 46.221, 36.283, 4135.971, 303.002, 9.46, 5.389, \
273, 6, 50.328, 39.508, 4487.084, 328.724, 9.442, 5.868, \
273, 7, 58.496, 45.92, 5177.302, 379.29, 9.408, 6.821, \
273, 8, 66.602, 52.282, 5851.714, 428.697, 9.373, 7.766, \
273, 9, 74.644, 58.596, 6510.564, 476.964, 9.339, 8.703, \
273, 10, 82.624, 64.86, 7154.093, 524.109, 9.305, 9.634, \
273, 11, 90.541, 71.074, 7782.539, 570.149, 9.271, 10.557, \
273, 12, 98.395, 77.24, 8396.141, 615.102, 9.237, 11.473, \
273, 13, 106.186, 83.356, 8995.135, 658.984, 9.204, 12.381, \
273, 14, 113.914, 89.423, 9579.753, 701.813, 9.17, 13.282, \
273, 15, 121.58, 95.44, 10150.228, 743.606, 9.137, 14.176, \
273, 16, 129.182, 101.408, 10706.79, 784.38, 9.104, 15.062, \
273, 17, 136.722, 107.327, 11249.666, 824.151, 9.071, 15.941, \
273, 18, 144.199, 113.196, 11779.084, 862.937, 9.038, 16.813, \
325, 5, 50.265, 39.458, 6435.553, 396.034, 11.315, 4.923, \
325, 5.5, 55.206, 43.336, 7046.344, 433.621, 11.298, 5.407, \
325, 6, 60.13, 47.202, 7651.328, 470.851, 11.28, 5.889, \
325, 7, 69.932, 54.897, 8844.019, 544.247, 11.246, 6.849, \
325, 8, 79.671, 62.542, 10013.921, 616.241, 11.211, 7.803, \
325, 9, 89.347, 70.137, 11161.326, 686.851, 11.177, 8.751, \
325, 10, 98.96, 77.684, 12286.523, 756.094, 11.143, 9.692, \
325, 11, 108.511, 85.181, 13389.802, 823.988, 11.108, 10.628, \
325, 12, 117.998, 92.629, 14471.449, 890.551, 11.074, 11.557, \
325, 13, 127.423, 100.027, 15531.749, 955.8, 11.04, 12.48, \
325, 14, 136.785, 107.376, 16570.983, 1019.753, 11.007, 13.397, \
325, 15, 146.084, 114.676, 17589.434, 1082.427, 10.973, 14.308, \
325, 16, 155.32, 121.926, 18587.379, 1143.839, 10.939, 15.212, \
325, 17, 164.494, 129.128, 19565.097, 1204.006, 10.906, 16.111, \
325, 18, 173.604, 136.279, 20522.862, 1262.945, 10.873, 17.003, \
356, 6, 65.973, 51.789, 10105.153, 567.705, 12.376, 5.899, \
356, 7, 76.749, 60.248, 11689.849, 656.733, 12.341, 6.862, \
356, 8, 87.462, 68.658, 13246.985, 744.213, 12.307, 7.82, \
356, 9, 98.112, 77.018, 14776.884, 830.162, 12.272, 8.772, \
356, 10, 108.699, 85.329, 16279.865, 914.599, 12.238, 9.719, \
356, 11, 119.223, 93.59, 17756.245, 997.542, 12.204, 10.66, \
356, 12, 129.685, 101.803, 19206.34, 1079.008, 12.17, 11.596, \
356, 13, 140.084, 109.966, 20630.464, 1159.015, 12.136, 12.525, \
356, 14, 150.419, 118.079, 22028.929, 1237.58, 12.102, 13.449, \
356, 15, 160.692, 126.144, 23402.045, 1314.722, 12.068, 14.368, \
356, 16, 170.903, 134.159, 24750.12, 1390.456, 12.034, 15.281, \
356, 17, 181.05, 142.124, 26073.461, 1464.801, 12.001, 16.188, \
356, 18, 191.134, 150.041, 27372.371, 1537.774, 11.967, 17.09, \
377, 6, 69.932, 54.897, 12035.01, 638.462, 13.119, 5.905, \
377, 7, 81.367, 63.873, 13928.954, 738.937, 13.084, 6.87, \
377, 8, 92.74, 72.801, 15791.852, 837.764, 13.049, 7.83, \
377, 9, 104.05, 81.679, 17624.043, 934.962, 13.015, 8.785, \
377, 10, 115.296, 90.508, 19425.867, 1030.55, 12.98, 9.735, \
377, 11, 126.481, 99.287, 21197.661, 1124.544, 12.946, 10.679, \
377, 12, 137.602, 108.017, 22939.761, 1216.963, 12.912, 11.618, \
377, 13, 148.66, 116.698, 24652.501, 1307.825, 12.878, 12.552, \
377, 14, 159.656, 125.33, 26336.212, 1397.147, 12.844, 13.48, \
377, 15, 170.588, 133.912, 27991.224, 1484.946, 12.81, 14.403, \
377, 16, 181.458, 142.445, 29617.866, 1571.24, 12.776, 15.321, \
377, 17, 192.265, 150.928, 31216.462, 1656.046, 12.742, 16.233, \
377, 18, 203.01, 159.363, 32787.338, 1739.381, 12.709, 17.141, \
406.4, 6, 75.474, 59.247, 15128.325, 744.504, 14.158, 5.911, \
406.4, 7, 87.833, 68.949, 17519.249, 862.168, 14.123, 6.879, \
406.4, 8, 100.129, 78.601, 19873.893, 978.046, 14.088, 7.843, \
406.4, 9, 112.362, 88.204, 22192.625, 1092.157, 14.054, 8.801, \
406.4, 10, 124.533, 97.758, 24475.813, 1204.518, 14.019, 9.754, \
406.4, 11, 136.64, 107.263, 26723.821, 1315.149, 13.985, 10.702, \
406.4, 12, 148.685, 116.718, 28937.014, 1424.066, 13.951, 11.646, \
406.4, 13, 160.667, 126.124, 31115.751, 1531.287, 13.916, 12.584, \
406.4, 14, 172.587, 135.48, 33260.394, 1636.83, 13.882, 13.518, \
406.4, 15, 184.443, 144.788, 35371.298, 1740.713, 13.848, 14.446, \
406.4, 16, 196.236, 154.046, 37448.821, 1842.954, 13.814, 15.37, \
406.4, 17, 207.967, 163.254, 39493.315, 1943.569, 13.78, 16.289, \
406.4, 18, 219.635, 172.413, 41505.134, 2042.575, 13.747, 17.203, \
426, 7, 92.143, 72.332, 20226.521, 949.602, 14.816, 6.885, \
426, 8, 105.055, 82.468, 22952.911, 1077.601, 14.781, 7.85, \
426, 9, 117.904, 92.555, 25639.693, 1203.741, 14.747, 8.81, \
426, 10, 130.69, 102.592, 28287.252, 1328.04, 14.712, 9.765, \
426, 11, 143.414, 112.58, 30895.973, 1450.515, 14.678, 10.716, \
426, 12, 156.074, 122.518, 33466.237, 1571.185, 14.643, 11.662, \
426, 13, 168.672, 132.408, 35998.423, 1690.067, 14.609, 12.603, \
426, 14, 181.207, 142.248, 38492.911, 1807.179, 14.575, 13.54, \
426, 15, 193.679, 152.038, 40950.075, 1922.539, 14.541, 14.472, \
426, 16, 206.088, 161.779, 43370.29, 2036.164, 14.507, 15.399, \
426, 17, 218.435, 171.471, 45753.928, 2148.072, 14.473, 16.322, \
426, 18, 230.719, 181.114, 48101.36, 2258.28, 14.439, 17.239, \
457, 7, 98.96, 77.684, 25055.354, 1096.514, 15.912, 6.893, \
457, 8, 112.846, 88.584, 28446.363, 1244.917, 15.877, 7.86, \
457, 9, 126.669, 99.435, 31791.548, 1391.315, 15.842, 8.823, \
457, 10, 140.429, 110.237, 35091.324, 1535.725, 15.808, 9.781, \
457, 11, 154.127, 120.989, 38346.104, 1678.166, 15.773, 10.735, \
457, 12, 167.761, 131.692, 41556.299, 1818.656, 15.739, 11.685, \
457, 13, 181.333, 142.346, 44722.317, 1957.213, 15.704, 12.63, \
457, 14, 194.842, 152.951, 47844.567, 2093.854, 15.67, 13.571, \
457, 15, 208.288, 163.506, 50923.453, 2228.597, 15.636, 14.508, \
457, 16, 221.671, 174.012, 53959.378, 2361.461, 15.602, 15.44, \
457, 17, 234.991, 184.468, 56952.744, 2492.461, 15.568, 16.368, \
457, 18, 248.249, 194.875, 59903.951, 2621.617, 15.534, 17.291, \
508, 8, 125.664, 98.646, 39279.961, 1546.455, 17.68, 7.874, \
508, 9, 141.089, 110.755, 43928.39, 1729.464, 17.645, 8.841, \
508, 10, 156.451, 122.814, 48520.246, 1910.246, 17.611, 9.803, \
508, 11, 171.751, 134.824, 53055.991, 2088.819, 17.576, 10.762, \
508, 12, 186.988, 146.785, 57536.083, 2265.2, 17.541, 11.717, \
508, 13, 202.161, 158.697, 61960.98, 2439.409, 17.507, 12.667, \
508, 14, 217.273, 170.559, 66331.136, 2611.462, 17.473, 13.614, \
508, 15, 232.321, 182.372, 70647.006, 2781.378, 17.438, 14.557, \
508, 16, 247.306, 194.135, 74909.04, 2949.175, 17.404, 15.496, \
508, 17, 262.229, 205.85, 79117.688, 3114.87, 17.37, 16.431, \
508, 18, 277.088, 217.514, 83273.399, 3278.48, 17.336, 17.362, \
530, 8, 131.193, 102.986, 44695.456, 1686.621, 18.458, 7.879, \
530, 9, 147.309, 115.638, 49997.138, 1886.684, 18.423, 8.847, \
530, 10, 163.363, 128.24, 55237.053, 2084.417, 18.388, 9.811, \
530, 11, 179.354, 140.793, 60415.683, 2279.837, 18.354, 10.772, \
530, 12, 195.281, 153.296, 65533.508, 2472.963, 18.319, 11.728, \
530, 13, 211.146, 165.75, 70591.006, 2663.812, 18.284, 12.681, \
530, 14, 226.949, 178.155, 75588.653, 2852.402, 18.25, 13.63, \
530, 15, 242.688, 190.51, 80526.923, 3038.752, 18.216, 14.575, \
530, 16, 258.365, 202.816, 85406.287, 3222.879, 18.181, 15.517, \
530, 17, 273.978, 215.073, 90227.217, 3404.801, 18.147, 16.455, \
530, 18, 289.529, 227.28, 94990.181, 3584.535, 18.113, 17.389}

#include "StandartProfil%Rect_profil_N.h"

class TStandartProfil
{
  private:

  int n_Profil;  //     
  int n_Profil_Tube;  //     .    
  int Index;      // ,   
  // 0- h, 1-b, 2-s, 3-t, 4-A, 5-P, 6-Iy, 7-Wy, 8-Sy, 9-iy, 10-Iz, 11-Wz, 12-iz, 13-R
  double Gost_Profil[300][16];
//    
//                    0 - xa  1-Iw  2-w1  3-w2   4-Ww1   5-Ww2   6-Itor  7-R =sqrt(GItor/EIw)
  double Gost_SectorProfil[300][8];
  AnsiString Name_Profil[700];
  double Tube_Profil[700][15];
  double Thickness[700];
  int Type_profil_tube;
  int Index_thick_tube;      //    ,     

  public:
  TStandartProfil(void);
  //-------------  -------------------------
  //   
  void  SetProfil(int index);
  //       
  double * GetVectorParamProfil(int index_profil);
  //        
  double * GetVectorSectorParamProfil(int index_profil);
  //       
  AnsiString* GetVectorNameProfil(int *n_profil);


  //    ,  0)  , 1)  , 2)   
  int Get_NumberProfil(SECT_DVUTAVR* section, int index);
  //   ,     0- , 4- , 6-  
  int Get_NumberProfil_param(double param, int index);
  //        
  int SetParamProfil(SECT_DVUTAVR* sect, int n_profil);

  //-------------  -------------------------
  //   
  void  SetProfil_Tube(int index);
  //    
  int GetNumberAllProfil_Tube();

  //         (h*b)     (t)
  double * GetVectorParamProfil_Tube(int index_profil, int n_thick);
  //         
  double * GetVectorParamProfil_TubeNum(int number_prof);
  //         (h*b)     (t)
  int GetNumberProfil_Tube(int index_profil, int n_thick);
  //         (h*b)   
  double *GetVectorParamThickness_Tube(int n_profil, int *num_thick);
  //     (h*b)     (t)     
  int GetGroup_a_Profil_Tube(int Number, int *index_profil, int *n_thick);
  //        
  int SetParamProfil_Tube(COMMON_SECT* sect_comm, int type_sect, int Number);
  //    ,  0)  ,   , 1)  , 2)   
  int Get_NumberProfil_Tube(int type_sect, COMMON_SECT* sect_com, int index);

  //   ,     0- , 4- , 6-  
  int Choice_Profil_param(SECT_DVUTAVR* sect, double Ar, double ix, double W, double h_sect, double tw, double tf, double bf, bool flag_message);


};

void Check_StandartProfil(SECT_DVUTAVR* sect1, SECT_DVUTAVR* sect2, AnsiString text);
//        
void    Set_TypeProfil(SECT_DVUTAVR* sect1, int index_profil, int type_profil);
//          
void  Set_TypeProfil_Com(int type_sect, SECT_DVUTAVR* sect, int index_profil, int type_profil);

//      (         )
void    Set_TypeProfilInit(SECT_DVUTAVR* sect, int index_profil, int type_profil);


//---------------------------------------------------------------------------
#endif

